Long running tests that are to be run manually and not on CRAN.
They should be run routinely to ensure sanity of CVXR, even if
not on CRAN.


##library(testthat)
##library(CVXR)
##Sys.setenv(NOT_CRAN = TRUE)
##for (f in list.files(".", pattern = ".R$")) test_file(f)

# Problem data
m <- 101
L <- 2
h <- L/(m-1)

# Form objective
x <- Variable(m)
y <- Variable(m)
objective <- Minimize(sum(y))

# Form constraints
constraints <- list(x[1] == 0, y[1] == 1, x[m] == 1, y[m] == 1,
                    diff(x)^2 + diff(y)^2 <= h^2)

# Solve catenary problem
prob <- Problem(objective, constraints)
result <- solve(prob)

# Plot and compare with ideal catenary
xs <- result$getValue(x)
ys <- result$getValue(y)
plot(c(0,1), c(0,1), type = "n", xlab = "x", ylab = "y")
lines(xs, ys, col = "blue", lwd = 2)

points(c(0,1), c(1,1))
curve(0.22964*cosh((x - 0.5)/0.22964) - 0.02603, 0, 1, col = "red", add = TRUE)
grid()

# Lower right endpoint and add staircase structure
ground <- sapply(seq(0, 1, length.out = m), function(x) {
  if(x < 0.2)
    return(0.6)
  else if(x >= 0.2 && x < 0.4)
    return(0.4)
  else if(x >= 0.4 && x < 0.6)
    return(0.2)
  else
    return(0)
})

# Solve catenary problem with ground constraint
constraints <- c(constraints, y >= ground)
constraints[[4]] <- (y[m] == 0.5)
prob <- Problem(objective, constraints)
result <- solve(prob)

# Plot catenary against ground
xs <- result$getValue(x)
ys <- result$getValue(y)
plot(c(0, 1), c(1, 0.5), type = "n", xlab = "x", ylab = "y", ylim = c(0, 1))
points(c(0, 1), c(1, 0.5))
lines(xs, ys, col = "blue", lwd = 2)
lines(xs, ground, col = "red")
grid()

# Binary support vector classifier
set.seed(10)
n <- 2
m <- 50

# Generate data
X <- matrix(rnorm(m*n), nrow = m, ncol = n)
y <- c(rep(-1, m/2), rep(1, m/2))
X[y == 1,] = X[y == 1,] + 1

# Form problem
cost <- 10
beta0 <- Variable()
beta <- Variable(n)
slack <- Variable(m)
loss <- (1/2)*sum_squares(vstack(beta, beta0)) + cost*sum(slack)
constr <- list(y * (X %*% beta + beta0) >= 1 - slack, slack >= 0)
prob <- Problem(Minimize(loss), constr)

# Solve and plot result
result <- solve(prob)
result$value
b0 <- result$getValue(beta0)
bres <- result$getValue(beta)

plot(X, col = (3-y), main = "Support Vector Classifier", pch = 19)
legend("topright", paste("y =", unique(y)), col = 3-unique(y), pch = 19)
slope <- -bres[1]/bres[2]
intercept <- b0/bres[2]
margin <- 1/bres[2]
abline(a = intercept, b = slope)
abline(a = intercept + margin, b = slope, lty = 2)
abline(a = intercept - margin, b = slope, lty = 2)

# Import problem data
data(dspop)   # Population
data(dssamp)  # Skewed sample

ypop <- dspop[,1]
Xpop <- dspop[,-1]
y <- dssamp[,1]
X <- dssamp[,-1]
m <- nrow(X)

# Given population mean of features
b <- as.matrix(apply(Xpop, 2, mean))

# Construct the direct standardization problem
w <- Variable(m)
objective <- sum(entr(w))
constraints <- list(w >= 0, sum(w) == 1, t(X) %*% w == b)
prob <- Problem(Maximize(objective), constraints)

# Solve for the distribution weights
result <- solve(prob)
result$value
result$getValue(w)
weights <- result$getValue(w)

# Plot probability density function
cl <- rainbow(3)
plot(density(ypop), col = cl[1], main = "Probability Density Function", xlab = "y", ylab = NA, ylim = c(0, 0.2), zero.line = FALSE)
lines(density(y), col = cl[2])
lines(density(y, weights = weights), col = cl[3])
legend("topleft", c("True", "Sample", "Estimate"), lty = c(1,1,1), col = cl)

# Plot cumulative distribution function
plot_cdf <- function(data, probs, color = 'k', lwd = 1) {
  if(missing(probs))
    probs <- rep(1.0/length(data), length(data))
  distro <- cbind(data, probs)
  dsort <- distro[order(distro[,1]),]
  ecdf <- base::cumsum(dsort[,2])
  lines(dsort[,1], ecdf, col = color, lwd = lwd)
}

# Compare weighted with original distribution
plot(NA, main = "Cumulative Distribution Function", xlab = "y", ylab = NA, ylim = c(0,1), xlim = c(-2, 14))
plot_cdf(ypop, color = cl[1])
plot_cdf(y, color = cl[2])
plot_cdf(y, weights, color = cl[3])
legend("topleft", c("True", "Sample", "Estimate"), lty = c(1,1,1), col = cl)

context("test-vignettes")


test_that("Test non-negative least squares", {
    skip_on_cran()
    library(MASS)
    print("LS")

    ## Generate problem data
    s <- 1
    m <- 10
    n <- 300
    mu <- rep(0, 9)
    Sigma <- data.frame(c(1.6484, -0.2096, -0.0771, -0.4088, 0.0678, -0.6337, 0.9720, -1.2158, -1.3219),
                        c(-0.2096, 1.9274, 0.7059, 1.3051, 0.4479, 0.7384, -0.6342, 1.4291, -0.4723),
                        c(-0.0771, 0.7059, 2.5503, 0.9047, 0.9280, 0.0566, -2.5292, 0.4776, -0.4552),
                        c(-0.4088, 1.3051, 0.9047, 2.7638, 0.7607, 1.2465, -1.8116, 2.0076, -0.3377),
                        c(0.0678, 0.4479, 0.9280, 0.7607, 3.8453, -0.2098, -2.0078, -0.1715, -0.3952),
                        c(-0.6337, 0.7384, 0.0566, 1.2465, -0.2098, 2.0432, -1.0666,  1.7536, -0.1845),
                        c(0.9720, -0.6342, -2.5292, -1.8116, -2.0078, -1.0666, 4.0882,  -1.3587, 0.7287),
                        c(-1.2158, 1.4291, 0.4776, 2.0076, -0.1715, 1.7536, -1.3587, 2.8789, 0.4094),
                        c(-1.3219, -0.4723, -0.4552, -0.3377, -0.3952, -0.1845, 0.7287, 0.4094, 4.8406))

    X <- MASS::mvrnorm(n, mu, Sigma)
    X <- cbind(rep(1, n), X)
    b <- c(0, 0.8, 0, 1, 0.2, 0, 0.4, 1, 0, 0.7)
    y <- X %*% b + rnorm(n, 0, s)

    ## Construct the OLS problem without constraints
    beta <- Variable(m)
    objective <- Minimize(sum((y - X %*% beta)^2))
    prob <- Problem(objective)

    ## Solve the OLS problem for beta
    system.time(result <- solve(prob))
    beta_ols <- result$getValue(beta)

    ## Add non-negativity constraint on beta
    constraints <- list(beta >= 0)
    prob2 <- Problem(objective, constraints)

    ## Solve the NNLS problem for beta
    system.time(result2 <- solve(prob2))
    beta_nnls <- result2$getValue(beta)
    expect_true(all(beta_nnls >= -1e-6))   ## All resulting beta should be non-negative

    ## Calculate the fitted y values
    fit_ols <- X %*% beta_ols
    fit_nnls <- X %*% beta_nnls

    ## Plot coefficients for OLS and NNLS
    coeff <- cbind(b, beta_ols, beta_nnls)
    colnames(coeff) <- c("Actual", "OLS", "NNLS")
    rownames(coeff) <- paste("beta", 1:length(b)-1, sep = "")
    barplot(t(coeff), ylab = "Coefficients", beside = TRUE, legend.text = TRUE)
})

test_that("Test censored regression", {
  skip_on_cran()
  ## Problem data
  n <- 30
  M <- 50
  K <- 200
  set.seed(n*M*K)

  print("CENSORED")

  X <- matrix(stats::rnorm(K*n), nrow = K, ncol = n)
  beta_true <- matrix(stats::rnorm(n), nrow = n, ncol = 1)
  y <- X %*% beta_true + 0.3*sqrt(n)*stats::rnorm(K)

  ## Order variables based on y
  idx <- order(y, decreasing = FALSE)
  y_ordered <- y[idx]
  X_ordered <- X[idx,]

  ## Find cutoff and censor
  D <- (y_ordered[M] + y_ordered[M+1])/2
  y_censored <- pmin(y_ordered, D)

  plot_results <- function(beta_res, bcol = "blue", bpch = 17) {
      graphics::plot(1:M, y_censored[1:M], col = "black", xlab = "Observations", ylab = "y", ylim = c(min(y), max(y)), xlim = c(1,K))
      graphics::points((M+1):K, y_ordered[(M+1):K], col = "red")
      graphics::points(1:K, X_ordered %*% beta_res, col = bcol, pch = bpch)
      graphics::abline(a = D, b = 0, col = "black", lty = "dashed")
      graphics::legend("topleft", c("Uncensored", "Censored", "Estimate"), col = c("black", "red", bcol), pch = c(1,1,bpch))
  }

  ## Regular OLS
  beta <- Variable(n)
  obj <- sum((y_censored - X_ordered %*% beta)^2)
  prob <- Problem(Minimize(obj))
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  beta_ols <- result$getValue(beta)
  plot_results(beta_ols)

  ## OLS using uncensored data
  obj <- sum((y_censored[1:M] - X_ordered[1:M,] %*% beta)^2)
  prob <- Problem(Minimize(obj))
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  beta_unc <- result$getValue(beta)
  plot_results(beta_unc)

  ## Censored regression
  obj <- sum((y_censored[1:M] - X_ordered[1:M,] %*% beta)^2)
  constr <- list(X_ordered[(M+1):K,] %*% beta >= D)
  prob <- Problem(Minimize(obj), constr)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  beta_cens <- result$getValue(beta)
  plot_results(beta_cens)
})

test_that("Test Elastic-net regression", {
  skip_on_cran()
  set.seed(1)
  print("ELASTIC")

  # Problem data
  n = 20
  m = 1000
  DENSITY = 0.25    # Fraction of non-zero beta
  beta_true = matrix(rnorm(n), ncol = 1)
  idxs <- sample.int(n, size = floor((1-DENSITY)*n), replace = FALSE)
  beta_true[idxs] <- 0

  sigma = 45
  X = matrix(rnorm(m*n, sd = 5), nrow = m, ncol = n)
  eps <- matrix(rnorm(m, sd = sigma), ncol = 1)
  y = X %*% beta_true + eps

  # Elastic-net penalty function
  elastic_reg <- function(beta, lambda = 0, alpha = 0) {
    ridge <- (1 - alpha) * sum(beta^2)
    lasso <- alpha * p_norm(beta, 1)
    lambda * (lasso + ridge)
  }

  TRIALS <- 10
  beta_vals <- matrix(0, nrow = n, ncol = TRIALS)
  lambda_vals <- 10^seq(-2, log10(50), length.out = TRIALS)
  beta <- Variable(n)
  loss <- sum((y - X %*% beta)^2)/(2*m)

  # Elastic-net regression
  alpha <- 0.75
  for(i in 1:TRIALS) {
    lambda <- lambda_vals[i]
    obj <- loss + elastic_reg(beta, lambda, alpha)
    prob <- Problem(Minimize(obj))
    result <- solve(prob)
    expect_equal(result$status, "optimal")
    beta_vals[,i] <- result$getValue(beta)
  }

  # Plot coefficients against regularization
  plot(0, 0, type = "n", main = "Regularization Path for Elastic-net Regression", xlab = expression(lambda), ylab = expression(beta), ylim = c(-0.75, 1.25), xlim = c(0, 50))
  matlines(lambda_vals, t(beta_vals))

  # Compare with glmnet results
  library(glmnet)
  model_net <- glmnet(X, y, family = "gaussian", alpha = alpha, lambda = lambda_vals, standardize = FALSE, intercept = FALSE)
  coef_net <- coef(model_net)[-1, seq(TRIALS, 1, by = -1)]    # Reverse order to match beta_vals
  sum((beta_vals - coef_net)^2)/(n*TRIALS)
})

test_that("Test Huber regression", {
  skip_on_cran()
  n <- 1
  m <- 450
  M <- 1      ## Huber threshold
  p <- 0.1    ## Fraction of responses with sign flipped

  print("HUBER")

  ## Generate problem data
  beta_true <- 5*matrix(stats::rnorm(n), nrow = n)
  X <- matrix(stats::rnorm(m*n), nrow = m, ncol = n)
  y_true <- X %*% beta_true
  eps <- matrix(stats::rnorm(m), nrow = m)

  ## Randomly flip sign of some responses
  factor <- 2*stats::rbinom(m, size = 1, prob = 1-p) - 1
  y <- factor * y_true + eps

  ## Solve ordinary least squares problem
  beta <- Variable(n)
  rel_err <- norm(beta - beta_true, "F")/norm(beta_true, "F")

  obj <- sum((y - X %*% beta)^2)
  prob <- Problem(Minimize(obj))
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  beta_ols <- result$getValue(beta)
  err_ols <- result$getValue(rel_err)

  ## Plot fit against measured responses
  plot(X[factor == 1], y[factor == 1], col = "black", xlab = "X", ylab = "y")
  points(X[factor == -1], y[factor == -1], col = "red")
  lines(X, X %*% beta_ols, col = "blue")

  ## Solve Huber regression problem
  obj <- sum(CVXR::huber(y - X %*% beta, M))
  prob <- Problem(Minimize(obj))
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  beta_hub <- result$getValue(beta)
  err_hub <- result$getValue(rel_err)
  lines(X, X %*% beta_hub, col = "seagreen", lty = "dashed")

  ## Solve ordinary least squares assuming sign flips known
  obj <- sum((y - factor*(X %*% beta))^2)
  prob <- Problem(Minimize(obj))
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  beta_prs <- result$getValue(beta)
  err_prs <- result$getValue(rel_err)
  lines(X, X %*% beta_prs, col = "black")
  legend("topright", c("OLS", "Huber", "Prescient"), col = c("blue", "seagreen", "black"), lty = 1)
})

test_that("Test logistic regression", {
  skip_on_cran()
  n <- 20
  m <- 1000
  offset <- 0
  sigma <- 45
  DENSITY <- 0.2

  print("LOGISTIC")

  beta_true <- stats::rnorm(n)
  idxs <- sample(n, size = floor((1-DENSITY)*n), replace = FALSE)
  beta_true[idxs] <- 0
  X <- matrix(stats::rnorm(m*n, 0, 5), nrow = m, ncol = n)
  y <- sign(X %*% beta_true + offset + stats::rnorm(m, 0, sigma))

  beta <- Variable(n)
  obj <- -sum(logistic(-X[y <= 0,] %*% beta)) - sum(logistic(X[y == 1,] %*% beta))
  prob <- Problem(Maximize(obj))
  result <- solve(prob)
  expect_equal(result$status, "optimal")

  log_odds <- result$getValue(X %*% beta)
  beta_res <- result$getValue(beta)
  y_probs <- 1/(1 + exp(-X %*% beta_res))
  log(y_probs/(1 - y_probs))
})


test_that("Test saturating hinges problem", {
  skip_on_cran()
  library(ElemStatLearn)
  print("SAT HINGES")

  ## Import and sort data
  data(bone)
  X <- bone[bone$gender == "female",]$age
  y <- bone[bone$gender == "female",]$spnbmd
  ord <- order(X, decreasing = FALSE)
  X <- X[ord]
  y <- y[ord]

  ## Choose knots evenly distributed along domain
  k <- 10
  lambdas <- c(1, 0.5, 0.01)
  idx <- floor(seq(1, length(X), length.out = k))
  knots <- X[idx]

  ## Saturating hinge
  f_est <- function(x, knots, w0, w) {
    hinges <- sapply(knots, function(t) { pmax(x - t, 0) })
    w0 + hinges %*% w
  }

  ## Loss function
  loss_obs <- function(y, f) { (y - f)^2 }

  ## Form problem
  w0 <- Variable(1)
  w <- Variable(k)
  loss <- sum(loss_obs(y, f_est(X, knots, w0, w)))
  constr <- list(sum(w) == 0)

  xrange <- seq(min(X), max(X), length.out = 100)
  splines <- matrix(0, nrow = length(xrange), ncol = length(lambdas))

  for(i in 1:length(lambdas)) {
    lambda <- lambdas[i]
    reg <- lambda * p_norm(w, 1)
    obj <- loss + reg
    prob <- Problem(Minimize(obj), constr)

    ## Solve problem and save spline weights
    result <- solve(prob)
    expect_equal(result$status, "optimal")
    w0s <- result$getValue(w0)
    ws <- result$getValue(w)
    splines[,i] <- f_est(xrange, knots, w0s, ws)
  }

  ## Plot saturating hinges
  plot(X, y, xlab = "Age", ylab = "Change in Bone Density", col = "black", type = "p")
  matlines(xrange, splines, col = "blue", lty = 1:length(lambdas), lwd = 1.5)
  legend("topright", as.expression(lapply(lambdas, function(x) bquote(lambda==.(x)))), col = "blue", lty = 1:length(lambdas), bty = "n")

  ## Add outliers to data
  set.seed(1)
  nout <- 50
  X_out <- runif(nout, min(X), max(X))
  y_out <- runif(nout, min(y), 3*max(y)) + 0.3
  X_all <- c(X, X_out)
  y_all <- c(y, y_out)

  ## Solve with squared error loss
  loss_obs <- function(y, f) { (y - f)^2 }
  loss <- sum(loss_obs(y_all, f_est(X_all, knots, w0, w)))
  prob <- Problem(Minimize(loss + reg), constr)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  spline_sq <- f_est(xrange, knots, result$getValue(w0), result$getValue(w))

  ## Solve with Huber loss
  loss_obs <- function(y, f, M) { CVXR::huber(y - f, M) }
  loss <- sum(loss_obs(y, f_est(X, knots, w0, w), 0.01))
  prob <- Problem(Minimize(loss + reg), constr)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  spline_hub <- f_est(xrange, knots, result$getValue(w0), result$getValue(w))

  ## Compare fitted functions with squared error and Huber loss
  plot(X, y, xlab = "Age", ylab = "Change in Bone Density", col = "black", type = "p", ylim = c(min(y), 1))
  points(X_out, y_out, col = "red", pch = 16)
  matlines(xrange, cbind(spline_hub, spline_sq), col = "blue", lty = 1:2, lwd = 1.5)
  legend("topright", c("Huber Loss", "Squared Loss"), col = "blue", lty = 1:2, bty = "n")
})

test_that("Test log-concave distribution estimation", {
  skip_on_cran()
  set.seed(1)
  print("LOG CONCAVE")

  ## Calculate a piecewise linear function
  pwl_fun <- function(x, knots) {
    n <- nrow(knots)
    x0 <- sort(knots$x, decreasing = FALSE)
    y0 <- knots$y[order(knots$x, decreasing = FALSE)]
    slope <- diff(y0)/diff(x0)

    sapply(x, function(xs) {
      if(xs <= x0[1])
        y0[1] + slope[1]*(xs -x0[1])
      else if(xs >= x0[n])
        y0[n] + slope[n-1]*(xs - x0[n])
      else {
        idx <- which(xs <= x0)[1]
        y0[idx-1] + slope[idx-1]*(xs - x0[idx-1])
      }
    })
  }

  ## Problem data
  m <- 25
  xrange <- 0:100
  knots <- data.frame(x = c(0, 25, 65, 100), y = c(10, 30, 40, 15))
  xprobs <- pwl_fun(xrange, knots)/15
  xprobs <- exp(xprobs)/sum(exp(xprobs))
  x <- sample(xrange, size = m, replace = TRUE, prob = xprobs)

  K <- max(xrange)
  xhist <- hist(x, breaks = -1:K, right = TRUE, include.lowest = FALSE)
  counts <- xhist$counts

  ## Solve problem with log-concave constraint
  u <- Variable(K+1)
  obj <- t(counts) %*% u
  constraints <- list(sum(exp(u)) <= 1, diff(u[1:K]) >= diff(u[2:(K+1)]))
  prob <- Problem(Maximize(obj), constraints)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  pmf <- result$getValue(exp(u))

  ## Plot probability mass function
  cl <- rainbow(3)
  plot(NA, xlim = c(0, 100), ylim = c(0, 0.025), xlab = "x", ylab = "Probability Mass Function")
  lines(xrange, xprobs, lwd = 2, col = cl[1])
  lines(density(x, bw = "sj"), lwd = 2, col = cl[2])
  ## lines(counts/sum(counts), lwd = 2, col = cl[2])
  lines(xrange, pmf, lwd = 2, col = cl[3])
  legend("topleft", c("True", "Empirical", "Optimal Estimate"), lty = c(1,1,1), col = cl)

  ## Plot cumulative distribution function
  plot(NA, xlim = c(0, 100), ylim = c(0, 1), xlab = "x", ylab = "Cumulative Distribution Function")
  lines(xrange, base::cumsum(xprobs), lwd = 2, col = cl[1])
  lines(xrange, base::cumsum(counts)/sum(counts), lwd = 2, col = cl[2])
  lines(xrange, base::cumsum(pmf), lwd = 2, col = cl[3])
  legend("topleft", c("True", "Empirical", "Optimal Estimate"), lty = c(1,1,1), col = cl)
})

test_that("Test channel capacity problem", {
  skip_on_cran()
  ## Problem data
  n <- 2
  m <- 2
  P <- rbind(c(0.75, 0.25),    ## Channel transition matrix
             c(0.25, 0.75))

  print("CHANNEL")

  ## Form problem
  x <- Variable(n)   ## Probability distribution of input signal x(t)
  y <- P %*% x       ## Probability distribution of output signal y(t)
  c <- apply(P * log2(P), 2, sum)
  I <- t(c) %*% x + sum(entr(y))   ## Mutual information between x and y
  obj <- Maximize(I)
  constraints <- list(sum(x) == 1, x >= 0)
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$status, "optimal")

  ## Optimal channel capacity and input signal.
  result$value
  result$getValue(x)
})

test_that("Test optimal allocation in a Gaussian broadcast channel", {
  skip_on_cran()
  ## Problem data
  n <- 5
  alpha <- seq(10, n-1+10)/n
  beta <- seq(10, n-1+10)/n
  P_tot <- 0.5
  W_tot <- 1.0

  print("OPTIMAL ALLOCATION")

  ## Form problem
  P <- Variable(n)   ## Power
  W <- Variable(n)   ## Bandwidth
  R <- kl_div(alpha*W, alpha*(W + beta*P)) - alpha*beta*P   ## Bitrate
  objective <- Minimize(sum(R))
  constraints <- list(P >= 0, W >= 0, sum(P) == P_tot, sum(W) == W_tot)
  prob <- Problem(objective, constraints)
  result <- solve(prob)
  expect_equal(result$status, "optimal")

  ## Optimal utility, power, and bandwidth
  -result$value
  result$getValue(P)
  result$getValue(W)
})

test_that("Test catenary problem", {
  skip_on_cran()
  ## Problem data
  m <- 101
  L <- 2
  h <- L/(m-1)
  print("CATENARY")
  ## Form objective
  x <- Variable(m)
  y <- Variable(m)
  objective <- Minimize(sum(y))

  ## Form constraints
  constraints <- list(x[1] == 0, y[1] == 1, x[m] == 1, y[m] == 1,
                      diff(x)^2 + diff(y)^2 <= h^2)

  ## Solve the catenary problem
  prob <- Problem(objective, constraints)
  system.time(result <- solve(prob))
  expect_equal(result$status, "optimal")

  ## Plot and compare with ideal catenary
  xs <- result$getValue(x)
  ys <- result$getValue(y)
  graphics::plot(c(0, 1), c(0, 1), type = 'n', xlab = "x", ylab = "y")
  graphics::lines(xs, ys, col = "blue", lwd = 2)
  graphics::grid()

  ideal <- function(x) { 0.22964*cosh((x-0.5)/0.22964)-0.02603 }
  expect_equal(ys, ideal(xs), tolerance = 1e-3)
  ## points(c(0, 1), c(1, 1))
  ## curve(0.22964*cosh((x-0.5)/0.22964)-0.02603, 0, 1, col = "red", add = TRUE)
  ## grid()

  ## Lower right endpoint and add staircase structure
  ground <- sapply(seq(0, 1, length.out = m), function(x) {
    if(x < 0.2)
      return(0.6)
    else if(x >= 0.2 && x < 0.4)
      return(0.4)
    else if(x >= 0.4 && x < 0.6)
      return(0.2)
    else
      return(0)
  })

  ## Solve catenary problem with ground constraint
  constraints <- c(constraints, y >= ground)
  constraints[[4]] <- (y[m] == 0.5)
  prob <- Problem(objective, constraints)
  result <- solve(prob)
  expect_equal(result$status, "optimal")

  ## Plot catenary against ground
  xs <- result$getValue(x)
  ys <- result$getValue(y)
  graphics::plot(c(0, 1), c(1, 0.5), type = "n", xlab = "x", ylab = "y", ylim = c(0, 1))
  graphics::points(c(0, 1), c(1, 0.5))
  graphics::lines(xs, ys, col = "blue", lwd = 2)
  graphics::lines(xs, ground, col = "red")
  graphics::grid()
})

test_that("Test direct standardization problem", {
  skip_on_cran()
  print("DIRECT")

  skew_sample <- function(data, bias) {
  if(missing(bias))
    bias <- rep(1.0, ncol(data))
    num <- exp(data %*% bias)
    return(num / sum(num))
  }

  plot_cdf <- function(data, probs, color = 'k') {
    if(missing(probs))
      probs <- rep(1.0/length(data), length(data))
    distro <- cbind(data, probs)
    dsort <- distro[order(distro[,1]),]
    ecdf <- base::cumsum(dsort[,2])
    lines(dsort[,1], ecdf, col = color)
  }

  ## Problem data
  n <- 2
  m <- 1000
  msub <- 100

  ## Generate original distribution
  sex <- stats::rbinom(m, 1, 0.5)
  age <- sample(10:60, m, replace = TRUE)
  mu <- 5 * sex + 0.1 * age
  X <- cbind(sex, age)
  y <- stats::rnorm(mu, 1.0)
  b <- as.matrix(apply(X, 2, mean))

  ## Generate skewed subsample
  skew <- skew_sample(X, c(-0.95, -0.05))
  sub <- sample(1:m, msub, replace = TRUE, prob = skew)

  ## Construct the direct standardization problem
  w <- Variable(msub)
  objective <- sum(entr(w))
  constraints <- list(w >= 0, sum(w) == 1, t(X[sub,]) %*% w == b)
  prob <- Problem(Maximize(objective), constraints)

  ## Solve for the distribution weights
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  weights <- result$getValue(w)

  ## Plot probability density function
  cl <- rainbow(3)
  plot(density(y), col = cl[1], xlab = "y", ylab = NA, ylim = c(0, 0.5), zero.line = FALSE)
  lines(density(y[sub]), col = cl[2])
  lines(density(y[sub], weights = weights), col = cl[3])
  legend("topleft", c("True", "Sample", "Estimate"), lty = c(1,1,1), col = cl)

  ## Plot cumulative distribution function
  plot(NA, xlab = "y", ylab = NA, xlim = c(-2, 3), ylim = c(0, 1))
  plot_cdf(y, color = cl[1])
  plot_cdf(y[sub], color = cl[2])
  plot_cdf(y[sub], weights, color = cl[3])
  legend("topleft", c("True", "Sample", "Estimate"), lty = c(1,1,1), col = cl)
})

test_that("Test risk-return tradeoff in portfolio optimization", {
  skip_on_cran()
  print("PORTFOLIO")

  ## Problem data
  set.seed(10)
  n <- 10
  SAMPLES <- 100
  mu <- matrix(abs(stats::rnorm(n)), nrow = n)
  Sigma <- matrix(stats::rnorm(n^2), nrow = n, ncol = n)
  Sigma <- t(Sigma) %*% Sigma

  ## Form problem
  w <- Variable(n)
  ret <- t(mu) %*% w
  risk <- quad_form(w, Sigma)
  constraints <- list(w >= 0, sum(w) == 1)

  ## Risk aversion parameters
  gammas <- 10^seq(-2, 3, length.out = SAMPLES)
  ret_data <- rep(0, SAMPLES)
  risk_data <- rep(0, SAMPLES)
  w_data <- matrix(0, nrow = SAMPLES, ncol = n)

  ## Compute trade-off curve
  for(i in 1:length(gammas)) {
    gamma <- gammas[i]
    objective <- ret - gamma * risk
    prob <- Problem(Maximize(objective), constraints)
    result <- solve(prob)
    expect_equal(result$status, "optimal")

    ## Evaluate risk/return for current solution
    risk_data[i] <- result$getValue(sqrt(risk))
    ret_data[i] <- result$getValue(ret)
    w_data[i,] <- result$getValue(w)
  }

  ## Plot trade-off curve
  plot(risk_data, ret_data, xlab = "Risk (Standard Deviation)", ylab = "Return", xlim = c(0, 4), ylim = c(0, 2), type = "l", lwd = 2, col = "blue")
  points(sqrt(diag(Sigma)), mu, col = "red", cex = 1.5, pch = 16)
  markers_on <- c(10, 20, 30, 40)
  for(marker in markers_on) {
    points(risk_data[marker], ret_data[marker], col = "black", cex = 1.5, pch = 15)
    nstr <- sprintf("%.2f", gammas[marker])
    text(risk_data[marker] + 0.2, ret_data[marker] - 0.05, bquote(paste(gamma, " = ", .(nstr))), cex = 1.5)
  }

  ## Plot weights for a few gamma
  w_plot <- t(w_data[markers_on,])
  colnames(w_plot) <- sprintf("%.2f", gammas[markers_on])
  barplot(w_plot, xlab = expression(paste("Risk Aversion (", gamma, ")", sep = "")), ylab = "Fraction of Budget")
})

test_that("Test Kelly gambling optimal bets", {
  skip_on_cran()
  print("KELLY")

  set.seed(1)
  n <- 20      ## Total bets
  K <- 100     ## Number of possible returns
  PERIODS <- 100
  TRIALS <- 5

  ## Generate return probabilities
  ps <- runif(K)
  ps <- ps/sum(ps)

  ## Generate matrix of possible returns
  rets <- runif(K*(n-1), 0.5, 1.5)
  shuff <- sample(1:length(rets), size = length(rets), replace = FALSE)
  rets[shuff[1:30]] <- 0      ## Set 30 returns to be relatively low
  rets[shuff[31:60]] <- 5     ## Set 30 returns to be relatively high
  rets <- matrix(rets, nrow = K, ncol = n-1)
  rets <- cbind(rets, rep(1, K))   ## Last column represents not betting

  ## Solve for Kelly optimal bets
  b <- Variable(n)
  obj <- Maximize(t(ps) %*% log(rets %*% b))
  constraints <- list(sum(b) == 1, b >= 0)
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  bets <- result$getValue(b)

  ## Naive betting scheme: bet in proportion to expected return
  bets_cmp <- matrix(0, nrow = n)
  bets_cmp[n] <- 0.15                  ## Hold 15% of wealth
  rets_avg <- ps %*% rets
  ## tidx <- order(rets_avg[-n], decreasing = TRUE)[1:9]
  tidx <- 1:(n-1)
  fracs <- rets_avg[tidx]/sum(rets_avg[tidx])
  bets_cmp[tidx] <- fracs*(1-bets_cmp[n])

  ## Calculate wealth over time
  wealth <- matrix(0, nrow = PERIODS, ncol = TRIALS)
  wealth_cmp <- matrix(0, nrow = PERIODS, ncol = TRIALS)
  for(i in 1:TRIALS) {
    sidx <- sample(1:K, size = PERIODS, replace = TRUE, prob = ps)
    winnings <- rets[sidx,] %*% bets
    wealth[,i] <- cumprod(winnings)

    winnings_cmp <- rets[sidx,] %*% bets_cmp
    wealth_cmp[,i] <- cumprod(winnings_cmp)
  }

  ## Plot Kelly optimal growth trajectories
  matplot(1:PERIODS, wealth, xlab = "Time", ylab = "Wealth", log = "y", type = "l", col = "red", lty = 1, lwd = 2)
  matlines(1:PERIODS, wealth_cmp, col = "blue", lty = 2, lwd = 2)
  legend("topleft", c("Kelly Optimal Bets", "Naive Bets"), col = c("red", "blue"), lty = c(1, 2), lwd = 2, bty = "n")
})

test_that("Test worst-case covariance", {
  skip_on_cran()
  print("WORST CASE")

  ## Problem data
  w <- matrix(c(0.1, 0.2, -0.05, 0.1))
  ## Constraint matrix:
  ## [[0.2, + ,  +,   +-],
  ##  [+,   0.1, -,   - ],
  ##  [+,   -,   0.3, + ],
  ##  [+-,  -,   +,  0.1]]

  ## Form problem
  Sigma <- Variable(4, 4, PSD = TRUE)
  obj <- Maximize(t(w) %*% Sigma %*% w)
  constraints <- list(Sigma[1,1] == 0.2, Sigma[2,2] == 0.1, Sigma[3,3] == 0.3, Sigma[4,4] == 0.1,
                      Sigma[1,2] >= 0, Sigma[1,3] >= 0, Sigma[2,3] <= 0, Sigma[2,4] <= 0, Sigma[3,4] >= 0)
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$status, "optimal")
  print(result$getValue(Sigma))

  ## Sigma_true <- rbind(c(0.2,    0.0978, 0,     0.0741),
  ##                     c(0.0978, 0.1,   -0.101, 0),
  ##                     c(0,     -0.101,  0.3,   0),
  ##                     c(0.0741, 0,      0,     0.1))

  ## The new SCS solver gives slightly different results from the above
  ## So the values below have been obtained from cvxpy 1.25.

  Sigma_true <- rbind(c(0.2,    0.09674, 0,     0.0762),
                      c(0.09674, 0.1,   -0.103, 0),
                      c(0,     -0.103,  0.3,   0.0041),
                      c(0.0762, 0,      .0041,     0.1))

  expect_equal(sqrt(result$value), 0.1232, tolerance = 1e-3)
  expect_equal(result$getValue(Sigma), Sigma_true, tolerance = 1e-3)

  ## Problem data
  n <- 5
  w <- rexp(n)
  w <- w / sum(w)
  mu <- abs(matrix(stats::rnorm(n), nrow = n, ncol = 1))/15
  Sigma_nom <- matrix(runif(n^2, -0.15, 0.8), nrow = n, ncol = n)
  Sigma_nom <- t(Sigma_nom) %*% Sigma_nom

  ## Known upper and lower bounds
  Delta <- matrix(0.2, nrow = n, ncol = n)
  diag(Delta) <- 0
  U <- Sigma_nom + Delta
  L <- Sigma_nom - Delta

  Sigma <- Variable(n, n, PSD = TRUE)
  obj <- quad_form(w, Sigma)
  constr <- list(L <= Sigma, Sigma <= U, Sigma == t(Sigma))
  prob <- Problem(Maximize(obj), constr)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
  print(result$getValue(Sigma))
})

test_that("Test sparse inverse covariance estimation", {
  skip_on_cran()
  library(Matrix)
  library(expm)
  print("SPARSE INV")

  set.seed(1)
  n <- 10      ## Dimension of matrix
  m <- 1000    ## Number of samples
  alphas <- c(10, 4, 1)

  ## Create sparse, symmetric PSD matrix S
  A <- rsparsematrix(n, n, 0.15, rand.x = stats::rnorm)
  Strue <- A %*% t(A) + 0.05 * diag(rep(1, n))    ## Force matrix to be strictly positive definite
  image(Strue != 0, main = "Inverse of true covariance matrix")

  ## Create covariance matrix associated with S
  R <- base::solve(Strue)

  ## Sample from distribution with covariance R
  ## If Y ~ N(0, I), then R^{1/2} * Y ~ N(0, R) since R is symmetric
  x_sample <- matrix(stats::rnorm(n*m), nrow = m, ncol = n) %*% t(expm::sqrtm(R))
  Q <- cov(x_sample)    ## Sample covariance matrix

  S <- Variable(n, n, PSD = TRUE) ## Variable constrained to positive semidefinite cone
  obj <- Maximize(log_det(S) - matrix_trace(S %*% Q))
  for(alpha in alphas) {
    constraints <- list(sum(abs(S)) <= alpha)

    ## Form and solve optimization problem
    prob <- Problem(obj, constraints)
    result <- solve(prob)
    expect_equal(result$status, "optimal")

    ## Create covariance matrix
    R_hat <- base::solve(result$getValue(S))
    Sres <- result$getValue(S)
    Sres[abs(Sres) <= 1e-4] <- 0
    title <- bquote(bold(paste("Estimated inv. cov matrix (", alpha, " = ", .(alpha), ")")))
    image(Sres != 0, main = title)
  }
})

test_that("Test fastest mixing Markov chain (FMMC)", {
  skip_on_cran()
  print("MCMC")

  ## Boyd, Diaconis, and Xiao. SIAM Rev. 46 (2004) pgs. 667-689 at pg. 672
  ## Form the complementary graph
  antiadjacency <- function(g) {
    n <- max(as.numeric(names(g)))   ## Assumes names are integers starting from 1
    a <- lapply(1:n, function(i) c())
    names(a) <- 1:n
    for(x in names(g)) {
      for(y in 1:n) {
        if(!(y %in% g[[x]]))
          a[[x]] <- c(a[[x]], y)
      }
    }
    a
  }

  ## Fastest mixing Markov chain on graph g
  FMMC <- function(g, verbose = FALSE) {
    a <- antiadjacency(g)
    n <- length(names(a))
    P <- Variable(n, n)
    o <- rep(1, n)
    objective <- Minimize(norm(P - 1.0/n, "2"))
    constraints <- list(P %*% o == o, t(P) == P, P >= 0)
    for(i in names(a)) {
      for(j in a[[i]]) {  ## (i-j) is a not-edge of g!
        idx <- as.numeric(i)
        if(idx != j)
          constraints <- c(constraints, P[idx,j] == 0)
      }
    }
    prob <- Problem(objective, constraints)
    result <- solve(prob)
    expect_equal(result$status, "optimal")
    if(verbose)
      cat("Status: ", result$status, ", Optimal Value = ", result$value)
    list(status = result$status, value = result$value, P = result$getValue(P))
  }

  disp_result <- function(states, P, tol = 1e-3) {
      rownames(P) <- states
      colnames(P) <- states
      print(P)

  }

  ## SIAM Rev. 46 examples pg. 674: Figure 1 and Table 1
  ## a) line graph L(4)
  g <- list("1" = 2, "2" = c(1,3), "3" = c(2,4), "4" = 3)
  result <- FMMC(g, verbose = TRUE)
  disp_result(names(g), result$P)

  ## b) triangle + one edge
  g <- list("1" = 2, "2" = c(1,3,4), "3" = c(2,4), "4" = c(2,3))
  result <- FMMC(g, verbose = TRUE)
  disp_result(names(g), result$P)

  ## c) bipartite 2 + 3
  g <- list("1" = c(2,4,5), "2" = c(1,3), "3" = c(2,4,5), "4" = c(1,3), "5" = c(1,3))
  result <- FMMC(g, verbose = TRUE)
  disp_result(names(g), result$P)

  ## d) square + central point
  g <- list("1" = c(2,3,5), "2" = c(1,4,5), "3" = c(1,4,5), "4" = c(2,3,5), "5" = c(1,2,3,4,5))
  result <- FMMC(g, verbose = TRUE)
  disp_result(names(g), result$P)
})

# Problem data
n <- 2
m <- 2
P <- rbind(c(0.75, 0.25),    # Channel transition matrix
           c(0.25, 0.75))

# Form problem
x <- Variable(n)   # Probability distribution of input signal x(t)
y <- P %*% x       # Probability distribution of output signal y(t)
c <- apply(P * log2(P), 2, sum)
I <- c %*% x + sum(entr(y))   # Mutual information between x and y
obj <- Maximize(I)
constraints <- list(sum(x) == 1, x >= 0)
prob <- Problem(obj, constraints)

result <- solve(prob)
result$value
result$getValue(x)

# Problem data
n <- 30
M <- 50
K <- 200

set.seed(n*M*K)
X <- matrix(rnorm(K*n), nrow = K, ncol = n)
beta_true <- matrix(rnorm(n), nrow = n, ncol = 1)
y <- X %*% beta_true + 0.3*sqrt(n)*rnorm(K)

# Order variables based on y
idx <- order(y, decreasing = FALSE)
y_ordered <- y[idx]
X_ordered <- X[idx,]

# Find cutoff and censor
D <- (y_ordered[M] + y_ordered[M+1])/2
y_censored <- pmin(y_ordered, D)

plot_results <- function(beta_res, title = "", bcol = "blue", bpch = 17) {
  plot(1:M, y_censored[1:M], col = "black", main = title, xlab = "Observations", ylab = "y", ylim = c(min(y), max(y)), xlim = c(1,K))
  points((M+1):K, y_ordered[(M+1):K], col = "red")
  points(1:K, X_ordered %*% beta_res, col = bcol, pch = bpch)
  abline(a = D, b = 0, col = "black", lty = "dashed")
  legend("topleft", c("Uncensored", "Censored", "Estimate"), col = c("black", "red", bcol), pch = c(1,1,bpch))
}

# Regular OLS
beta <- Variable(n)
obj <- sum((y_censored - X_ordered %*% beta)^2)
prob <- Problem(Minimize(obj))
result <- solve(prob)
beta_ols <- result$getValue(beta)
plot_results(beta_ols, "OLS on Censored")

# OLS using uncensored data
obj <- sum((y_censored[1:M] - X_ordered[1:M,] %*% beta)^2)
prob <- Problem(Minimize(obj))
result <- solve(prob)
beta_unc <- result$getValue(beta)
plot_results(beta_unc, "OLS on Uncensored")

# Censored regression
obj <- sum((y_censored[1:M] - X_ordered[1:M,] %*% beta)^2)
constr <- list(X_ordered[(M+1):K,] %*% beta >= D)
prob <- Problem(Minimize(obj), constr)
result <- solve(prob)
beta_cens <- result$getValue(beta)
plot_results(beta_cens, "Censored Regression")

# TODO_NARAS_12: Should we retire this test since it no longer exists in CVXPY?
context("test-g03-ls")
TOL <- 1e-6

test_that("Test regression", {
    ## Set the random seed to get consistent data
    skip_on_cran()
    set.seed(1)

    ## Number of examples to use
    n <- 100

    ## Specify the true value of the variable
    true_coeffs <- matrix(c(2, -2, 0.5), nrow = 3, ncol = 1)

    ## Generate data
    x_data <- matrix(stats::runif(n) * 5, nrow = n, ncol = 1)
    x_data_expanded <- cbind(x_data, x_data^2, x_data^3)
    y_data <- x_data_expanded %*% true_coeffs + 0.5 * matrix(stats::runif(n, 1), nrow = n, ncol = 1)

    slope <- Variable()
    offset <- Variable()
    line <- offset + x_data * slope
    residuals <- line - y_data
    fit_error <- sum_squares(residuals)
    result <- solve(Problem(Minimize(fit_error), list()))
    ## result <- solve(Problem(Minimize(fit_error), list()), solver = "LS")
    ## optval <- result$value
    ## expect_equal(optval, 1171.60037715, tolerance = TOL)

    quadratic_coeff <- Variable()
    slope <- Variable()
    offset <- Variable()
    quadratic <- offset + x_data * slope + quadratic_coeff * x_data^2
    residuals <- quadratic - y_data
    fit_error <- sum_squares(residuals)
    ## result <- solve(Problem(Minimize(fit_error), list()), solver = "LS")
    result2 <- solve(Problem(Minimize(fit_error), list()), solver = "ECOS")
    ## optval <- result$value
    optval2 <- result2$value
    ## expect_equal(optval, 139.225650756, tolerance = TOL)
    expect_equal(optval2, 109.639449308, tolerance = TOL)
})

test_that("Test control", {
    ## Some constraints on our motion
    ## The object should start from the origin and end at rest
    skip_on_cran()
    initial_velocity <- matrix(c(-20, 100), nrow = 2, ncol = 1)
    final_position <- matrix(c(100, 100), nrow = 2, ncol = 1)

    Tnum <- 5  ## The number of timesteps
    h <- 0.1   ## The time between time intervals
    mass <- 1  ## Mass of object
    drag <- 0.1  ## Drag on object
    g <- matrix(c(0, -9.8), nrow = 2, ncol = 1)   ## Gravity on object

    ## Declare the variables we need
    position <- Variable(2, Tnum)
    velocity <- Variable(2, Tnum)
    force <- Variable(2, Tnum-1)

    ## Create a problem instance
    mu <- 1
    constraints <- list()

    ## Add constraints on our variables
    for(i in 1:(Tnum-1)) {
        constraints <- c(constraints, position[,i+1] == position[,i] + h * velocity[,i])
        acceleration <- force[,i]/mass + g - drag * velocity[,i]
        constraints <- c(constraints, velocity[,i+1] == velocity[,i] + h * acceleration)
    }

    ## Add position constraints
    constraints <- c(constraints, position[,1] == 0)
    constraints <- c(constraints, position[,Tnum] == final_position)

    ## Add velocity constraints
    constraints <- c(constraints, velocity[,1] == initial_velocity)
    constraints <- c(constraints, velocity[,Tnum] == 0)

    ## Solve the problem
    result <- solve(Problem(Minimize(sum_squares(force)), constraints))   ## TODO: Remove once LS solver is implemented.
    ## result <- solve(Problem(Minimize(sum_squares(force)), constraints), solver = "LS")
    ## optval <- result$value
    ## expect_equal(optval, 17859.0, tolerance = 1)
})

test_that("Test sparse system", {
    skip_on_cran()
    m <- 1000
    n <- 800
    r <- 700

    set.seed(1)
    density <- 0.2
    A <- Matrix::rsparsematrix(m, n, density, rand.x = stats::runif)
    b <- matrix(stats::rnorm(m), nrow = m, ncol = 1)
    G <- Matrix::rsparsematrix(r, n, density, rand.x = stats::runif)
    h <- matrix(stats::rnorm(r), nrow = r, ncol = 1)

    x <- Variable(n)
    result <- solve(Problem(Minimize(sum_squares(A %*% x - b)), list(G %*% x == h)))
    ## result <- solve(Problem(Minimize(sum_squares(A %*% x - b)), list(G %*% x == h)), solver = "LS")
    optval <- result$value
    expect_equal(optval, 6542.100424497, tolerance = TOL)
})

test_that("Test equivalent forms", {
    skip_on_cran()
    m <- 100
    n <- 80
    r <- 70

    set.seed(1)
    A <- matrix(stats::rnorm(m*n), nrow = m, ncol = n)
    b <- matrix(stats::rnorm(m), nrow = m, ncol = 1)
    G <- matrix(stats::rnorm(r*n), nrow = r, ncol = n)
    h <- matrix(stats::rnorm(r), nrow = r, ncol = 1)

    ## ||Ax-b||^2 = x^T (A^T A) x - 2(A^T b)^T x + ||b||^2
    P <- t(A) %*% A
    q <- -2 * t(A) %*% b
    r <- t(b) %*% b

    Pinv <- base::solve(P)

    x <- Variable(n)

    obj1 <- sum_squares(A %*% x - b)
    obj2 <- sum_entries((A %*% x - b)^2)
    obj3 <- quad_form(x, P) + t(q) %*% x + r
    obj4 <- matrix_frac(x, Pinv) + t(q) %*% x + r

    cons <- list(G %*% x == h)

    v1 <- solve(Problem(Minimize(obj1), cons), solver = "ECOS")$value
    v2 <- solve(Problem(Minimize(obj2), cons), solver = "ECOS")$value
    v3 <- solve(Problem(Minimize(obj3), cons), solver = "ECOS")$value
    ## v1 <- solve(Problem(Minimize(obj1), cons), solver = "LS")$value
    ## v2 <- solve(Problem(Minimize(obj2), cons), solver = "LS")$value
    ## v3 <- solve(Problem(Minimize(obj3), cons), solver = "LS")$value
    ## v4 <- solve(Problem(Minimize(obj4), cons), solver = "LS")$value

    expect_equal(v1, 622.204576157, tolerance = TOL)
    expect_equal(v2, 622.204576157, tolerance = TOL)
    expect_equal(v3, 622.204576157, tolerance = TOL)
    ## expect_equal(v4, 622.204576157, tolerance = TOL)
})

test_that("Test smooth ridge", {
    skip_on_cran()
    set.seed(1)
    n <- 500
    k <- 50
    delta <- 1
    eta <- 1

    A <- matrix(stats::runif(k*n), nrow = k, ncol = n)
    b <- matrix(stats::runif(k), nrow = k, ncol = 1)
    x <- Variable(n)
    obj <- sum_squares(A %*% x - b) + delta*sum_squares(x[1:(n-1)]-x[2:n]) + eta*sum_squares(x)
    optval <- solve(Problem(Minimize(obj)))$value
    ## optval <- solve(Problem(Minimize(obj), list()), solver = "LS")$value
    expect_equal(optval, 0.208432916, tolerance = TOL)
})

context("test-g05-cbc")
TOL <- 1e-6

a <- Variable(name='a')
b <- Variable(name='b')
c <- Variable(name='c')

x <- Variable(2, name='x')
y <- Variable(3, name='y')
z <- Variable(2, name='z')

A <- Variable(2, 2, name='A')
B <- Variable(2, 2, name='B')
C <- Variable(3, 2, name='C')

CBC_AVAILABLE <- "CBC" %in% installed_solvers()

test_that("Test basic LPs", {
    skip_on_cran()
    skip_if_not(CBC_AVAILABLE, "Skipping CBC test as it is not available.!")
    ## TODO: This _used to be_ a bug in the rcbc library. NOW FIXED!
    prob <- Problem(Minimize(0), list(x == 2))
    result <- solve(prob, verbose = FALSE, solver = "CBC")
    expect_equal(result$value, 0, tolerance = TOL)
    expect_equal(result$getValue(x), matrix(c(2,2)), tolerance = TOL)

    prob <- Problem(Minimize(-a), list(a <= 1))
    result <- solve(prob, verbose = FALSE, solver = "CBC")
    expect_equal(result$value, -1, tolerance = TOL)
    expect_equal(result$getValue(a), 1, tolerance = TOL)
})

test_that("Test a basic LP", {
    skip_on_cran()
    skip_if_not(CBC_AVAILABLE, "Skipping CBC test as it is not available.!")
    prob <- Problem(Minimize(p_norm(x, 1)), list(x == 0))
    result <- solve(prob, verbose = FALSE, solver = "CBC")
    expect_equal(result$value, 0, tolerance = TOL)
    expect_equal(result$getValue(x), matrix(c(0,0)), tolerance = TOL)

    # Example from
    # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
    objective <- Minimize(-4*x[1] - 5*x[2])
    constraints <- list(2*x[1] +   x[2] <= 3,
                          x[1] + 2*x[2] <= 3,
                          x[1] >= 0,
                          x[2] >= 0)
    prob <- Problem(objective, constraints)
    result <- solve(prob, verbose = FALSE, solver = "CBC")
    expect_equal(result$value, -9, tolerance = TOL)
    expect_equal(result$getValue(x), matrix(c(1,1)), tolerance = TOL)
})

test_that("Test a basic MILP", {
  skip_on_cran()
  skip_if_not(CBC_AVAILABLE, "Skipping CBC test as it is not available.!")
  bool_var <- Variable(boolean = TRUE)
  int_var <- Variable(integer = TRUE)
  prob <- Problem(Minimize(p_norm(x, 1)),
                  list(x == bool_var, bool_var == 0))
  result <- solve(prob, verbose = FALSE, solver = "CBC")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 0, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(0,0)), tolerance = TOL)

    # Example from
    # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] +   x[2] <= int_var,
                      x[1] + 2*x[2] <= 3*bool_var,
                      x[1] >= 0,
                      x[2] >= 0,
                      int_var == 3*bool_var,
                      int_var == 3)
  prob <- Problem(objective, constraints)
  result <- solve(prob, verbose = FALSE, solver = "CBC")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(int_var), 3, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 1, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1,1)), tolerance = TOL)
})

test_that("Test a hard knapsack problem", {
  skip_on_cran()
  skip_if_not(CBC_AVAILABLE, "Skipping CBC test as it is not available.!")
    ## Instance "knapPI_1_50_1000_1" from "http://www.diku.dk/~pisinger/genhard.c"
  n <- 50
  c <- 995
  z <- 8373
  coeffs <- rbind(c(1,   94, 485, 0), c(2,  506, 326, 0), c(3,  416, 248, 0),
                  c(4,  992, 421, 0), c(5,  649, 322, 0), c(6,  237, 795, 0),
                  c(7,  457,  43, 1), c(8,  815, 845, 0), c(9,  446, 955, 0),
                  c(10, 422, 252, 0), c(11, 791,   9, 1), c(12, 359, 901, 0),
                  c(13, 667, 122, 1), c(14, 598,  94, 1), c(15,   7, 738, 0),
                  c(16, 544, 574, 0), c(17, 334, 715, 0), c(18, 766, 882, 0),
                  c(19, 994, 367, 0), c(20, 893, 984, 0), c(21, 633, 299, 0),
                  c(22, 131, 433, 0), c(23, 428, 682, 0), c(24, 700,  72, 1),
                  c(25, 617, 874, 0), c(26, 874, 138, 1), c(27, 720, 856, 0),
                  c(28, 419, 145, 0), c(29, 794, 995, 0), c(30, 196, 529, 0),
                  c(31, 997, 199, 1), c(32, 116, 277, 0), c(33, 908,  97, 1),
                  c(34, 539, 719, 0), c(35, 707, 242, 0), c(36, 569, 107, 0),
                  c(37, 537, 122, 0), c(38, 931,  70, 1), c(39, 726,  98, 1),
                  c(40, 487, 600, 0), c(41, 772, 645, 0), c(42, 513, 267, 0),
                  c(43,  81, 972, 0), c(44, 943, 895, 0), c(45,  58, 213, 0),
                  c(46, 303, 748, 0), c(47, 764, 487, 0), c(48, 536, 923, 0),
                  c(49, 724,  29, 1), c(50, 789, 674, 0))  # index, p / w / x

  X <- Variable(n, boolean = TRUE)
  prob <- Problem(Maximize(sum(multiply(coeffs[,2], X))),
                  list(sum(multiply(coeffs[,3], X)) <= c))
  result <- solve(prob, verbose = FALSE, solver = "CBC")
  expect_equal(result$value, z, tolerance = TOL)   # objective
})

test_that("Test that all CBC solver options work", {
  skip_on_cran()
  skip_if_not(CBC_AVAILABLE, "Skipping CBC test as it is not available.!")
  prob <- Problem(Minimize(p_norm(x, 1)),
                  list(x == Variable(2, boolean = TRUE)))
  for(i in 1:2) {
      # Some cut-generators seem to be buggy for now -> set to false
      # result <- solve(prob, verbose = TRUE, solver = "CBC", GomoryCuts = TRUE, MIRCuts = TRUE,
      #            MIRCuts2 = TRUE, TwoMIRCuts = TRUE, ResidualCapacityCuts = TRUE,
      #            KnapsackCuts = TRUE, FlowCoverCuts = TRUE, CliqueCuts = TRUE,
      #            LiftProjectCuts = TRUE, AllDifferentCuts = FALSE, OddHoleCuts = TRUE,
      #            RedSplitCuts = FALSE, LandPCuts = FALSE, PreProcessCuts = FALSE,
      #            ProbingCuts = TRUE, SimpleRoundingCuts = TRUE)
      result <- solve(prob, verbose = TRUE, solver = "CBC", maximumSeconds = 100)
      expect_equal(result$getValue(x), matrix(c(0,0)), tolerance = TOL)
  }
})

context("test-g01-mosek_conif")

MOSEK_AVAILABLE  <- "MOSEK" %in% installed_solvers()
TOL <- 1e-6

if (MOSEK_AVAILABLE) library("Rmosek")

test_that("test MOSEK SOCP", {
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")

  # Formulate the following SOCP with CVXR
  #    min 3 * x[1] + 2 * x[2] + x[3]
  #       s.t. p_norm(x,2) <= y[1]
  #            p_norm(x,2) <= y[2]
  #            x[1] + x[2] + 3*x[3] >= 1.0
  #            y <= 5
  # and solve with MOSEK and ECOS. Compare MOSEK and ECOS primal and dual solutions.

  x <- Variable(3)
  y <- Variable(2)
  constraints <- list(p_norm(x, 2) <= y[1],
                      p_norm(x, 2) <= y[2],
                      x[1] + x[2] + 3 * x[3] >= 1.0,
                      y <= 5)
  obj <- Minimize(3 * x[1] + 2 * x[2] + x[3])
  prob <- Problem(obj, constraints)
  result_mosek <- solve(prob, solver = "MOSEK")
  x_mosek <- result_mosek$getValue(x)
  duals_mosek <- lapply(constraints, function(c) { result_mosek$getDualValue(c) })

  result_ecos <- solve(prob, solver = "ECOS")
  x_ecos <- result_ecos$getValue(x)
  duals_ecos <- lapply(constraints, function(c) { result_ecos$getDualValue(c) })

  expect_equal(x_mosek, x_ecos, tolerance = TOL)
  expect_equal(length(duals_ecos), length(duals_mosek))
  for(i in seq_along(duals_mosek)) {
      expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = 1e-4)
  }

})

test_that("test MOSEK SDP", {
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")
  # Solve "Example 8.3" from Convex Optimization by Boyd & Vandenberghe.
  # Verify (1) optimal objective values, (2) that the dual variable to the PSD constraint
  # belongs to the correct cone (i.e. the dual variable is itself PSD), and (3) that
  # complementary slackness holds with the PSD primal variable and its dual variable.

  # This is an example from Convex Optimization by B&V.
  # Example 8.3 (page 408 in the 19th printing).
  rho <- Variable(4, 4)
  constraints <- list(0.6 <= rho[1, 2], rho[1, 2] <= 0.9,
                      0.8 <= rho[1, 3], rho[1, 3] <= 0.9,
                      0.5 <= rho[2, 4], rho[2, 4] <= 0.7,
                      -0.8 <= rho[3, 4], rho[3, 4] <= -0.4,
                      rho[1, 1] == 1, rho[2, 2] == 1, rho[3, 3] == 1, rho[4, 4] == 1,
                      rho %>>% 0)

  # First, minimize rho[1, 4]
  obj <- Minimize(rho[1, 4])
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(round(result$value, 2), -0.39)
  Y <- result$getDualValue(constraints[[length(constraints)]])
  eigs <- eigen(Y, only.values = TRUE)
  expect_true(all(eigs$value >= 0))
  complementary_slackness <- sum(diag(result$getValue(rho) %*% Y))
  expect_equal(complementary_slackness, 0.0, tolereance = TOL)

  # Then, maximize rho[1, 4]
  obj <- Maximize(rho[1, 4])
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(round(result$value, 2), 0.23)
  Y <- result$getDualValue(constraints[[length(constraints)]])
  eigs <- eigen(Y, only.values = TRUE)
  expect_true(all(eigs$value >= 0))
  complementary_slackness <- sum(diag(result$getValue(rho) %*% Y))
  expect_equal(complementary_slackness, 0.0, tolerance = TOL)
})

test_that("test MOSEK exponential cone", {
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")
  # Formulate the following exponential cone problem with cvxpy
  #   min   3 * x[1] + 2 * x[2] + x[3]
  #     s.t.  0.1 <= x[1] + x[2] + x[3] <= 1
  #           x >= 0
  #           x[1] >= x[2] * exp(x[3] / x[2])
  # and solve with MOSEK and ECOS. Ensure that MOSEK and ECOS have the same
  # primal and dual solutions.
  #
  # Note that the exponential cone constraint can be rewritten in terms of the
  # relative entropy cone. The correspondence is as follows:
  #     x[1] >= x[2] * exp(x[3] / x[2])
  #       iff
  #     x[2] * log(x[2] / x[1]) + x[3] <= 0.

  ## TODO: Only run if exponential cone is supported.
  ## Formulate and solve the problem with CVXR
  x <- Variable(3, 1)
  constraints <- list(sum(x) <= 1.0, sum(x) >= 0.1, x >= 0.01,
                      kl_div(x[2], x[1]) + x[2] - x[1] + x[3] <= 0)
  obj <- Minimize(3 * x[1] + 2 * x[2] + x[1])
  prob <- Problem(obj, constraints)
  result_mosek <- solve(prob, solver = "MOSEK")
  val_mosek = result_mosek$value
  x_mosek = result_mosek$getValue(x)
  duals_mosek = lapply(constraints, function(c) { result_mosek$getDualValue(c) })

  result_ecos <- solve(prob, solver = "ECOS")
  val_ecos = result_ecos$value
  x_ecos = result_ecos$getValue(x)
  duals_ecos = lapply(constraints, function(c) { result_ecos$getDualValue(c) })

  ## Verify results
  expect_equal(val_mosek, val_ecos, tolerance = TOL)
  expect_equal(x_mosek, x_ecos, tolerance = 1e-4)
  expect_equal(length(duals_ecos), length(duals_mosek))
  for(i in seq_along(duals_mosek))
      expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = 1e-4)
})

test_that("test MOSEK MI SOCP", {
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")

  # Formulate the following mixed-integer SOCP with CVXR
  #   min 3 * x[1] + 2 * x[2] + x[3] + y[1] + 2 * y[2]
  #     s.t. p_norm(x,2) <= y[1]
  #          p_norm(x,2) <= y[2]
  #          x[1] + x[2] + 3*x[3] >= 0.1
  #          y <= 5, y integer.
  # and solve with MOSEK.

  x <- Variable(3)
  y <- Variable(2, integer = TRUE)
  constraints <- list(p_norm(x, 2) <= y[1],
                      p_norm(x, 2) <= y[2],
                      x[1] + x[2] + 3 * x[3] >= 0.1,
                      y <= 5)
  obj <- Minimize(3 * x[1] + 2 * x[2] + x[3] + y[1] + 2 * y[2])
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$getValue(y), as.matrix(c(1,1)), tolerance = TOL)
})

test_that("test MOSEK LP solution selection", {
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")
  # Problem from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp

  x <- Variable(2)
  objective <- Minimize(-4 * x[1] - 5 * x[2])
  constraints <- list(2 * x[1] + x[2] <= 3,
                      x[1] + 2 * x[2] <= 3,
                      x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)

  # Default solution (interior point)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1,1)), tolerance = 1e-5)

  # NOTE: Rmosek does not provide the bfs option.
  # Basic feasible solution
  # result <- solve(prob, solver = "MOSEK", bfs = TRUE)
  # expect_equal(result$value, -9, tolerance = 1e-10)
  # expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = 1e-10)

})

context("test-g01-convolution")
TOL <- 1e-6

test_that("test 1D convolution", {
  skip_on_cran()
  n <- 3
  x <- Variable(n)
  f <- c(1, 2, 3)
  g <- c(0, 1, 0.5)
  f_conv_g <- c(0, 1, 2.5, 4, 1.5)
  expr <- conv(f, g)
  expect_true(is_constant(expr))
  expect_equal(dim(expr), c(5, 1))
  expect_equal(value(expr), f_conv_g)

  expr <- conv(f, x)
  expect_true(is_affine(expr))
  expect_equal(dim(expr), c(5, 1))

  # Matrix stuffing
  t <- Variable()
  prob <- Problem(Minimize(p_norm(expr, 1)), list(x == g))
  result <- solve(prob)
  expect_equal(result$value, sum(f_conv_g), tolerance = 1e-3)
  expect_equal(result$getValue(expr), f_conv_g, tolerance = TOL)
})

test_that("test a problem with convolution", {
  skip_on_cran()
  N <- 5
  y <- matrix(stats::rnorm(N), nrow = N, ncol = 1)
  h <- matrix(stats::rnorm(2), nrow = 2, ncol = 1)
  x <- Variable(N)
  v <- conv(h, x)
  obj <- Minimize(sum(y * v[1:N]))
  result <- solve(Problem(obj, list()))
  expect_equal(result$status, "unbounded")
})

context("test-g01-problem")
TOL <- 1e-6

a <- Variable(name = "a")
b <- Variable(name = "b")
c <- Variable(name = "c")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

ConicSolver <- CVXR:::ConicSolver
INSTALLED_SOLVERS <- installed_solvers()
SCS.dims_to_solver_dict <- CVXR:::SCS.dims_to_solver_dict
ECOS.dims_to_solver_dict <- CVXR:::ECOS.dims_to_solver_dict
.p_norm <- CVXR:::.p_norm

test_that("test the variables method", {
  skip_on_cran()
  p <- Problem(Minimize(a), list(a <= x, b <= A + 2))
  vars_ <- variables(p)
  ref <- list(a, x, b, A)
  mapply(function(v, r) { expect_equal(v, r) }, vars_, ref)
})

test_that("test the parameters method", {
  skip_on_cran()
  p1 <- Parameter()
  p2 <- Parameter(3, nonpos = TRUE)
  p3 <- Parameter(4, 4, nonneg = TRUE)
  p <- Problem(Minimize(p1), list(a + p1 <= p2, b <= p3 + p3 + 2))
  params <- parameters(p)
  ref <- c(p1, p2, p3)
  mapply(function(p, r) { expect_equal(p, r) }, params, ref)
})

test_that("test the constants method", {
  skip_on_cran()
  c1 <- matrix(stats::rnorm(2), nrow = 1, ncol = 2)
  c2 <- matrix(stats::rnorm(2), nrow = 2, ncol = 1)
  p <- Problem(Minimize(c1 %*% x), list(x >= c2))
  constants_ <- constants(p)
  ref <- list(c1, c2)
  expect_equal(length(constants_), length(ref))
  mapply(function(c, r) {
    expect_equal(dim(c), dim(r))
    expect_true(all(value(c) == r))
  }, constants_, ref)

  # Single scalar constants
  p <- Problem(Minimize(a), list(x >= 1))
  constants_ <- constants(p)
  ref <- list(matrix(1))
  expect_equal(length(ref), length(constants_))
  mapply(function(c, r) {
    expect_equal(dim(c), dim(r))
    expect_true(all(value(c) == r))
  }, constants_, ref)
})

test_that("Test the size_metrics method", {
  skip_on_cran()
  p1 <- Parameter()
  p2 <- Parameter(3, nonpos = TRUE)
  p3 <- Parameter(4, 4, nonneg = TRUE)

  c1 <- matrix(stats::rnorm(2), nrow = 2, ncol = 1)
  c2 <- matrix(stats::rnorm(2), nrow = 1, ncol = 2)
  constants <- c(2, as.numeric(c2 %*% c1))

  p <- Problem(Minimize(p1), list(a + p1 <= p2, b <= p3 + p3 + constants[1], c == constants[2]))

  # num_scalar variables
  n_variables <- size_metrics(p)@num_scalar_variables
  ref <- size(a) + size(b) + size(c)
  expect_equal(n_variables, ref)

  # num_scalar_data
  n_data <- size_metrics(p)@num_scalar_data
  ref <- size(p1) + size(p2) + size(p3) + length(constants)  # 2 and c2 %*% c1 are both single scalar constants
  expect_equal(n_data, ref)

  # num_scalar_eq_constr
  n_eq_constr <- size_metrics(p)@num_scalar_eq_constr
  ref <- prod(dim(c2 %*% c1))
  expect_equal(n_eq_constr, ref)

  # num_scalar_leq_constr
  n_leq_constr <- size_metrics(p)@num_scalar_leq_constr
  ref <- size(p3) + size(p2)
  expect_equal(n_leq_constr, ref)

  # max_data_dimension
  max_data_dim <- size_metrics(p)@max_data_dimension
  ref <- max(dim(p3))
  expect_equal(max_data_dim, ref)
})

test_that("Test the solver_stats method", {
  skip_on_cran()
  prob <- Problem(Minimize(p_norm(x)), list(x == 0))
  result <- solve(prob, solver = "ECOS")
  expect_true(result$solve_time > 0)
  expect_true(result$setup_time > 0)
  expect_true(result$num_iters > 0)
})

test_that("Test the get_problem_data method", {
  skip_on_cran()
  data <- get_problem_data(Problem(Minimize(exp(a) + 2)), "SCS")[[1]]
  dims <- data[[ConicSolver()@dims]]
  expect_equal(dims@exp, 1)
  expect_equal(length(data[["c"]]), 2)
  expect_equal(dim(data[["A"]]), c(3,2))

  data <- get_problem_data(Problem(Minimize(p_norm(x) + 3)), "ECOS")[[1]]
  dims <- data[[ConicSolver()@dims]]
  expect_equal(dims@soc, list(3))
  expect_equal(length(data[["c"]]), 3)
  expect_equal(dim(data[["A"]]), c(0,0))
  expect_equal(dim(data[["G"]]), c(3,3))

  if("CVXOPT" %in% INSTALLED_SOLVERS) {
    data <- get_problem_data(Problem(Minimize(p_norm(x) + 3)), "CVXOPT")[[1]]
    dims <- data[["dims"]]
    expect_equal(dims@soc, list(3))
    # TODO: We cannot test whether the coefficients or offsets were correctly parsed until we update the CVXOPT interface.
  }
})

test_that("Test unpack results method", {
  skip_on_cran()
  prob <- Problem(Minimize(exp(a)), list(a == 0))
  tmp <- get_problem_data(prob, solver = "SCS")
  args <- tmp[[1]]
  chain <- tmp[[2]]
  inv <- tmp[[3]]
  data <- list(c = args[["c"]], A = args[["A"]], b = args[["b"]])
  cones <- SCS.dims_to_solver_dict(args[[ConicSolver()@dims]])
  solution <- scs::scs(A = data$A, b = data$b, obj = data$c, cone = cones)
  prob <- Problem(Minimize(exp(a)), list(a == 0))
  result <- unpack_results(prob, solution, chain, inv)
  expect_equal(result$getValue(a), 0, tolerance = 1e-3)
  expect_equal(result$value, 1, tolerance = 1e-3)
  expect_equal(result$status, "optimal")

  prob <- Problem(Minimize(p_norm(x)), list(x == 0))
  tmp <- get_problem_data(prob, solver = "ECOS")
  args <- tmp[[1]]
  chain <- tmp[[2]]
  inv <- tmp[[3]]
  cones <- ECOS.dims_to_solver_dict(args[[ConicSolver()@dims]])
  solution <- ECOSolveR::ECOS_csolve(args[["c"]], args[["G"]], args[["h"]], cones, args[["A"]], args[["b"]])
  prob <- Problem(Minimize(p_norm(x)), list(x == 0))
  result <- unpack_results(prob, solution, chain, inv)
  expect_equal(result$getValue(x), matrix(c(0,0)))
  expect_equal(result$value, 0)
  expect_equal(result$status, "optimal")
})

# test_that("Test silencing and enabling solver messages", {
# })

# test_that("Test registering other solve methods", {
#  Problem.register_solve("test", function(self) { 1 })
#  p <- Problem(Minimize(1))
#  result <- solve(p, method = "test")
#  expect_equal(result$value, 1)
#
#  test <- function(self, a, b = 2) { c(a, b) }
#  Problem.register_solve("test", test)
#  p <- Problem(Minimize(0))
#  result <- solve(p, 1, b = 3, method = "test")
#  expect_equal(result$value, c(1,3))
#  result <- solve(p, 1, method = "test")
#  expect_equal(result$value, c(1,2))
#  result <- solve(p, 1, method = "test", b = 4)
#  expect_equal(result$value, c(1,4))
# })

# TODO: Adapt this test to the reduction infrastructure.
# test_that("Test that variables and constraints keep a consistent order", {
#   num_solves <- 4
#   vars_lists <- list()
#   ineqs_lists <- list()
#   var_ids_order_created <- list()
#   for(k in 1:num_solves) {
#     sum <- 0
#     constraints <- list()
#     var_ids <- c()
#     for(i in 1:100) {
#       var <- Variable(name = as.character(i))
#       var_ids <- c(var_ids, var@id)
#       sum <- sum + var
#       constraints <- c(constraints, list(var >= i))
#     }
#     var_ids_order_created <- c(var_ids_order_created, list(var_ids))
#     obj <- Minimize(sum)
#     p <- Problem(obj, constraints)
#     canon <- canonicalize(p)
#     objective <- canon[[1]]
#     constraints <- canon[[2]]
#     sym_data <- SymData(objective, constraints, ECOS())
#
#     # Sort by offset
#     offsets <- sym_data@.var_offsets
#     vars_ <- as.numeric(names(sort(offsets, decreasing = FALSE)))
#     vars_lists <- c(vars_lists, list(vars_))
#     ineqs_lists <- c(ineqs_lists, list(sym_data@.constr_map[[LEQ_MAP]]))
#   }
#
#   # Verify order of variables is consistent
#   for(i in 1:num_solves)
#     expect_equal(var_ids_order_created[[i]], vars_lists[[i]])
#
#   for(i in 1:num_solves) {
#     idx <- 1
#     for(constr in ineqs_lists[[i]]) {
#       var_tmp <- get_expr_vars(constr$expr)[[1]]
#       var_id <- as.numeric(var_tmp[[1]])
#       expect_equal(var_ids_order_created[[i]][idx], var_id)
#       idx <- idx + 1
#     }
#   }
# })

# TODO: Adapt this test to the reduction infrastructure.
# test_that("Test removing duplicate constraints objects", {
#   eq <- (x == 2)
#   le <- (x <= 2)
#   obj <- 0
#
#   test <- function(self) {
#     canon <- canonicalize(self)
#     objective <- canon[[1]]
#     constraints <- canon[[2]]
#     sym_data <- SymData(objective, constraints)
#     list(length(sym_data@constr_map[EQ_MAP]), length(sym_data@constr_map[LEQ_MAP]))
#   }
#   # Problem.register_solve("test", test)
#   # p <- Problem(Minimize(obj), list(eq, eq, le, le))
#   # result <- solve(p, method = "test")
#   # expect_equal(result$value, c(1,1))
#
#   # Internal constraints
#   X <- Semidef(2)
#   obj <- sum_entries(X + X)
#   p <- Problem(Minimize(obj))
#   # result <- solve(p, method = "test")
#   # expect_equal(result$value, c(0,1))
#
#   # Duplicates from non-linear constraints
#   # exp <- norm(x, "2")
#   # prob <- Problem(Minimize(0), list(exp <= 1, exp <= 2))
#   # result <- solve(prob, method = "test")
#   # expect_equal(result$value, c(0,4))
# })

test_that("test the is_dcp method", {
  skip_on_cran()
  p <- Problem(Minimize(norm_inf(a)))
  expect_true(is_dcp(p))

  p <- Problem(Maximize(norm_inf(a)))
  expect_false(is_dcp(p))
  expect_error(solve(p))
})

test_that("test the is_qp method", {
  skip_on_cran()
  A <- matrix(rnorm(4*3), nrow = 4, ncol = 3)
  b <- matrix(rnorm(4), nrow = 4)
  Aeq <- matrix(rnorm(2*3), nrow = 2, ncol = 3)
  beq <- matrix(rnorm(2), nrow = 2, ncol = 1)
  Fmat <- matrix(rnorm(2*3), nrow = 2, ncol = 3)
  g <- matrix(rnorm(2), nrow = 2, ncol = 1)
  obj <- sum_squares(A %*% y - b)
  qpwa_obj <- 3*sum_squares(-abs(A %*% y)) + quad_over_lin(max_elemwise(abs(A %*% y), rep(3, 4)), 2)
  not_qpwa_obj <- 3*sum_squares(abs(A %*% y)) + quad_over_lin(min_elemwise(abs(A %*% y), rep(3, 4)), 2)

  p <- Problem(Minimize(obj), list())
  expect_true(is_qp(p))

  p <- Problem(Minimize(qpwa_obj), list())
  expect_true(is_qp(p))

  p <- Problem(Minimize(not_qpwa_obj), list())
  expect_false(is_qp(p))

  p <- Problem(Minimize(obj), list(Aeq %*% y == beq, Fmat %*% y <= g))
  expect_true(is_qp(p))

  p <- Problem(Minimize(obj), list(max_elemwise(1, 3*y) <= 200, abs(2*y) <= 100, p_norm(2*y, 1) <= 1000, Aeq %*% y == beq))
  expect_true(is_qp(p))

  p <- Problem(Minimize(qpwa_obj), list(max_elemwise(1, 3*y) <= 200, abs(2*y) <= 100, p_norm(2*y, 1) <= 1000, Aeq %*% y == beq))
  expect_true(is_qp(p))

  p <- Problem(Minimize(obj), list(max_elemwise(1, 3*y^2) <= 200))
  expect_false(is_qp(p))

  p <- Problem(Minimize(qpwa_obj), list(max_elemwise(1, 3*y^2) <= 200))
  expect_false(is_qp(p))
})

test_that("test problems involving variables with the same name", {
  skip_on_cran()
  var <- Variable(name = "a")
  p <- Problem(Maximize(a + var), list(var == 2 + a, var <= 3))
  result <- solve(p)
  expect_equal(result$value, 4.0, tolerance = TOL)
  expect_equal(result$getValue(a), 1, tolerance = TOL)
  expect_equal(result$getValue(var), 3, tolerance = TOL)
})

test_that("test adding problems", {
  skip_on_cran()
  prob1 <- Problem(Minimize(a), list(a >= b))
  prob2 <- Problem(Minimize(2*b), list(a >= 1, b >= 2))
  prob_minimize <- prob1 + prob2
  expect_equal(length(prob_minimize@constraints), 3)
  result <- solve(prob_minimize)
  expect_equal(result$value, 6, tolerance = TOL)

  prob3 <- Problem(Maximize(a), list(b <= 1))
  prob4 <- Problem(Maximize(2*b), list(a <= 2))
  prob_maximize <- prob3 + prob4
  expect_equal(length(prob_maximize@constraints), 2)
  result <- solve(prob_maximize)
  expect_equal(result$value, 4, tolerance = TOL)

  # Test using the sum function
  prob5 <- Problem(Minimize(3*a))
  prob_sum <- Reduce("+", list(prob1, prob2, prob5))
  expect_equal(length(prob_sum@constraints), 3)
  result <- solve(prob_sum)
  expect_equal(result$value, 12, tolerance = TOL)
  prob_sum <- Reduce("+", list(prob1))
  expect_equal(length(prob_sum@constraints), 1)

  # Test Minimize + Maximize
  expect_error(prob_bad_sum <- prob1 + prob3, "Problem does not follow DCP rules")
})

test_that("test problem multiplication by scalar", {
  skip_on_cran()
  prob1 <- Problem(Minimize(a^2), list(a >= 2))
  answer <- solve(prob1)$value
  factors <- c(0, 1, 2.3, -4.321)
  for(f in factors) {
    expect_equal(solve(f * prob1)$value, f * answer, tolerance = TOL)
    expect_equal(solve(prob1 * f)$value, f * answer, tolerance = TOL)
  }
})

test_that("test problem linear combinations", {
  skip_on_cran()
  prob1 <- Problem(Minimize(a), list(a >= b))
  prob2 <- Problem(Minimize(2*b), list(a >= 1, b >= 2))
  prob3 <- Problem(Maximize(-(b + a)^2), list(b >= 3))

  # Simple addition and multiplication.
  combo1 <- prob1 + 2 * prob2
  combo1_ref <- Problem(Minimize(a + 4*b), list(a >= b, a >= 1, b >= 2))
  expect_equal(solve(combo1)$value, solve(combo1_ref)$value)

  # Division and subtraction.
  combo2 <- prob1 - prob3/2
  combo2_ref <- Problem(Minimize(a + (b + a)^2/2), list(b >= 3, a >= b))
  expect_equal(solve(combo2)$value, solve(combo2_ref)$value)

  # Multiplication with 0 (prob2's constraints should still hold).
  combo3 <- prob1 + 0*prob2 - 3*prob3
  combo3_ref <- Problem(Minimize(a + 3*(b + a)^2), list(a >= b, a >= 1, b >= 3))
  expect_equal(solve(combo3)$value, solve(combo3_ref)$value, tolerance = TOL)
})

# test_that("test solving problems in parallel", {
#   p <- Parameter()
#   problem <- Problem(Minimize(a^2 + b^2 + p), list(b >= 2, a >= 1))
#   value(p) <- 1
#
#   # Ensure that parallel solver still works after repeated calls
#   for(i in 1:2) {
#     result <- solve(problem, parallel = TRUE)
#     expect_equal(result$value, 6.0, tolerance = TOL)
#     expect_equal(result$status, "optimal")
#     expect_equal(result$getValue(a), 1, tolerance = TOL)
#     expect_equal(result$getValue(b), 2, tolerance = TOL)
#   }
#
#   # The constant p should not be a separate problem, but rather added to the first separable problem
#   expect_true(length(problem@.separable_problems) == 2)
#
#   # Ensure that parallel solver works with options
#   result <- solve(problem, parallel = TRUE, verbose = TRUE, warm_start = TRUE)
#   expect_equal(result$value, 6.0, tolerance = TOL)
#   expect_equal(result$status, "optimal")
#   expect_equal(result$getValue(a), 1, tolerance = TOL)
#   expect_equal(result$getValue(b), 2, tolerance = TOL)
#
#   # Ensure that parallel solver works when problem changes
#   objective <- Minimize(a^2 + b^2)
#   problem <- Problem(objective, problem@constraints)
#   result <- solve(problem, parallel = TRUE)
#   expect_equal(result$value, 5.0, tolerance = TOL)
#   expect_equal(result$status, "optimal")
#   expect_equal(result$getValue(a), 1, tolerance = TOL)
#   expect_equal(result$getValue(b), 2, tolerance = TOL)
# })

test_that("Test scalar LP problems", {
  skip_on_cran()
  p <- Problem(Minimize(3*a), list(a >= 2))
  result <- solve(p)
  expect_equal(result$value, 6, tolerance = TOL)
  expect_equal(result$getValue(a), 2, tolerance = TOL)

  p <- Problem(Maximize(3*a - b), list(a <= 2, b == a, b <= 5))
  result <- solve(p)
  expect_equal(result$value, 4.0, tolerance = TOL)
  expect_equal(result$getValue(a), 2, tolerance = TOL)
  expect_equal(result$getValue(b), 2, tolerance = TOL)

  # With a constant in the objective
  p <- Problem(Minimize(3*a - b + 100), list(a >= 2, b + 5*c - 2 == a, b <= 5 + c))
  result <- solve(p)
  expect_equal(result$value, 101+1.0/6, tolerance = TOL)
  expect_equal(result$getValue(a), 2, tolerance = TOL)
  expect_equal(result$getValue(b), 5-1.0/6, tolerance = TOL)
  expect_equal(result$getValue(c), -1.0/6, tolerance = TOL)

  # Test status and value
  exp <- Maximize(a)
  p <- Problem(exp, list(a <= 2))
  result <- solve(p, solver = "ECOS")
  # expect_equal(result$value, value(p))
  expect_equal(result$status, "optimal")
  expect_false(is.na(result$getValue(a)))
  expect_false(is.na(result$getDualValue(p@constraints[[1]])))

  # Unbounded problems
  p <- Problem(Maximize(a), list(a >= 2))
  result <- solve(p, solver = "ECOS")
  expect_equal(result$value, Inf)
  expect_true(is.na(result$getValue(a)))
  expect_true(is.na(result$getDualValue(p@constraints[[1]])))

  if("CVXOPT" %in% INSTALLED_SOLVERS) {
    p <- Problem(Minimize(-a), list(a >= 2))
    result <- solve(p, solver = "CVXOPT")
    # expect_equal(result$value, value(p))
    expect_equal(result$status, "unbounded")
    expect_equal(result$value, -Inf)
  }

  # Infeasible problems
  p <- Problem(Maximize(a), list(a >= 2, a <= 1))
  # a <- save_value(a, 2)
  # p@constraints[[1]] <- save_value(p@constraints[[1]], 2)

  result <- solve(p, solver = "ECOS")
  # expect_equal(result$value, value(p))
  expect_equal(result$status, "infeasible")
  expect_equal(result$value, -Inf)
  expect_true(is.na(result$getValue(a)))
  expect_true(is.na(result$getDualValue(p@constraints[[1]])))

  p <- Problem(Minimize(-a), list(a >= 2, a <= 1))
  result <- solve(p, solver = "ECOS")
  # expect_equal(result$value, value(p))
  expect_equal(result$status, "infeasible")
  expect_equal(result$value, Inf)
})

test_that("Test vector LP problems", {
  skip_on_cran()
  c <- Constant(matrix(c(1, 2), nrow = 2, ncol = 1))@value
  p <- Problem(Minimize(t(c) %*% x), list(x >= c))
  result <- solve(p)
  expect_equal(result$value, 5, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1, 2)), tolerance = TOL)

  A <- Constant(rbind(c(3, 5), c(1, 2)))@value
  I <- Constant(rbind(c(1, 0), c(0, 1)))
  p <- Problem(Minimize(t(c) %*% x + a), list(A %*% x >= c(-1, 1), 4*I %*% z == x, z >= c(2,2), a >= 2))
  result <- solve(p)
  expect_equal(result$value, 26, tolerance = 1e-3)
  obj <- result$getValue(t(c) %*% x + a)
  expect_equal(obj, result$value, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(8,8)), tolerance = 1e-3)
  expect_equal(result$getValue(z), matrix(c(2,2)), tolerance = 1e-3)
})

test_that("Test ECOS with no inequality constraints", {
  skip_on_cran()
  Tmat <- value(Constant(matrix(1, nrow = 2, ncol = 2)))
  p <- Problem(Minimize(1), list(A == Tmat))
  result <- solve(p, solver = "ECOS")
  expect_equal(result$value, 1, tolerance = TOL)
  expect_equal(result$getValue(A), Tmat, tolerance = TOL)
})

test_that("Test matrix LP problems", {
  skip_on_cran()
  Tmat <- value(Constant(matrix(1, nrow = 2, ncol = 2)))
  p <- Problem(Minimize(1), list(A == Tmat))
  result <- solve(p)
  expect_equal(result$value, 1, tolerance = TOL)
  expect_equal(result$getValue(A), Tmat, tolerance = TOL)

  Tmat <- value(Constant(matrix(1, nrow = 2, ncol = 3)*2))
  p <- Problem(Minimize(1), list(A >= Tmat %*% C, A == B, C == t(Tmat)))
  result <- solve(p)
  expect_equal(result$value, 1, tolerance = TOL)
  expect_equal(result$getValue(A), result$getValue(B), tolerance = TOL)
  expect_equal(result$getValue(C), t(Tmat), tolerance = TOL)
  expect_true(all(result$getValue(A) >= Tmat %*% result$getValue(C)))

  # Test variables are dense
  expect_true(is(result$getValue(A), "matrix"))
})

test_that("Test variable promotion", {
  skip_on_cran()
  p <- Problem(Minimize(a), list(x <= a, x == c(1, 2)))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)
  expect_equal(result$getValue(a), 2, tolerance = TOL)

  p <- Problem(Minimize(a), list(A <= a, A == rbind(c(1,2), c(3,4))))
  result <- solve(p)
  expect_equal(result$value, 4, tolerance = TOL)
  expect_equal(result$getValue(a), 4, tolerance = TOL)

  # Promotion must happen before multiplication
  p <- Problem(Minimize(matrix(1, nrow = 1, ncol = 2) %*% (x + a + 1)), list(a + x >= c(1, 2)))
  result <- solve(p)
  expect_equal(result$value, 5, tolerance = TOL)
})

test_that("Test parameter promotion", {
  skip_on_cran()
  a <- Parameter()
  value(a) <- 2
  exp <- cbind(c(1,2), c(3,4))*a
  expect_false(any(value(exp) - 2*cbind(c(1,2), c(3,4)) != 0))
})

test_that("test problems with parameters", {
  skip_on_cran()
  p1 <- Parameter()
  p2 <- Parameter(3, nonpos = TRUE)
  p3 <- Parameter(4, 4, nonneg = TRUE)
  p <- Problem(Maximize(p1*a), list(a + p1 <= p2, b <= p3 + p3 + 2))

  value(p1) <- 2
  value(p2) <- -matrix(1, nrow = 3, ncol = 1)
  value(p3) <- matrix(1, nrow = 4, ncol = 4)
  ##p <- Problem(Maximize(p1*a), list(a + p1 <= p2, b <= p3 + p3 + 2))
  result <- solve(p)
  expect_equal(result$value, -6, tolerance = TOL)

  value(p1) <- NA_real_
  p <- Problem(Maximize(p1*a), list(a + p1 <= p2, b <= p3 + p3 + 2))
  expect_error(solve(p))
})

test_that("test problems with norm_inf", {
  skip_on_cran()
  # Constant argument
  p <- Problem(Minimize(norm_inf(-2)))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)

  # Scalar arguments
  p <- Problem(Minimize(norm_inf(a)), list(a >= 2))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)
  expect_equal(result$getValue(a), 2, tolerance = TOL)

  p <- Problem(Minimize(3*norm_inf(a + 2*b) + c), list(a >= 2, b <= -1, c == 3))
  result <- solve(p)
  expect_equal(result$value, 3, tolerance = TOL)
  expect_equal(result$getValue(a + 2*b), 0, tolerance = TOL)
  expect_equal(result$getValue(c), 3, tolerance = TOL)

  # Maximize
  p <- Problem(Maximize(-norm_inf(a)), list(a <= -2))
  result <- solve(p)
  expect_equal(result$value, -2, tolerance = TOL)
  expect_equal(result$getValue(a), -2, tolerance = TOL)

  # Vector arguments
  p <- Problem(Minimize(norm_inf(x - z) + 5), list(x >= c(2,3), z <= c(-1,-4)))
  result <- solve(p, solver = "ECOS")
  expect_equal(result$value, 12, tolerance = TOL)
  expect_equal(result$getValue(x[2] - z[2]), 7, tolerance = TOL)
})

test_that("Test problems with norm1", {
  skip_on_cran()
  # Constant argument
  p <- Problem(Minimize(norm1(-2)))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)

  # Scalar arguments
  p <- Problem(Minimize(norm1(a)), list(a <= -2))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)
  expect_equal(result$getValue(a), -2, tolerance = TOL)

  # Maximize
  p <- Problem(Maximize(-norm1(a)), list(a <= -2))
  result <- solve(p)
  expect_equal(result$value, -2, tolerance = TOL)
  expect_equal(result$getValue(a), -2, tolerance = TOL)

  # Vector arguments
  p <- Problem(Minimize(norm1(x - z) + 5), list(x >= c(2,3), z <= c(-1,-4)))
  result <- solve(p)
  expect_equal(result$value, 15, tolerance = TOL)
  expect_equal(result$getValue(x[2] - z[2]), 7, tolerance = TOL)
})

test_that("Test problems with norm2", {
  skip_on_cran()
  # Constant argument
  p <- Problem(Minimize(norm2(-2)))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)

  # Scalar arguments
  p <- Problem(Minimize(norm2(a)), list(a <= -2))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)
  expect_equal(result$getValue(a), -2, tolerance = TOL)

  # Maximize
  p <- Problem(Maximize(-norm2(a)), list(a <= -2))
  result <- solve(p)
  expect_equal(result$value, -2, tolerance = TOL)
  expect_equal(result$getValue(a), -2, tolerance = TOL)

  # Vector arguments
  p <- Problem(Minimize(norm2(x - z) + 5), list(x >= c(2,3), z <= c(-1,-4)))
  result <- solve(p)
  expect_equal(result$value, 12.61577, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(2,3)), tolerance = TOL)
  expect_equal(result$getValue(z), matrix(c(-1,-4)), tolerance = TOL)

  # Row arguments
  p <- Problem(Minimize(norm2(t(x - z)) + 5), list(x >= c(2,3), z <= c(-1,-4)))
  result <- solve(p)
  expect_equal(result$value, 12.61577, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(2,3)), tolerance = TOL)
  expect_equal(result$getValue(z), matrix(c(-1,-4)), tolerance = TOL)
})

test_that("Test problems with abs", {
  skip_on_cran()
  p <- Problem(Minimize(sum_entries(abs(A))), list(-2 >= A))
  result <- solve(p)
  expect_equal(result$value, 8, tolerance = TOL)
  expect_equal(result$getValue(A), matrix(rep(-2, 4), nrow = 2, ncol = 2), tolerance = TOL)
})

test_that("Test problems with quad_form", {
  skip_on_cran()
  expect_error(solve(Problem(Minimize(quad_form(x, A)))), "At least one argument to QuadForm must be constant.")
  expect_error(solve(Problem(Minimize(quad_form(1, A)))), "Invalid dimensions for arguments.")
  expect_error(solve(Problem(Minimize(quad_form(x, rbind(c(-1,0), c(0,9)))))))              # Error: Problem does not follow DCP rules

  P <- rbind(c(4,0), c(0,9))
  p <- Problem(Minimize(quad_form(x, P)), list(x >= 1))
  result <- solve(p)
  expect_equal(result$value, 13, tolerance = 1e-3)

  c <- c(1,2)
  p <- Problem(Minimize(quad_form(c, A)), list(A >= 1))
  result <- solve(p)
  expect_equal(result$value, 9, tolerance = TOL)

  c <- c(1,2)
  P <- rbind(c(4,0), c(0,9))
  p <- Problem(Minimize(quad_form(c, P)))
  result <- solve(p)
  expect_equal(result$value, 40)
})

test_that("Test combining atoms", {
  skip_on_cran()
  p <- Problem(Minimize(norm2(5 + p_norm(z,1) + p_norm(x,1) + norm_inf(x - z))), list(x >= c(2,3), z <= c(-1,-4), p_norm(x + z,2) <= 2))
  result <- solve(p)
  expect_equal(result$value, 22, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(2,3)), tolerance = TOL)
  expect_equal(result$getValue(z), matrix(c(-1,-4)), tolerance = TOL)
})

test_that("Test multiplying by constant atoms", {
  skip_on_cran()
  p <- Problem(Minimize(norm2(c(3,4)) * a), list(a >= 2))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equal(result$getValue(a), 2, tolerance = TOL)
})

test_that("Test recovery of dual variables", {
  skip_on_cran()
  for(solver in c("ECOS", "SCS", "CVXOPT")) {
    if(solver %in% INSTALLED_SOLVERS) {
      if(solver == "SCS")
        acc <- 1e-1
      else
        acc <- 1e-5
      p <- Problem(Minimize(p_norm(x + z, 1)), list(x >= c(2,3), cbind(c(1,2), c(3,4)) %*% z == c(-1,-4), p_norm(x + z, 2) <= 100))
      result <- solve(p, solver = solver)
      expect_equal(result$value, 4, tolerance = acc)
      expect_equal(result$getValue(x), matrix(c(4,3)), tolerance = acc)
      expect_equal(result$getValue(z), matrix(c(-4,1)), tolerance = acc)

      # Dual values
      expect_equal(result$getDualValue(p@constraints[[1]]), matrix(c(0,1)), tolerance = acc)
      expect_equal(result$getDualValue(p@constraints[[2]]), matrix(c(-1,0.5)), tolerance = acc)
      expect_equal(result$getDualValue(p@constraints[[3]]), 0, tolerance = acc)

      Tmat <- matrix(1, nrow = 2, ncol = 3) * 2
      c <- matrix(c(3,4), nrow = 1, ncol = 2)
      p <- Problem(Minimize(1), list(A >= Tmat %*% C, A == B, C == t(Tmat)))
      result <- solve(p, solver = solver)

      # Dual values
      expect_equal(result$getDualValue(p@constraints[[1]]), matrix(0, nrow = 2, ncol = 2), tolerance = acc)
      expect_equal(result$getDualValue(p@constraints[[2]]), matrix(0, nrow = 2, ncol = 2), tolerance = acc)
      expect_equal(result$getDualValue(p@constraints[[3]]), matrix(0, nrow = 3, ncol = 2), tolerance = acc)
    }
  }
})

test_that("Test problems with indexing", {
  skip_on_cran()
  # Vector variables
  p <- Problem(Maximize(x[1,1]), list(x[1,1] <= 2, x[2,1] == 3))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(2,3)))

  n <- 10
  Aloc <- matrix(0:(n^2-1), nrow = n, ncol = n)
  xloc <- Variable(n,n)
  p <- Problem(Minimize(sum_entries(xloc)), list(xloc == Aloc))
  result <- solve(p)
  answer <- n*n*(n*n+1)/2 - n*n
  expect_equal(result$value, answer)

  # Matrix variables
  obj <- A[1,1] + A[1,2] + A[2,2] + A[2,1]
  p <- Problem(Maximize(obj), list(A <= rbind(c(1,-2), c(-3,4))))
  result <- solve(p)
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(A), rbind(c(1,-2), c(-3,4)))

  # Indexing arithmetic expressions
  exp <- cbind(c(1,2), c(3,4)) %*% z + x
  p <- Problem(Minimize(exp[2,1]), list(x == z, z == c(1,2)))
  result <- solve(p)
  expect_equal(result$value, 12, tolerance = TOL)
  expect_equal(result$getValue(x), result$getValue(z), tolerance = TOL)
})

test_that("Test problems with slicing", {
  skip_on_cran()
  p <- Problem(Maximize(sum_entries(C)), list(C[2:3,] <= 2, C[1,] == 1))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equal(result$getValue(C), cbind(c(1,2,2), c(1,2,2)))

  p <- Problem(Maximize(sum_entries(C[seq(1,3,2),2])), list(C[2:3,] <= 2, C[1,] == 1))
  result <- solve(p)
  expect_equal(result$value, 3, tolerance = TOL)
  expect_equal(result$getValue(C[seq(1,3,2),2]), matrix(c(1,2)))

  p <- Problem(Maximize(sum_entries((C[1:2,] + A)[,1:2])), list(C[2:3,] <= 2, C[1,] == 1, (A + B)[,1] == 3,
                                                             (A + B)[,2] == 2, B == 1))
  result <- solve(p)
  expect_equal(result$value, 12, tolerance = TOL)
  expect_equal(result$getValue(C[1:2,]), cbind(c(1,2), c(1,2)), tolerance = TOL)
  expect_equal(result$getValue(A), cbind(c(2,2),c(1,1)), tolerance = TOL)

  p <- Problem(Maximize(matrix(c(3,4), nrow = 1, ncol = 2) %*% (C[1:2,] + A)[,1]),
               list(C[2:3,] <= 2, C[1,] == 1, matrix(c(1,2), nrow = 1, ncol = 2) %*% (A + B)[,1] == 3,
                    (A + B)[,2] == 2, B == 1, 3*A[,1] <= 3))
  result <- solve(p)
  expect_equal(result$value, 12, tolerance = TOL)
  expect_equal(result$getValue(C[1:2,1]), matrix(c(1,2)), tolerance = TOL)
  expect_equal(result$getValue(A), cbind(c(1,-0.5), c(1,1)), tolerance = TOL)

  p <- Problem(Minimize(norm2((C[1:2,] + A)[,1])), list(C[2:3,] <= 2, C[1,] == 1, (A + B)[,1] == 3, (A + B)[,2] == 2, B == 1))
  result <- solve(p)
  expect_equal(result$value, 3, tolerance = TOL)
  expect_equal(result$getValue(C[1:2,1]), matrix(c(1,-2)), tolerance = 1e-4)
  expect_equal(result$getValue(A), cbind(c(2,2), c(1,1)), tolerance = TOL)

  # Transpose of slice
  p <- Problem(Maximize(sum_entries(C)), list(t(C[2:3,]) <= 2, t(C[1,]) == 1))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equal(result$getValue(C), cbind(c(1,2,2), c(1,2,2)))
})

test_that("Test the vstack function", {
  skip_on_cran()
  c <- matrix(1, nrow = 1, ncol = 5)
  p <- Problem(Minimize(c %*% vstack(x, y)), list(x == c(1,2), y == c(3,4,5)))
  result <- solve(p)
  expect_equal(result$value, 15, tolerance = TOL)

  c <- matrix(1, nrow = 1, ncol = 4)
  p <- Problem(Minimize(c %*% vstack(x, x)), list(x == c(1,2)))
  result <- solve(p)
  expect_equal(result$value, 6, tolerance = TOL)

  c <- matrix(1, nrow = 2, ncol = 2)
  p <- Problem(Minimize(sum_entries(vstack(A, C))), list(A >= 2*c, C == -2))
  result <- solve(p)
  expect_equal(result$value, -4, tolerance = TOL)

  c <- matrix(1, nrow = 1, ncol = 2)
  p <- Problem(Minimize(sum_entries(vstack(c %*% A, c %*% B))), list(A >= 2, B == -2))
  result <- solve(p)
  expect_equal(result$value, 0, tolerance = TOL)

  c <- matrix(c(1,-1), nrow = 2, ncol = 1)
  p <- Problem(Minimize(t(c) %*% vstack(a^2, sqrt(b))), list(a == 2, b == 16))
  expect_error(solve(p))
})

test_that("Test the hstack function", {
  skip_on_cran()
  c <- matrix(1, nrow = 1, ncol = 5)
  p <- Problem(Minimize(c %*% t(hstack(t(x), t(y)))), list(x == c(1,2), y == c(3,4,5)))
  result <- solve(p)
  expect_equal(result$value, 15, tolerance = TOL)

  c <- matrix(1, nrow = 1, ncol = 4)
  p <- Problem(Minimize(c %*% t(hstack(t(x), t(x)))), list(x == c(1,2)))
  result <- solve(p)
  expect_equal(result$value, 6, tolerance = TOL)

  c <- matrix(1, nrow = 2, ncol = 2)
  p <- Problem(Minimize(sum_entries(hstack(t(A), t(C)))), list(A >= 2*c, C == -2))
  result <- solve(p)
  expect_equal(result$value, -4, tolerance = TOL)

  D <- Variable(3,3)
  expr <- hstack(C, D)
  p <- Problem(Minimize(expr[1,2] + sum_entries(hstack(expr, expr))), list(C >= 0, D >= 0, D[1,1] == 2, C[1,2] == 3))
  result <- solve(p)
  expect_equal(result$value, 13, tolerance = TOL)

  c <- matrix(c(1,-1), nrow = 2, ncol = 1)
  p <- Problem(Minimize(t(c) %*% t(hstack(t(a^2), t(sqrt(b))))), list(a == 2, b == 16))
  expect_error(solve(p))
})

test_that("Test using a CVXR expression as an objective", {
  skip_on_cran()
  expect_error(Problem(x+2))
})

test_that("Test variable transpose", {
  skip_on_cran()
  p <- Problem(Minimize(sum_entries(x)), list(t(x) >= matrix(c(1,2), nrow = 1, ncol = 2)))
  result <- solve(p)
  expect_equal(result$value, 3, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1,2)))

  p <- Problem(Minimize(sum_entries(C)), list(matrix(c(1,1), nrow = 1, ncol = 2) %*% t(C) >= matrix(0:2, nrow = 1, ncol = 3)))
  result <- solve(p)
  value <- result$getValue(C)

  constraints <- lapply(1:3, function(i) { 1*C[i,1] + 1*C[i,2] >= (i-1) })
  p <- Problem(Minimize(sum_entries(C)), constraints)
  result2 <- solve(p)
  expect_equal(result$value, result2$value)
  expect_equal(result$getValue(C), value)

  p <- Problem(Minimize(A[1,2] - t(A)[2,1]), list(A == cbind(c(1,2), c(3,4))))
  result <- solve(p)
  expect_equal(result$value, 0, tolerance = TOL)

  exp <- t(-x)
  p <- Problem(Minimize(sum_entries(x)), list(t(-x) <= 1))
  result <- solve(p)
  expect_equal(result$value, -2, tolerance = TOL)

  c <- matrix(c(1,-1), nrow = 2, ncol = 1)
  p <- Problem(Minimize(max_elemwise(t(c), 2, 2 + t(c))[2]))
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)

  c <- cbind(c(1,-1,2), c(1,-1,2))
  p <- Problem(Minimize(sum_entries(t(max_elemwise(c, 2, 2+c))[,1])))
  result <- solve(p)
  expect_equal(result$value, 6, tolerance = TOL)

  c <- cbind(c(1,-1,2), c(1,-1,2))
  p <- Problem(Minimize(sum_entries(t(t(c)^2)[,1])))
  result <- solve(p)
  expect_equal(result$value, 6, tolerance = TOL)

  # Slice of transpose
  p <- Problem(Maximize(sum_entries(C)), list(t(C)[,2:3] <= 2, t(C)[,1] == 1))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equal(result$getValue(C), cbind(c(1,2,2), c(1,2,2)))
})

test_that("Test multiplication on the left by a non-constant", {
  skip_on_cran()
  c <- matrix(c(1,2), nrow = 2, ncol = 1)
  p <- Problem(Minimize(t(c) %*% A %*% c), list(A >= 2))
  result <- solve(p)
  expect_equal(result$value, 18, tolerance = TOL)

  p <- Problem(Minimize(a*2), list(a >= 2))
  result <- solve(p)
  expect_equal(result$value, 4, tolerance = TOL)

  p <- Problem(Minimize(t(x) %*% c), list(x >= 2))
  result <- solve(p)
  expect_equal(result$value, 6, tolerance = TOL)

  p <- Problem(Minimize((t(x) + t(z)) %*% c), list(x >= 2, z >= 1))
  result <- solve(p)
  expect_equal(result$value, 9, tolerance = TOL)
})

test_that("Test redundant constraints", {
  skip_on_cran()
  obj <- Minimize(sum_entries(x))
  constraints <- list(x == 2, x == 2, t(x) == 2, x[1] == 2)
  p <- Problem(obj, constraints)
  result <- solve(p, solver = "ECOS")
  expect_equal(result$value, 4, tolerance = TOL)

  obj <- Minimize(sum_entries(x^2))
  constraints <- list(x == x)
  p <- Problem(obj, constraints)
  result <- solve(p, solver = "ECOS")
  expect_equal(result$value, 0, tolerance = TOL)
})

test_that("Test that symmetry is enforced", {
  skip_on_cran()
  p <- Problem(Minimize(lambda_max(A)), list(A >= 2))
  result <- solve(p)
  expect_equal(result$getValue(A), t(result$getValue(A)), tolerance = 1e-3)

  p <- Problem(Minimize(lambda_max(A)), list(A == cbind(c(1,2), c(3,4))))
  result <- solve(p)
  expect_equal(result$status, "infeasible")
})

test_that("Test SDP", {
  skip_on_cran()
  # Ensure SDP constraints enforce transpose
  obj <- Maximize(A[2,1] - A[1,2])
  p <- Problem(obj, list(lambda_max(A) <= 100, A[1,1] == 2, A[2,2] == 2, A[2,1] == 2))
  result <- solve(p)
  expect_equal(result$value, 0, tolerance = 1e-3)
})

test_that("Test getting values for expressions", {
  skip_on_cran()
  diff_exp <- x - z
  inf_exp <- norm_inf(diff_exp)
  sum_entries_exp <- 5 + p_norm(z,1) + p_norm(x,1) + inf_exp
  constr_exp <- norm2(x + z)
  obj <- norm2(sum_entries_exp)
  p <- Problem(Minimize(obj), list(x >= c(2,3), z <= c(-1,-4), constr_exp <= 2))
  result <- solve(p)
  expect_equal(result$value, 22, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(2,3)), tolerance = TOL)
  expect_equal(result$getValue(z), matrix(c(-1,-4)), tolerance = TOL)

  # Expression values
  xs <- result$getValue(x)
  zs <- result$getValue(z)
  expect_equal(result$getValue(diff_exp), xs - zs, tolerance = TOL)
  expect_equal(result$getValue(inf_exp), norm(xs - zs, "I"))
  expect_equal(result$getValue(sum_entries_exp), 5 + norm(zs, "1") + norm(xs, "1") + norm(xs - zs, "I"))
  expect_equal(result$getValue(constr_exp), base::norm(xs + zs, "2"))
  expect_equal(result$getValue(obj), result$value)
})

test_that("Test multiplication by zero", {
  skip_on_cran()
  exp <- 0*a
  expect_equal(value(exp), matrix(0))
  obj <- Minimize(exp)
  p <- Problem(obj)
  result <- solve(p)
  expect_equal(result$value, 0, tolerance = TOL)
  expect_false(is.na(result$getValue(a)))
})

test_that("Tests a problem with division", {
  skip_on_cran()
  obj <- Minimize(norm_inf(A/5))
  p <- Problem(obj, list(A >= 5))
  result <- solve(p)
  expect_equal(result$value, 1, tolerance = TOL)
})

test_that("Tests problems with multiply", {
  skip_on_cran()
  c <- cbind(c(1,-1), c(2,-2))
  expr <- multiply(c, A)
  obj <- Minimize(norm_inf(expr))
  p <- Problem(obj, list(A == 5))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equal(result$getValue(expr), cbind(c(5,-5), c(10,-10)), tolerance = TOL)

  # Test with a sparse matrix
  c <- Matrix::sparseMatrix(i = c(1,2), j = c(1,1), x = c(1,2))
  expr <- multiply(c, x)
  obj <- Minimize(norm_inf(expr))
  p <- Problem(obj, list(x == 5))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equivalent(as.matrix(result$getValue(expr)), matrix(c(5,10)))

  # Test promotion
  c <- cbind(c(1,-1), c(2,-2))
  expr <- multiply(c, a)
  obj <- Minimize(norm_inf(expr))
  p <- Problem(obj, list(a == 5))
  result <- solve(p)
  expect_equal(result$value, 10, tolerance = TOL)
  expect_equivalent(as.matrix(result$getValue(expr)), cbind(c(5,-5), c(10,-10)))
})

test_that("Tests that errors occur when you use an invalid solver", {
  skip_on_cran()
  expect_error(solve(Problem(Minimize(Bool())), solver = "ECOS"))
  expect_error(solve(Problem(Minimize(lambda_max(a))), solver = "ECOS"))
  expect_error(solve(Problem(Minimize(a)), solver = "SCS"))
})

test_that("Tests problems with reshape_expr", {
  skip_on_cran()
  # Test on scalars
  expect_equal(value(reshape_expr(1,c(1,1))), matrix(1))

  # Test vector to matrix
  x <- Variable(4)
  mat <- cbind(c(1,-1), c(2,-2))
  vec <- matrix(1:4)
  vec_mat <- cbind(c(1,2), c(3,4))
  expr <- reshape_expr(x,c(2,2))
  obj <- Minimize(sum_entries(mat %*% expr))
  prob <- Problem(obj, list(x == vec))
  result <- solve(prob)
  expect_equal(result$value, sum(mat %*% vec_mat))

  # Test on matrix to vector
  c <- 1:4
  expr <- reshape_expr(A,c(4,1))
  obj <- Minimize(t(expr) %*% c)
  constraints <- list(A == cbind(c(-1,-2), c(3,4)))
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$value, 20, tolerance = TOL)
  expect_equal(result$getValue(expr), matrix(c(-1,-2,3,4)))
  expect_equal(result$getValue(reshape_expr(expr,c(2,2))), cbind(c(-1,-2), c(3,4)))

  # Test matrix to matrix
  expr <- reshape_expr(C,c(2,3))
  mat <- rbind(c(1,-1), c(2,-2))
  C_mat <- rbind(c(1,4), c(2,5), c(3,6))
  obj <- Minimize(sum_entries(mat %*% expr))
  prob <- Problem(obj, list(C == C_mat))
  result <- solve(prob)
  reshaped = matrix(C_mat, nrow = 2, ncol = 3, byrow = FALSE)
  expect_equal(result$value, sum(mat %*% reshaped), tolerance = TOL)
  expect_equal(result$getValue(expr), reshaped, tolerance = TOL)

  # Test promoted expressions
  c <- cbind(c(1,-1), c(2,-2))
  expr <- reshape_expr(c * a,c(1,4))
  obj <- Minimize(expr %*% (1:4))
  prob <- Problem(obj, list(a == 2))
  result <- solve(prob)
  expect_equal(result$value, -6, tolerance = TOL)
  expect_equal(result$getValue(expr), 2*matrix(c, nrow = 1), tolerance = TOL)

  expr <- reshape_expr(c * a,c(4,1))
  obj <- Minimize(t(expr) %*% (1:4))
  prob <- Problem(obj, list(a == 2))
  result <- solve(prob)
  expect_equal(result$value, -6, tolerance = TOL)
  expect_equal(result$getValue(expr), 2*matrix(c, ncol = 1), tolerance = TOL)
})

test_that("Tests problems with vec", {
  skip_on_cran()
  c <- 1:4
  expr <- vec(A)
  obj <- Minimize(t(expr) %*% c)
  constraints <- list(A == cbind(c(-1,-2), c(3,4)))
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$value, 20, tolerance = TOL)
  expect_equal(result$getValue(expr), matrix(c(-1,-2,3,4)))
})

test_that("Test a problem with diag", {
  skip_on_cran()
  C <- Variable(3,3)
  obj <- Maximize(C[1,3])
  constraints <- list(diag(C) == 1, C[1,2] == 0.6, C[2,3] == -0.3, C == Variable(3, 3, PSD = TRUE))
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$value, 0.583151, tolerance = 1e-2)
})

# test_that("Test presolve parameters", {
#   # Test with parameters
#   gamma <- Parameter(nonneg = TRUE)
#   x <- Variable()
#   obj <- Minimize(x)
#   value(gamma) <- 0
#   prob <- Problem(obj, list(gamma == 1, x >= 0))
#   result <- solve(prob, solver = "SCS")
#   expect_equal(result$status, "infeasible")
#
#   value(gamma) <- 1
#   prob <- Problem(obj, list(gamma == 1, x >= 0))
#   result <- solve(prob, solver = "SCS")
#   expect_equal(result$status, "optimal")
# })

# test_that("Test that expressions with parameters are updated properly", {
#   x <- Variable()
#   y <- Variable()
#   x0 <- Parameter()
#
#   # Initial guess for x
#   value(x0) <- 2
#
#   # Make the constraints x^2 - y == 0
#   xSquared <- x0*x0 + 2*x0*(x-x0)
#   g <- xSquared - y
#
#   # Set up the problem
#   obj <- abs(x - 1)
#   prob <- Problem(Minimize(obj), list(g == 0))
#   result <- solve(prob)
#
#   value(x0) <- 1
#   xSquared <- x0*x0 + 2*x0*(x-x0)
#   g <- xSquared - y
#   prob <- Problem(Minimize(obj), list(g == 0))
#   result <- solve(prob)
#   # expect_equal(result$getValue(g), 0, tolerance = TOL)
#
#   # Test multiplication
#   prob <- Problem(Minimize(x0*x), list(x == 1))
#   value(x0) <- 2
#   result <- solve(prob)
#   x0@value <- 1
#   result <- solve(prob)
#   expect_equal(result$value, 1, tolerance = TOL)
# })

test_that("Test interaction of caching with changing constraints", {
  skip_on_cran()
  prob <- Problem(Minimize(a), list(a == 2, a >= 1))
  result <- solve(prob)
  expect_equal(result$value, 2, tolerance = TOL)

  prob@constraints[[1]] = (a == 1)
  result <- solve(prob)
  expect_equal(result$value, 1, tolerance = TOL)
})

test_that("Test positive definite constraints", {
  skip_on_cran()
  C <- Variable(3,3)
  obj <- Maximize(C[1,3])
  constraints <- list(diag(C) == 1, C[1,2] == 0.6, C[2,3] == -0.3, C == t(C), C %>>% 0)
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$value, 0.583151, tolerance = 1e-2)

  C <- Variable(2,2)
  obj <- Maximize(C[1,2])
  constraints <- list(C == 1, C %>>% rbind(c(2,0), c(0,2)))
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$status, "infeasible")

  C <- Variable(2, 2, symmetric = TRUE)
  obj <- Minimize(C[1,1])
  constraints <- list(C %<<% cbind(c(2,0), c(0,2)))
  prob <- Problem(obj, constraints)
  result <- solve(prob)
  expect_equal(result$status, "unbounded")
})

test_that("Test the duals of PSD constraints", {
  skip_on_cran()
  # Test dual values with SCS
  C <- Variable(2, 2, symmetric = TRUE, name = "C")
  obj <- Maximize(C[1,1])
  constraints <- list(C %<<% cbind(c(2,0), c(0,2)))
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$value, 2, tolerance = 1e-4)

  psd_constr_dual <- result$getDualValue(constraints[[1]])
  C <- Variable(2, 2, symmetric = TRUE, name = "C")
  X <- Variable(2, 2, PSD = TRUE)
  obj <- Maximize(C[1,1])
  constraints <- list(X == cbind(c(2,0), c(0,2)) - C)
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$getDualValue(constraints[[1]]), psd_constr_dual, tolerance = 1e-3)

  # Test dual values with SCS that have off-diagonal entries
  C <- Variable(2, 2, symmetric = TRUE)
  obj <- Maximize(C[1,2] + C[2,1])
  constraints <- list(C %<<% cbind(c(2,0), c(0,2)), C >= 0)
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$value, 4, tolerance = 1e-3)

  psd_constr_dual <- result$getDualValue(constraints[[1]])
  C <- Variable(2, 2, symmetric = TRUE)
  X <- Variable(2, 2, PSD = TRUE)
  obj <- Maximize(C[1,2] + C[2,1])
  constraints <- list(X == cbind(c(2,0), c(0,2)) - C, C >= 0)
  prob <- Problem(obj, constraints)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$getDualValue(constraints[[1]]), psd_constr_dual, tolerance = 1e-3)
})

test_that("Test geo_mean function", {
  skip_on_cran()
    x <- Variable(2)
    cost <- geo_mean(x)
    prob <- Problem(Maximize(cost), list(x <= 1))
    result <- solve(prob)
    expect_equal(result$value, 1, tolerance = TOL)

    prob <- Problem(Maximize(cost), list(sum(x) <= 1))
    result <- solve(prob)
    expect_equal(result$getValue(x), matrix(c(0.5,0.5)), tolerance = TOL)

    x <- Variable(3,3)
    expect_error(geo_mean(x))

    x <- Variable(3,1)
    g <- geo_mean(x)
    ##expect_equal(g@w, gmp::as.bigq(1,3)*3, tolerance = TOL)

    x <- Variable(1,5)
    g <- geo_mean(x)
    ##expect_equal(g@w, gmp::as.bigq(1,5)*5, tolerance = TOL)

    ## Check that we get the right answer for max geo_mean(x) s.t. sum(x) <= 1
    p <- c(0.07, 0.12, 0.23, 0.19, 0.39)

    short_geo_mean <- function(x, p) {
        p <- as.numeric(p)/sum(p)
        x <- as.numeric(x)
        prod(x^p)
    }

    x <- Variable(5)
    prob <- Problem(Maximize(geo_mean(x, p)), list(sum(x) <= 1))
    result <- solve(prob)
    x <- as.numeric(result$getValue(x))
    x_true <- p/sum(p)

    expect_equal(result$value, result$getValue(geo_mean(x, p)), tolerance = TOL)
    expect_equal(result$value, short_geo_mean(x, p), tolerance = TOL)
    expect_equal(x, x_true, tolerance = 1e-3)

    ## Check that we get the right answer for max geo_mean(x) s.t. p_norm(x) <= 1
    x <- Variable(5)
    prob <- Problem(Maximize(geo_mean(x, p)), list(p_norm(x) <= 1))
    result <- solve(prob)
    x <- as.numeric(result$getValue(x))
    x_true <- sqrt(p/sum(p))

    expect_equal(result$value, result$getValue(geo_mean(x, p)), tolerance = 1e-3)
    expect_equal(result$value, short_geo_mean(x, p), tolerance = 1e-3)
    expect_equal(x, x_true, tolerance = 1e-3)

    ## The following 3 tests check vstack and hstack input to geo_mean
    ## The following 3 formulations should be equivalent
    n <- 5
    x_true <- rep(1,n)
    x <- Variable(n)

    result <- solve(Problem(Maximize(geo_mean(x)), list(x <= 1)))
    xval <- as.numeric(result$getValue(x))
    expect_equal(xval, x_true, tolerance = 1e-3)

    ##args <- list()
    ##for(i in 1:n)
    ##    args <- c(args, x[i])
    args <- lapply(seq_len(n), function(ind) x[ind])
    y <- do.call(vstack, args)
    result <- solve(Problem(Maximize(geo_mean(y)), list(x <= 1)))
    xval <- as.numeric(result$getValue(x))
    expect_equal(xval, x_true, tolerance = 1e-3)

    y <- do.call(hstack, args)
    result <- solve(Problem(Maximize(geo_mean(y)), list(x <= 1)))
    xval <- as.numeric(result$getValue(x))
    expect_equal(xval, x_true, tolerance = 1e-3)
})

test_that("Test p_norm function", {
  skip_on_cran()
    x <- Variable(3, name = "x")
    avec <- c(1.0, 2, 3)

    ## TODO: Add -1, 0.5, 0.3, -2.3 and testing positivity constraints

  for(p in c(1, 1.6, 1.3, 2, 1.99, 3, 3.7, Inf)) {
    prob <- Problem(Minimize(p_norm(x, p = p)), list(t(x) %*% avec >= 1))
    result <- solve(prob)

    # Formula is true for any a >= 0 with p > 1
    if(p == Inf)
      x_true <- rep(1, length(avec))/sum(avec)
    else if(p == 1) {
      # Only works for the particular a = c(1,2,3)
      x_true <- c(0,0,1.0/3)
    } else
      x_true <- avec^(1.0/(p-1)) / as.numeric(avec %*% (avec^(1.0/(p-1))))

    x_alg <- as.vector(result$getValue(x))
    expect_equal(x_alg, x_true, tolerance = 1e-3)
    expect_equal(result$value, .p_norm(x_alg, p), tolerance = TOL)
    expect_equal(.p_norm(x_alg, p), result$getValue(p_norm(x_alg, p)))
  }
})

test_that("Test p_norm concave", {
  skip_on_cran()
  x <- Variable(3, name = "x")

  # Test positivity constraints
  a <- c(-1.0, 2, 3)
  for(p in c(-1, 0.5, 0.3, -2.3)) {
    prob <- Problem(Minimize(sum_entries(abs(x-a))), list(p_norm(x,p) >= 0))
    result <- solve(prob)
    expect_equal(result$value, 1, tolerance = TOL)
  }

  a <- c(1.0, 2, 3)
  for(p in c(-1, 0.5, 0.3, -2.3)) {
    prob <- Problem(Minimize(sum_entries(abs(x-a))), list(p_norm(x,p) >= 0))
    result <- solve(prob)
    expect_equal(result$value, 0, tolerance = TOL)
  }
})

test_that("Test power function", {
  skip_on_cran()
  x <- Variable()
  prob <- Problem(Minimize(power(x, 1.7) + power(x, -2.3) - power(x, 0.45)))
  result <- solve(prob)
  xs <- result$getValue(x)
  expect_true(abs(1.7*xs^0.7 - 2.3*xs^-3.3 - 0.45*xs^-0.55) <= 1e-3)
})

test_that("Test a problem with multiply by a scalar", {
  skip_on_cran()
  Tnum <- 10
  Jnum <- 20
  rvec <- matrix(stats::rnorm(Tnum*Jnum), nrow = Tnum, ncol = Jnum)
  dy <- matrix(stats::rnorm(2*Tnum), nrow = 2*Tnum, ncol = 1)
  theta <- Variable(Jnum)

  delta <- 1e-3
  loglambda <- rvec %*% theta   # rvec: TxJ regressor matrix, theta: (Jx1) cvx variable
  a <- multiply(dy[1:Tnum], loglambda)  # size (Tx1)
  b1 <- exp(loglambda)
  b2 <- multiply(delta, b1)
  cost <- -a + b1

  cost <- -a + b2  # size (Tx1)
  prob <- Problem(Minimize(sum_entries(cost)))
  result <- solve(prob, solver = "SCS")

  obj <- Minimize(sum_entries(multiply(2, x)))
  prob <- Problem(obj, list(x == 2))
  result <- solve(prob)
  expect_equal(result$value, 8, tolerance = TOL)
})

INSTALLED_SOLVERS <- installed_solvers()
TOL <- 1e-4
x <- Variable(2, name = "x")
slope <- Variable(1, name = "slope")
offset <- Variable(1, name = "offset")
quadratic_coeff <- Variable(1, name = "quadratic_coeff")

#LP, QP, SOCP, SDP, MIP, GP
test_that("Test a basic LP with all solvers", {
  skip_on_cran()

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)

  ## scs3.0 fix for tol have to be more lenient...
  for(solver in INSTALLED_SOLVERS){
    result <- solve(prob, solver = solver)
    expect_equal(result$value, -9, tolerance = 10 * TOL)
    expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = 10 * TOL)
  }

  #Example from
  # https://www.cvxpy.org/examples/basic/linear_program.html
  m <- 15
  n <- 10
  set.seed(1)
  s0 <- rnorm(m)
  lamb0 <- pmax(-s0, 0)
  s0 <- pmax(s0, 0)
  x0 <- rnorm(n)
  A <- matrix(rnorm(m * n), nrow = m, ncol = n)
  b <- A %*% x0 + s0
  c <- -t(A) %*% lamb0
  x_var <- Variable(n)
  prob <- Problem(Minimize(t(c) %*% x_var), list(A %*% x_var <= b))
  for(solver in INSTALLED_SOLVERS){
    suppressWarnings(
    result <- solve(prob, solver = solver, abstol = 1e-6, verbose = TRUE)
    )
    expect_equal(result$value, -7.83446, tolerance = TOL)
  }

})

#QP
test_that("Test a basic QP with all solvers", {
  skip_on_cran()

  set.seed(0)
  #Regression 1 test-g01-qp.R
  n <- 100

  # Specify the true value of the variable
  true_coeffs <- matrix(c(2, -2, 0.5), ncol = 1)

  # Generate data
  x_data <- 5*rnorm(n)
  x_data_expanded <- sapply(1:3, function(i) { x_data^i })
  y_data <- x_data_expanded %*% true_coeffs + 0.5*runif(n)

  line <- offset + slope*x_data
  residuals <- line - y_data
  fit_error <- sum_squares(residuals)
  p <- Problem(Minimize(fit_error), list())
  model <- lm(y_data ~ x_data)

  ##CBC, ECOS_BB, GLPK_MI, GLPK don't support QPs
  applicable_solvers  <- setdiff(INSTALLED_SOLVERS, list("CBC", "ECOS_BB", "GLPK_MI", "GLPK"))
  ## SCS is known to cause problems
  ## Works sometimes if we set rho_x = 1e-2, but too problematic
  applicable_solvers  <- setdiff(applicable_solvers, c("SCS", "CVXOPT"))

  for(solver in applicable_solvers) {
    result <- solve(p, solver)
    print(sprintf("Solver: %s status: %s\n", solver, result$status))
    expect_equal(sum((model$residuals)^2), result$value, tolerance = TOL)
    expect_equal(as.numeric(model$coefficients[1]), result$getValue(offset), tolerance = TOL)
    expect_equal(as.numeric(model$coefficients[2]), result$getValue(slope), tolerance = TOL)
  }

  ##Regression 2 test-g01-qp.R
  quadratic <- offset + slope*x_data + quadratic_coeff*x_data^2
  residuals <- quadratic - y_data
  fit_error <- sum_squares(residuals)
  p <- Problem(Minimize(fit_error), list())
  x_data_sq <- x_data^2
  model <- lm(y_data ~ x_data + x_data_sq)
  for(solver in applicable_solvers) {
    ##cat(sprintf("Doing %s\n", solver))
    result <- solve(p, solver)
    expect_equal(sum((model$residuals)^2), result$value, tolerance = TOL)
    expect_equal(as.numeric(model$coefficients[1]), result$getValue(offset), tolerance = TOL)
    expect_equal(as.numeric(model$coefficients[2]), result$getValue(slope), tolerance = TOL)
    expect_equal(as.numeric(model$coefficients[3]), result$getValue(quadratic_coeff), tolerance = TOL)
  }

})

test_that("Test a basic SOCP with solvers", {
  skip_on_cran()
  applicable_solvers <- setdiff(INSTALLED_SOLVERS, list("CBC", "ECOS_BB", "GLPK_MI", "GLPK", "OSQP"))
  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, (x[1] + 2*x[2])^2 <= 9, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  for(solver in applicable_solvers) {
    result <- solve(prob, solver = solver)
    print(sprintf("Solver: %s status: %s\n", solver, result$status))
    expect_equal(result$value, -9, tolerance = TOL)
    expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)
  }

  # Example from
  # https://www.cvxpy.org/examples/basic/socp.html
  set.seed(1)
  m <- 3
  n <- 10
  p <- 5
  n_i <- 5
  f = rnorm(n)
  A <- vector(mode="list", m)
  b <- vector(mode="list", m)
  c <- vector(mode="list", m)
  d <- vector(mode="list", m)
  x0 <- rnorm(n)
  soc_constraints <- vector(mode="list", m+1)
  x_var <- Variable(n)
  for(i in 1:m){
    A[[i]] <- matrix(rnorm(n_i * n), nrow = n_i, ncol = n)
    b[[i]] <- rnorm(n_i)
    c[[i]] <- rnorm(n)
    d[[i]] <- norm(A[[i]] %*% x0 + b[[i]], "f")
    soc_constraints[[i]] <- CVXR:::SOC(t(c[[i]]) %*% x_var + d[[i]], A[[i]] %*% x_var + b[[i]])
  }
  Fmat <- matrix(rnorm(p * n), nrow = p, ncol = n)
  g <- Fmat %*% x0
  soc_constraints[[m+1]] <- Fmat %*% x_var == g
  prob <- Problem(Minimize(t(f)%*%x_var), soc_constraints)
  for(solver in applicable_solvers) {
    result <- solve(prob, solver=solver)
    print(sprintf("Solver: %s status: %s\n", solver, result$status))
    expect_equal(result$value, -10.13341, tolerance=TOL)
  }

})

test_that("Test a basic SDP with all solvers", {
  skip_on_cran()
  # Example from
  # https://www.cvxpy.org/examples/basic/sdp.html
  n <- 3
  p <- 3
  set.seed(4)
  C <- matrix(rnorm(n^2), nrow = n)
  A <- vector(mode="list", p)
  b <- numeric(p)
  X <- Variable(n, n, PSD=T)
  constraints <- list()
  for(i in 1:p){
    A[[i]] <- matrix(rnorm(n^2), nrow = n)
    b[i] <- rnorm(1)
    constraints <- c(constraints, matrix_trace(A[[i]] %*% X) == b[i])
  }
  prob <- Problem(Minimize(matrix_trace(C %*% X)), constraints)

  check_matrix <- matrix(c(.3771707, -.5692205, .1166577, -.5692205,
                           .8590441, -.1760618, .11665767,
                           -.17606183, .03608155), nrow = n)
  # SCS and MOSEK and CVXOPT, CLARABEL are the only solvers that support SDPs
  ## Not adding clarabel for now
  for(solver in intersect(INSTALLED_SOLVERS, c("SCS", "MOSEK", "CVXOPT"))) {
    result <- solve(prob, solver = solver)
    print(sprintf("Solver: %s status: %s\n", solver, result$status))
    expect_equal(result$value, 1.395479, tolerance=TOL)
    expect_equal(result$getValue(X), check_matrix, tolerance=TOL)
  }
})

test_that("Test a mixed-integer quadratic program",{
  skip_on_cran()
  # Example from
  # https://www.cvxpy.org/examples/basic/mixed_integer_quadratic_program.html
  m <- 40
  n <- 25
  set.seed(1)
  A <- matrix(runif(m*n), nrow = m)
  b <- rnorm(m)
  x <- Variable(n, integer=T)
  obj <- Minimize(sum_squares(A %*% x - b))
  prob <- Problem(obj)
  applicable_solvers <- intersect(INSTALLED_SOLVERS, c("ECOS_BB", "CPLEX", "GUROBI", "MOSEK"))
  for(solver in applicable_solvers) {
    result <- solve(prob, solver=solver)
    expect_equal(result$value, 13.34086, tolerance=TOL)
  }
})

test_that("Test a simple geometric program", {
  skip_on_cran()
  # Example from
  # https://www.cvxpy.org/examples/dgp/dgp_fundamentals.html
  x <- Variable(pos=TRUE)
  y <- Variable(pos=TRUE)
  z <- Variable(pos=TRUE)

  obj <- x * y * z
  constraints <- list(4*x*y*z + 2*x*z <= 10,
                      x <= 2*y,
                      y <= 2*x,
                      z >=1)
  prob <- Problem(Maximize(obj), constraints)
  ## Leave out CLARABEL for now
  for(solver in c("ECOS", "SCS")){
    result <- solve(prob, solver=solver, gp=TRUE)
    expect_equal(result$value, 2, tolerance=TOL)
    expect_equal(result$getValue(x), 1, tolerance=TOL)
    expect_equal(result$getValue(y), 2, tolerance=TOL)
    expect_equal(result$getValue(z), 1, tolerance=TOL)
  }

})

context("test-g01-complex")
TOL <- 1e-6

test_that("test the Variable class", {
  skip_on_cran()
  x <- Variable(2, complex = FALSE)
  y <- Variable(2, complex = TRUE)
  z <- Variable(2, imag = TRUE)

  expect_false(is_complex(x))
  expect_false(is_imag(x))
  expect_true(is_complex(y))
  expect_false(is_imag(y))
  expect_true(is_complex(z))
  expect_true(is_imag(z))

  expect_error(value(x) <- c(1i, 0))

  value(y) <- c(1, 0)
  value(y) <- c(1i, 0)

  expect_error(value(z) <- c(1, 0))
})

test_that("test the Parameter class", {
  skip_on_cran()
  x <- Parameter(2, complex = FALSE)
  y <- Parameter(2, complex = TRUE)
  z <- Parameter(2, imag = TRUE)

  expect_false(is_complex(x))
  expect_false(is_imag(x))
  expect_true(is_complex(y))
  expect_false(is_imag(y))
  expect_true(is_complex(z))
  expect_true(is_imag(z))

  expect_error(value(x) <- c(1i, 0))

  value(y) <- c(1, 0)
  value(y) <- c(1i, 0)

  expect_error(value(z) <- c(1, 0))
})

test_that("test the Constant class", {
  skip_on_cran()
  x <- Constant(2)
  y <- Constant(2i + 1)
  z <- Constant(2i)

  expect_false(is_complex(x))
  expect_false(is_imag(x))
  expect_true(is_complex(y))
  expect_false(is_imag(y))
  expect_true(is_complex(z))
  expect_true(is_imag(z))
})

test_that("test objectives", {
  skip_on_cran()
  x <- Variable(complex = TRUE)
  expect_error(Minimize(x))
  expect_error(Maximize(x))
})

test_that("test basic arithmetic expressions", {
  skip_on_cran()
  x <- Variable(complex = TRUE)
  y <- Variable(imag = TRUE)
  z <- Variable()

  expr <- x + z
  expect_true(is_complex(expr))
  expect_false(is_imag(expr))

  expr <- y + z
  expect_true(is_complex(expr))
  expect_false(is_imag(expr))

  expr <- y*z
  expect_true(is_complex(expr))
  expect_true(is_imag(expr))

  expr <- y*y
  expect_false(is_complex(expr))
  expect_false(is_imag(expr))

  expr <- y/2
  expect_true(is_complex(expr))
  expect_true(is_imag(expr))

  expr <- y/1i
  expect_false(is_complex(expr))
  expect_false(is_imag(expr))

  A <- matrix(1, nrow = 2, ncol = 2)
  expr <- A %*% y %*% A
  expect_true(is_complex(expr))
  expect_true(is_imag(expr))
})

test_that("test real function", {
  skip_on_cran()
  A <- matrix(1, nrow = 2, ncol = 2)
  expr <- Constant(A) + 1i*Constant(A)
  expr <- Re(expr)
  expect_true(is_real(expr))
  expect_false(is_complex(expr))
  expect_false(is_imag(expr))
  expect_equal(value(expr), A)

  x <- Variable(complex = TRUE)
  expr <- Im(x) + Re(x)
  expect_true(is_real(expr))
})

test_that("test imag function", {
  skip_on_cran()
  A <- matrix(1, nrow = 2, ncol = 2)
  expr <- Constant(A) + 2i*Constant(A)
  expr <- Im(expr)
  expect_true(is_real(expr))
  expect_false(is_complex(expr))
  expect_false(is_imag(expr))
  expect_equal(value(expr), 2*A)
})

test_that("test conj function", {
  skip_on_cran()
  A <- matrix(1, nrow = 2, ncol = 2)
  expr <- Constant(A) + 1i*Constant(A)
  expr <- Conj(expr)
  expect_false(is_real(expr))
  expect_true(is_complex(expr))
  expect_false(is_imag(expr))
  expect_equal(value(expr), A - 1i*A)
})

test_that("test canonicalization for affine atoms", {
  skip_on_cran()
  # Scalar.
  x <- Variable()
  expr <- Im(x + 1i*x)
  prob <- Problem(Minimize(expr), list(x >= 0))
  result <- solve(prob)
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(x), 0, tolerance = TOL)

  x <- Variable(imag = TRUE)
  expr <- 1i*x
  prob <- Problem(Minimize(expr), list(Im(x) <= 1))
  result <- solve(prob)
  expect_equal(result$value, -1, tolerance = TOL)
  expect_equal(result$getValue(x), 1i, tolerance = TOL)

  x <- Variable(2)
  expr <- x/1i
  prob <- Problem(Minimize(expr[1]*1i + expr[2]*1i), list(Re(x + 1i) >= 1))
  result <- solve(prob)
  expect_equal(result$value, -Inf)
  prob <- Problem(Minimize(expr[1]*1i + expr[2]*1i), list(Re(x + 1i) <= 1))
  result <- solve(prob)
  expect_equal(result$value, -2, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)
  prob <- Problem(Minimize(expr[1]*1i + expr[2]*1i), list(Re(x + 1i) >= 1, Conj(x) <= 0))
  result <- solve(prob)   # TODO_NARAS_1: OSQP returns a solver_error, but ECOS is correct.
  expect_equal(result$value, Inf)

  x <- Variable(2,2)
  y <- Variable(3,2, complex = TRUE)
  expr <- vstack(x, y)
  prob <- Problem(Minimize(sum(Im(Conj(expr)))), list(x == 0, Re(y) == 0, Im(y) <= 1))
  result <- solve(prob)
  expect_equal(result$value, -6, tolerance = TOL)
  expect_equal(result$getValue(y), 1i*matrix(1, nrow = 3, ncol = 2), tolerance = TOL)
  expect_equal(result$getValue(x), matrix(0, nrow = 2, ncol = 2), tolerance = TOL)
})

# test_that("test with parameters", {
#  p <- Parameter(imag = TRUE, value = 1i)
#  x <- Variable(2, complex = TRUE)
#  prob <- Problem(Maximize(sum(Im(x) + Re(x))), list(abs(p*x) <= 2))
#  result <- solve(prob)
#  expect_equal(result$value, 4*sqrt(2), tolerance = TOL)
#  val <- matrix(sqrt(2), nrow = 2, ncol = 1)
#  expect_equal(result$getValue(x), val + 1i*val)
# })

test_that("test with absolute value", {
  skip_on_cran()
  x <- Variable(2, complex = TRUE)
  prob <- Problem(Maximize(sum(Im(x) + Re(x))), list(abs(x) <= 2))
  result <- solve(prob)
  expect_equal(result$value, 4*sqrt(2))
  val <- matrix(sqrt(2), nrow = 2, ncol = 1)
  expect_equal(result$getValue(x), val + 1i*val)
})

test_that("test with p-norm", {
  skip_on_cran()
  x <- Variable(1, 2, complex = TRUE)
  prob <- Problem(Maximize(sum(Im(x) + Re(x))), list(norm1(x) <= 2))
  result <- solve(prob)
  expect_equal(result$value, 2*sqrt(2), tolerance = TOL)
  val <- matrix(sqrt(2)/2, nrow = 2, ncol = 1)
  # expect_equal(result$getValue(x), val + 1i*val)

  x <- Variable(2, 2, complex = TRUE)
  prob <- Problem(Maximize(sum(Im(x) + Re(x))), list(p_norm(x, p = 2) <= sqrt(8)))
  result <- solve(prob)
  expect_equal(result$value, 8, tolerance = TOL)
  val <- matrix(1, nrow = 2, ncol = 2)
  expect_equal(result$getValue(x), val + 1i*val, tolerance = TOL)
})

test_that("test matrix norms", {
  skip_on_cran()
  P <- 0:7 - 2i*(0:7)
  P <- matrix(P, nrow = 2, ncol = 4, byrow = TRUE)
  sigma_max <- base:::norm(P, type = "2")
  X <- Variable(2, 4, complex = TRUE)
  prob <- Problem(Minimize(norm(X, "2")), list(X == P))
  result <- solve(prob)
  expect_equal(result$value, sigma_max, tolerance = 1e-3)

  norm_nuc_val <- sum(svd(P)$d)
  X <- Variable(2, 4, complex = TRUE)
  prob <- Problem(Minimize(norm_nuc(X)), list(X == P))
  result <- solve(prob, solver = "SCS", eps = 1e-4)
  expect_equal(result$value, norm_nuc_val, tolerance = 0.1)
})

test_that("test log-determinant", {
  skip_on_cran()
  P <- (0:8) - 2i*(0:8)
  P <- matrix(P, nrow = 3, ncol = 3)
  P <- Conj(t(P)) %*% P/100 + diag(0.1, 3)
  value <- value(log_det(P))
  X <- Variable(3, 3, complex = TRUE)
  prob <- Problem(Maximize(log_det(X)), list(X == P))
  result <- solve(prob, solver = "SCS", eps = 1e-6)
  expect_equal(result$value, value, tolerance = 1e-2)
})

test_that("test eigenvalue atoms", {
  skip_on_cran()
  P <- (0:8) - 2i*(0:8)
  P <- matrix(P, nrow = 3, ncol = 3)
  P1 <- Conj(t(P)) %*% P/10 + diag(0.1, 3)
  P2 <- rbind(c(10, 1i, 0), c(-1i, 10, 0), c(0, 0, 1))
  for(P in list(P1, P2)) {
    value <- value(lambda_max(P))
    # X <- Variable(dim(P), complex = TRUE)
    X <- Variable(nrow(P), ncol(P), complex = TRUE)
    prob <- Problem(Minimize(lambda_max(X)), list(X == P))
    result <- solve(prob, solver = "SCS", eps = 1e-5)
    expect_equal(result$value, value, tolerance = 1e-2)

    eigs <- Re(eigen(P, only.values = TRUE)$values)
    value <- value(sum_largest(eigs, 2))
    # X <- Variable(dim(P), complex = TRUE)
    X <- Variable(nrow(P), ncol(P), complex = TRUE)
    prob <- Problem(Minimize(lambda_sum_largest(X, 2)), list(X == P))
    result <- solve(prob, solver = "SCS", eps = 1e-8, verbose = TRUE)
    expect_equal(result$value, value, tolerance = 1e-3)
    expect_equal(result$getValue(X), P, tolerance = 1e-3)

    value <- value(sum_smallest(eigs, 2))
    # X <- Variable(dim(P), complex = TRUE)
    X <- Variable(nrow(P), ncol(P), complex = TRUE)
    prob <- Problem(Maximize(lambda_sum_smallest(X, 2)), list(X == P))
    result <- solve(prob, solver = "SCS", eps = 1e-6)
    expect_equal(result$value, value, tolerance = 1e-3)
  }
})

test_that("test quad_form atom", {
  skip_on_cran()
  # Create a random positive definite Hermitian matrix for all tests.
  set.seed(42)
  P <- matrix(rnorm(9), nrow = 3, ncol = 3) - 1i*matrix(rnorm(9), nrow = 3, ncol = 3)
  P <- Conj(t(P)) %*% P

  # Solve a problem with real variable.
  b <- 0:2
  x <- Variable(3, complex = FALSE)
  value <- value(quad_form(b, P))
  prob <- Problem(Minimize(quad_form(x, P)), list(x == b))
  result <- solve(prob)
  expect_equal(result$value, Re(value[1]))

  # Solve a problem with complex variable.
  b <- (0:2) + 3i*(0:2 + 10)
  x <- Variable(3, complex = TRUE)
  value <- value(quad_form(b, P))
  prob <- Problem(Minimize(quad_form(x, P)), list(x == b))
  result <- solve(prob)
  normalization <- max(abs(result$value), abs(value))
  expect_equal(result$value/normalization, Re(value[1])/normalization, tolerance = 1e-5)

  # Solve a problem with imaginary variable.
  b <- 3i*(0:2 + 10)
  x <- Variable(3, imag = TRUE)
  value <- value(quad_form(b, P))
  expr <- quad_form(x, P)
  prob <- Problem(Minimize(expr), list(x == b))
  result <- solve(prob)
  normalization <- max(abs(result$value), abs(value))
  expect_equal(result$value/normalization, Re(value[1])/normalization, tolerance = TOL)
})

test_that("test matrix_frac atom", {
  skip_on_cran()
  P <- rbind(c(10, 1i), c(-1i, 10))
  Y <- Variable(2, 2, complex = TRUE)
  b <- 0:1
  x <- Variable(2, complex = FALSE)
  value <- value(matrix_frac(b, P))
  expr <- matrix_frac(x, Y)
  prob <- Problem(Minimize(expr), list(x == b, Y == P))
  result <- solve(prob, solver = "SCS", eps = 1e-6, max_iters = 7500, verbose = TRUE)
  expect_equal(result$value, Re(value[1]), tolerance = 1e-3)

  b <- (0:1 + 3i*(0:1 + 10))
  x <- Variable(2, complex = TRUE)
  value <- value(matrix_frac(b, P))
  expr <- matrix_frac(x, Y)
  prob <- Problem(Minimize(expr), list(x == b, Y == P))
  result <- solve(prob, solver = "SCS", eps = 1e-6)
  expect_equal(result$value, Re(value[1]), tolerance = 1e-3)

  b <- (0:1 + 10)/10i
  x <- Variable(2, imag = TRUE)
  value <- value(matrix_frac(b, P))
  expr <- matrix_frac(x, Y)
  prob <- Problem(Minimize(expr), list(x == b, Y == P))
  result <- solve(prob, solver = "SCS", eps = 1e-5, max_iters = 7500)
  expect_equal(result$value, Re(value[1]), tolerance = 1e-3)
})

test_that("test Hermitian variables", {
  skip_on_cran()
  X <- Variable(2, 2, hermitian = TRUE)
  prob <- Problem(Minimize(Im(X[2,1])), list(X[1,1] == 2, X[2,2] == 3, X[1,2] == 1+1i))
  result <- solve(prob)
  expect_equal(result$getValue(X), cbind(c(2, 1-1i), c(1+1i, 3)))
})

test_that("test positive semidefinite variables", {
  skip_on_cran()
  X <- Variable(2, 2, hermitian = TRUE)
  prob <- Problem(Minimize(Im(X[2,1])), list(X %>>% 0, X[1,1] == -1))
  result <- solve(prob)
  expect_equal(result$status, "infeasible")
})

test_that("test promotion of complex variables", {
  skip_on_cran()
  v <- Variable(complex = TRUE)
  obj <- Maximize(Re(sum(v * matrix(1, nrow = 2, ncol = 2))))
  con <- list(cvxr_norm(v) <= 1)
  prob <- Problem(obj, con)
  result <- solve(prob, reltol = 1e-6, abstol = 1e-6)
  expect_equal(result$value, 4.0, tolerance = TOL)
})

# TODO_NARAS_2: Figure out how to handle complex sparse matrices in R.
# test_that("test problem with complex sparse matrix", {
#   # Define sparse matrix [[0, 1i], [-1i, 0]]
#   require(Matrix)
#   A <- rbind(c(0, 1i), c(-1i, 0))
#   A_sparse <- Matrix(A, sparse = TRUE)
#
#   # Feasibility with sparse matrix.
#   rho <- Variable(2, 2, complex = TRUE)
#   Id <- diag(2)
#   obj <- Maximize(0)
#   cons <- list(A_sparse %*% rho == Id)
#   prob <- Problem(obj, cons)
#   result <- solve(prob)
#   rho_sparse <- value(rho)
#   # Infeasible here, which is wrong!
#
#   # Feasibility with R matrices.
#   rho <- Variable(2, 2, complex = TRUE)
#   Id <- diag(2)
#   obj <- Maximize(0)
#   cons <- list(A %*% rho == Id)
#   prob <- Problem(obj, cons)
#   result <- solve(prob)
#   expect_equal(result$getValue(rho), rho_sparse)
# })

test_that("test with special index", {
  skip_on_cran()
  c <- c(0, 1)
  n <- length(c)

  # Create optimization variables.
  f <- Variable(n, n, hermitian = TRUE)

  # Create constraints.
  constraints <- list(f %>>% 0)
  for(k in seq_len(n-1)) {   # TODO: Check indices match range in Python.
    i <- seq(from = n-k, length.out = k)
    indices <- (i*n) + i - (n-k) + 1
    constraints <- c(constraints, sum(vec(f)[indices]) == c[n-k+1])
  }

  # Form objective.
  obj <- Maximize(c[1] - Re(matrix_trace(f)))

  # Form and solve problem.
  prob <- Problem(obj, constraints)
  sol <- solve(prob)
  expect_equal(sol$status, "optimal")
})

test_that("test that complex arguments are rejected", {
  skip_on_cran()
  x <- Variable(complex = TRUE)
  expect_error(x >= 0, "Inequality constraints cannot be complex.")
  expect_error(quad_over_lin(x, x), "The second argument to QuadOverLin cannot be complex.")
  expect_error(sum_largest(x, 2), "Arguments to SumLargest cannot be complex.")

  x <- Variable(2, complex = TRUE)
  for(atom in c("GeoMean", "LogSumExp", "MaxEntries", "Entr", "Exp", "Huber", "Log", "Log1p", "Logistic")) {
    print(atom)
    error_msg <- paste("Arguments to ", atom, " cannot be complex.", sep = "")

    if(atom %in% c("LogSumExp", "MaxEntries"))
      expect_error(new(atom, expr = x), error_msg)
    else
      expect_error(new(atom, x = x), error_msg)
  }

  x <- Variable(2, complex = TRUE)
  for(atom in c("MaxElemwise", "KLDiv")) {
    print(atom)
    error_msg <- paste("Arguments to ", atom, " cannot be complex.", sep = "")

    if(atom == "MaxElemwise")
      expect_error(max_elemwise(x, x), error_msg)
    else
      expect_error(kl_div(x, x), error_msg)
  }

  x <- Variable(2, complex = TRUE)
  for(atom in c(inv_pos, sqrt, function(y) { power(y, 0.2) })) {
    expect_error(atom(x), "Arguments to Power cannot be complex.")
  }

  x <- Variable(2, complex = TRUE)
  for(atom in c(harmonic_mean, function(y) { p_norm(y, 0.2) })) {
    expect_error(atom(x), "Pnorm(x, p) cannot have x complex for p < 1.", fixed = TRUE)
  }
})

context("test-g01-domain")
TOL <- 1e-6

a <- Variable(name = "a")

x <- Variable(2, name = "x")
y <- Variable(2, name = "y")
z <- Variable(3, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

# test_that("Test domain for partial minimization/maximization problems", {
#   for(obj in list(Minimize(a^-1), Maximize(log(a)))) {
#     prob <- Problem(obj, list(x + a >= c(5,8)))

    # Optimize over nothing
    # expr <- partial_optimize(prob, dont_opt_vars = list(x, a))
    # dom <- domain(expr)
    # constr <- list(a >= -100, x >= 0)
    # prob <- Problem(Minimize(sum(x + a)), c(dom, constr))
    # result <- solve(prob)
    # expect_equal(result$value, 13, tolerance = TOL)
    # expect_true(result$getValue(a) >= 0)
    # expect_true(all(value(x + a - c(5, 8)) >= -1e-3))

    # Optimize over x
    # expr <- partial_optimize(prob, opt_vars = list(x))
    # dom <- domain(expr)
    # constr <- list(a >= -100, x >= 0)
    # prob <- Problem(Minimize(sum(x + a)), c(dom, constr))
    # result <- solve(prob)
    # expect_equal(result$value, 0, tolerance = TOL)
    # expect_true(result$getValue(a) >= 0)
    # expect_equal(result$getValue(x), matrix(c(0,0)))

    # Optimize over x and a
    # expr <- partial_optimize(prob, opt_vars = list(x, a))
    # dom <- domain(expr)
    # constr <- list(a >= -100, x >= 0)
    # prob <- Problem(Minimize(sum(x + a)), c(dom, constr))
    # result <- solve(prob)
    # expect_equal(result$getValue(a), -100, tolerance = TOL)
    # expect_equal(result$getValue(x), matrix(c(0,0)), tolerance = TOL)
#   }
# })

test_that("Test domain for geo_mean", {
  skip_on_cran()
  dom <- domain(geo_mean(x))
  prob <- Problem(Minimize(sum(x)), dom)
  result <- solve(prob)
  expect_equal(result$value, 0, tolerance = TOL)

  # No special case for only one weight
  dom <- domain(geo_mean(x, c(0,2)))
  dom <- c(dom, x >= -1)
  prob <- Problem(Minimize(sum(x)), dom)
  result <- solve(prob)
  expect_equal(result$getValue(x), matrix(c(-1,0)), tolerance = TOL)

  dom <- domain(geo_mean(z, c(0,1,1)))
  dom <- c(dom, z >= -1)
  prob <- Problem(Minimize(sum(z)), dom)
  result <- solve(prob)
  expect_equal(result$getValue(z), matrix(c(-1,0,0)))
})

test_that("Test domain for quad_over_lin", {
  skip_on_cran()
  dom <- domain(quad_over_lin(x, a))
  result <- solve(Problem(Minimize(a), dom))
  expect_equal(result$getValue(a), 0, tolerance = TOL)
})

test_that("Test domain for lambda_max", {
  skip_on_cran()
  dom <- domain(lambda_max(A))
  A0 <- rbind(c(1,2), c(3,4))
  result <- solve(Problem(Minimize(norm2(A-A0)), dom))
  expect_equal(result$getValue(A), rbind(c(1,2.5), c(2.5,4)), tolerance = TOL)
})

test_that("Test domain for p_norm", {
  skip_on_cran()
  dom <- domain(p_norm(a, -0.5))
  prob <- Problem(Minimize(a), dom)
  result <- solve(prob)
  expect_equal(result$value, 0, tolerance = TOL)
})

test_that("Test domain for log", {
  skip_on_cran()
  dom  <- domain(log(a))
  result <- solve(Problem(Minimize(a), dom))
  expect_equal(result$getValue(a), 0, tolerance = TOL)
})

test_that("Test domain for log1p", {
  skip_on_cran()
  dom <- domain(log1p(a))
  result <- solve(Problem(Minimize(a), dom))
  expect_equal(result$getValue(a), -1, tolerance = TOL)
})

test_that("Test domain for entr", {
  skip_on_cran()
  dom <- domain(entr(a))
  result <- solve(Problem(Minimize(a), dom))
  expect_equal(result$getValue(a), 0, tolerance = TOL)
})

test_that("Test domain for kl_div", {
  skip_on_cran()
  b <- Variable()
  dom <- domain(kl_div(a, b))
  result <- solve(Problem(Minimize(a + b), dom))
  expect_equal(result$getValue(a), 0, tolerance = TOL)
  expect_equal(result$getValue(b), 0, tolerance = TOL)
})

test_that("Test domain for power", {
  skip_on_cran()
  dom <- domain(sqrt(a))
  result <- solve(Problem(Minimize(a), dom))
  expect_equal(result$getValue(a), 0, tolerance = TOL)

  dom <- domain(a^2)
  result <- solve(Problem(Minimize(a), c(dom, a >= -100)))
  expect_equal(result$getValue(a), -100, tolerance = TOL)

  dom <- domain(a^-1)
  result <- solve(Problem(Minimize(a), c(dom, a >= -100)))
  expect_equal(result$getValue(a), 0, tolerance = TOL)

  dom <- domain(a^3)
  result <- solve(Problem(Minimize(a), c(dom, a >= -100)))
  expect_equal(result$getValue(a), 0, tolerance = TOL)
})

test_that("Test domain for log_det", {
  skip_on_cran()
  dom <- domain(log_det(A + diag(rep(1,2))))
  prob <- Problem(Minimize(sum(diag(A))), dom)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$value, -2, tolerance = 1e-3)
})

test_that("Test domain for matrix_frac", {
  skip_on_cran()
  dom <- domain(matrix_frac(x, A + diag(rep(1,2))))
  prob <- Problem(Minimize(sum(diag(A))), dom)
  result <- solve(prob, solver = "SCS")
  expect_equal(result$value, -2, tolerance = 1e-3)
})

context("test-g01-dgp")
TOL <- 1e-6

test_that("test product", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  prod <- x*y
  expect_true(is_dgp(prod))
  expect_true(is_log_log_convex(prod))
  expect_true(is_log_log_concave(prod))

  prod <- prod*prod
  expect_true(is_dgp(prod))
  expect_true(is_log_log_convex(prod))
  expect_true(is_log_log_concave(prod))

  prod <- 5.0*prod
  expect_true(is_dgp(prod))
  expect_true(is_log_log_convex(prod))
  expect_true(is_log_log_concave(prod))

  prod <- -5.0*prod
  expect_false(is_dgp(prod))
  expect_false(is_log_log_convex(prod))
  expect_false(is_log_log_concave(prod))
})

test_that("test product with unconstrained variables is not DGP", {
  skip_on_cran()
  x <- Variable()
  y <- Variable()
  prod <- x*y
  expect_false(is_dgp(prod))
  expect_false(is_log_log_convex(prod))
  expect_false(is_log_log_concave(prod))

  z <- Variable(pos = TRUE)
  prod <- x*z
  expect_false(is_dgp(prod))
  expect_false(is_log_log_convex(prod))
  expect_false(is_log_log_concave(prod))
})

test_that("test division", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  div <- x/y

  expect_true(is_log_log_affine(div))

  posynomial <- 5.0*x*y + 1.2*y*y
  div <- posynomial/(3.0*x*y^(-0.1))
  expect_true(is_log_log_convex(div))
  expect_false(is_log_log_concave(div))
  expect_true(is_dgp(div))

  div <- posynomial/(3.0*x + y)
  expect_false(is_log_log_convex(div))
  expect_false(is_log_log_concave(div))
  expect_false(is_dgp(div))
})

test_that("test add", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  expr <- x + y
  expect_true(is_dgp(expr))
  expect_true(is_log_log_convex(expr))
  expect_false(is_log_log_concave(expr))

  posynomial <- 5.0*x*y + 1.2*y*y
  expect_true(is_dgp(posynomial))
  expect_true(is_log_log_convex(posynomial))
})

test_that("test add with unconstrained variables is not DGP", {
  skip_on_cran()
  x <- Variable()
  y <- Variable(pos = TRUE)
  expr <- x + y
  expect_false(is_dgp(expr))
  expect_false(is_log_log_convex(expr))
  expect_false(is_log_log_concave(expr))

  posynomial <- 5.0*x*y + 1.2*y*y
  expect_false(is_dgp(posynomial))
  expect_false(is_log_log_convex(posynomial))
  expect_false(is_log_log_concave(posynomial))
})

test_that("test monomials", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)
  monomial <- 5.0*(x^(0.1)) * y^(-0.1) * z^3
  expect_true(is_dgp(monomial))
  expect_true(is_log_log_convex(monomial))
  expect_true(is_log_log_concave(monomial))

  monomial <- -1.0*monomial
  expect_false(is_dgp(monomial))
  expect_false(is_log_log_convex(monomial))
  expect_false(is_log_log_concave(monomial))
})

test_that("test elementwise maximum", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)
  monomial <- 5.0*(x^(0.1)) * y^(-0.1) * z^3
  posynomial <- 5.0*x*y + 1.2*y*y
  another_posynomial <- posynomial*posynomial
  expr <- max_elemwise(monomial, posynomial, another_posynomial)
  expect_true(is_dgp(expr))
  expect_true(is_log_log_convex(expr))
  expect_false(is_log_log_concave(expr))

  expr <- posynomial*expr
  expect_true(is_dgp(expr))
  expect_true(is_log_log_convex(expr))
  expect_false(is_log_log_concave(expr))

  expr <- posynomial*expr + expr
  expect_true(is_dgp(expr))
  expect_true(is_log_log_convex(expr))
})

test_that("test elementwise minimum", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)
  monomial <- 5.0*(x^(0.1)) * y^(-0.1) * z^3
  posynomial <- 5.0*x*y + 1.2*y*y
  another_posynomial <- posynomial*posynomial
  expr <- min_elemwise(monomial, 1/posynomial, 1/another_posynomial)
  expect_true(is_dgp(expr))
  expect_false(is_log_log_convex(expr))
  expect_true(is_log_log_concave(expr))

  expr <- (1/posynomial)*expr
  expect_true(is_dgp(expr))
  expect_false(is_log_log_convex(expr))
  expect_true(is_log_log_concave(expr))

  expr <- expr^2
  expect_true(is_dgp(expr))
  expect_false(is_log_log_convex(expr))
  expect_true(is_log_log_concave(expr))
})

test_that("test constant", {
  skip_on_cran()
  x <- Constant(1.0)
  expect_true(is_dgp(x))
  expect_false(is_dgp(-1.0*x))
})

test_that("test geometric mean", {
  skip_on_cran()
  x <- Variable(3, pos = TRUE)
  p <- c(1, 2, 0.5)
  expr <- geo_mean(x, p)
  expect_true(is_dgp(expr))
  expect_true(is_log_log_affine(expr))
  expect_true(is_log_log_convex(expr))
  expect_true(is_log_log_concave(expr))
})

context("test-g01-constraints")
TOL <- 1e-6

a <- Variable(name = "a")
b <- Variable(name = "b")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

SOC <- CVXR:::SOC
save_value <- CVXR:::save_value

test_that("test the EqConstraint class", {
  skip_on_cran()
  constr <- x == z
  expect_equal(name(constr), "x == z")
  expect_equal(dim(constr), c(2,1))

  # Test value and dual_value
  expect_true(is.na(dual_value(constr)))
  expect_error(constr_value(constr))

  x <- save_value(x, 2)
  z <- save_value(z, 2)
  constr <- x == z
  expect_true(constr_value(constr))
  x <- save_value(x, 3)
  constr <- x == z
  expect_false(constr_value(constr))

  value(x) <- c(2,1)
  value(z) <- c(2,2)
  constr <- x == z
  expect_false(constr_value(constr))
  expect_equal(violation(constr), matrix(c(0,1)), tolerance = TOL)
  expect_equal(residual(constr), matrix(c(0,1)), tolerance = TOL)

  value(z) <- c(2,1)
  constr <- x == z
  expect_true(constr_value(constr))
  expect_equal(violation(constr), matrix(c(0,0)))
  expect_equal(residual(constr), matrix(c(0,0)))

  expect_error(x == y)
})

test_that("test the LeqConstraint class", {
  skip_on_cran()
  constr <- x <= z
  expect_equal(name(constr), "x <= z")
  expect_equal(dim(constr), c(2,1))

  # Test value and dual_value
  expect_true(is.na(dual_value(constr)))
  expect_error(constr_value(constr))
  x <- save_value(x, 1)
  z <- save_value(z, 2)
  constr <- x <= z
  expect_true(constr_value(constr))
  x <- save_value(x, 3)
  constr <- x <= z
  expect_false(constr_value(constr))

  value(x) <- c(2,1)
  value(z) <- c(2,0)
  constr <- x <= z
  expect_false(constr_value(constr))
  expect_equal(violation(constr), matrix(c(0,1)), tolerance = TOL)
  expect_equal(residual(constr), matrix(c(0,1)), tolerance = TOL)

  value(z) <- c(2,2)
  constr <- x <= z
  expect_true(constr_value(constr))
  expect_equal(violation(constr), matrix(c(0,0)), tolerance = TOL)
  expect_equal(residual(constr), matrix(c(0,0)), tolerance = TOL)

  expect_error(x <= y)
})

test_that("Test the PSD constraint %>>%", {
  skip_on_cran()
  constr <- A %>>% B
  expect_equal(name(constr), "A + -B >> 0")
  expect_equal(dim(constr), c(2,2))

  # Test value and dual_value
  expect_true(is.na(dual_value(constr)))
  expect_error(constr_value(constr))
  A <- save_value(A, rbind(c(2,-1), c(1,2)))
  B <- save_value(B, rbind(c(1,0), c(0,1)))
  constr <- A %>>% B
  expect_true(constr_value(constr))
  expect_equal(violation(constr), 0, tolerance = TOL)
  expect_equal(residual(constr), 0, tolerance = TOL)

  B <- save_value(B, rbind(c(3,0), c(0,3)))
  constr <- A %>>% B
  expect_false(constr_value(constr))
  expect_equal(violation(constr), 1, tolerance = TOL)
  expect_equal(residual(constr), 1, tolerance = TOL)

  expect_error(x %>>% 0, "Non-square matrix in positive definite constraint.")
})

test_that("Test the PSD constraint %<<%", {
  skip_on_cran()
  constr <- A %<<% B
  expect_equal(name(constr), "B + -A >> 0")
  expect_equal(dim(constr), c(2,2))

  # Test value and dual_value
  expect_true(is.na(dual_value(constr)))
  expect_error(constr_value(constr))
  B <- save_value(B, rbind(c(2,-1), c(1,2)))
  A <- save_value(A, rbind(c(1,0), c(0,1)))
  constr <- A %<<% B
  expect_true(constr_value(constr))
  A <- save_value(A, rbind(c(3,0), c(0,3)))
  constr <- A %<<% B
  expect_false(constr_value(constr))

  expect_error(x %<<% 0, "Non-square matrix in positive definite constraint.")
})

test_that("test the >= operator", {
  skip_on_cran()
  constr <- z >= x
  expect_equal(name(constr), "x <= z")
  expect_equal(dim(constr), c(2,1))
  expect_error(y >= x)
})

test_that("test the SOC class", {
  skip_on_cran()
  exp <- x + z
  scalar_exp <- a + b
  constr <- SOC(scalar_exp, exp)
  expect_equal(size(constr), 3)
})

context("test-g01-atoms")
TOL <- 1e-5

CONSTANT <- "CONSTANT"
AFFINE <- "AFFINE"
CONVEX <- "CONVEX"
CONCAVE <- "CONCAVE"
ZERO <- "ZERO"
UNKNOWN <- "UNKNOWN"
NONNEG <- "NONNEGATIVE"
NONPOS <- "NONPOSITIVE"

a <- Variable(name = "a")

x <- Variable(2, name = "x")
y <- Variable(2, name = "y")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

test_that("test the norm_inf function", {
  exp <- x + y
  atom <- norm_inf(exp)

  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)
  expect_true(is_convex(atom))
  expect_true(is_concave(-atom))
  expect_equal(curvature(norm_inf(atom)), CONVEX)
  expect_equal(curvature(norm_inf(-atom)), CONVEX)
})

test_that("test the norm1 function", {
  exp <- x + y
  atom <- norm1(exp)

  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)
  expect_equal(curvature(norm1(atom)), CONVEX)
  expect_equal(curvature(norm1(-atom)), CONVEX)
})

test_that("test quad_form function", {
  P <- Parameter(2,2)
  expr <- quad_form(x, P)
  expect_false(is_dcp(expr))
})

test_that("test the power function", {
  for(a_dim in list(c(1, 1), c(3, 1), c(2, 3))) {
    # x_pow <- Variable(a_dim)
    # y_pow <- Variable(a_dim)
    x_pow <- new("Variable", dim = a_dim)
    y_pow <- new("Variable", dim = a_dim)
    exp <- x_pow + y_pow

    for(p in c(0, 1, 2, 3, 2.7, 0.67, -1, -2.3, 4/5)) {
      atom <- power(exp, p)
      expect_equal(dim(atom), a_dim)

      if(p > 1 || p < 0)
        expect_equal(curvature(atom), CONVEX)
      else if(p == 1)
        expect_equal(curvature(atom), AFFINE)
      else if(p == 0)
        expect_equal(curvature(atom), CONSTANT)
      else
        expect_equal(curvature(atom), CONCAVE)

      if(p != 1)
        expect_equal(sign(atom), NONNEG)
    }
  }
  expect_error(value(power(-1, 3)),
               "Power cannot be applied to negative values", fixed = TRUE)

  expect_error(value(power(0, -1)),
               "Power cannot be applied to negative or zero values", fixed = TRUE)

})

test_that("test the geo_mean function", {
  atom <- geo_mean(x)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)
})

test_that("test the harmonic_mean function", {
  atom <- harmonic_mean(x)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)
})

test_that("test the p_norm function", {
  atom <- p_norm(x, p = 1.5)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = 1)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = 2)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = Inf)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = 0.5)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = 0.7)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = -0.1)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = -1)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)

  atom <- p_norm(x, p = -1.3)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONCAVE)
  expect_equal(sign(atom), NONNEG)
})

test_that("test matrix norms", {
  for(p in c("1", "2", "I", "F", "M")) {
    for(var in c(A, C)) {
      atom <- norm(var, p)
      # expect_equal(dim(atom), NULL)
      expect_equal(dim(atom), c(1,1))
      expect_equal(curvature(atom), CONVEX)
      expect_equal(sign(atom), NONNEG)

      value(var) <- matrix(rnorm(size(var)), nrow = nrow(var), ncol = ncol(var))
      expect_equal(value(norm(var, p)), base:::norm(value(var), type = p))
    }
  }
})

test_that("test the quad_over_lin function", {
  atom <- quad_over_lin(x^2, a)
  expect_equal(curvature(atom), CONVEX)

  atom <- quad_over_lin(-x^2, a)
  expect_equal(curvature(atom), CONVEX)

  atom <- quad_over_lin(sqrt(x), a)
  expect_equal(curvature(atom), UNKNOWN)
  expect_false(is_dcp(atom))

  expect_error(quad_over_lin(x, x),
               "The second argument to QuadOverLin must be a scalar.", fixed = TRUE)
})

test_that("test the arg count for max_elemwise and min_elemwise", {
  expect_error(max_elemwise(1),
               "argument \"arg2\" is missing, with no default", fixed = TRUE)
  expect_error(min_elemwise(1),
               "argument \"arg2\" is missing, with no default", fixed = TRUE)
})

test_that("test the matrix_frac function", {
  atom <- matrix_frac(x, A)
  # expect_equal(dim(atom), NULL)
  expect_equal(dim(atom), c(1,1))
  expect_equal(curvature(atom), CONVEX)

  # Test matrix_frac dim validation
  expect_error(matrix_frac(x, C),
               "The second argument to MatrixFrac must be a square matrix.", fixed = TRUE)
  expect_error(matrix_frac(Variable(3), A),
               "The arguments to MatrixFrac have incompatible dimensions.", fixed = TRUE)
})

test_that("test the sign for max_entries", {
  expect_equal(sign(max_entries(1)), NONNEG)
  expect_equal(sign(max_entries(-2)), NONPOS)
  expect_equal(sign(max_entries(Variable())), UNKNOWN)
  expect_equal(sign(max_entries(0)), ZERO)

  # Test with axis argument
  expect_equal(dim(max_entries(Variable(2), axis = 1)), c(2, 1))
  expect_equal(dim(max_entries(Variable(2), axis = 2, keepdims = TRUE)), c(1, 1))
  # expect_equal(dim(max_entries(Variable(c(2, 3)), axis = 1)), 2)
  # expect_equal(dim(max_entries(Variable(c(2, 3)), axis = 2, keepdims = TRUE)), c(1, 3))
  expect_equal(dim(max_entries(Variable(2, 3), axis = 1)), c(2, 1))
  expect_equal(dim(max_entries(Variable(2, 3), axis = 2, keepdims = TRUE)), c(1, 3))

  # Invalid axis
  expect_error(max_entries(x, axis = 4),
               "Invalid argument for axis. Must be an integer between 1 and 2", fixed = TRUE)
})

test_that("test the sign for min_entries", {
  expect_equal(sign(min_entries(1)), NONNEG)
  expect_equal(sign(min_entries(-2)), NONPOS)
  expect_equal(sign(min_entries(Variable())), UNKNOWN)
  expect_equal(sign(min_entries(0)), ZERO)

  # Test with axis argument
  expect_equal(dim(min_entries(Variable(2), axis = 1)), c(2, 1))
  expect_equal(dim(min_entries(Variable(2), axis = 2, keepdims = TRUE)), c(1, 1))
  # expect_equal(dim(min_entries(Variable(c(2, 3)), axis = 1)), 2)
  # expect_equal(dim(min_entries(Variable(c(2, 3)), axis = 2, keepdims = TRUE)), c(1, 3))
  expect_equal(dim(min_entries(Variable(2, 3), axis = 1)), c(2, 1))
  expect_equal(dim(min_entries(Variable(2, 3), axis = 2, keepdims = TRUE)), c(1, 3))

  # Invalid axis
  expect_error(min_entries(x, axis = 4),
               "Invalid argument for axis. Must be an integer between 1 and 2", fixed = TRUE)
})

test_that("test sign logic for max_elemwise", {
  expect_equal(sign(max_elemwise(1, 2)), NONNEG)
  expect_equal(sign(max_elemwise(1, Variable())), NONNEG)
  expect_equal(sign(max_elemwise(1, -2)), NONNEG)
  expect_equal(sign(max_elemwise(1, 0)), NONNEG)

  expect_equal(sign(max_elemwise(Variable(), 0)), NONNEG)
  expect_equal(sign(max_elemwise(Variable(), Variable())), UNKNOWN)
  expect_equal(sign(max_elemwise(Variable(), -2)), UNKNOWN)

  expect_equal(sign(max_elemwise(0, 0)), ZERO)
  expect_equal(sign(max_elemwise(0, -2)), ZERO)

  expect_equal(sign(max_elemwise(-3, -2)), NONPOS)

  # Many args
  expect_equal(sign(max_elemwise(-2, Variable(), 0, -1, Variable(), -1)), NONNEG)

  # Promotion
  expect_equal(sign(max_elemwise(1, Variable(2))), NONNEG)
  expect_equal(dim(max_elemwise(1, Variable(2))), c(2, 1))
})

test_that("test sign logic for min_elemwise", {
  expect_equal(sign(min_elemwise(1, 2)), NONNEG)
  expect_equal(sign(min_elemwise(1, Variable())), UNKNOWN)
  expect_equal(sign(min_elemwise(1, -2)), NONPOS)
  expect_equal(sign(min_elemwise(1, 0)), ZERO)

  expect_equal(sign(min_elemwise(Variable(), 0)), NONPOS)
  expect_equal(sign(min_elemwise(Variable(), Variable())), UNKNOWN)
  expect_equal(sign(min_elemwise(Variable(), -2)), NONPOS)

  expect_equal(sign(min_elemwise(0, 0)), ZERO)
  expect_equal(sign(min_elemwise(0, -2)), NONPOS)

  expect_equal(sign(min_elemwise(-3, -2)), NONPOS)

  # Many args
  expect_equal(sign(min_elemwise(-2, Variable(), 0, -1, Variable(), 1)), NONPOS)

  # Promotion
  expect_equal(sign(min_elemwise(-1, Variable(2))), NONPOS)
  expect_equal(dim(min_elemwise(-1, Variable(2))), c(2, 1))
})

test_that("test the sum_entries function", {
  expect_equal(sign(sum_entries(1)), NONNEG)
  expect_equal(sign(sum_entries(c(1, -1))), UNKNOWN)
  expect_equal(curvature(sum_entries(c(1, -1))), CONSTANT)
  expect_equal(sign(sum_entries(Variable(2))), UNKNOWN)
  # expect_equal(dim(sum_entries(Variable(2))), NULL)
  expect_equal(dim(sum_entries(Variable(2))), c(1, 1))
  expect_equal(curvature(sum_entries(Variable(2))), AFFINE)
  # expect_equal(dim(sum_entries(Variable(c(2, 1)), keepdims = TRUE)), c(1, 1))
  expect_equal(dim(sum_entries(Variable(2, 1), keepdims = TRUE)), c(1, 1))

  # Mixed curvature
  mat <- matrix(c(1,-1), nrow = 1, ncol = 2)
  expect_equal(curvature(sum_entries( mat %*% Variable(2)^2 )), UNKNOWN)

  # Test with axis argument
  expect_equal(dim(sum_entries(Variable(2), axis = 1)), c(2, 1))
  # expect_equal(dim(sum_entries(Variable(2), axis = 2)), NULL)
  expect_equal(dim(sum_entries(Variable(2), axis = 2)), c(1, 1))
  # expect_equal(dim(sum_entries(Variable(c(2, 3)), axis = 1)), 2)
  # expect_equal(dim(sum_entries(Variable(c(2, 3)), axis = 2, keepdims = TRUE)), c(1, 3))
  # expect_equal(dim(sum_entries(Variable(c(2, 3)), axis = 2, keepdims = FALSE)), 3)
  expect_equal(dim(sum_entries(Variable(2, 3), axis = 1)), c(2, 1))
  expect_equal(dim(sum_entries(Variable(2, 3), axis = 2, keepdims = TRUE)), c(1, 3))
  expect_equal(dim(sum_entries(Variable(2, 3), axis = 2, keepdims = FALSE)), c(3, 1))

  # Invalid axis
  expect_error(sum_entries(x, axis = 4),
               "Invalid argument for axis. Must be an integer between 1 and 2", fixed = TRUE)

  A <- diag(3)
  expect_equal(value(CVXR::sum_entries(A)), 3)

  A <- diag(3)
  expect_equal(value(CVXR::sum_entries(A, axis = 1)), c(1, 1, 1))

})

test_that("test the multiply function", {
  expect_equal(sign(multiply(c(1, -1), x)), UNKNOWN)
  expect_equal(curvature(multiply(c(1, -1), x)), AFFINE)
  expect_equal(dim(multiply(c(1, -1), x)), c(2, 1))
  pos_param <- Parameter(2, nonneg = TRUE)
  neg_param <- Parameter(2, nonpos = TRUE)
  expect_equal(sign(multiply(pos_param, pos_param)), NONNEG)
  expect_equal(sign(multiply(pos_param, neg_param)), NONPOS)
  expect_equal(sign(multiply(neg_param, neg_param)), NONNEG)

  expect_equal(curvature(multiply(neg_param, x^2)), CONCAVE)

  # Test promotion
  expect_equal(dim(multiply(c(1, -1), 1)), c(2, 1))
  expect_equal(dim(multiply(1, C)), dim(C))
  # expect_error(multiply(x, c(1, -1)))

  expect_equal(sign(multiply(x, c(1, -1))), UNKNOWN)
  expect_equal(curvature(multiply(x, c(1, -1))), AFFINE)
  expect_equal(dim(multiply(x, c(1, -1))), c(2,1))
})

test_that("test the vstack function", {
  atom <- vstack(x, y, x)
  expect_equal(dim(atom), c(6, 1))

  atom <- vstack(A, C, B)
  expect_equal(dim(atom), c(7, 2))

  entries <- list()
  for(i in 1:dim(x)[1]) {
   for(j in 1:dim(x)[2]) {
     entries <- c(entries, x[i, j])
   }
  }
  atom <- do.call(vstack, entries)
  # atom <- vstack(x[1,1], x[2,1])

  expect_error(vstack(C, 1),
               "All the input dimensions except for axis 1 must match exactly.", fixed = TRUE)

})

test_that("test the reshape_expr function", {
  expr <- reshape_expr(A, c(4, 1))
  expect_equal(sign(expr), UNKNOWN)
  expect_equal(curvature(expr), AFFINE)
  expect_equal(dim(expr), c(4, 1))

  expr <- reshape_expr(expr, c(2, 2))
  expect_equal(dim(expr), c(2, 2))

  expr <- reshape_expr(x^2, c(1, 2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(curvature(expr), CONVEX)
  expect_equal(dim(expr), c(1, 2))

  expect_error(reshape_expr(C, c(5, 4)),
               "Invalid reshape dimensions (54)", fixed = TRUE)
})

test_that("test the vec function", {
  expr <- vec(C)
  expect_equal(sign(expr), UNKNOWN)
  expect_equal(curvature(expr), AFFINE)
  expect_equal(dim(expr), c(6, 1))

  expr <- vec(x)
  expect_equal(dim(expr), c(2, 1))

  expr <- vec(a^2)
  expect_equal(sign(expr), NONNEG)
  expect_equal(curvature(expr), CONVEX)
  expect_equal(dim(expr), c(1, 1))
})

test_that("test the diag function", {
  expr <- diag(x)
  expect_equal(sign(expr), UNKNOWN)
  expect_equal(curvature(expr), AFFINE)
  expect_equal(dim(expr), c(2,2))

  expr <- diag(A)
  expect_equal(sign(expr), UNKNOWN)
  expect_equal(curvature(expr), AFFINE)
  expect_equal(dim(expr), c(2, 1))

  expr <- diag(t(x))
  expect_equal(sign(expr), UNKNOWN)
  expect_equal(curvature(expr), AFFINE)
  expect_equal(dim(expr), c(2, 2))

  expect_error(diag(C),
               "Argument to Diag must be a vector or square matrix.", fixed = TRUE)
})

test_that("test the matrix_trace function", {
  expr <- matrix_trace(A)
  expect_equal(sign(expr), UNKNOWN)
  expect_equal(curvature(expr), AFFINE)
  # expect_equal(dim(expr), NULL)
  expect_equal(dim(expr), c(1, 1))

  expect_error(matrix_trace(C),
               "Argument to Trace must be a square matrix", fixed = TRUE)
})

test_that("test the log1p function", {
  expr <- log1p(Constant(1))
  expect_equal(sign(expr), NONNEG)
  expect_equal(curvature(expr), CONSTANT)
  expect_equal(dim(expr), c(1, 1))
  expr <- CVXR::log1p(Constant(-0.5))
  expect_equal(sign(expr), NONPOS)
})

test_that("test the upper_tri function", {
  expect_error(upper_tri(C),
               "Argument to UpperTri must be a square matrix.", fixed = TRUE)
})

test_that("test the huber function", {
  huber(x, 1)
  expect_error(huber(x, -1),
               "M must be a non-negative scalar constant", fixed = TRUE)
  expect_error(huber(x, c(1, 1)),
               "M must be a non-negative scalar constant", fixed = TRUE)

  # M parameter
  M <- Parameter(nonneg = TRUE)
  # Valid
  huber(x, M)
  value(M) <- 1
  expect_equal(value(huber(2, M)), 3, tolerance = TOL)
  # Invalid
  M <- Parameter(nonpos = TRUE)
  expect_error(huber(x, M),
               "M must be a non-negative scalar constant", fixed = TRUE)
})

test_that("test the sum_largest function", {
  expect_error(sum_largest(x, -1),
               "[SumLargest: validation] k must be a positive integer", fixed = TRUE)
  expect_error(lambda_sum_largest(x, 2.4),
               "First argument must be a square matrix.", fixed = TRUE)
  expect_error(lambda_sum_largest(Variable(2, 2), 2.4),
               "Second argument must be a positive integer.", fixed = TRUE)
})

test_that("test the sum_smallest function", {
  expect_error(sum_smallest(x, -1),
               "[SumLargest: validation] k must be a positive integer", fixed = TRUE)
  expect_error(lambda_sum_smallest(Variable(2, 2), 2.4),
               "Second argument must be a positive integer.", fixed = TRUE)
})

test_that("test the bmat function", {
  v_np <- matrix(1, nrow = 3, ncol = 1)
  v_00 <- matrix(c(0,0), nrow = 2, ncol = 1)
  v_12 <- matrix(c(1,2), nrow = 2, ncol = 1)
  expr <- bmat(list(list(v_np, v_np), list(v_00, v_12)))
  expect_equal(dim(expr), c(5, 2))
  const <- rbind(cbind(v_np, v_np), cbind(c(0, 0), c(1, 2)))
  expect_equal(value(expr), const)
})

test_that("test the conv function", {
  a <- matrix(1, nrow = 3, ncol = 1)
  b <- Parameter(2, nonneg = TRUE)
  expr <- conv(a, b)
  expect_true(is_nonneg(expr))
  expect_equal(dim(expr), c(4, 1))
  b <- Parameter(2, nonpos = TRUE)
  expr <- conv(a, b)
  expect_true(is_nonpos(expr))
  expect_error(conv(x, -1),
               "The first argument to Conv must be constant.", fixed = TRUE)
  expect_error(conv(cbind(c(0, 1), c(0, 1)), x),
               "The arguments to Conv must resolve to vectors.", fixed = TRUE)
})

test_that("test the kronecker function", {
  a <- matrix(1, nrow = 3, ncol = 2)
  b <- Parameter(2, nonneg = TRUE)
  expr <- kronecker(a, b)
  expect_true(is_nonneg(expr))
  expect_equal(dim(expr), c(6, 2))
  b <- Parameter(2, nonpos = TRUE)
  expr <- kronecker(a, b)
  expect_true(is_nonpos(expr))
  expect_error(kronecker(x, -1),
               "The first argument to Kron must be constant.", fixed = TRUE)
})

# test_that("test DCP properties of partial optimize", {
#   # Evaluate the 1-norm in the usual way (i.e., in epigraph form)
#   dims <- 3
#   x <- Variable(dims)
#   t <- Variable(dims)
#   xval <- matrix(rep(-5, dims), nrow = dims, ncol = 1)
#   p2 <- Problem(Minimize(sum_entries(t)), list(-t <= x, x <= t))
#   g <- partial_optimize(p2, list(t), list(x))
#   expect_equal(curvature(g), CONVEX)
#
#   p2 <- Problem(Maximize(sum_entries(t)), list(-t <= x, x <= t))
#   g <- partial_optimize(p2, list(t), list(x))
#   expect_equal(curvature(g), CONCAVE)
#
#   p2 <- Problem(Maximize(t[1]^2), list(-t <= x, x <= t))
#   g <- partial_optimize(p2, list(t), list(x))
#   expect_false(is_convex(g))
#   expect_false(is_concave(g))
# })
#
# test_that("test the partial_optimize eval 1-norm", {
#   # Evaluate the 1-norm in the usual way (i.e., in epigraph form)
#   dims <- 3
#   x <- Variable(dims)
#   t <- Variable(dims)
#   xval <- matrix(rep(-5, dims), nrow = dims, ncol = 1)
#   p1 <- Problem(Minimize(sum_entries(t)), list(-t <= xval, xval <= t))
#   result1 <- solve(p1)
#
#   # Minimize the 1-norm via partial_optimize
#   p2 <- Problem(Minimize(sum_entries(t)), list(-t <= x, x <= t))
#   # g <- partial_optimize(p2, list(t), list(x))
#   # p3 <- Problem(Minimize(g), list(x == xval))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, -result3$value)
#
#   # Try leaving out args
#
#   # Minimize the 1-norm via partial_optimize
#   p2 <- Problem(Minimize(sum_entries(t)), list(-t <= x, x <= t))
#   # g <- partial_optimize(p2, opt_vars = list(t))
#   # p3 <- Problem(Minimize(g), list(x == xval))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, result3$value)
#
#   # Minimize the 1-norm via partial_optimize
#   # g <- partial_optimize(p2, dont_opt_vars = list(x))
#   # p3 <- Problem(Minimize(g), list(x == xval))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, result3$value)
#
#   # expect_error(partial_optimize(p2))
#   # expect_error(partial_optimize(p2, list(), list(x)))
# })
#
# test_that("test partial_optimize min 1-norm", {
#   # Minimize the 1-norm in the usual way
#   dims <- 3
#   x <- Variable(dims)
#   t <- Variable(dims)
#   p1 <- Problem(Minimize(sum_entries(t)), list(-t <= x, x <= t))
#
#   # Minimize the 1-norm via partial_optimize
#   # g <- partial_optimize(p1, list(t), list(x))
#   # p2 <- Problem(Minimize(g))
#   # result2 <- solve(p2)
#
#   result1 <- solve(p1)
#   # expect_equal(result1$value, result2$value)
# })
#
# test_that("test partial_optimize simple problem", {
#   x <- Variable(1)
#   y <- Variable(1)
#
#   # Solve the (simple) two-stage problem by "combining" the two stages (i.e., by solving a single linear program)
#   p1 <- Problem(Minimize(x+y), list(x+y >= 3, y >= 4, x >= 5))
#   result1 <- solve(p1)
#
#   # Solve the two-stage problem via partial_optimize
#   p2 <- Problem(Minimize(y), list(x+y >= 3, y >= 4))
#   # g <- partial_optimize(p2, list(y), list(x))
#   # p3 <- Problem(Minimize(x+g), list(x >= 5))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, result3$value)
# })
#
# test_that("test partial_optimize special var", {
#   x <- Bool(1)
#   y <- Int(1)
#
#   # Solve the (simple) two-stage problem by "combining" the two stages (i.e., by solving a single linear program)
#   p1 <- Problem(Minimize(x+y), list(x+y >= 3, y >= 4, x >= 5))
#   # result1 <- solve(p1)
#
#   # Solve the two-stage problem via partial_optimize
#   p2 <- Problem(Minimize(y), list(x+y >= 3, y >= 4))
#   # g <- partial_optimize(p2, list(y), list(x))
#   # p3 <- Problem(Minimize(x+g), list(x >= 5))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, result3$value)
# })
#
# test_that("test partial_optimize special constr", {
#   x <- Variable(1)
#   y <- Variable(1)
#
#   # Solve the (simple) two-stage problem by "combining" the two stages (i.e., by solving a single linear program)
#   p1 <- Problem(Minimize(x+exp(y)), list(x+y >= 3, y >= 4, x >= 5))
#   result1 <- solve(p1)
#
#   # Solve the two-stage problem via partial_optimize
#   p2 <- Problem(Minimize(exp(y)), list(x+y >= 3, y >= 4))
#   # g <- partial_optimize(p2, list(y), list(x))
#   # p3 <- Problem(Minimize(x+g), list(x >= 5))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, result3$value)
# })
#
# test_that("test partial_optimize with parameters", {
#   x <- Variable(1)
#   y <- Variable(1)
#   gamma <- Parameter()
#
#   # Solve the (simple) two-stage problem by "combining" the two stages (i.e., by solving a single linear program)
#   p1 <- Problem(Minimize(x+y), list(x+y >= gamma, y >= 4, x >= 5))
#   gamma@value <- 3
#   # result1 <- solve(p1)
#
#   # Solve the two-stage problem via partial_optimize
#   p2 <- Problem(Minimize(y), list(x+y >= gamma, y >= 4))
#   # g <- partial_optimize(p2, list(y), list(x))
#   # p3 <- Problem(Minimize(x+g), list(x >= 5))
#   # result3 <- solve(p3)
#   # expect_equal(result1$value, result3$value)
# })
#
# test_that("test partial_optimize numeric function", {
#   x <- Variable(1)
#   y <- Variable(1)
#   xval <- 4
#
#   # Solve the (simple) two-stage problem by "combining" the two stages (i.e., by solving a single linear program)
#   p1 <- Problem(Minimize(y), list(xval+y >= 3))
#   result1 <- solve(p1)
#
#   # Solve the two-stage problem via partial_optimize
#   constr <- list(y >= -100)
#   p2 <- Problem(Minimize(y), c(x+y >= 3, constr))
#   # g <- partial_optimize(p2, list(y), list(x))
#   # x@value <- xval
#   # y@value <- 42
#   # const[1]@dual_variable@value <- 42
#   # result <- g@value
#   # expect_equal(result, result1$value)
#   # expect_equal(y@value, 42)
#   # expect_equal(constr[1]@dual_value, 42)
#
#   # No variables optimized over
#   p2 <- Problem(Minimize(y), list(x+y >= 3))
#   # g <- partial_optimize(p2, list(), list(x,y))
#   # x@value <- xval
#   # y@value <- 42
#   # p2@constraints[1]@dual_variable@value <- 42
#   # result <- g@value
#   # expect_equal(result, y@value)
#   # expect_equal(y@value, 42)
#   # expect_equal(p2@constraints[1]@dual_value, 42)
# })
#
# test_that("test partial_optimize stacked", {
#   # Minimize the 1-norm in the usual way
#   dims <- 3
#   x <- Variable(dims)
#   t <- Variable(dims)
#   p1 <- Problem(Minimize(sum_entries(t)), list(-t <= x, x <= t))
#
#   # Minimize the 1-norm via partial_optimize
#   # g <- partial_optimize(p1, list(t), list(x))
#   # g2 <- partial_optimize(Problem(Minimize(g)), list(x))
#   # p2 <- Problem(Minimize(g2))
#   # result2 <- solve(p2)
#
#   result1 <- solve(p1)
#   # expect_equal(result1$value, result2$value)
# })

test_that("test the NonNegative Variable class", {
  # x <- NonNegative()
  x <- Variable(nonneg = TRUE)
  p <- Problem(Minimize(5+x), list(x >= 3))
  result <- solve(p)
  expect_equal(result$value, 8, tolerance = TOL)
  expect_equal(result$getValue(x), 3, tolerance = TOL)
})

test_that("test mixed_norm", {
  y <- Variable(5, 5)
  obj <- Minimize(mixed_norm(y, Inf, 1))
  prob <- Problem(obj, list(y == matrix(1, nrow = 5, ncol = 5)))
  result <- solve(prob)
  expect_equal(result$value, 5, tolerance = TOL)
})

# test_that("test whether changing an array constant breaks DCP", {
#   c <- matrix(c(1, 2), nrow = 2, ncol = 1)
#   x@value <- c(1, 1)
#   expr <- t(c) %*% x^2
#   expect_equal(value(expr), 3, tolerance = TOL)
#   expect_true(is_dcp(expr))
#
#   c[1] <- -1
#   expect_equal(value(expr), 3, tolerance = TOL)
#   expect_true(is_dcp(expr))
# })

test_that("test that norm1 and normInf match definition for matrices", {
  A <- rbind(c(1,2), c(3,4))
  print(A)
  X <- Variable(2, 2)
  obj <- Minimize(norm1(X))
  prob <- Problem(obj, list(X == A))
  result <- solve(prob)
  print(result$value)
  expect_equal(result$value, value(norm1(A)), TOL)

  obj <- Minimize(norm_inf(X))
  prob <- Problem(obj, list(X == A))
  result <- solve(prob)
  print(result$value)
  expect_equal(result$value, value(norm_inf(A)), TOL)
})

#DK, uncomment once Indicator in transforms is uncommented
# test_that("test indicator", {
#   x <- Variable()
#   constraints <- list(0 <= x, x <= 1)
#   expr <- Indicator(constraints)
#   x@value <- .5
#   expect_equal(value(expr), 0.0)
#   x@value <- 2
#   expect_equal(value(expr), Inf)
#
# })

context("test-g01-monotonicity")

CONSTANT <- "CONSTANT"
AFFINE <- "AFFINE"
CONVEX <- "CONVEX"
CONCAVE <- "CONCAVE"
UNKNOWN <- "UNKNOWN"

test_that("Test application of DCP composition rules to determine curvature", {
  skip_on_cran()
  expr <- 1 + exp(Variable())
  expect_equal(curvature(expr), CONVEX)

  expr <- Parameter() * Variable(nonneg = TRUE)
  expect_equal(curvature(expr), AFFINE)

  f <- function(x) { x^2 + x^0.5 }
  expr <- f(Constant(2))
  expect_equal(curvature(expr), CONSTANT)

  expr <- exp(Variable())^2
  expect_equal(curvature(expr), CONVEX)

  expr <- 1 - sqrt(Variable())
  expect_equal(curvature(expr), CONVEX)

  expr <- log(sqrt(Variable()))
  expect_equal(curvature(expr), CONCAVE)

  expr <- -(exp(Variable()))^2
  expect_equal(curvature(expr), CONCAVE)

  expr <- log(exp(Variable()))
  expect_false(is_dcp(expr))

  expr <- entr(Variable(nonneg = TRUE))
  expect_equal(curvature(expr), CONCAVE)

  expr <- ((Variable()^2)^0.5)^0
  expect_equal(curvature(expr), CONSTANT)
})

test_that("Test DCP composition rules with signed monotonicity", {
  skip_on_cran()
  # Convex argument
  expr <- abs(1 + exp(Variable()))
  expect_equal(curvature(expr), CONVEX)

  expr <- abs(-entr(Variable()))
  expect_equal(curvature(expr), UNKNOWN)

  expr <- abs(-log(Variable()))
  expect_equal(curvature(expr), UNKNOWN)

  # Concave argument
  expr <- abs(log(Variable()))
  expect_equal(curvature(expr), UNKNOWN)

  expr <- abs(Variable()^2)
  expect_equal(curvature(expr), CONVEX)

  expr <- abs(entr(Variable()))
  expect_equal(curvature(expr), UNKNOWN)

  # Affine argument
  expr <- abs(Variable(nonneg = TRUE))
  expect_equal(curvature(expr), CONVEX)

  expr <- abs(-Variable(nonneg = TRUE))
  expect_equal(curvature(expr), CONVEX)

  expr <- abs(Variable())
  expect_equal(curvature(expr), CONVEX)
})

context("test-g01-lin_ops")

NEG <- "neg"
PARAM <- "param"
DENSE_CONST <- "dense_const"
SPARSE_CONST <- "sparse_const"
SCALAR_CONST <- "scalar_const"
SUM_ENTRIES <- "sum_entries"
VARIABLE <- "variable"

create_const <- CVXR:::create_const
create_eq <- CVXR:::create_eq
create_leq <- CVXR:::create_leq
create_param <- CVXR:::create_param
create_var <- CVXR:::create_var
get_expr_vars <- CVXR:::get_expr_vars

lo.neg_expr <- CVXR:::lo.neg_expr
lo.sum_expr <- CVXR:::lo.sum_expr
lo.sum_entries <- CVXR:::lo.sum_entries

test_that("Test creating a variable", {
  skip_on_cran()
  var <- create_var(c(5, 4), var_id = 1)
  expect_equal(var$dim, c(5, 4))
  expect_equal(var$data, 1)
  expect_equal(length(var$args), 0)
  expect_equal(var$type, VARIABLE)
})

test_that("Test creating a parameter", {
  skip_on_cran()
  A <- Parameter(5, 4)
  var <- create_param(A, c(5, 4))
  expect_equal(var$dim, c(5, 4))
  expect_equal(length(var$args), 0)
  expect_equal(var$type, PARAM)
})

test_that("Test creating a constant", {
  skip_on_cran()
  # Scalar constant
  dim <- c(1, 1)
  mat <- create_const(1.0, dim)
  expect_equal(mat$dim, dim)
  expect_equal(length(mat$args), 0)
  expect_equal(mat$type, SCALAR_CONST)
  expect_equal(mat$data, 1.0)

  # Dense matrix constant
  dim <- c(5, 4)
  mat <- create_const(matrix(1, nrow = dim[1], ncol = dim[2]), dim)
  expect_equal(mat$dim, dim)
  expect_equal(length(mat$args), 0)
  expect_equal(mat$type, DENSE_CONST)
  expect_equal(mat$data, matrix(1, nrow = dim[1], ncol = dim[2]))

  # Sparse matrix constant
  dim <- c(5, 5)
  mat <- create_const(Matrix::sparseMatrix(i = 1:5, j = 1:5, x = 1), dim, sparse = TRUE)
  expect_equal(mat$dim, dim)
  expect_equal(length(mat$args), 0)
  expect_equal(mat$type, SPARSE_CONST)
  expect_equivalent(as.matrix(mat$data), diag(rep(1, 5)))
})

test_that("Test adding lin expr", {
  skip_on_cran()
  dim <- c(5, 4)
  x <- create_var(dim)
  y <- create_var(dim)

  # Expanding dict.
  add_expr <- lo.sum_expr(list(x, y))
  expect_equal(add_expr$dim, dim)
  expect_equal(length(add_expr$args), 2)
})

test_that("Test getting vars from an expression", {
  skip_on_cran()
  dim <- c(5, 4)
  x <- create_var(dim)
  y <- create_var(dim)
  A <- create_const(matrix(1, nrow = dim[1], ncol = dim[2]), dim)

  # Expanding dict.
  add_expr <- lo.sum_expr(list(x, y, A))
  vars_ <- get_expr_vars(add_expr)
  expect_equal(vars_[[1]], list(x$data, dim))
  expect_equal(vars_[[2]], list(y$data, dim))
})

test_that("Test negating an expression", {
  skip_on_cran()
  dim <- c(5, 4)
  var <- create_var(dim)
  expr <- lo.neg_expr(var)
  expect_equal(length(expr$args), 1)
  expect_equal(expr$dim, dim)
  expect_equal(expr$type, NEG)
})

test_that("Test creating an equality constraint", {
  skip_on_cran()
  dim <- c(5, 5)
  x <- create_var(dim)
  y <- create_var(dim)
  lh_expr <- lo.sum_expr(list(x, y))
  value <- matrix(1, nrow = dim[1], ncol = dim[2])
  rh_expr <- create_const(value, dim)
  constr <- create_eq(lh_expr, rh_expr)
  expect_equal(constr$dim, dim)
  vars_ <- get_expr_vars(constr$expr)
  ref <- list(list(x$data, dim), list(y$data, dim))
  expect_equal(vars_, ref)
})

test_that("Test creating a less than or equal constraint", {
  skip_on_cran()
  dim <- c(5, 5)
  x <- create_var(dim)
  y <- create_var(dim)
  lh_expr <- lo.sum_expr(list(x, y))
  value <- matrix(1, nrow = dim[1], ncol = dim[2])
  rh_expr <- create_const(value, dim)
  constr <- create_leq(lh_expr, rh_expr)
  expect_equal(constr$dim, dim)
  vars_ <- get_expr_vars(constr$expr)
  ref <- list(list(x$data, dim), list(y$data, dim))
  expect_equal(vars_, ref)
})

test_that("Test sum entries op", {
  skip_on_cran()
  dim <- c(5, 5)
  x <- create_var(dim)
  expr <- lo.sum_entries(x, c(1, 1))
  expect_equal(expr$dim, c(1, 1))
  expect_equal(length(expr$args), 1)
  expect_equal(expr$type, SUM_ENTRIES)
})

context("test-g01-sign")

pos <- Constant(1)
neg <- Constant(-1)
zero <- Constant(0)
unknown <- Variable()

test_that("test sign addition", {
  expect_equal(sign(pos + neg), sign(unknown))
  expect_equal(sign(neg + zero), sign(neg))
  expect_equal(sign(pos + pos), sign(pos))
  expect_equal(sign(unknown + zero), sign(unknown))
})

test_that("test sign subtraction", {
  expect_equal(sign(pos - neg), sign(pos))
  expect_equal(sign(neg - zero), sign(neg))
  expect_equal(sign(pos - pos), sign(unknown))
})

test_that("test sign multiplication", {
  expect_equal(sign(zero * pos), sign(zero))
  expect_equal(sign(unknown * pos), sign(unknown))
  expect_equal(sign(pos * neg), sign(neg))
  expect_equal(sign(pos * pos), sign(pos))
  expect_equal(sign(neg * neg), sign(pos))
  expect_equal(sign(zero * unknown), sign(zero))
})

test_that("test sign negation", {
  expect_equal(sign(-zero), sign(zero))
  expect_equal(sign(-pos), sign(neg))
})

test_that("test if sign is nonnegative or nonpositive", {
  expect_true(is_nonneg(pos))
  expect_false(is_nonneg(neg))
  expect_false(is_nonneg(unknown))
  expect_true(is_nonneg(zero))
  
  expect_false(is_nonpos(pos))
  expect_true(is_nonpos(neg))
  expect_false(is_nonpos(unknown))
  expect_true(is_nonpos(zero))
  
  expect_true(is_zero(zero))
  expect_false(is_zero(neg))
  
  expect_false(is_nonneg(unknown) || is_nonpos(unknown))
})

context("test-g05-cplex")

tol <- 1e-4

CPLEX_AVAILABLE <- "CPLEX" %in% installed_solvers()
if (CPLEX_AVAILABLE) library(Rcplex)

test_that("test a simple LP with CPLEX", {
  # Example lpex1.m in CPLEX
  skip_on_cran()
  skip_if_not(CPLEX_AVAILABLE, "Skipping CPLEX test as it is not available.!")
  cvec <- c(1,2,3)
  Amat <- matrix(c(-1,1,1,-1,3,-1),byrow=TRUE,nc=3)
  bvec <- c(20, -30)
  ub <- c(40, Inf, Inf)
  cplex <- Rcplex(cvec, Amat, bvec, ub=ub, objsense="max", sense=c('L','G'))

  xvar <- Variable(3, nonneg=T)
  obj <- Maximize(t(as.matrix(cvec)) %*% xvar)
  constraints <- list(-xvar[1] + xvar[2] + xvar[3] <= 20,
                      xvar[1] - 3 * xvar[2] + xvar[3] <= 30,
                      xvar[1] <= 40)
  prob <- Problem(obj, constraints)
  cvxr <- solve(prob, solver = "CPLEX")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, cplex$obj, tolerance = tol)
  expect_equal(cvxr$getValue(xvar), matrix(cplex$xopt), tolerance = tol)
})

test_that("test a simple QP with CPLEX", {
  # Example qpex1.m in CPLEX
  skip_on_cran()
  skip_if_not(CPLEX_AVAILABLE, "Skipping CPLEX test as it is not available.!")
  cvec <- c(1,2,3)
  Qmat <- matrix(c(-33, 6, 0, 6,-22, 11.5, 0, 11.5, -11),
                 byrow=TRUE, nc=3)
  Amat <- matrix(c(-1, 1, 1, 1, -3, 1),
                 byrow=TRUE, nc=3)
  bvec <- c(20, 30)
  ub <- c(40, Inf, Inf)
  cplex <- Rcplex(cvec, Amat, bvec, Qmat, ub=ub, objsense="max")

  xvar <- Variable(3, nonneg=T)
  obj <- Maximize(t(as.matrix(cvec)) %*% xvar + .5 * quad_form(xvar, Qmat))
  constraints <- list(-xvar[1] + xvar[2] + xvar[3] <= 20,
                      xvar[1] - 3 * xvar[2] + xvar[3] <= 30,
                      xvar[1] <= 40)
  prob <- Problem(obj, constraints)
  cvxr <- solve(prob, solver = "CPLEX")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, cplex$obj, tolerance = tol)
  expect_equal(cvxr$getValue(xvar), matrix(cplex$xopt), tolerance = tol)
})

test_that("test a mixed integer linear program with CPLEX", {
  # Example mipex1.m in CPLEX
  skip_on_cran()
  skip_if_not(CPLEX_AVAILABLE, "Skipping CPLEX test as it is not available.!")
  cvec <- c(1,2,3,1)
  Amat <- matrix(c(-1, 1, 1, 10, 1, -3,
                   1, 0, 0, 1, 0, -3.5), byrow = T, nc = 4)
  bvec <- c(20, 30, 0)
  lb <- c(0, 0, 0, 2)
  ub <- c(40, Inf, Inf, 3)
  vtype <- c(rep("C", 3), "I")
  cplex <- Rcplex(cvec, Amat, bvec, lb=lb, ub=ub, sense=c("L","L","E"),
                objsense="max", vtype=vtype)

  xnonint <- Variable(3, nonneg=T)
  xint <- Variable(integer = T)
  xvar <- rbind(xnonint, xint)
  obj <- Maximize(t(as.matrix(cvec)) %*% xvar)
  constraints <- list(-xvar[1] + xvar[2] + xvar[3] + 10 * xvar[4] <= 20,
                      xvar[1] - 3 * xvar[2] + xvar[3] <= 30,
                      xvar[2] - 3.5 * xvar[4] == 0,
                      xvar[1] <= 40,
                      xvar[4] >= 2,
                      xvar[4] <= 3)
  prob <- Problem(obj, constraints)
  cvxr <- solve(prob, solver = "CPLEX")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, cplex$obj, tolerance = tol)
  expect_equal(cvxr$getValue(xvar), matrix(cplex$xopt), tolerance = tol)
})

test_that("test a mixed integer quadratic program with CPLEX", {
  # Example miqpex1.m in CPLEX
  skip_on_cran()
  skip_if_not(CPLEX_AVAILABLE, "Skipping CPLEX test as it is not available.!")
  cvec <- c(1,2,3,1)
  Qmat <- matrix(c(-33, 6, 0, 0, 6,-22, 11.5, 0,
                   0, 11.5, -11,0, 0, 0, 0, 0),
                 byrow=TRUE, nc=4)
  Amat <- matrix(c(-1, 1, 1, 10,
                   1, -3, 1, 0,
                   0, 1, 0,-3.5),
                 byrow=TRUE, nc=4)
  bvec <- c(20, 30, 0)
  ub <- c(40, Inf, Inf, 3)
  vtype <- c(rep("C",3), "I")
  cplex <- Rcplex(cvec, Amat, bvec, Qmat=Qmat,
                  ub=ub, sense=c("L","L","E"),
                objsense="max", vtype=vtype)

  xnonint <- Variable(3, nonneg=T)
  xint <- Variable(integer = T)
  xvar <- rbind(xnonint, xint)
  obj <- Maximize(t(as.matrix(cvec)) %*% xvar + .5 * quad_form(xvar, Qmat))
  constraints <- list(-xvar[1] + xvar[2] + xvar[3] + 10 * xvar[4] <= 20,
                      xvar[1] - 3 * xvar[2] + xvar[3] <= 30,
                      xvar[2] - 3.5 * xvar[4] == 0,
                      xvar[1] <= 40,
                      xvar[4] >= 0,
                      xvar[4] <= 3)
  prob <- Problem(obj, constraints)
  cvxr <- solve(prob, solver = "CPLEX")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, cplex$obj, tolerance = tol)
  expect_equal(cvxr$getValue(xvar), matrix(cplex$xopt), tolerance = tol)
})

context("test-g01-expressions")
TOL <- 1e-6

CONSTANT <- "CONSTANT"
AFFINE <- "AFFINE"
CONVEX <- "CONVEX"
CONCAVE <- "CONCAVE"
UNKNOWN <- "UNKNOWN"

ZERO <- "ZERO"
NONNEG <- "NONNEGATIVE"
NONPOS <- "NONPOSITIVE"

a <- Variable(name = "a")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

canonical_form <- CVXR:::canonical_form
save_value <- CVXR:::save_value

test_that("Test the Variable class", {
  skip_on_cran()
  x <- Variable(2, name = "x")
  y <- Variable()
  expect_equal(dim(x), c(2,1))
  expect_equal(dim(y), c(1,1))
  expect_equal(curvature(x), AFFINE)

  expect_error(Variable(2,2, diag = TRUE, symmetric = TRUE), "Cannot set more than one special attribute.", fixed = TRUE)
  expect_error(Variable(2,0), "Invalid dimensions 20", fixed = TRUE)
  expect_error(Variable(2,0.5), "Invalid dimensions 20.5", fixed = TRUE)

})

test_that("Test assigning a value to a variable", {
  skip_on_cran()
  # Scalar variable
  a <- Variable()
  value(a) <- 1
  expect_equal(value(a), matrix(1))
  expect_error(value(a) <- c(2,1), "Invalid dimensions (2,1) for value", fixed = TRUE)

  # Test assigning None
  value(a) <- 1
  value(a) <- NA_real_
  expect_true(is.na(value(a)))

  # Vector variable
  x <- Variable(2)
  value(x) <- c(2,1)
  expect_equal(value(x), matrix(c(2,1)))

  # Matrix variable
  A <- Variable(3, 2)
  value(A) <- matrix(1, nrow = 3, ncol = 2)
  expect_equal(value(A), matrix(1, nrow = 3, ncol = 2))

  # Test assigning negative val to non-negative variable
  x <- Variable(nonneg = TRUE)
  expect_error(value(x) <- -2, "Value must be nonnegative", fixed = TRUE)

  # Small negative values are rounded to zero
  # *** BEGIN BN EDIT
  # This last test does not seem right given the change
  # made in interface.R for intf_sign!!
  # value(x) <- -1e-8
  # expect_equal(value(x), 0)
  # *** END BN EDIT
})

test_that("Test transposing variables", {
  skip_on_cran()
  var <- t(a)
  expect_equal(dim(var), c(1,1))

  a <- save_value(a, 2)
  var <- t(a)
  expect_equal(value(var), matrix(2))

  var <- t(x)
  expect_equal(dim(var), c(1,2))

  x <- save_value(x, matrix(c(1, 2), nrow = 2, ncol = 1))
  var <- t(x)
  expect_equal(value(var)[1,1], 1)
  expect_equal(value(var)[1,2], 2)

  var <- t(C)
  expect_equal(dim(var), c(2,3))

  index <- var[2,1]
  expect_equal(dim(index), c(1,1))

  var <- t(t(x))
  expect_equal(dim(var), c(2,1))
})

test_that("Test the Constant class", {
  skip_on_cran()
  c <- Constant(2)
  expect_equal(value(c), matrix(2))
  expect_equal(dim(c), c(1,1))
  expect_equal(curvature(c), CONSTANT)
  expect_equal(sign(c), NONNEG)
  expect_equal(sign(Constant(-2)), NONPOS)
  expect_equal(sign(Constant(0)), ZERO)
  expect_equal(canonical_form(c)[[1]]$dim, c(1,1))
  expect_equal(canonical_form(c)[[2]], list())

  # Test the sign
  c <- Constant(matrix(2, nrow = 1, ncol = 2))
  expect_equal(dim(c), c(1,2))
  expect_equal(sign(c), NONNEG)
  expect_equal(sign(-c), NONPOS)
  expect_equal(sign(0*c), ZERO)
  c <- Constant(matrix(c(2, -2), nrow = 1, ncol = 2))
  expect_equal(sign(c), UNKNOWN)

  # Test sign of a complex expression
  c <- Constant(matrix(c(1,2), nrow = 2, ncol = 1))
  Acon <- Constant(matrix(1, nrow = 2, ncol = 2))
  exp <- t(c) %*% Acon %*% c
  expect_equal(sign(exp), NONNEG)
  expect_equal(sign(t(c) %*% c), NONNEG)
  exp <- t(t(c))
  expect_equal(sign(exp), NONNEG)
  exp <- t(c) %*% A
  expect_equal(sign(exp), UNKNOWN)
})

test_that("test R vectors as constants", {
  skip_on_cran()
  c <- matrix(c(1,2), nrow = 1, ncol = 2)
  p  <- Parameter(2)
  value(p) <- c(1,1)
  expect_equal(value(c %*% p), matrix(3))
  expect_equal(dim(c %*% x), c(1,1))
})

test_that("test the Parameters class", {
  skip_on_cran()
  p <- Parameter(name = "p")
  expect_equal(name(p), "p")
  expect_equal(dim(p), c(1,1))

  p <- Parameter(4, 3, nonneg = TRUE)
  expect_error(value(p) <- 1,
               "Invalid dimensions (1,1) for value", fixed = TRUE)

  val <- matrix(-1, nrow = 4, ncol = 3)
  val[1,1] <- 2

  p <- Parameter(4, 3, nonneg = TRUE)
  expect_error(value(p) <- val,
               "Value must be nonnegative", fixed = TRUE)

  p <- Parameter(4, 3, nonpos = TRUE)
  expect_error(value(p) <- val,
               "Value must be nonpositive", fixed = TRUE)

  # No error for unknown sign
  p <- Parameter(4, 3)
  value(p) <- val

  # Initialize a parameter with a value
  p <- Parameter(value = 10)
  expect_equal(value(p), matrix(10))

  # Test assigning NA
  value(p) <- 10
  value(p) <- NA_real_
  expect_true(is.na(value(p)))

  # Test valid diagonal parameter
  p <- Parameter(2, 2, diag = TRUE)
  value(p) <- sparseMatrix(i = 1:2, j = 1:2, x=c(1,1))
  expect_equal(as.matrix(value(p)), diag(2), check.attributes = FALSE)

  expect_error(p <- Parameter(2, 1, nonpos = TRUE, value = c(2,1)),
               "Value must be nonpositive", fixed = TRUE)
  expect_error(p <- Parameter(4, 3, nonneg = TRUE, value = c(1,2)),
               "Invalid dimensions (2,1) for value", fixed = TRUE)
})

#DK
test_that("test the PSD/NSD matrices", {
  skip_on_cran()
  # Test valid rank-deficient PSD parameter.
  set.seed(42)
  a <- matrix(rnorm(100*95), nrow = 100)
  a2 <- a%*%t(a) # This must be a PSD matrix.
  p <- Parameter(100, 100, PSD = TRUE)
  value(p) <- a2
  expect_equal(value(p), a2, TOL)

  # Test positive definite matrix with non-distinct eigenvalues
  m <- 10
  n <- 5
  A <- matrix(rnorm(m*n), nrow = m) + 1i * matrix(rnorm(m*n), nrow = m) # a random complex matrix
  A <- Conj(t(A)) %*% A # a random Hermitian positive definite matrix
  A <- rbind(cbind(Re(A), -Im(A)), cbind(Im(A), Re(A)))

  p <- Parameter(2*n, 2*n, PSD = TRUE)
  value(p) <- A
  expect_equal(value(p), A, TOL)

  # Test invalid PSD parameter
  expect_error(p <- Parameter(2, 2, PSD = TRUE, value = matrix(c(1, 0, 0, -1), nrow = 2)),
               'Value must be positive semidefinite', fixed = TRUE)

  #Test invalid NSD parameter
  expect_error(p <- Parameter(2, 2, NSD = TRUE, value = matrix(c(1, 0, 0, -1), nrow = 2)),
               'Value must be negative semidefinite', fixed = TRUE)

  # Test arithmetic.
  p <- Parameter(2, 2, PSD = TRUE)
  expect_true(CVXR:::is_psd(2*p))
  expect_true(CVXR:::is_psd(p+p))
  expect_true(CVXR:::is_nsd(-p))
  expect_true(CVXR:::is_psd(-2*-p))

})

#DK
test_that("test the Parameter class on bad inputs",{
  skip_on_cran()
  p <- Parameter(name = 'p')
  expect_equal(name(p), "p")
  expect_equal(dim(p), c(1,1))

  p <- Parameter(4, 3, nonneg = TRUE)
  #DK: I changed this from the python version because the dimensions aren't exactly the same as in cvxpy
  expect_error(value(p) <- c(1,1), "Invalid dimensions (2,1) for value", fixed = TRUE)

  val <- matrix(rep(-1, 12), nrow = 4)
  val[1,1] <- 2

  p <- Parameter(4, 3, nonneg = TRUE)
  expect_error(value(p) <- val, 'Value must be nonnegative', fixed = TRUE)

  p <- Parameter(4, 3, nonpos = TRUE)
  expect_error(value(p) <- val, 'Value must be nonpositive', fixed = TRUE)

  expect_error(p <- Parameter(2, 1, nonpos = TRUE, value = matrix(c(2,1))),
               'Value must be nonpositive', fixed = TRUE)

  expect_error(p <- Parameter(4, 3, nonneg = TRUE, value = matrix(c(2,1))),
               'Invalid dimensions (2,1) for value', fixed = TRUE)

  expect_error(p <- Parameter(2, 2, diag = TRUE, symmetric = TRUE),
               'Cannot set more than one special attribute.', fixed = TRUE)

  # Boolean
  expect_error(p <- Parameter(2, 2, boolean = TRUE, value = matrix(c(1, 1, 1, -1), nrow = 2)),
               'Value must be boolean', fixed = TRUE)

  # Integer
  expect_error(p <- Parameter(2, 2, integer = TRUE, value = matrix(c(1, 1.5, 1, -1), nrow = 2)),
               'Value must be integer', fixed = TRUE)

  # Diag
  expect_error(p <- Parameter(2, 2, diag = TRUE, value = matrix(c(1, 1, 1, -1), nrow = 2)),
               'Value must be diagonal', fixed = TRUE)

  # Symmetric
  expect_error(p <- Parameter(2, 2, symmetric = TRUE, value = matrix(c(1, 1, -1, -1), nrow = 2)),
               'Value must be symmetric', fixed = TRUE)

})

#DK
test_that("test symmetric variables",{
  skip_on_cran()
  expect_error(v <- Variable(4, 3, symmetric = TRUE),
               'Invalid dimensions 43. Must be a square matrix.', fixed = TRUE)

  v <- Variable(2, 2, symmetric = TRUE)
  expect_true(CVXR:::is_symmetric(v))
  v <- Variable(2, 2, PSD = TRUE)
  expect_true(CVXR:::is_symmetric(v))
  v <- Variable(2, 2, NSD = TRUE)
  expect_true(CVXR:::is_symmetric(v))
  v <- Variable(2, 2, diag = TRUE)
  expect_true(CVXR:::is_symmetric(v))
  expect_true(CVXR:::is_symmetric(a))
  expect_true(!CVXR:::is_symmetric(A))

  v <- Variable(2, 2, symmetric = TRUE)
  expr <- v + v
  expect_true(CVXR:::is_symmetric(expr))
  expr <- -v
  expect_true(CVXR:::is_symmetric(expr))
  expr <- t(v)
  expect_true(CVXR:::is_symmetric(expr))
  expr <- CVXR:::Real(v)
  expect_true(CVXR:::is_symmetric(expr))
  expr <- CVXR:::Imag(v)
  expect_true(CVXR:::is_symmetric(expr))
  expr <- CVXR:::Conjugate(v)
  expect_true(CVXR:::is_symmetric(expr))
  expr <- CVXR:::Promote(Variable(), c(2,2))
  expect_true(CVXR:::is_symmetric(expr))

})

#DK
test_that("test Hermitian variables", {
  skip_on_cran()
  expect_error(v <- Variable(4, 3, hermitian = TRUE),
               'Invalid dimensions 43. Must be a square matrix.', fixed = TRUE)

  v <- Variable(2, 2, hermitian = TRUE)
  expect_true(CVXR:::is_hermitian(v))
  v <- Variable(2, 2, diag = TRUE)
  expect_true(CVXR:::is_hermitian(v))


  v <- Variable(2, 2, hermitian = TRUE)
  expr <- v + v
  expect_true(CVXR:::is_hermitian(expr))
  expr <- -v
  expect_true(CVXR:::is_hermitian(expr))
  expr <- t(v)
  expect_true(CVXR:::is_hermitian(expr))
  expr <- CVXR:::Real(v)
  expect_true(CVXR:::is_hermitian(expr))
  expr <- CVXR:::Imag(v)
  expect_true(CVXR:::is_hermitian(expr))
  expr <- CVXR:::Conjugate(v)
  expect_true(CVXR:::is_hermitian(expr))
  expr <- CVXR:::Promote(Variable(), c(2,2))
  expect_true(CVXR:::is_hermitian(expr))
})

test_that("test rounding for attributes", {
  skip_on_cran()

  # Nonpos
  v <- Variable(1, nonpos = TRUE)
  expect_equal(CVXR:::project(v, 1), 0)
  v <- Variable(2, nonpos = TRUE)
  expect_equal(CVXR:::project(v, c(1, -1)), c(0,-1))

  # Nonneg
  v <- Variable(1, nonneg = TRUE)
  expect_equal(CVXR:::project(v, -1), 0)
  v <- Variable(2, nonneg = TRUE)
  expect_equal(CVXR:::project(v, c(1, -1)), c(1,0))

  # Boolean
  v <- Variable(2, 2, boolean = TRUE)
  expect_equal(CVXR:::project(v, t(matrix(c(1, 1, -1, 0), nrow =2))), c(1, 0, 1, 0), check.attributes = FALSE)

  # Integer
  v <- Variable(2, 2, integer = TRUE)
  expect_equal(CVXR:::project(v, t(matrix(c(1, 1, -1.6, 0), nrow =2))), c(1, -2, 1, 0), check.attributes = FALSE)

  # Symmetric
  v <- Variable(2, 2, symmetric = TRUE)
  expect_equal(CVXR:::project(v, matrix(c(1, 1, -1, 0), nrow =2)), c(1, 0, 0, 0), check.attributes = FALSE)

  # PSD
  v <- Variable(2, 2, PSD = TRUE)
  expect_equal(CVXR:::project(v, matrix(c(1, 1, -1, -1), nrow =2)), c(1, 0, 0, 0), check.attributes = FALSE)

  # NSD
  v <- Variable(2, 2, NSD = TRUE)
  expect_equal(CVXR:::project(v, matrix(c(1, 1, -1, -1), nrow =2)), c(0, 0, 0, -1), check.attributes = FALSE)

  # diag
  v <- Variable(2, 2, diag = TRUE)
  expect_equal(as.matrix(CVXR:::project(v, matrix(c(1, 1, -1, 0), nrow =2))), c(1, 0, 0, 0), check.attributes = FALSE)

  # Hermitian
  v <- Variable(2, 2, hermitian = TRUE)
  expect_equal(CVXR:::project(v, matrix(c(1, 1, -1i, 0), nrow =2)), matrix(c(1, 0.5 + 0.5i, 0.5 - 0.5i, 0), nrow = 2), check.attributes = FALSE)

  A <- Constant(1.0)
  expect_equal(CVXR:::is_psd(A), TRUE)
  expect_equal(CVXR:::is_nsd(A), FALSE)
  A <- Constant(-1.0)
  expect_equal(CVXR:::is_psd(A), FALSE)
  expect_equal(CVXR:::is_nsd(A), TRUE)
  A <- Constant(0.0)
  expect_equal(CVXR:::is_psd(A), TRUE)
  expect_equal(CVXR:::is_nsd(A), TRUE)

})

test_that("test the AddExpression class", {
  skip_on_cran()
  # Vectors
  c <- Constant(c(2,2))
  exp <- x + c
  expect_equal(curvature(exp), AFFINE)
  expect_equal(sign(exp), UNKNOWN)
  expect_equal(canonical_form(exp)[[1]]$dim, c(2,1))
  expect_equal(canonical_form(exp)[[2]], list())
  expect_equal(dim(exp), c(2,1))

  z <- Variable(2, name = "z")
  exp <- exp + z + x
  expect_error(x + y)

  # Matrices
  exp <- A + B
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(2,2))
  expect_error(A + C)
  expect_error(AddExpression(A, C))

  # Test that sum is flattened
  exp <- x + c + x
  expect_equal(length(exp@args), 3)
})

test_that("test the SubExpression class", {
  skip_on_cran()
  # Vectors
  c <- Constant(c(2,2))
  exp <- x - c
  expect_equal(curvature(exp), AFFINE)
  expect_equal(sign(exp), UNKNOWN)
  expect_equal(canonical_form(exp)[[1]]$dim, c(2,1))
  expect_equal(canonical_form(exp)[[2]], list())
  expect_equal(dim(exp), c(2,1))

  z <- Variable(2, name = "z")
  exp <- exp - z - x
  expect_error(x - y)

  # Matrices
  exp <- A - B
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(2,2))
  expect_error(A - C)
})

test_that("test the MulExpression class", {
  skip_on_cran()
  # Vectors
  c <- Constant(matrix(2, nrow = 1, ncol = 2))
  expr <- c %*% x
  expect_equal(curvature(expr), AFFINE)
  expect_equal(sign(c[1]*x), UNKNOWN)
  expect_equal(canonical_form(expr)[[1]]$dim, c(1,1))
  expect_equal(canonical_form(expr)[[2]], list())
  expect_equal(dim(expr), c(1,1))

  # Incompatible dimensions
  expect_error(matrix(c(2,2,3), nrow = 3, ncol = 1) %*% x)

  # Matrices: incompatible dimensions
  expect_error(Constant(cbind(c(2,1), c(2,2))) %*% C)

  # Affine times affine is okay
  expect_warning(q <- A %*% B)
  expect_true(is_quadratic(q))

  # Non-affine times non-constant raises error
  # expect_error(expect_warning(A %*% B) %*% A)

  # Constant expressions
  Tmat <- Constant(cbind(c(1,2,3), c(3,5,5)))
  expr <- (Tmat + Tmat) %*% B
  expect_equal(curvature(expr), AFFINE)
  expect_equal(dim(expr), c(3,2))

  # Expression that would break sign multiplication without promotion
  c <- Constant(matrix(c(2, 2, -2), nrow = 1, ncol = 3))
  expr <- matrix(c(1,2), nrow = 1, ncol = 2) + c %*% C
  expect_equal(sign(expr), UNKNOWN)

  # Scalar constants on the right should be moved left
  # expr <- C*2
  # expect_equivalent(value(expr@args[[1]]), 2)

  # Scalar variables on the left should be moved right
  # expr <- a*c(2,1)
  # expect_equivalent(value(expr@args[[1]]), matrix(c(2,1)))
})

test_that("test matrix multiplication operator %*%", {
  skip_on_cran()
  # Vectors
  c <- Constant(matrix(2, nrow = 1, ncol = 2))
  exp <- c %*% x
  expect_equal(curvature(exp), AFFINE)
  expect_equal(sign(exp), UNKNOWN)
  expect_equal(canonical_form(exp)[[1]]$dim, c(1,1))
  expect_equal(canonical_form(exp)[[2]], list())
  expect_equal(dim(exp), c(1,1))

  # expect_error(x %*% 2)    Note: Allow scalars to be multiplied with %*% to distinguish MulExpression from MulElemwise.
  expect_error(x %*% matrix(c(2,2,3), nrow = 3, ncol = 1))

  # Matrices
  expect_error(Constant(cbind(c(2,1), c(2,2))) %*% C)

  # Affine times affine is okay
  expect_warning(q <- A %*% B)
  expect_true(is_quadratic(q))

  # Non-affine times non-constant raises error
  # expect_error(expect_warning(A %*% B %*% A))

  # Constant expressions
  Tmat <- Constant(cbind(c(1,2,3), c(3,5,5)))
  exp <- (Tmat + Tmat) %*% B
  expect_equal(curvature(exp), AFFINE)
  expect_equal(sign(exp), UNKNOWN)

  # Expression that would break sign multiplication without promotion
  c <- Constant(matrix(c(2,2,-2), nrow = 1, ncol = 3))
  exp <- matrix(c(1,2), nrow = 1, ncol = 2) + c %*% C
  expect_equal(sign(exp), UNKNOWN)

  # Testing shape.
  a <- Parameter(1)
  x <- Variable(1)
  expr <- a%*%x
  expect_equal(dim(expr), c(1,1))

  A <- Parameter(4,4)
  z <- Variable(4,1)
  expr <- A %*% z
  expect_equal(dim(expr), c(4,1))

  v <- Variable(1,1)
  col_scalar <- Parameter(1,1)
  expect_true(identical(dim(v), dim(col_scalar), dim(col_scalar)))

})

test_that("test the DivExpression class", {
  skip_on_cran()
  # Vectors
  exp <- x/2
  expect_equal(curvature(exp), AFFINE)
  expect_equal(sign(exp), UNKNOWN)
  expect_equal(canonical_form(exp)[[1]]$dim, c(2,1))
  expect_equal(canonical_form(exp)[[2]], list())
  expect_equal(dim(exp), c(2,1))

  expect_error(x/c(2,2,3),
               "Incompatible dimensions for division", fixed = TRUE)

  # Constant expressions
  c <- Constant(2)
  exp <- c/(3-5)
  expect_equal(curvature(exp), CONSTANT)
  expect_equal(dim(exp), c(1,1))
  expect_equal(sign(exp), NONPOS)

  # Parameters
  p <- Parameter(nonneg = TRUE)
  value(p) <- 2
  exp <- 2/p
  expect_equal(value(exp), matrix(1))

  rho <- Parameter(nonneg = TRUE)
  value(rho) <- 1

  expect_equal(sign(rho), NONNEG)
  expect_equal(sign(Constant(2)), NONNEG)
  expect_equal(sign(Constant(2)/Constant(2)), NONNEG)
  expect_equal(sign(Constant(2)*rho), NONNEG)
  expect_equal(sign(rho/2), NONNEG)
})

test_that("test the NegExpression class", {
  skip_on_cran()
  # Vectors
  exp <- -x
  expect_equal(curvature(exp), AFFINE)
  expect_true(is_affine(exp))
  expect_equal(sign(exp), UNKNOWN)
  expect_false(is_nonneg(exp))
  expect_equal(canonical_form(exp)[[1]]$dim, c(2,1))
  expect_equal(canonical_form(exp)[[2]], list())
  expect_equal(dim(exp), dim(x))

  # Matrices
  exp <- -C
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(3,2))
})

test_that("test promotion of scalar constants", {
  skip_on_cran()
  # Vectors
  exp <- x + 2
  expect_equal(curvature(exp), AFFINE)
  expect_true(is_affine(exp))
  expect_equal(sign(exp), UNKNOWN)
  expect_false(is_nonpos(exp))
  expect_equal(canonical_form(exp)[[1]]$dim, c(2,1))
  expect_equal(canonical_form(exp)[[2]], list())
  expect_equal(dim(exp), c(2,1))

  expect_equal(dim(4 - x), c(2,1))
  expect_equal(dim(4 * x), c(2,1))
  expect_equal(dim(4 <= x), c(2,1))
  expect_equal(dim(4 == x), c(2,1))
  expect_equal(dim(x >= 4), c(2,1))

  # Matrices
  exp <- (A + 2) + 4
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(3 * A), c(2,2))
  expect_equal(dim(exp), c(2,2))
})

test_that("test indexing expression", {
  skip_on_cran()
  # Tuple of integers as key
  exp <- x[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_true(is_affine(exp))
  expect_equal(dim(exp), c(1,1))
  expect_equal(value(exp), NA_real_)

  exp <- t(x[2,1])
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))
  expect_error(x[3,1])
  expect_error(x[3])

  # Slicing
  exp <- C[1:2,2]
  expect_equal(dim(exp), c(2,1))
  exp <- C[1:nrow(C),1:2]
  expect_equal(dim(exp), c(3,2))
  exp <- C[seq(1, nrow(C), 2), seq(1, ncol(C), 2)]
  expect_equal(dim(exp), c(2,1))
  exp <- C[1:3, seq(1,2,2)]
  expect_equal(dim(exp), c(3,1))
  exp <- C[1:nrow(C),1]
  expect_equal(dim(exp), c(3,1))

  c <- Constant(cbind(c(1,-2), c(0,4)))
  exp <- c[2,2]
  expect_equal(curvature(exp), CONSTANT)
  expect_equal(sign(exp), UNKNOWN)
  expect_equal(sign(c[1,2]), UNKNOWN)
  expect_equal(sign(c[2,1]), UNKNOWN)
  expect_equal(dim(exp), c(1,1))
  expect_equal(value(exp), matrix(4))

  c <- Constant(cbind(c(1,-2,3), c(0,4,5), c(7,8,9)))
  exp <- c[1:3, seq(1,4,2)]
  expect_equal(curvature(exp), CONSTANT)
  expect_true(is_constant(exp))
  expect_equal(dim(exp), c(3,2))
  expect_equal(value(exp[1,2]), matrix(7))

  # Slice of transpose
  exp <- t(C)[1:2,2]
  expect_equal(dim(exp), c(2,1))

  # Arithmetic expression indexing
  exp <- (x + z)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(sign(exp), UNKNOWN)
  expect_equal(dim(exp), c(1,1))

  exp <- (x + a)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))

  exp <- (x - z)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))

  exp <- (x - a)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))

  exp <- (-x)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))

  c <- Constant(rbind(c(1,2), c(3,4)))
  exp <- (c %*% x)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))

  c <- Constant(rbind(c(1,2), c(3,4)))
  exp <- (c*a)[2,1]
  expect_equal(curvature(exp), AFFINE)
  expect_equal(dim(exp), c(1,1))
})

# DK: not sure if applicable in CVXR
# test_that("test NA as idx", {
#   expr <- a[NA, NA]
#   expect_equal(dim(expr), c(1, 1))
#
#   expr <- x[, NA]
#   expect_equal(dim(expr), c(2, 1))
#
#   expr <- x[NA, ]
#   expect_equal(dim(expr), c(1, 2))
#
#   expr <- Constant(c(1,2))[NA,]
#   expect_equal(dim(expr), c(1, 2))
#   expect_equal(value(expr), c(1,2))
#
# })
# test_that("test ouf of bounds indices", {
#   expect_error(x[100])
#   expect_error(x[-100])
# })

test_that("test out of bounds indices", {
  skip_on_cran()
  expect_error(x[100])
  expect_error(x[c(1,-2)])

  exp <- x[-100]
  expect_equal(dim(exp), c(2,1))

  exp <- x[0]
  expect_equal(dim(exp), c(0,1))
  expect_equal(value(exp), matrix(NA, nrow = 0, ncol = 0))

  # TODO_NARAS_8: More testing of R's out of bounds indices. R's behavior is different from Python, so we can't copy CVXPY's tests.
})

test_that("test negative indices", {
  skip_on_cran()
  c <- Constant(rbind(c(1,2), c(3,4)))
  exp <- c[-1,-1]
  expect_equal(value(exp), matrix(4))
  expect_equal(dim(exp), c(1,1))
  expect_equal(curvature(exp), CONSTANT)

  c <- Constant(1:4)
  exp <- c[c(-1,-4)]
  expect_equal(value(exp), matrix(c(2,3)))
  expect_equal(dim(exp), c(2,1))
  expect_equal(curvature(exp), CONSTANT)

  c <- Constant(1:4)
  exp <- c[seq(4,1,-1)]
  expect_equal(value(exp), matrix(c(4,3,2,1)))
  expect_equal(dim(exp), c(4,1))
  expect_equal(curvature(exp), CONSTANT)

  x <- Variable(4)
  expect_equal(dim(x[seq(4,1,-1)]), c(4,1))
  prob <- Problem(Minimize(0), list(x[seq(4,1,-1)] == c))
  result <- solve(prob)
  expect_equal(result$getValue(x), matrix(c(4,3,2,1)))

  # TODO_NARAS_9: More testing of R's negative indices (and sequences of negative indices)
})

test_that("test indexing with logical matrices", {
  skip_on_cran()
    ##  require(Matrix)
  A <- rbind(1:4, 5:8, 9:12)
  C <- Constant(A)

  # Logical matrix
  expr <- C[A <= 2]
  expect_equal(dim(expr), c(2,1))
  expect_equal(sign(expr), NONNEG)
  expect_equal(matrix(A[A <= 2]), value(expr))

  expr <- C[A %% 2 == 0]
  expect_equal(dim(expr), c(6,1))
  expect_equal(sign(expr), NONNEG)
  expect_equal(matrix(A[A %% 2 == 0]), value(expr))

  # Logical vector for rows, index for columns
  expr <- C[c(TRUE, FALSE, TRUE), 4]
  expect_equal(dim(expr), c(2,1))
  expect_equal(sign(expr), NONNEG)
  expect_equal(matrix(A[c(TRUE, FALSE, TRUE), 4]), value(expr))

  # Index for rows, logical vector for columns
  expr <- C[2, c(TRUE, FALSE, FALSE, TRUE)]
  expect_equal(dim(expr), c(1, 2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[2, c(TRUE, FALSE, FALSE, TRUE), drop = FALSE], value(expr))

  # Logical vector for rows, slice for columns
  expr <- C[c(TRUE, TRUE, TRUE), 2:3]
  expect_equal(dim(expr), c(3,2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[c(TRUE, TRUE, TRUE), 2:3], value(expr))

  # Slice for rows, logical vector for columns
  expr <- C[2:(nrow(C)-1), c(TRUE, FALSE, TRUE, TRUE)]
  expect_equal(dim(expr), c(1,3))    # Always cast 1-D arrays as column vectors. Edit: NOT!!
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[2:(nrow(A)-1), c(TRUE, FALSE, TRUE, TRUE), drop = FALSE], value(expr))

  # Logical vectors for rows and columns
  expr <- C[c(TRUE, TRUE, TRUE), c(TRUE, FALSE, TRUE, TRUE)]
  expect_equal(dim(expr), c(3,3))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[c(TRUE, TRUE, TRUE), c(TRUE, FALSE, TRUE, TRUE)], value(expr))
})

test_that("test indexing with vectors/matrices of indices", {
  skip_on_cran()
  A <- rbind(1:4, 5:8, 9:12)
  C <- Constant(A)

  # Vector for rows
  expr <- C[c(1,2)]
  expect_equal(dim(expr), c(2,4))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[c(1,2),], value(expr))

  # Vector for rows, index for columns
  expr <- C[c(1,3),4]
  expect_equal(dim(expr), c(2,1))
  expect_equal(sign(expr), NONNEG)
  expect_equal(matrix(A[c(1,3),4]), value(expr))

  # Index for rows, vector for columns
  expr <- C[2,c(1,3)]
  expect_equal(dim(expr), c(1,2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[2,c(1,3), drop = FALSE], value(expr))

  # Vector for rows, slice for columns
  expr <- C[c(1,3),2:3]
  expect_equal(dim(expr), c(2,2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[c(1,3), 2:3], value(expr))

  # Vector for rows and columns
  expr <- C[c(1,2), c(2,4)]
  expect_equal(dim(expr), c(2,2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[c(1,2), c(2,4)], value(expr))

  # Matrix for rows, vector for columns
  expr <- C[matrix(c(1,2)), c(2,4)]
  expect_equal(dim(expr), c(2,2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[matrix(c(1,2)), c(2,4)], value(expr))

  # Matrix for rows and columns
  expr <- C[matrix(c(1,2)), matrix(c(2,4))]
  expect_equal(dim(expr), c(2,2))
  expect_equal(sign(expr), NONNEG)
  expect_equal(A[matrix(c(1,2)), matrix(c(2,4))], value(expr))
})

test_that("test powers", {
  skip_on_cran()
  exp <- x^2
  expect_equal(curvature(exp), CONVEX)
  exp <- x^0.5
  expect_equal(curvature(exp), CONCAVE)
  exp <- x^(-1)
  expect_equal(curvature(exp), CONVEX)
})

test_that("test built-in sum (not good usage)", {
  skip_on_cran()
  a_copy <- a
  value(a_copy) <- 1
  expr <- sum(a_copy)
  expect_equal(value(expr), 1)

  x_copy <- x
  value(x_copy) <- c(1,2)
  expr <- sum(x_copy)
  expect_equal(value(expr), 3)
})

test_that("test piecewise linear", {
  skip_on_cran()
  A <- matrix(stats::rnorm(6), nrow = 2, ncol = 3)
  b <- matrix(stats::rnorm(2))

  expr <- A %*% y - b
  expect_true(is_pwl(expr))

  expr <- max_elemwise(1, 3*y)
  expect_true(is_pwl(expr))

  expr <- abs(y)
  expect_true(is_pwl(expr))

  expr <- p_norm(3*y, 1)
  expect_true(is_pwl(expr))

  expr <- p_norm(3*y^2, 1)
  expect_false(is_pwl(expr))
})

context("test-g01-linear_cone")
TOL <- 1e-6

a <- Variable(name = "a")
b <- Variable(name = "b")
c <- Variable(name = "c")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

accepts <- CVXR:::accepts
perform <- CVXR:::perform
invert <- CVXR:::invert
reduction_solve <- CVXR:::reduction_solve
ConeMatrixStuffing <- CVXR:::ConeMatrixStuffing
CvxAttr2Constr <- CVXR:::CvxAttr2Constr
FlipObjective <- CVXR:::FlipObjective
ExpCone <- CVXR:::ExpCone
SOC <- CVXR:::SOC

# solvers <- c(CVXR:::ECOS(), CVXR:::GUROBI(), CVXR:::MOSEK(), CVXR:::SCS(), CVXR:::CVXOPT(), CVXR:::GLPK())
solvers <- c(CVXR:::ECOS())

test_that("test scalar LP problems", {
  skip_on_cran()
  for(solver in solvers) {
    p <- Problem(Minimize(3*a), list(a >= 2))
    expect_true(accepts(ConeMatrixStuffing(), p))
    result <- solve(p, solver = name(solver))
    p_new <- perform(ConeMatrixStuffing(), p)
    result_new <- solve(p_new[[2]], solver = name(solver))
    expect_equal(result$value, result_new$value, tolerance = TOL)
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    expect_equal(inv_sltn@primal_vars[[as.character(id(a))]][1], result$getValue(a), tolerance = TOL)

    # TODO: Maximize.
    p <- Problem(Minimize(-3*a + b), list(a <= 2, b == a, b <= 5))
    result <- solve(p, solver = name(solver))
    expect_true(accepts(ConeMatrixStuffing(), p))
    p_new <- perform(ConeMatrixStuffing(), p)
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    expect_equal(inv_sltn@primal_vars[[as.character(id(a))]][1], result$getValue(a), tolerance = TOL)
    expect_equal(inv_sltn@primal_vars[[as.character(id(b))]][1], result$getValue(b), tolerance = TOL)

    # With a constant in the objective.
    p <- Problem(Minimize(3*a - b + 100), list(a >= 2, b + 5*c - 2 == a, b <= 5 + c))
    expect_true(accepts(ConeMatrixStuffing(), p))
    result <- solve(p, solver = name(solver))
    p_new <- perform(ConeMatrixStuffing(), p)
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value - 100, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    expect_equal(inv_sltn@primal_vars[[as.character(id(a))]][1], result$getValue(a))
    expect_equal(inv_sltn@primal_vars[[as.character(id(b))]][1], result$getValue(b))

    # Unbounded problems.
    # TODO: Maximize.
    p <- Problem(Minimize(-a), list(a >= 2))
    expect_true(accepts(ConeMatrixStuffing(), p))
    if(name(solver) != "GUROBI") {
      result <- solve(p, solver = name(solver))
      p_new <- perform(ConeMatrixStuffing(), p)
      expect_true(accepts(solver, p_new[[2]]))
      sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
      expect_equal(sltn@opt_val, result$value, tolerance = TOL)
      inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
      expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    }

    # Infeasible problems.
    p <- Problem(Maximize(a), list(a >= 2, a <= 1))
    result <- solve(p, solver = name(solver))
    expect_true(accepts(FlipObjective(), p))
    p_min <- perform(FlipObjective(), p)
    expect_true(accepts(ConeMatrixStuffing(), p_min[[2]]))
    p_new <- perform(ConeMatrixStuffing(), p_min[[2]])
    result_new <- solve(p_new[[2]], solver = name(solver))
    expect_equal(result$value, -result_new$value, tolerance = TOL)
    expect_true(accepts(solver, p_new[[2]]))
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, -result$value, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, -result$value, tolerance = TOL)
    inv_flipped_sltn <- invert(FlipObjective(), inv_sltn, p_min[[3]])
    expect_equal(inv_flipped_sltn@opt_val, result$value, tolerance = TOL)
  }
})

test_that("test vector LP problems", {
  skip_on_cran()
  for(solver in solvers) {
    c <- Constant(matrix(1:2))
    p <- Problem(Minimize(t(c) %*% x), list(x >= c))
    result <- solve(p, solver = name(solver))
    expect_true(accepts(ConeMatrixStuffing(), p))
    p_new <- perform(ConeMatrixStuffing(), p)
    # result_new <- solve(p_new[[2]], solver = name(solver))
    # expect_equal(result$value, result_new$value)
    expect_true(accepts(solver, p_new[[2]]))
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])

    p_new1 <- perform(ConeMatrixStuffing(), p)
    expect_true(accepts(solver, p_new1[[2]]))
    sltn <- reduction_solve(solver, p_new1[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new1[[3]])

    expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    expect_equal(inv_sltn@primal_vars[[as.character(id(x))]], result$getValue(x))

    A <- value(Constant(cbind(c(3,5), c(1,2))))
    I <- Constant(diag(2))
    p <- Problem(Minimize(t(c) %*% x + a), list(A %*% x >= c(-1, 1), 4*I %*% z == x, z >= c(2, 2), a >= 2))
    expect_true(accepts(ConeMatrixStuffing(), p))
    result <- solve(p, solver = name(solver))
    p_new <- perform(ConeMatrixStuffing(), p)
    result_new <- solve(p_new[[2]], solver = name(solver))
    expect_equal(result$value, result_new$value, tolerance = TOL)
    expect_true(accepts(solver, p_new[[2]]))
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value, tolerance = 0.1)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = 0.1)
    for(var in variables(p))
      expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = 0.1)
  }
})

test_that("test matrix LP problems", {
  skip_on_cran()
  for(solver in solvers) {
    Tmat <- value(Constant(matrix(1, nrow = 2, ncol = 2)))
    p <- Problem(Minimize(1 + a), list(A == Tmat + a, a >= 0))
    expect_true(accepts(ConeMatrixStuffing(), p))
    result <- solve(p, solver = name(solver))
    p_new <- perform(ConeMatrixStuffing(), p)
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value - 1, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    for(var in variables(p))
      expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = TOL)

    Tmat <- value(Constant(matrix(2, nrow = 2, ncol = 3)))
    p <- Problem(Minimize(1), list(A >= Tmat %*% C, A == B, C == t(Tmat)))
    expect_true(accepts(ConeMatrixStuffing(), p))
    result <- solve(p, solver = name(solver))
    p_new <- perform(ConeMatrixStuffing(), p)
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value - 1, tolerance = TOL)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
    for(var in variables(p))
      expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = TOL)
  }
})

test_that("test SOCP problems", {
  skip_on_cran()
  for(solver in solvers) {
    # Basic.
    p <- Problem(Minimize(b), list(p_norm(x, p = 2) <= b))
    pmod <- Problem(Minimize(b), list(SOC(b, x)))
    expect_true(accepts(ConeMatrixStuffing(), pmod))
    p_new <- perform(ConeMatrixStuffing(), pmod)
    if(accepts(solver, p_new[[2]])) {
      result <- solve(p, solver = name(solver))
      sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
      expect_equal(sltn@opt_val, result$value, tolerance = TOL)
      inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
      expect_equal(inv_sltn@opt_val, result$value, tolerance = TOL)
      for(var in variables(p))
        expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = TOL)
    }

    # More complex.
    p <- Problem(Minimize(b), list(p_norm(x/2 + y[1:2], p = 2) <= b + 5, x >= 1, y == 5))
    pmod <- Problem(Minimize(b), list(SOC(b + 5, x/2 + y[1:2]), x >= 1, y == 5))
    expect_true(accepts(ConeMatrixStuffing(), pmod))
    result <- solve(p, solver = name(solver))
    p_new <- perform(ConeMatrixStuffing(), pmod)
    sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
    expect_equal(sltn@opt_val, result$value, tolerance = 1e-2)
    inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
    expect_equal(inv_sltn@opt_val, result$value, tolerance = 1e-2)
    for(var in variables(p))
      expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = 1e-2)
  }
})

test_that("test exponential cone problems", {
  skip_on_cran()
  for(solver in solvers) {
    # Basic.
    p <- Problem(Minimize(b), list(exp(a) <= b, a >= 1))
    pmod <- Problem(Minimize(b), list(ExpCone(a, Constant(1), b), a >= 1))
    expect_true(accepts(ConeMatrixStuffing(), pmod))
    p_new <- perform(ConeMatrixStuffing(), pmod)
    if(accepts(solver, p_new[[2]])) {
      result <- solve(p, solver = name(solver))
      sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
      expect_equal(sltn@opt_val, result$value, tolerance = 0.1)
      inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
      expect_equal(inv_sltn@opt_val, result$value, tolerance = 0.1)
      for(var in variables(p))
        expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = 0.1)
    }

    # More complex.
    # TODO: CVXOPT fails here.
    if(name(solver) != "CVXOPT") {
      p <- Problem(Minimize(b), list(exp(a/2 + c) <= b+5, a >= 1, c >= 5))
      pmod <- Problem(Minimize(b), list(ExpCone(a/2 + c, Constant(1), b+5), a >= 1, c >= 5))
      expect_true(accepts(ConeMatrixStuffing(), pmod))
      result <- solve(p, solver = name(solver))
      p_new <- perform(ConeMatrixStuffing(), pmod)
      sltn <- reduction_solve(solver, p_new[[2]], FALSE, FALSE, 1e-8, 1e-8, 1e-8, 10000, list())
      expect_equal(sltn@opt_val, result$value, tolerance = 1)
      inv_sltn <- invert(ConeMatrixStuffing(), sltn, p_new[[3]])
      expect_equal(inv_sltn@opt_val, result$value, tolerance = 1)
      for(var in variables(pmod))
        expect_equal(inv_sltn@primal_vars[[as.character(id(var))]], as.matrix(result$getValue(var)), tolerance = 1)
    }
  }
})

test_that("test positive semidefinite constraints", {
  skip_on_cran()
  C <- Variable(3,3)
  obj <- Maximize(C[1,3])
  constraints <- list(diag(C) == 1, C[1,2] == 0.6, C[2,3] == -0.3, C == t(C), C %>>% 0)
  prob <- Problem(obj, constraints)
  expect_true(accepts(FlipObjective(), prob))
  p_min <- perform(FlipObjective(), prob)
  expect_true(accepts(ConeMatrixStuffing(), p_min[[2]]))

  C <- Variable(2,2)
  obj <- Maximize(C[1,2])
  constraints <- list(C == 1, C %>>% diag(2,2))
  prob <- Problem(obj, constraints)
  expect_true(accepts(FlipObjective(), prob))
  p_min <- perform(FlipObjective(), prob)
  expect_true(accepts(ConeMatrixStuffing(), p_min[[2]]))

  C <- Variable(2,2, symmetric = TRUE)
  obj <- Minimize(C[1,1])
  constraints <- list(C %<<% diag(2,2))
  tmp <- perform(CvxAttr2Constr(), Problem(obj, constraints))
  expect_true(accepts(ConeMatrixStuffing(), tmp[[2]]))
})

context("test-g01-dgp2dcp")
TOL <- 1e-6

Solution <- CVXR:::Solution
perform <- CVXR:::perform
reduce <- CVXR:::reduce
invert <- CVXR:::invert
retrieve <- CVXR:::retrieve
unpack_problem <- CVXR:::unpack_problem
cvxr_expr <- CVXR:::expr

Dgp2Dcp <- function(problem = NULL) { new("Dgp2Dcp", problem = problem) }
Dgp2Dcp.add_canon <- CVXR:::Dgp2Dcp.add_canon
Dgp2Dcp.mulexpression_canon <- CVXR:::Dgp2Dcp.mulexpression_canon
Dgp2Dcp.prod_canon <- CVXR:::Dgp2Dcp.prod_canon
Dgp2Dcp.trace_canon <- CVXR:::Dgp2Dcp.trace_canon

form_solution <- function(prob, result) {
  primal <- list()
  for(var in prob@variables)
    primal[[as.character(var@id)]] <- result$getValue(var)

  dual <- list()
  for(constr in prob@constraints)
    dual[[as.character(constr@id)]] <- result$getDualValue(constr)

  attr <- list(solve_time = result$solve_time, setup_time = result$setup_time, num_iters = result$num_iters)
  Solution(result$status, result$value, primal, dual, attr)
}

test_that("test unconstrained monomial", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  prod <- x*y
  dgp <- Problem(Minimize(prod))
  dgp2dcp <- Dgp2Dcp(dgp)

  tmp <- reduce(dgp2dcp)
  dgp2dcp <- tmp[[1]]
  dcp <- tmp[[2]]

  expect_equal(class(cvxr_expr(dcp@objective))[1], "AddExpression")
  expect_equal(length(cvxr_expr(dcp@objective)@args), 2)
  expect_equal(class(cvxr_expr(dcp@objective)@args[[1]])[1], "Variable")
  expect_equal(class(cvxr_expr(dcp@objective)@args[[2]])[1], "Variable")
  opt <- solve(dcp)

  # dcp is solved in log-space, so it is unbounded below
  # (since the OPT for dgp is 0 + epsilon).
  expect_equal(opt$value, -Inf)
  expect_equal(opt$status, "unbounded")

  solution <- form_solution(dcp, opt)
  dgp_unpack <- unpack_problem(dgp, retrieve(dgp2dcp, solution))
  expect_equal(dgp_unpack$value, 0.0)
  expect_equal(dgp_unpack$status, "unbounded")
  opt <- solve(dgp, gp = TRUE)
  expect_equal(opt$value, 0.0)
  expect_equal(opt$status, "unbounded")

  dgp <- Problem(Maximize(prod))
  dgp2dcp <- Dgp2Dcp(dgp)
  tmp <- reduce(dgp2dcp)
  dgp2dcp <- tmp[[1]]
  dcp <- tmp[[2]]
  opt <- solve(dcp)
  expect_equal(opt$value, Inf)
  expect_equal(opt$status, "unbounded")

  solution <- form_solution(dcp, opt)
  dgp_unpack <- unpack_problem(dgp, retrieve(dgp2dcp, solution))
  expect_equal(dgp_unpack$value, Inf)
  expect_equal(dgp_unpack$status, "unbounded")
  opt <- solve(dgp, gp = TRUE)
  expect_equal(opt$value, Inf)
  expect_equal(opt$status, "unbounded")
})

test_that("test basic equality constraint", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  dgp <- Problem(Minimize(x), list(x == 1.0))
  dgp2dcp <- Dgp2Dcp(dgp)

  tmp <- reduce(dgp2dcp)
  dgp2dcp <- tmp[[1]]
  dcp <- tmp[[2]]
  expect_equal(class(dcp@objective@args[[1]])[1], "Variable")

  opt <- solve(dcp)
  expect_equal(opt$value, 0.0, tolerance = TOL)
  expect_equal(opt$getValue(variables(dcp)[[1]]), 0.0, tolerance = TOL)

  solution <- form_solution(dcp, opt)
  dgp_unpack <- unpack_problem(dgp, retrieve(dgp2dcp, solution))
  expect_equal(dgp_unpack$value, 1.0, tolerance = TOL)
  expect_equal(dgp_unpack$getValue(x), 1.0, tolerance = TOL)
  result <- solve(dgp, gp = TRUE)
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), 1.0, tolerance = TOL)
})

test_that("test basic GP", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)
  constraints <- list(2*x*y + 2*x*z + 2*y*z <= 1.0, x >= 2*y)
  problem <- Problem(Minimize(1/(x*y*z)), constraints)
  result <- solve(problem, gp = TRUE)
  expect_equal(15.59, result$value, tolerance = 1e-2)
})

test_that("test max_elemwise", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)

  prod1 <- x*y^(0.5)
  prod2 <- 3.0*x*y^(0.5)
  obj <- Minimize(max_elemwise(prod1, prod2))
  constr <- list(x == 1.0, y == 4.0)

  dgp <- Problem(obj, constr)
  dgp2dcp <- Dgp2Dcp(dgp)
  tmp <- reduce(dgp2dcp)
  dgp2dcp <- tmp[[1]]
  dcp <- tmp[[2]]
  opt <- solve(dcp)
  solution <- form_solution(dcp, opt)
  dgp_unpack <- unpack_problem(dgp, retrieve(dgp2dcp, solution))
  expect_equal(dgp_unpack$value, 6.0, tolerance = TOL)
  expect_equal(dgp_unpack$getValue(x), 1.0, tolerance = TOL)
  expect_equal(dgp_unpack$getValue(y), 4.0, tolerance = TOL)
  result <- solve(dgp, gp = TRUE)
  expect_equal(result$value, 6.0, tolerance = TOL)
  expect_equal(result$getValue(x), 1.0, tolerance = TOL)
})

# TODO_NARAS_5: Test keepdims. Need to edit test to match CVXPY.
test_that("test prod_entries", {
  skip_on_cran()
  X <- matrix(0:11, nrow = 4, ncol = 3)
  expect_equal(prod(X), value(prod_entries(X)))
  expect_equal(apply(X, 1, prod), value(prod_entries(X, axis = 1)))
  expect_equal(apply(X, 2, prod), value(prod_entries(X, axis = 2)))

  prod <- prod_entries(X)
  X_canon <- Dgp2Dcp.prod_canon(prod, prod@args)[[1]]
  expect_equal(sum(X), value(X_canon))

  prod <- prod_entries(X, axis = 1)
  X_canon <- Dgp2Dcp.prod_canon(prod, prod@args)[[1]]
  expect_equal(apply(X, 1, sum), value(X_canon))

  prod <- prod_entries(X, axis = 2)
  X_canon <- Dgp2Dcp.prod_canon(prod, prod@args)[[1]]
  expect_equal(apply(X, 2, sum), value(X_canon))

  X <- matrix(0:11, nrow = 12, ncol = 1)
  expect_equal(prod(X), value(prod_entries(X)))

  prod <- prod_entries(X)
  X_canon <- Dgp2Dcp.prod_canon(prod, prod@args)[[1]]
  expect_equal(sum(X), value(X_canon))

  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  posy1 <- x*y^(0.5) + 3.0*x*y^(0.5)
  posy2 <- x*y^(0.5) + 3.0*x^2*y^(0.5)
  expect_true(is_log_log_convex(prod_entries(posy1, posy2)))
  expect_false(is_log_log_concave(prod_entries(posy1, posy2)))
  expect_false(is_dgp(prod_entries(posy1, 1/posy1)))

  m <- x*y^(0.5)
  expect_true(is_log_log_affine(prod_entries(m, m)))
  expect_true(is_log_log_concave(prod_entries(m, 1/posy1)))
  expect_false(is_log_log_convex(prod_entries(m, 1/posy1)))
})

test_that("test max_entries", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)

  prod1 <- x*y^(0.5)
  prod2 <- 3.0*x*y^(0.5)
  obj <- Minimize(max_entries(hstack(prod1, prod2)))
  constr <- list(x == 1.0, y == 4.0)

  dgp <- Problem(obj, constr)
  dgp2dcp <- Dgp2Dcp(dgp)
  tmp <- reduce(dgp2dcp)
  dgp2dcp <- tmp[[1]]
  dcp <- tmp[[2]]
  opt <- solve(dcp)
  solution <- form_solution(dcp, opt)
  dgp_unpack <- unpack_problem(dgp, retrieve(dgp2dcp, solution))
  expect_equal(dgp_unpack$value, 6.0)
  expect_equal(dgp_unpack$getValue(x), 1.0)
  expect_equal(dgp_unpack$getValue(y), 4.0)
  result <- solve(dgp, gp = TRUE)
  expect_equal(result$value, 6.0, tolerance = TOL)
  expect_equal(result$getValue(x), 1.0, tolerance = TOL)
})

test_that("test min_elemwise", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)

  prod1 <- x*y^(0.5)
  prod2 <- 3.0*x*y^(0.5)
  posy <- prod1 + prod2
  obj <- Maximize(min_elemwise(prod1, prod2, 1/posy))
  constr <- list(x == 1.0, y == 4.0)

  dgp <- Problem(obj, constr)
  result <- solve(dgp, gp = TRUE)
  expect_equal(result$value, 1.0/(2.0 + 6.0), tolerance = TOL)
  expect_equal(result$getValue(x), 1.0, tolerance = TOL)
  expect_equal(result$getValue(y), 4.0, tolerance = TOL)
})

test_that("test min_entries", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)

  prod1 <- x*y^(0.5)
  prod2 <- 3.0*x*y^(0.5)
  posy <- prod1 + prod2
  obj <- Maximize(min_entries(hstack(prod1, prod2, 1/posy)))
  constr <- list(x == 1.0, y == 4.0)

  dgp <- Problem(obj, constr)
  result <- solve(dgp, gp = TRUE)
  expect_equal(result$value, 1.0/(2.0 + 6.0), tolerance = TOL)
  expect_equal(result$getValue(x), 1.0, tolerance = TOL)
  expect_equal(result$getValue(y), 4.0, tolerance = TOL)
})

# TODO: Enable test once sum_largest is implemented.
# test_that("test sum_largest", {
#   x <- Variable(4, pos = TRUE)
#   obj <- Minimize(sum_largest(x, 3))
#   constr <- list(x[1]*x[2]*x[3]*x[4] >= 16)
#   dgp <- Problem(obj, constr)
#   dgp2dcp <- Dgp2Dcp(dgp)
#   tmp <- reduce(dgp2dcp)
#   dgp2dcp <- tmp[[1]]
#   dcp <- tmp[[2]]
#   result <- solve(dcp)
#   dgp <- unpack_problem(dgp, retrieve(dgp2dcp, result$solution))
#   opt <- 6.0
#   expect_equal(dgp@value, opt, tolerance = TOL)
#   expect_equal(value(x[1]*x[2]*x[3]*x[4]), 16, tolerance = 1e-2)
#   dgp <- clear_solution(dgp)
#   result <- solve(dgp, gp = TRUE)
#   expect_equal(result$value, opt, tolerance = TOL)
#   expect_equal(value(x[1]*x[2]*x[3]*x[4]), 16, tolerance = 1e-2)
#
#   # An unbounded problem.
#   x <- Variable(4, pos = TRUE)
#   y <- Variable(pos = TRUE)
#   obj <- Minimize(sum_largest(x, 3)*y)
#   constr <- list(x[1]*x[2]*x[3]*x[4] >= 16)
#   dgp <- Problem(obj, constr)
#   dgp2dcp <- Dgp2Dcp(dgp)
#   tmp <- reduce(dgp2dcp)
#   dgp2dcp <- tmp[[1]]
#   dcp <- tmp[[2]]
#   opt <- solve(dcp)
#   expect_equal(dcp@value, -Inf)
#   dgp <- unpack_problem(dgp, retrieve(dgp2dcp, opt$solution))
#   expect_equal(dgp@value, 0.0, tolerance = TOL)
#   expect_equal(dgp@status, "unbounded")
#   dgp <- clear_solution(dgp)
#   result <- solve(dgp, gp = TRUE)
#   expect_equal(result$value, 0.0, tolerance = TOL)
#   expect_equal(result$status, "unbounded")
#
#   # Another unbounded problem.
#   x <- Variable(2, pos = TRUE)
#   obj <- Minimize(sum_largest(x, 1))
#   dgp <- Problem(obj)
#   dgp2dcp <- Dgp2Dcp(dgp)
#   tmp <- reduce(dgp2dcp)
#   dgp2dcp <- tmp[[1]]
#   dcp <- tmp[[2]]
#   opt <- solve(dcp)
#   expect_equal(result$value, -Inf)
#   dgp <- unpack_problem(dgp, retrieve(dgp2dcp, opt$solution))
#   expect_equal(dgp@value, 0.0, tolerance = TOL)
#   expect_equal(dgp@status, "unbounded")
#   dgp <- clear_solution(dgp)
#   result <- solve(dgp, gp = TRUE)
#   expect_equal(dgp@value, 0.0, tolerance = TOL)
#   expect_equal(dgp@status, "unbounded")
#
#   # Composition with posynomials.
#   x <- Variable(4, pos = TRUE)
#   obj <- Minimize(sum_largest(hstack(list(3*x[1]^(0.5) * x[2]^(0.5), x[1]*x[2] + 0.5*x[2]*x[4]^3, x[3])), 2))
#   constr <- list(x[1]*x[2] >= 16)
#   dgp <- Problem(obj, constr)
#   dgp2dcp <- Dgp2Dcp(dgp)
#   dcp <- reduce(dgp2dcp)
#   result <- solve(dcp)
#   dgp <- unpack_problem(dgp, retrieve(dgp2dcp, result$solution))
#
#   # opt = 3 * sqrt(4) * sqrt(4) + (4 * 4 + 0.5 * 4 * epsilon) = 28
#   opt <- 28.0
#   expect_equal(dgp@value, opt, tolerance = 1e-2)
#   expect_equal(value(x[1]*x[2]), 16.0, tolerance = 1e-2)
#   expect_equal(value(x[4]), 0.0, tolerance = 1e-2)
#   dgp <- clear_solution(dgp)
#   result <- solve(dgp, gp = TRUE)
#   expect_equal(result$value, opt, tolerance = 1e-2)
#   expect_equal(value(x[1]*x[2]), 16.0, tolerance = 1e-2)
#   expect_equal(value(x[4]), 0.0, tolerance = 1e-2)
# })

test_that("test div", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  p <- Problem(Minimize(x*y), list(y/3 <= x, y >= 1))
  result <- solve(p, gp = TRUE)
  expect_equal(result$value, 1.0/3.0, tolerance = TOL)
  expect_equal(result$getValue(y), 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), 1.0/3.0, tolerance = TOL)
})

test_that("test geo_mean", {
  skip_on_cran()
  x <- Variable(3, pos = TRUE)
  p <- c(1, 2, 0.5)
  expr <- geo_mean(x, p)
  dgp <- Problem(Minimize(expr))
  dgp2dcp <- Dgp2Dcp(dgp)
  tmp <- reduce(dgp2dcp)
  dgp2dcp <- tmp[[1]]
  dcp <- tmp[[2]]
  result <- solve(dcp)
  expect_equal(result$value, -Inf)

  solution <- form_solution(dcp, result)
  dgp_unpack <- unpack_problem(dgp, retrieve(dgp2dcp, solution))
  expect_equal(dgp_unpack$value, 0.0)
  expect_equal(dgp_unpack$status, "unbounded")
  result <- solve(dgp, gp = TRUE)
  expect_equal(result$value, 0.0)
  expect_equal(result$status, "unbounded")
})

test_that("test solving non-dgp problem raises error", {
  skip_on_cran()
  problem <- Problem(Minimize(-1.0*Variable()))
  expect_error(solve(problem, gp = TRUE))
  result <- solve(problem)
  expect_equal(result$status, "unbounded")
  expect_equal(result$value, -Inf)
})

test_that("test solving non-dcp problem raises error", {
  skip_on_cran()
  problem <- Problem(Minimize(Variable(pos = TRUE) * Variable(pos = TRUE)))
  expect_error(solve(problem))
  result <- solve(problem, gp = TRUE)
  expect_equal(result$status, "unbounded", tolerance = TOL)
  expect_equal(result$value, 0.0, tolerance = TOL)
})

test_that("test add_canon", {
  skip_on_cran()
  X <- Constant(rbind(1:3, 4:6))
  Y <- Constant(rbind(2:4, 5:7))
  Z <- X + Y
  canon <- Dgp2Dcp.add_canon(Z, Z@args)
  canon_matrix <- canon[[1]]
  constraints <- canon[[2]]
  expect_equal(length(constraints), 0)
  expect_equal(dim(canon_matrix), dim(Z))
  expected <- log(exp(value(X)) + exp(value(Y)))
  expect_equal(expected, value(canon_matrix), tolerance = TOL)

  # Test promotion.
  X <- Constant(rbind(1:3, 4:6))
  y <- Constant(2.0)
  Z <- X + y
  canon <- Dgp2Dcp.add_canon(Z, Z@args)
  canon_matrix <- canon[[1]]
  constraints <- canon[[2]]
  expect_equal(length(constraints), 0)
  expect_equal(dim(canon_matrix), dim(Z))
  expected <- log(exp(value(X)) + as.numeric(exp(value(y))))
  expect_equal(expected, value(canon_matrix), tolerance = TOL)
})

test_that("test matmul_canon", {
  skip_on_cran()
  X <- Constant(rbind(1:3, 4:6))
  Y <- Constant(matrix(1:3, nrow = 3))
  Z <- X %*% Y
  canon <- Dgp2Dcp.mulexpression_canon(Z, Z@args)
  canon_matrix <- canon[[1]]
  constraints <- canon[[2]]
  expect_equal(length(constraints), 0)
  expect_equal(dim(canon_matrix), c(2,1))
  first_entry <- log(exp(2.0) + exp(4.0) + exp(6.0))
  second_entry <- log(exp(5.0) + exp(7.0) + exp(9.0))
  expect_equal(first_entry, as.numeric(value(canon_matrix[1,1])), tolerance = TOL)
  expect_equal(second_entry, as.numeric(value(canon_matrix[2,1])), tolerance = TOL)
})

test_that("test trace_canon", {
  skip_on_cran()
  X <- Constant(rbind(c(1.0, 5.0), c(9.0, 14.0)))
  Y <- matrix_trace(X)
  canon <- Dgp2Dcp.trace_canon(Y, Y@args)
  canon_matrix <- canon[[1]]
  constraints <- canon[[2]]
  expect_equal(length(constraints), 0)
  expect_true(is_scalar(canon_matrix))
  expected <- log(exp(1.0) + exp(14.0))
  expect_equal(expected, value(canon_matrix), tolerance = TOL)
})

test_that("test one_minus_pos", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  obj <- Maximize(x)
  constr <- list(one_minus_pos(x) >= 0.4)
  problem <- Problem(obj, constr)
  result <- solve(problem, gp = TRUE)
  expect_equal(result$value, 0.6, tolerance = TOL)
  expect_equal(result$getValue(x), 0.6, tolerance = TOL)
})

test_that("test qp solver not allowed", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  problem <- Problem(Minimize(x))
  expect_error(solve(problem, solver = "OSQP", gp = TRUE))
})

# TODO: Enable test once sum_largest is implemented.
# test_that("test paper example sum_largest", {
#   x <- Variable(4, pos = TRUE)
#   x1 <- x[1]
#   x2 <- x[2]
#   x3 <- x[3]
#   x4 <- x[4]
#   obj <- Minimize(sum_largest(hstack(3*x1^(0.5) * x2^(0.5), x1*x2 + 0.5*x2*x4^3, x3), 2))
#   constr <- list(x1*x2*x3 >= 16)
#   p <- Problem(obj, constr)
#   expect_silent(solve(p, gp = TRUE))   # Smoke test.
# })

test_that("test paper example one_minus_pos", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  obj <- Minimize(x*y)
  constr <- list((y * one_minus_pos(x/y))^2 >= 1, x >= y/3)
  problem <- Problem(obj, constr)
  expect_silent(solve(problem, gp = TRUE))   # Smoke test.
})

test_that("test paper example eye_minus_inv", {
  skip_on_cran()
  X <- Variable(2,2, pos = TRUE)
  obj <- Minimize(matrix_trace(eye_minus_inv(X)))
  constr <- list(geo_mean(diag(X)) == 0.1)
  problem <- Problem(obj, constr)
  expect_silent(solve(problem, gp = TRUE, solver = "SCS"))   # Smoke test.
})

test_that("test paper example exp_log", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  obj <- Minimize(x*y)
  constr <- list(exp(y/x) <= log(y))
  problem <- Problem(obj, constr)
  expect_silent(solve(problem, gp = TRUE))   # Smoke test.
})

test_that("test pf matrix completion", {
  skip_on_cran()
  X <- Variable(3,3, pos = TRUE)
  obj <- Minimize(pf_eigenvalue(X))
  known_indices <- cbind(c(1,1,2,3,3), c(1,3,2,1,2))
  constr <- list(X[known_indices] == c(1.0, 1.9, 0.8, 3.2, 5.9),
                 X[1,2] * X[2,1] * X[2,3] * X[3,3] == 1.0)
  problem <- Problem(obj, constr)
  expect_silent(solve(problem, gp = TRUE))   # Smoke test.
})

test_that("test rank one nmf", {
  skip_on_cran()
  X <- Variable(3,3, pos = TRUE)
  x <- Variable(3, pos = TRUE)
  y <- Variable(3, pos = TRUE)
  xy <- hstack(x[1]*y, x[2]*y, x[3]*y)
  R <- max_elemwise(multiply(X, (xy)^(-1.0)), multiply(X^(-1.0), xy))
  objective <- sum(R)
  constraints <- list(X[1,1] == 1.0, X[1,3] == 1.9, X[2,2] == 0.8, X[3,1] == 3.2, X[3,2] == 5.9,
                      x[1] * x[2] * x[3] == 1.0)
  # Smoke test.
  prob <- Problem(Minimize(objective), constraints)
  expect_silent(solve(prob, gp = TRUE))
})

test_that("test documentation problem", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  z <- Variable(pos = TRUE)

  objective_fn <- x*y*z
  constraints <- list(4*x*y*z + 2*x*z <= 10, x <= 2*y, y <= 2*x, z >= 1)
  problem <- Problem(Maximize(objective_fn), constraints)
  expect_silent(solve(problem, gp = TRUE))   # Smoke test.
})

test_that("test solver error", {
  skip_on_cran()
  x <- Variable(pos = TRUE)
  y <- Variable(pos = TRUE)
  prod <- x*y
  dgp <- Problem(Minimize(prod))
  dgp2dcp <- Dgp2Dcp()
  tmp <- perform(dgp2dcp, dgp)
  dgp2dcp <- tmp[[1]]
  data <- tmp[[2]]
  inverse_data <- tmp[[3]]

  soln <- Solution("solver_error", NA_real_, list(), list(), list())
  dgp_soln <- invert(dgp2dcp, soln, inverse_data)
  expect_equal(dgp_soln@status, "solver_error")
})

context("test-g01-non_optimal")

test_that("Test scalar LP problems", {
  skip_on_cran()
  x1 <- Variable()
  x2 <- Variable()
  obj <- Minimize(-x1-x2)
  constraints <- list(2*x1 + x2 >= 1, x1 + 3*x2 >= 1, x1 >= 0, x2 >= 0)
  p_unb <- Problem(obj, constraints)
  p_inf <- Problem(Minimize(x1), list(x1 >= 0, x1 <= -1))
  for(solver in c("ECOS", "SCS")) {
    print(solver)
    result <- solve(p_unb, solver = solver)
    expect_equal(tolower(result$status), "unbounded")
    result <- solve(p_inf, solver = solver)
    expect_equal(tolower(result$status), "infeasible")
  }
})

test_that("Test vector LP problems", {
  skip_on_cran()
  # Infeasible and unbounded problems
  x <- Variable(5)
  p_inf <- Problem(Minimize(sum(x)), list(x >= 1, x <= 0))
  p_unb <- Problem(Minimize(sum(x)), list(x <= 1))
  for(solver in c("ECOS", "SCS")) {
    print(solver)
    result <- solve(p_unb, solver = solver)
    expect_equal(tolower(result$status), "unbounded")
    result <- solve(p_inf, solver = solver)
    expect_equal(tolower(result$status), "infeasible")
  }
})

# test_that("Test the optimal inaccurate status", {
#  x <- Variable(5)
#  prob <- Problem(Maximize(sum(sqrt(x))), list(x <= 0))
#  result <- solve(prob, solver = "SCS")
#  expect_equal(tolower(result$status), "optimal_inaccurate")
#  expect_false(is.na(result$value))
# })

# test_that("Test SOC problems", {
#   # Infeasible and unbounded problems.
#   x <- Variable(5)
#   obj <- Maximize(sum(sqrt(x)))
#   p_inf <- Problem(obj, list(x >= 1, x <= 0))
#   p_unb <- Problem(obj, list(x >= 1))
#   for(solver in c("ECOS", "SCS")) {
#     print(solver)
#     result <- solve(p_inf, solver = solver)
#     expect_equal(result$status, "infeasible")
#     result <- solve(p_unb, solver = solver)
#     expect_equal(result$status, "unbounded")
#   }
# })

# test_that("Test PSD problems", {
#   # Infeasible and unbounded problems.
#   X <- Variable(5,5)
#   obj <- Maximize(lambda_min(X))
#   p_inf <- Problem(obj, list(X >= 1, X <= 0))
#   p_unb <- Problem(obj)
#   for(solver in c("SCS")) {
#     print(solver)
#     result <- solve(p_inf, solver = solver)
#     expect_equal(result$status, "infeasible")
#     result <- solve(p_unb, solver = solver)
#     expect_equal(result$status, "unbounded")
#   }
# })

## These tests were moved here because scs causes errors on R-devel on travis
## Also because they go over the time limit
context("test-examples")
TOL <- 1e-6

test_that("Test Chebyshev center", {
    skip_on_cran()
    # Find the largest Euclidean ball in the polyhedron.
    # Goal is to find the largest Euclidean ball (i.e. its center and radius)
    # that lies in a polyhedron described by linear inequalities in this fashion:
    # P = {x : a_i'*x <= b_i, i=1,...,m} where x is in R^2.

    # Generate the input data.
    a1 <- matrix(c(2,1))
    a2 <- matrix(c(2,-1))
    a3 <- matrix(c(-1,2))
    a4 <- matrix(c(-1,-2))
    b <- matrix(1, nrow = 4)

    # Create and solve the model.
    r <- Variable(name = "r")
    x_c <- Variable(2, name = "x_c")
    obj <- Maximize(r)
    constraints <- list(   # TODO: Have atoms compute values for constants.
        t(a1) %*% x_c + norm(a1, "F")*r <= b[1],
        t(a2) %*% x_c + norm(a2, "F")*r <= b[2],
        t(a3) %*% x_c + norm(a3, "F")*r <= b[3],
        t(a4) %*% x_c + norm(a4, "F")*r <= b[4]
    )

    p <- Problem(obj, constraints)
    result <- solve(p)
    expect_equal(result$value, 0.447214, tolerance = TOL)
    expect_equal(result$getValue(r), result$value, tolerance = TOL)
    expect_equal(result$getValue(x_c), matrix(c(0,0)), tolerance = TOL)
})

test_that("Test issue with scalars", {
    skip_on_cran()

    n <- 6
    eps <- 1e-6
    set.seed(10)
    P0 <- matrix(stats::rnorm(n*n), ncol = n)
    eye <- diag(n)
    P0 <- t(P0) %*% P0 + eps * eye

    print(P0)

    P1 <- matrix(stats::rnorm(n*n), nrow = n, ncol = n)
    P1 <- t(P1) %*% P1
    P2 <- matrix(stats::rnorm(n*n), nrow = n, ncol = n)
    P2 <- t(P2) %*% P2
    P3 <- matrix(stats::rnorm(n*n), nrow = n, ncol = n)
    P3 <- t(P3) %*% P3

    q0 <- matrix(stats::rnorm(n), ncol = 1)
    q1 <- matrix(stats::rnorm(n), ncol = 1)
    q2 <- matrix(stats::rnorm(n), ncol = 1)
    q3 <- matrix(stats::rnorm(n), ncol = 1)

    r0 <- matrix(stats::rnorm(1), ncol = 1)
    r1 <- matrix(stats::rnorm(1), ncol = 1)
    r2 <- matrix(stats::rnorm(1), ncol = 1)
    r3 <- matrix(stats::rnorm(1), ncol = 1)

    slack <- Variable()

    # Form the problem.
    x <- Variable(n)
    objective <- Minimize(0.5*quad_form(x, P0) + t(q0) %*% x + r0 + slack)
    constraints <- list(0.5*quad_form(x, P1) + t(q1) %*% x + r1 <= slack,
                        0.5*quad_form(x, P2) + t(q2) %*% x + r2 <= slack,
                        0.5*quad_form(x, P3) + t(q3) %*% x + r3 <= slack
    )

    # We now find the primal result and compare it to the dual result to check
    # if strong duality holds, i.e., the duality gap is effectively zero.
    p <- Problem(objective, constraints)
    result <- solve(p)

    # Note that since our data is random, we may need to run this program multiple times
    # to get a feasible primal. When feasible, we can print out the following values:
    print(result$getValue(x))   # solution
    lam1 <-  result$getDualValue(constraints[[1]])
    lam2 <-  result$getDualValue(constraints[[2]])
    lam3 <-  result$getDualValue(constraints[[3]])
    print(class(lam1))

    P_lam <- P0 + lam1*P1 + lam2*P2 + lam3*P3
    q_lam <- q0 + lam1*q1 + lam2*q2 + lam3*q3
    r_lam <- r0 + lam1*r1 + lam2*r2 + lam3*r3
    dual_result <- -0.5*t(q_lam) %*% P_lam %*% q_lam + r_lam
    print(dim(dual_result))
    expect_equal(CVXR:::intf_dim(dual_result), c(1,1))
})

test_that("Test examples from the README", {
    skip_on_cran()

    ## Problem data
    m <- 30
    n <- 20
    A <- matrix(stats::rnorm(m*n), nrow = m, ncol = n)
    b <- matrix(stats::rnorm(m), nrow = m, ncol = 1)

    ## Construct the problem
    x <- Variable(n)
    objective <- Minimize(sum((A %*% x - b)^2))
    constraints <- list(x >= 0, x <= 1)
    p <- Problem(objective, constraints)

    ## The optimal objective is returned by solve(p)
    result <- solve(p)
    ## The optimal value for x is stored in result$getValue(x)
    print(result$getValue(x))
    ## The optimal Lagrange multiplier for a constraint is stored in result$getDualValue(constraints[[1]])
    print(result$getDualValue(constraints[[1]]))

    ###########################################
    ## Scalar variable
    a <- Variable()

    ## Column vector variable of length 5
    x <- Variable(5)

    ## Matrix variable with 4 rows and 7 columns
    A <- Variable(4, 7)

    ###########################################
    ## Positive scalar parameter
    m <- Parameter(nonneg = TRUE)

    ## Column vector parameter with unknown sign (by default)
    c <- Parameter(5)

    ## Matrix parameter with negative entries
    G <- Parameter(4, 7, nonpos = TRUE)

    ## Assigns a constant value to G
    value(G) <- -matrix(1, nrow = 4, ncol = 7)

    # Raises an error for assigning a value with invalid sign
    expect_error(value(G) <- matrix(1, nrow = 4, ncol = 7), "Value must be nonpositive")

    ###########################################
    a <- Variable()
    x <- Variable(5)

    ## expr is an Expression object after each assignment
    expr <- 2*x
    expr <- expr - a
    expr <- sum(expr) + norm2(x)

    ###########################################
    ## Problem data
    n <- 10
    m <- 5
    A <- matrix(stats::rnorm(n*m), nrow = n, ncol = m)
    b <- matrix(stats::rnorm(n), nrow = n, ncol = 1)
    gamma <- Parameter(nonneg = TRUE)

    ## Construct the problem
    x <- Variable(m)
    loss <- sum((A %*% x - b)^2)

    get_x <- function(gamma_value) {
        value(gamma) <- gamma_value
        objective <- Minimize(loss + gamma*norm1(x))
        # objective <- Minimize(loss + gamma_value*norm1(x))
        p <- Problem(objective)

        result <- solve(p)
        result$getValue(x)
    }

    gammas <- 10^seq(-1, 2, length.out = 2)

    ## Serial computation
    x_values <- sapply(gammas, get_x)

    ###########################################
    n <- 10

    mu <- matrix(stats::rnorm(n), nrow = 1, ncol = n)
    sigma <- matrix(stats::rnorm(n*n), nrow = n, ncol = n)
    sigma <- t(sigma) %*% sigma
    gamma <- Parameter(nonneg = TRUE)
    value(gamma) <- 1
    x <- Variable(n)

    ## Constants:
    ## mu is the vector of expected returns.
    ## sigma is the covariance matrix.
    ## gamma is a Parameter that trades off risk and return.

    ## Variables:
    ## x is a vector of stock holdings as fractions of total assets.

    expected_return <- mu %*% x
    risk <- quad_form(x, sigma)

    objective <- Maximize(expected_return - gamma*risk)
    p <- Problem(objective, list(sum(x) == 1))
    result <- solve(p)

    ## The optimal expected return
    print(result$getValue(expected_return))

    ## The optimal risk
    print(result$getValue(risk))

    ###########################################
    N <- 50
    M <- 40
    n <- 10
    data1 <- lapply(1:N, function(i) { list(1, matrix(stats::rnorm(n, mean = 1.0, sd = 2.0))) })
    data2 <- lapply(1:M, function(i) { list(-1, matrix(stats::rnorm(n, mean = -1.0, sd = 2.0))) })
    data <- c(data1, data2)

    ## Construct problem
    gamma <- Parameter(nonneg = TRUE)
    value(gamma) <- 0.1
    ## 'a' is a variable constrained to have at most 6 nonzero entries
    a <- Variable(n)
    b <- Variable()

    slack <- lapply(data, function(x) {
        label <- x[[1]]
        sample <- x[[2]]
        pos(1 - label*(t(sample) %*% a - b))
    })
    objective <- Minimize(norm2(a) + gamma*Reduce("+", slack))
    p <- Problem(objective)
    result <- solve(p)

    ## Count misclassifications
    errors <- 0
    for(v in data) {
        label <- v[[1]]
        sample <- v[[2]]
        if(label * result$getValue(t(sample) %*% a - b) < 0)
            errors <- errors + 1
    }

    print(paste(errors, "misclassifications"))
    print(result$getValue(a))
    print(result$getValue(b))
})

test_that("Test advanced tutorial 1", {
    skip_on_cran()

    # Solving a problem with different solvers.
    x <- Variable(2)
    obj <- Minimize(x[1] + norm1(x))
    constraints <- list(x >= 2)
    prob <- Problem(obj, constraints)

    # Solve with ECOS.
    result <- solve(prob, solver = "ECOS")
    print(paste("Optimal value with ECOS:", result$value))
    expect_equal(result$value, 6, tolerance = TOL)

    # Solve with ECOS_BB.
    result <- solve(prob, solver = "ECOS_BB")
    print(paste("Optimal value with ECOS_BB:", result$value))
    expect_equal(result$value, 6, tolerance = TOL)

    # Solve with CVXOPT.
    if("CVXOPT" %in% installed_solvers()) {
        result <- solve(prob, solver = "CVXOPT")
        print(paste("Optimal value with CVXOPT:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    # Solve with SCS.
    result <- solve(prob, solver = "SCS")
    print(paste("Optimal value with SCS:", result$value))
    expect_equal(result$value, 6, tolerance = 1e-2)

    # Solve with CPLEX.
    if("CPLEX" %in% installed_solvers()) {
        result <- solve(prob, solver = "CPLEX")
        print(paste("Optimal value with CPLEX:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    if("GLPK" %in% installed_solvers()) {
        # Solve with GLPK.
        result <- solve(prob, solver = "GLPK")
        print(paste("Optimal value with GLPK:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)

        # Solve with GLPK_MI.
        result <- solve(prob, solver = "GLPK_MI")
        print(paste("Optimal value with GLPK_MI:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    # Solve with MOSEK.
    if("MOSEK" %in% installed_solvers()) {
        result <- solve(prob, solver = "MOSEK")
        print(paste("Optimal value with MOSEK:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    # Solve with GUROBI.
    if("GUROBI" %in% installed_solvers()) {
        result <- solve(prob, solver = "GUROBI")
        print(paste("Optimal value with GUROBI:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    print(installed_solvers())
})

test_that("Test log-determinant", {
    skip_on_cran()

    # Generate data
    x <- cbind(c(0.55, 0.0),
               c(0.25, 0.35),
               c(-0.2, 0.2),
               c(-0.25, -0.1),
               c(0.0, -0.3),
               c(0.4, -0.2))
    n <- nrow(x)
    m <- ncol(x)

    # Create and solve the model
    A <- Variable(n,n)
    b <- Variable(n)
    obj <- Maximize(log_det(A))
    constraints <- lapply(seq_len(m), function(i) { norm2(A %*% x[,i] + b) <= 1 })
    p <- Problem(obj, constraints)
    result <- solve(p)
    expect_equal(result$value, 1.9746, tolerance = 1e-2)
})

test_that("Test portfolio problem that caused DCPAttr errors", {
    skip_on_cran()

    library(Matrix)
    set.seed(5)
    n <- 100   # 10000
    m <- 10   # 100

    Fmat <- rsparsematrix(m, n, density = 0.01)
    Fmat@x <- rep(1, length(Fmat@x))
    D <- sparseMatrix(i = seq_len(n), j = seq_len(n), x = rep(1,n))
    D@x <- rnorm(length(D@x))^2
    Z <- matrix(rnorm(m), nrow = m, ncol = 1)
    Z <- Z %*% t(Z)

    x <- Variable(n)
    y <- Fmat %*% x

    # DCPAttr causes error because not all the curvature matrices are
    # reduced to constants when an atom is scalar.
    norm2(D %*% x)^2 + (Z %*% y)^2
})

test_that("Test examples from CVXR introduction", {
    skip_on_cran()

    m <- 30
    n <- 20
    set.seed(1)
    A <- matrix(rnorm(m*n), nrow = m, ncol = n)
    b <- matrix(rnorm(m), nrow = m, ncol = 1)

    # Construct the problem.
    x <- Variable(n)
    objective <- Minimize(sum((A %*% x - b)^2))
    constraints <- list(x >= 0, x <= 1)
    prob <- Problem(objective, constraints)

    # The optimal objective is returned by solve(prob).
    result <- solve(prob)
    # The optimal value for x is stored in result$getValue(x)
    print(result$getValue(x))
    # The optimal Lagrange multiplier for a constraint is stored in result$getDualValue(constraint[[1]])
    print(result$getDualValue(prob@constraints[[1]]))

    ########################################

    # Create the two scalar variables.
    x <- Variable()
    y <- Variable()

    # Create two constraints.
    constraints <- list(x + y == 1, x - y >= 1)

    # Form objective.
    obj <- Minimize((x - y)^2)

    # Form and solve problem.
    prob <- Problem(obj, constraints)
    result <- solve(prob)   # Returns the optimal value.
    print(paste("status:", result$status))
    print(paste("optimal value:", result$value))
    print(paste("optimal var (x):", result$getValue(x)))
    print(paste("optimal var (y):", result$getValue(y)))

    ########################################

    # Create the two scalar variables.
    x <- Variable()
    y <- Variable()

    # Create two constraints.
    constraints <- list(x + y == 1, x - y >= 1)

    # Form objective.
    obj <- Minimize((x - y)^2)

    # Form and solve problem.
    prob <- Problem(obj, constraints)
    result <- solve(prob)   # Returns the optimal value.
    print(paste("status:", result$status))
    print(paste("optimal value:", result$value))
    print(paste("optimal var (x):", result$getValue(x)))
    print(paste("optimal var (y):", result$getValue(y)))

    expect_equal(result$status, "optimal")
    expect_equal(result$value, 1.0, tolerance = TOL)
    expect_equal(result$getValue(x), 1.0, tolerance = TOL)
    expect_equal(result$getValue(y), 0, tolerance = TOL)

    ########################################

    # Replace the objective.
    prob <- Problem(Maximize(x + y), prob@constraints)
    result <- solve(prob)
    print(paste("optimal value:", result$value))

    expect_equal(result$value, 1.0, tolerance = 1e-3)

    # Replace the constraint (x + y == 1).
    constraints <- prob@constraints
    constraints[[1]] <- (x + y <= 3)
    prob <- Problem(prob@objective, constraints)
    result <- solve(prob)
    print(paste("optimal value:", result$value))

    expect_equal(result$value, 3.0, tolerance = 1e-2)

    ########################################

    x <- Variable()

    # An infeasible problem.
    prob <- Problem(Minimize(x), list(x >= 1, x <= 0))
    result <- solve(prob)
    print(paste("status:", result$status))
    print(paste("optimal value:", result$value))

    expect_equal(result$status, "infeasible")
    expect_equal(result$value, Inf)

    # An unbounded problem.
    prob <- Problem(Minimize(x))
    result <- solve(prob)
    print(paste("status:", result$status))
    print(paste("optimal value:", result$value))

    expect_equal(result$status, "unbounded")
    expect_equal(result$value, -Inf)

    ########################################

    # A scalar variable.
    Variable()

    # Column vector variable of length 5.
    x <- Variable(5)

    # Matrix variable with 4 rows and 7 columns.
    A <- Variable(4,7)

    ########################################

    m <- 10
    n <- 5
    set.seed(1)
    A <- matrix(rnorm(m*n), nrow = m, ncol = n)
    b <- matrix(rnorm(m))

    # Construct the problem.
    x <- Variable(n)
    objective <- Minimize(sum((A %*% x - b)^2))
    constraints <- list(x >= 0, x <= 1)
    prob <- Problem(objective, constraints)
    result <- solve(prob)

    print(paste("Optimal value:", result$value))
    print("Optimal var:")
    print(result$getValue(x))

    expect_equal(result$value, 7.24427715882, tolerance = TOL)

    ########################################

    # Positive scalar parameter.
    m <- Parameter(nonneg = TRUE)

    # Column vector parameter with unknown sign (by default).
    Parameter(5)

    # Matrix parameter with negative entries.
    G <- Parameter(4,7, nonpos = TRUE)

    # Assigns a constant value to G.
    value(G) <- -matrix(1, nrow = 4, ncol = 7)

    ########################################

    # Create parameter, then assign value.
    rho <- Parameter(nonneg = TRUE)
    value(rho) <- 2

    # Initialize parameter with a value.
    rho <- Parameter(nonneg = TRUE, value = 2)

    ########################################

    n <- 15
    m <- 10
    set.seed(1)
    A <- matrix(rnorm(n*m), nrow = n, ncol = m)
    b <- matrix(rnorm(n), nrow = n, ncol = 1)
    # gamma must be positive due to DCP rules.
    gamma <- Parameter(nonneg = TRUE)

    # Construct the problem.
    x <- Variable(m)
    error <- sum((A %*% x - b)^2)
    obj <- Minimize(error + gamma*p_norm(x,1))
    prob <- Problem(obj)

    # Construct a tradeoff curve of ||Ax-b||^2 vs. ||x||_1.
    sq_penalty <- c()
    l1_penalty <- c()
    x_values <- list()
    gamma_vals <- 10^seq(-4, 6, length.out = 50)
    for(val in gamma_vals) {
        value(gamma) <- val
        obj <- Minimize(error + gamma*p_norm(x,1))
        prob <- Problem(obj)
        result <- solve(prob)

        # Use value(expr) to get the numerical value of an expression in the problem.
        sq_penalty <- c(sq_penalty, result$getValue(error))
        l1_penalty <- c(l1_penalty, result$getValue(p_norm(x,1)))
        x_values <- c(x_values, list(result$getValue(x)))
    }

    ########################################
    X <- Variable(5,4)
    A <- matrix(1, nrow = 3, ncol = 5)

    # Use size(expr) to get the total number of elements.
    print(paste("size of X:", size(X)))
    print(paste("size of sum(X):", size(sum(X))))
    print(paste("size of A %*% X:", size(A %*% X)))

    # ValueError raised for invalid dimensions.
    tryCatch({
        A + X
    }, error = function(e) {
        print(e)
    })
})

test_that("Test image in-painting", {
    skip_on_cran()

    set.seed(1)
    rows <- 100
    cols <- 100

    ## Load the images and convert to arrays
    Uorig <- matrix(sample(0:255, size = rows * cols, replace = TRUE), nrow = rows, ncol = cols)

    ## Known is 1 if the pixel is known, 0 if the pixel was corrupted
    ## Known <- matrix(0, nrow = rows, ncol = cols)

    ## for(i in 1:rows) {
    ##     for(j in 1:cols) {
    ##         if(stats::runif(1) > 0.7)
    ##             Known[i,j] <- 1
    ##     }
    ## }

    Known <- sapply(seq_len(cols), function(x) as.numeric(stats::runif(n = rows) > 0.7))

    Ucorr <- Known %*% Uorig

    ## Recover the original image using total variation in-painting
    U <- Variable(rows, cols)
    obj <- Minimize(tv(U))
    constraints <- list(Known * U == Known * Ucorr)
    prob <- Problem(obj, constraints)
    res <- solve(prob, solver = "SCS")   ## Does testing on travis cause SCS to bomb?
    ## It certainly gives warnings, but that is a known problem with SCS
})

test_that("Test advanced tutorial 2", {
    skip_on_cran()

    x <- Variable()
    prob <- Problem(Minimize(x^2), list(x == 2))

    # Get ECOS arguments.
    tmp <- get_problem_data(prob, "ECOS")
    data <- tmp[[1]]
    chain <- tmp[[2]]
    inverse <- tmp[[3]]

    # Get ECOS_BB arguments.
    tmp <- get_problem_data(prob, "ECOS_BB")
    data <- tmp[[1]]
    chain <- tmp[[2]]
    inverse <- tmp[[3]]

    # Get CVXOPT arguments.
    if("CVXOPT" %in% installed_solvers()) {
        tmp <- get_problem_data(prob, "CVXOPT")
        data <- tmp[[1]]
        chain <- tmp[[2]]
        inverse <- tmp[[3]]
    }

    # Get SCS arguments.
    tmp <- get_problem_data(prob, "SCS")
    data <- tmp[[1]]
    chain <- tmp[[2]]
    inverse <- tmp[[3]]

    library(ECOSolveR)

    # Get ECOS arguments.
    tmp <- get_problem_data(prob, "ECOS")
    data <- tmp[[1]]
    chain <- tmp[[2]]
    inverse <- tmp[[3]]

    # Call ECOS solver.
    solution <- ECOSolveR::ECOS_csolve(c = data$c, G = data$G, h = data$h, dims = ECOS.dims_to_solver_dict(data$dims), A = data$A, b = data$b)

    # Unpack raw solver output.
    unpack_results(prob, solution, chain, inverse)
})

test_that("Test the log_sum_exp function", {
    skip_on_cran()

    set.seed(1)
    m <- 5
    n <- 2
    X <- matrix(1, nrow = m, ncol = n)
    w <- Variable(n)

    # expr2 <- lapply(1:m, function(i) { log_sum_exp(vstack(0, X[i,] %*% w)) })
    expr2 <- lapply(1:m, function(i) { log_sum_exp(vstack(0, matrix(X[i,], nrow = 1) %*% w)) })
    expr3 <- Reduce("+", expr2)
    obj <- Minimize(expr3)
    p <- Problem(obj)
    res <- solve(p, solver = "SCS", max_iters = 1)
})

# test_that("Test risk-return tradeoff curve", {
#     ##skip_on_cran()
#
#     library(expm)
#     n <- 4
#     S <- rbind(c( 4e-2, 6e-3,  -4e-3, 0.0),
#                c( 6e-3, 1e-2,    0.0, 0.0),
#                c(-4e-3,  0.0, 2.5e-3, 0.0),
#                c(  0.0,  0.0,    0.0, 0.0))
#     pbar <- matrix(c(0.12, 0.10, 0.07, 0.03))
#
#     N <- 100
#     Sroot <- expm::sqrtm(S)
#     x <- Variable(n, name = "x")
#     mu <- Parameter(name = "mu")
#     value(mu) <- 1   # TODO: Parameter("positive")
#     objective <- Minimize(-pbar %*% x  + mu * quad_over_lin(Sroot %*% x, 1))
#     constraints <- list(sum(x) == 1, x >= 0)
#     p <- Problem(objective, constraints)
#
#     ts <- seq(0, N-1)
#     mus <- 10^(5.0*ts/N-1.0)
#     xs <- list()
#     for(mu_val in mus) {
#         value(mu) <- mu_val
#         objective <- Minimize(-pbar %*% x  + mu * quad_over_lin(Sroot %*% x, 1))
#         p <- Problem(objective, constraints)
#         result <- solve(p)
#         xs <- c(xs, list(result$getValue(x)))
#     }
#
#     returns <- lapply(xs, function(x) { as.numeric(pbar %*% x) })
#     risks <- lapply(xs, function(x) { as.numeric(sqrt(x %*% S %*% x)) })
# })

context("test-g05-mosek")
TOL <- 1e-6

MOSEK_AVAILABLE  <- "MOSEK" %in% installed_solvers()

if (MOSEK_AVAILABLE) library("Rmosek")

test_that("test MOSEK affco1 example",{
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")
  # Example from
  # https://docs.mosek.com/9.1/rmosek/examples-list.html#doc-example-file-affco1-r
  affco1 <- function(){
    prob <- list(sense="max")

    # Variables [x1; x2; t1; t2]
    prob$c <- c(0, 0, 1, 1)

    # Linear inequality x_1 - x_2 <= 1
    prob$A <- Matrix(c(1, -1, 0, 0), nrow=1, sparse=TRUE)
    prob$bc <- rbind(blc=-Inf, buc=1)
    prob$bx <- rbind(blx=rep(-Inf,4), bux=rep(Inf,4))

    # The quadratic cone
    FQ <- rbind(c(0,0,0,0), c(1,0,0,0), c(0,1,0,0))
    gQ <- c(1, -0.5, -0.6)
    cQ <- matrix(list("QUAD", 3, NULL), nrow=3, ncol=1)

    # The power cone for (x_1, 1, t_1) \in POW3^(1/3,2/3)
    FP1 <- rbind(c(1,0,0,0), c(0,0,0,0), c(0,0,1,0))
    gP1 <- c(0, 1, 0)
    cP1 <- matrix(list("PPOW", 3, c(1/3, 2/3)), nrow=3, ncol=1)

    # The power cone for (x_1+x_2+0.1, 1, t_2) \in POW3^(1/4,3/4)
    FP2 <- rbind(c(1,1,0,0), c(0,0,0,0), c(0,0,0,1))
    gP2 <- c(0.1, 1, 0)
    cP2 <- matrix(list("PPOW", 3, c(1.0, 3.0)), nrow=3, ncol=1)

    # All cones
    prob$F <- rbind(FQ, FP1, FP2)
    prob$g <- cbind(gQ, gP1, gP2)
    prob$cones <- cbind(cQ, cP1, cP2)
    rownames(prob$cones) <- c("type","dim","conepar")

    r <- mosek(prob, list(soldetail=1))
    stopifnot(identical(r$response$code, 0))
    list(status = r$response$code, value = r$sol$itr$pobjval, x = r$sol$itr$xx[1:2])
  }
  # rmosek answer
  rmosek <- affco1()

  # CVXR answer
  x  <- Variable(2)
  obj  <- x[1, 1]^(1/3) + (sum(x) + 0.1)^(1/4)
  cons  <- list(
    sum_squares(x - matrix(c(0.5, 0.6))) <= 1,
    x[1, 1] >= 0,
    x[1, 1] <= x[2, 1] + 1
  )
  p  <- Problem(Maximize(obj), cons)
  cvxr <- solve(p, gp = FALSE, solver = "MOSEK")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, rmosek$value, tolerance = 1e-4)
  expect_equal(cvxr$getValue(x), matrix(rmosek$x), tolerance = 1e-4)
})

test_that("test MOSEK simple quadratic optimization problem",{
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")

  # Example from
  # https://docs.mosek.com/9.1/rmosek/tutorial-qo-shared.html
  qo1 <- function(){
    # Specify the non-quadratic part of the problem.
    prob <- list(sense="min")
    prob$c <- c(0, -1, 0)
    prob$A <- Matrix(c(1, 1, 1), nrow=1, sparse=TRUE)
    prob$bc <- rbind(blc=1,
                     buc=Inf)
    prob$bx <- rbind(blx=rep(0,3),
                     bux=rep(Inf,3))

    # Specify the quadratic objective matrix in triplet form.
    prob$qobj$i <- c(1,  3,   2,  3)
    prob$qobj$j <- c(1,  1,   2,  3)
    prob$qobj$v <- c(2, -1, 0.2,  2)

    # Solve the problem
    r <- mosek(prob, list(soldetail=1))

    # Return the solution
    stopifnot(identical(r$response$code, 0))
    r$sol$itr
  }
  rmosek <- qo1()

  xvar <- Variable(3, nonneg=TRUE)
  Pmat <- matrix(c(1, 0, -.5, 0, .1, 0, -.5, 0, 1), nrow = 3)
  obj <- Minimize(quad_form(xvar, Pmat) - xvar[2])
  constraints <- list(sum_entries(xvar[1:3]) >= 1)
  prob <- Problem(obj, constraints)
  cvxr <- solve(prob, solver="MOSEK")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, rmosek$pobjval, tolerance = 1e-4)
  expect_equal(cvxr$getValue(xvar), matrix(rmosek$xx), tolerance = 1e-4)

})


test_that("test MOSEK simple conic quadratic problem", {
  skip_on_cran()
  skip_if_not(MOSEK_AVAILABLE, "Skipping MOSEK test as it is not available.!")

  # Example from
  # https://docs.mosek.com/9.1/rmosek/tutorial-cqo-shared.html

  cqo1 <- function(){
    # Specify the non-conic part of the problem.
    prob <- list(sense="min")
    prob$c  <- c(0, 0, 0, 1, 1, 1)
    prob$A  <- Matrix(c(1, 1, 2, 0, 0, 0), nrow=1, sparse=TRUE)
    prob$bc <- rbind(blc=1,
                     buc=1)
    prob$bx <- rbind(blx=c(rep(0,3), rep(-Inf,3)),
                     bux=rep(Inf,6))

    # Specify the cones.
    NUMCONES <- 2
    prob$cones <- matrix(list(), nrow=2, ncol=NUMCONES)
    rownames(prob$cones) <- c("type","sub")

    prob$cones[,1] <- list("QUAD", c(4, 1, 2))
    prob$cones[,2] <- list("RQUAD", c(5, 6, 3))

    # Solve the problem
    r <- mosek(prob, list(soldetail=1))

    # Return the solution
    stopifnot(identical(r$response$code, 0))
    r$sol
  }
  rmosek <- cqo1()

  xpos <- Variable(3, nonneg=TRUE)
  xother <- Variable(3)
  xvar <- rbind(xpos, xother)
  cvar <- Matrix(c(0, 0, 0, 1, 1, 1))
  obj <- Minimize(t(xvar) %*% cvar)
  # To deal with rotated cone constraint, reference
  # https://github.com/cvxgrp/cvxpy/issues/737
  constraints <- list( xvar[1] + xvar[2] + 2*xvar[3] == 1,
                       CVXR:::SOC(xvar[4],xvar[1:2]),
                       CVXR:::PSDConstraint(rbind(cbind(2*xvar[5], xvar[3]), cbind(xvar[3], xvar[6])))
                       )
  prob <- Problem(obj, constraints)
  cvxr <- solve(prob, solver = "MOSEK")

  expect_equal(cvxr$status, "optimal")
  expect_equal(cvxr$value, rmosek$itr$pobjval, tolerance = 1e-4)
  # Answers are slightly different but objective value is same and constraints satisfied
  #expect_equal(cvxr$getValue(xvar), matrix(rmosek$itr$xx), tolerance = 1e-2)
})

context("test-benchmarks")

if(!require(microbenchmark))
  install.packages("microbenchmark")

perform <- CVXR:::perform
ConeMatrixStuffing <- CVXR:::ConeMatrixStuffing

test_that("test diffcp SDP example", {
  randn_symm <- function(n) {
    A <- matrix(rnorm(n*n), nrow = n, ncol = n)
    return((A + t(A))/2)
  }

  randn_psd <- function(n) {
    A <- 1.0 / (10 * matrix(rnorm(n*n), nrow = n, ncol = n))
    return(A %*% t(A))
  }

  n <- 100
  p <- 100
  C <- randn_psd(n)
  As <- lapply(1:p, function(i) { randn_symm(n) })
  Bs <- matrix(rnorm(p), nrow = p)

  diffcp_sdp <- function() {
    X <- Variable(n, n, PSD = TRUE)
    objective <- matrix_trace(C %*% X)
    constraints <- lapply(1:p, function(i) { As[[i]] %*% X == Bs[i] })
    problem <- Problem(Minimize(objective), constraints)
    get_problem_data(problem, "SCS")
  }
  microbenchmark(diffcp_sdp(), times = 1L)
})

test_that("test TV inpainting", {
    ## 512 is too big!
    ## rows <- 512
    ## cols <- 512
    ##
    rows <- 64
    cols <- 64
    colors <- 3

  Uorig <- array(rnorm(rows*cols*colors), dim = c(rows, cols, colors))
  known <- array(0, dim = c(rows, cols, colors))
  for(i in seq_len(rows)) {
    for(j in seq_len(cols)) {
      if(runif(1) > 0.7) {
        for(k in seq_len(colors))
          known[i,j,k] <- 1
      }
    }
  }

  tv_inpainting <- function() {
    Ucorr <- known*Uorig
    variables <- list()
    constraints <- list()

    for(i in seq_len(colors)) {
      U <- Variable(rows, cols)
      variables <- c(variables, U)
      constraints <- c(constraints, known[,,i] * U == known[,,i] * Ucorr[,,i])
    }
    obj <- do.call(tv, variables)
    prob <- Problem(Minimize(obj), constraints)
    get_problem_data(prob, "SCS")
  }
  microbenchmark(tv_inpainting(), times = 3L)
})

test_that("test least squares", {
  m <- 20
  n <- 15
  A <- matrix(rnorm(m*n), nrow = m, ncol = n)
  b <- matrix(rnorm(m), nrow = m)

  least_squares <- function() {
    x <- Variable(n)
    cost <- sum_squares(A %*% x - b)
    get_problem_data(Problem(Minimize(cost)), "OSQP")
  }
  microbenchmark(least_squares(), times = 1L)
})

test_that("test qp", {
  m <- 15
  n <- 10
  p <- 5
  P <- matrix(rnorm(n*n), nrow = n, ncol = n)
  P <- t(P) %*% P
  q <- matrix(rnorm(n), nrow = n)
  G <- matrix(rnorm(m*n), nrow = m, ncol = n)
  h <- G %*% matrix(rnorm(n), nrow = n)
  A <- matrix(rnorm(p*n), nrow = p, ncol = n)
  b <- matrix(rnorm(p), nrow = p)

  qp <- function() {
    x <- Variable(n)
    get_problem_data(Problem(Minimize((1/2)*quad_form(x, P) + t(q) %*% x),
                             list(G %*% x <= h, A %*% x == b)), "OSQP")
  }
  microbenchmark(qp(), times = 1L)
})

test_that("test stuffing perf with many constraints", {
  m <- 2000
  n <- 2000
  A <- matrix(rnorm(m*n), nrow = m, ncol = n)
  C <- matrix(runif(floor(m/2)), nrow = floor(m/2))
  b <- matrix(rnorm(m), nrow = m)

  x <- Variable(n)
  cost <- sum(A %*% x)

  constraints <- lapply(1:floor(m/2), function(i) { C[i] * x[i] <= b[i] })
  constraints <- c(constraints, lapply(1:floor(m/2), function(i) { C[i] * x[floor(m/2) + i] == b[floor(m/2) + i] }))

  p <- Problem(Minimize(cost), constraints)

  stuff <- function(mat) {
    perform(ConeMatrixStuffing(), mat)
  }

  microbenchmark(stuff(p), times = 1L)
})

context("test-g01-quadratic")

test_that("test elementwise power", {
  x <- Variable(3)
  y <- Variable(3)
  expect_false(is_constant(x))
  expect_true(is_affine(x))
  expect_true(is_quadratic(x))

  expect_warning(s <- power(t(x) %*% y, 0))
  expect_true(is_constant(s))
  expect_true(is_affine(s))
  expect_true(is_quadratic(s))

  t <- power(x-y, 1)
  expect_false(is_constant(t))
  expect_true(is_affine(t))
  expect_true(is_quadratic(t))

  u <- power(x+2*y, 2)
  expect_false(is_constant(u))
  expect_false(is_affine(u))
  expect_true(is_quadratic(u))
  expect_true(is_dcp(u))

  w <- (x+2*y)^2
  expect_false(is_constant(w))
  expect_false(is_affine(w))
  expect_true(is_quadratic(w))
  expect_true(is_dcp(w))
})

test_that("test matrix multiplication", {
  x <- Variable(3, 5)
  y <- Variable(3, 5)
  expect_false(is_constant(x))
  expect_true(is_affine(x))
  expect_true(is_quadratic(x))

  expect_warning(s <- t(x) %*% y)
  expect_false(is_constant(s))
  expect_false(is_affine(s))
  expect_true(is_quadratic(s))
  expect_false(is_dcp(s))
})

test_that("test quad_over_lin function", {
  x <- Variable(3, 5)
  y <- Variable(3, 5)
  z <- Variable()
  s <- quad_over_lin(x-y, z)
  expect_false(is_constant(s))
  expect_false(is_affine(s))
  expect_false(is_quadratic(s))
  expect_true(is_dcp(s))

  t <- quad_over_lin(x+2*y, 5)
  expect_false(is_constant(t))
  expect_false(is_affine(t))
  expect_true(is_quadratic(t))
  expect_true(is_dcp(t))
})

test_that("test matrix_frac function", {
  x <- Variable(5)
  M <- diag(5)
  P <- t(M) %*% M
  s <- matrix_frac(x, P)
  expect_false(is_constant(s))
  expect_false(is_affine(s))
  expect_true(is_quadratic(s))
  expect_true(is_dcp(s))
})

test_that("test quadratic form", {
  x <- Variable(5)
  P <- diag(5) - 2*matrix(1, nrow = 5, ncol = 5)
  q <- matrix(1, nrow = 5, ncol = 1)

  expect_warning(s <- t(x) %*% P %*% x + t(q) %*% x)
  expect_false(is_constant(s))
  expect_false(is_affine(s))
  expect_true(is_quadratic(s))
  expect_false(is_dcp(s))
})

test_that("test sum_squares function", {
  X <- Variable(5, 4)
  P <- matrix(1, nrow = 3, ncol = 5)
  Q <- matrix(1, nrow = 4, ncol = 7)
  M <- matrix(1, nrow = 3, ncol = 7)

  y <- P %*% X %*% Q + M
  expect_false(is_constant(y))
  expect_true(is_affine(y))
  expect_true(is_quadratic(y))
  expect_true(is_dcp(y))

  s <- sum_squares(y)
  expect_false(is_constant(s))
  expect_false(is_affine(s))
  expect_true(is_quadratic(s))
  expect_true(is_dcp(s))

  # Frobenius norm squared is indeed quadratic
  # but can't show quadraticity using recursive rules
  t <- norm(y, "F")^2
  expect_false(is_constant(t))
  expect_false(is_affine(t))
  expect_false(is_quadratic(t))
  expect_true(is_dcp(t))
})

test_that("test indefinite quadratic", {
  x <- Variable()
  y <- Variable()
  z <- Variable()

  s <- y*z
  expect_true(is_quadratic(s))
  expect_false(is_dcp(s))

  t <- (x+y)^2 - s - z*z
  expect_true(is_quadratic(t))
  expect_false(is_dcp(t))
})

test_that("test non-quadratic", {
  x <- Variable()
  y <- Variable()
  z <- Variable()

  s <- max_entries(vstack(x, y, z))^2
  expect_false(is_quadratic(s))

  s <- max_entries(vstack(x^2, power(y, 2), z))
  expect_false(is_quadratic(s))
})

test_that("test affine product", {
  x <- Variable(3, 5)
  y <- Variable(5, 4)

  expect_warning(s <- x %*% y)
  expect_false(is_constant(s))
  expect_false(is_affine(s))
  expect_true(is_quadratic(s))
  expect_false(is_dcp(s))
})

context("test-g01-nonlinear_atoms")
TOL <- 1e-6

x <- Variable(2, name = "x")
y <- Variable(2, name = "y")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

test_that("Test log problem", {
  skip_on_cran()
  # Log in objective
  obj <- Maximize(sum(log(x)))
  constr <- list(x <= as.matrix(c(1, exp(1))))
  p <- Problem(obj, constr)
  result <- solve(p)
  expect_equal(result$value, 1, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1, exp(1))), tolerance = TOL)

  # Log in constraint
  obj <- Minimize(sum(x))
  constr <- list(log(x) >= 0, x <= as.matrix(c(1,1)))
  p <- Problem(obj, constr)
  result <- solve(p)
  expect_equal(result$value, 2, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1, 1)), tolerance = TOL)

  # Index into log
  obj <- Maximize(log(x)[2])
  constr <- list(x <= as.matrix(c(1, exp(1))))
  p <- Problem(obj, constr)
  result <- solve(p)
  expect_equal(result$value, 1, tolerance = TOL)

  # Scalar log
  obj <- Maximize(log(x[2]))
  constr <- list(x <= as.matrix(c(1, exp(1))))
  p <- Problem(obj, constr)
  result <- solve(p)
  expect_equal(result$value, 1, tolerance = TOL)
})

test_that("Test the entr function", {
  skip_on_cran()
  expect_equal(value(entr(0)), 0)
  expect_warning(expect_equal(value(entr(-1)), -Inf))
})

test_that("Test a problem with KL-divergence", {
  skip_on_cran()
  kK <- 50
  kSeed <- 10

  # Generate a random reference distribution
  # set.seed(kSeed)
  npSPriors <- matrix(stats::runif(kK), nrow = kK, ncol = 1)
  npSPriors <- npSPriors/sum(npSPriors)

  # Reference distribution
  p_refProb <- Parameter(kK, 1, nonneg = TRUE)

  # Distribution to be estimated
  v_prob <- Variable(kK, 1)
  objkl <- 0.0
  con <- 0.0
  for(k in 1:kK) {
    # objkl <- objkl + kl_div(v_prob[k,1], p_refProb[k,1])   # TODO: Parameters are unimplemented
    objkl <- objkl + kl_div(v_prob[k,1], npSPriors[k,1])
    con <- con + v_prob[k,1]
  }

  constrs <- list(con == 1)
  klprob <- Problem(Minimize(objkl), constrs)
  value(p_refProb) <- npSPriors

  result <- solve(klprob, solver = "SCS", verbose = TRUE)
  expect_equal(result$getValue(v_prob), npSPriors, tolerance = 1e-3)
  result <- solve(klprob, solver = "ECOS", verbose = TRUE)
  expect_equal(result$getValue(v_prob), npSPriors, tolerance = 1e-3)
})

test_that("Test a problem with entr", {
  skip_on_cran()
  for(n in c(5, 10, 25)) {
    print(n)
    x <- Variable(n)
    obj <- Maximize(sum(entr(x)))
    p <- Problem(obj, list(sum(x) == 1))
    result <- solve(p, solver = "ECOS", verbose = TRUE)
    expect_equal(result$getValue(x), matrix(rep(1.0/n, n)), tolerance = TOL)
    result <- solve(p, solver = "SCS", verbose = TRUE)
    expect_equal(result$getValue(x), matrix(rep(1.0/n, n)), tolerance = 1e-3)
  }
})

test_that("Test a problem with exp", {
  skip_on_cran()
  for(n in c(5, 10, 25)) {
    print(n)
    x <- Variable(n)
    obj <- Minimize(sum(exp(x)))
    p <- Problem(obj, list(sum(x) == 1))
    result <- solve(p, solver = "ECOS", verbose = TRUE)
    expect_equal(result$getValue(x), matrix(rep(1.0/n, n)), tolerance = TOL)
    result <- solve(p, solver = "SCS", verbose = TRUE)
    expect_equal(result$getValue(x), matrix(rep(1.0/n, n)), tolerance = 1e-3)
  }
})

test_that("Test a problem with log", {
  skip_on_cran()
  for(n in c(5, 10, 25)) {
    print(n)
    x <- Variable(n)
    obj <- Maximize(sum(log(x)))
    p <- Problem(obj, list(sum(x) == 1))
    result <- solve(p, solver = "ECOS", verbose = TRUE)
    expect_equal(result$getValue(x), matrix(rep(1.0/n, n)), tolerance = TOL)
    result <- solve(p, solver = "SCS", verbose = TRUE)
    expect_equal(result$getValue(x), matrix(rep(1.0/n, n)), tolerance = 1e-2)
  }
})

context("test-g01-matrices")

a <- Variable(name = "a")
b <- Variable(name = "b")
c <- Variable(name = "c")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

assert_expression <- function(expr, dim) {
  skip_on_cran()
  expect_true(is(expr, "Expression") || is(expr, "Constraint"))
  expect_equal(dim(expr), dim)
}

test_that("Test R vectors", {
  skip_on_cran()
  ## Vector
  v <- 1:2
  assert_expression(x + v, c(2, 1))
  assert_expression(v + x, c(2, 1))
  assert_expression(x - v, c(2, 1))
  assert_expression(v - x, c(2, 1))
  assert_expression(x <= v, c(2, 1))
  assert_expression(v <= x, c(2, 1))
  assert_expression(x == v, c(2, 1))
  assert_expression(v == x, c(2, 1))

  ## Matrix
  Amat <- matrix(1:8, nrow = 4, ncol = 2)
  assert_expression(Amat %*% x, c(4, 1))

  ## PSD inequalities
  Amat <- matrix(1, nrow = 2, ncol = 2)
  assert_expression(Amat %<<% A, c(2, 2))
  assert_expression(Amat %>>% A, c(2, 2))
})

test_that("Test R matrices", {
  skip_on_cran()
  ## Vector
  v <- matrix(1:2, nrow = 2, ncol = 1)
  assert_expression(x + v, c(2, 1))
  assert_expression(v + v + x, c(2, 1))
  assert_expression(x - v, c(2, 1))
  assert_expression(v - v - x, c(2, 1))
  assert_expression(x <= v, c(2, 1))
  assert_expression(v <= x, c(2, 1))
  assert_expression(x == v, c(2, 1))
  assert_expression(v == x, c(2, 1))

  ## Matrix
  Amat <- matrix(1:8, nrow = 4, ncol = 2)
  assert_expression(Amat %*% x, c(4, 1))
  assert_expression((t(Amat) %*% Amat) %*% x, c(2, 1))

  ## PSD inequalities
  Amat <- matrix(rep(1, 4), nrow = 2, ncol = 2)
  assert_expression(Amat %<<% A, c(2, 2))
  assert_expression(Amat %>>% A, c(2, 2))
})

test_that("Test R scalars", {
  skip_on_cran()
  v <- 2.0
  assert_expression(x + v, c(2, 1))
  assert_expression(v + x, c(2, 1))
  assert_expression(v * x, c(2, 1))
  assert_expression(x - v, c(2, 1))
  assert_expression(v - v - x, c(2, 1))
  assert_expression(x <= v, c(2, 1))
  assert_expression(v <= x, c(2, 1))
  assert_expression(x == v, c(2, 1))
  assert_expression(v == x, c(2, 1))

  ## PSD inequalities
  assert_expression(v %<<% A, c(2, 2))
  assert_expression(v %>>% A, c(2, 2))
})

test_that("Test sparseMatrix objects from the Matrix library", {
  skip_on_cran()
    ##require(Matrix)

    ## Constants
    A <- matrix(1:8, nrow = 4, ncol = 2)
    A <- Matrix::Matrix(A, sparse = TRUE)
    A <- Matrix::sparseMatrix(i = 1:2, j = 1:2, x = rep(1, 2))
    Aidx <- Matrix::Matrix(A[1,], sparse = TRUE)
    expect_equal(dim(Aidx), c(2, 1))
    expect_equal(Aidx[1,1], 1)
    expect_equal(Aidx[2,1], 0)

    ## Linear ops
    var <- Variable(4, 2)
    A <- matrix(1:8, nrow = 4, ncol = 2)
    A <- Matrix::Matrix(A, sparse = TRUE)
    B <- cbind(A, A)
    assert_expression(var + A, c(4, 2))
    assert_expression(A + var, c(4, 2))
    assert_expression(B %*% var, c(4, 2))
    assert_expression(var - A, c(4, 2))
    assert_expression(A - A - var, c(4, 2))
})

context("test-g01-solvers")

##NOTE added By BN while making SCS3.0 update.
##Many of the tests of options seem incorrect. They only pass because the default
##options are in effect. Fix this!

TOL <- 1e-6

a <- Variable(name = "a")
b <- Variable(name = "b")
c <- Variable(name = "c")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

SOLVER_MAP_CONIC <- CVXR:::SOLVER_MAP_CONIC
SOLVER_MAP_QP <- CVXR:::SOLVER_MAP_QP
INSTALLED_SOLVERS <- installed_solvers()
CVXOPT_INSTALLED  <- "CVXOPT" %in% INSTALLED_SOLVERS
GLPK_INSTALLED  <- "GLPK"  %in% INSTALLED_SOLVERS
GLPK_MI_INSTALLED  <- "GLPK_MI" %in% INSTALLED_SOLVERS
CPLEX_INSTALLED  <- "CPLEX" %in% INSTALLED_SOLVERS
GUROBI_INSTALLED  <- "GUROBI" %in% INSTALLED_SOLVERS
MOSEK_INSTALLED  <- "MOSEK" %in% INSTALLED_SOLVERS
XPRESS_INSTALLED  <- "XPRESS" %in% INSTALLED_SOLVERS
NAG_INSTALLED  <- "NAG" %in% INSTALLED_SOLVERS

## For CRAN drop CPLEX
##SOLVER_MAP_CONIC$CPLEX  <- NULL
##SOLVER_MAP_QP$CPLEX  <- NULL

test_that("Test that all the ECOS solver options work", {
  skip_on_cran()
  # Test ecos
  # feastol, abstol, reltol, feastol_inacc,
  # abstol_inacc, and reltol_inacc for tolerance values
  # max_iters for the maximum number of iterations,
  EPS <- 1e-4
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  for(i in 1:2) {
    result <- solve(prob, solver = "ECOS", feastol = EPS, abstol = EPS, reltol = EPS,
                    feastol_inacc = EPS, abstol_inacc = EPS, reltol_inacc = EPS,
                    max_iters = 20, verbose = TRUE, warm_start = TRUE)
  }
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)
})

test_that("Test that all the ECOS BB solver options work", {
  skip_on_cran()
  # 'mi_maxiter'
  # maximum number of branch and bound iterations (default: 1000)
  # 'mi_abs_eps'
  # absolute tolerance between upper and lower bounds (default: 1e-6)
  # 'mi_rel_eps'
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == Variable(2, boolean = TRUE)))
  for(i in 1:2) {
    result <- solve(prob, solver = "ECOS_BB", mi_max_iters = 100, mi_abs_eps = 1e-6,
                    mi_rel_eps = 1e-5, verbose = TRUE, warm_start = TRUE)
  }
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)
})

test_that("Test that all the SCS solver options work", {
  skip_on_cran()
  # Test SCS 3.0
  # MAX_ITERS, EPS_REL, EPS_ABS, ALPHA, UNDET_TOL, VERBOSE, and NORMALIZE.
  # If opts is missing, then the algorithm uses default settings.
  # USE_INDIRECT = True
  EPS <- 1e-4
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  for(i in 1:2) {
    result <- solve(prob, solver = "SCS", num_iter = 50, eps_rel = EPS, eps_tol = EPS, alpha = 1.2,
                    verbose = TRUE, normalize = TRUE)
  }
  expect_equal(result$value, 1.0, tolerance = 1e-2)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = 1e-2)
})

test_that("Test that all the CVXOPT solver options work", {
    skip_on_cran()
    skip_if_not(CVXOPT_INSTALLED)
    prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
    EPS <- 1e-7
    for(i in 1:2) {
      result <- solve(prob, solver = "CVXOPT", feastol = EPS, abstol = EPS, reltol = EPS,
                      max_iters = 20, verbose = TRUE, kktsolver = "chol", refinement = 2, warm_start = TRUE)
    }
    expect_equal(result$value, 1.0, tolerance = TOL)
    expect_equal(result$getValue(x), matrix(c(0, 0)), tolerance = TOL)
})

test_that("Test a basic LP with GLPK", {
  skip_on_cran()
  # Either the problem is solved or GLPK is not installed.
  skip_if_not(GLPK_INSTALLED)
  prob <- Problem(Minimize(p_norm(x, 1) + 1.0), list(x == 0))
  result <- solve(prob, solver = "GLPK")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(0, 0)), tolerance = TOL)

  ## Example from
  ## http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3,
                      x[1] + 2*x[2] <= 3,
                      x[1] >= 0,
                      x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GLPK")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1, 1)), tolerance = TOL)
})

test_that("Test a basic MILP with GLPK", {
  skip_on_cran()
  # Either the problem is solved or GLPK is not installed.
  skip_if_not(GLPK_MI_INSTALLED)
  bool_var <- Variable(boolean = TRUE)
  int_var <- Variable(integer = TRUE)
  prob <- Problem(Minimize(p_norm(x, 1) + 1.0), list(x == bool_var, bool_var == 0))
  result <- solve(prob, solver = "GLPK_MI", verbose = TRUE)
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 0, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(0, 0)), tolerance = TOL)

  ## Example from
  ## http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= int_var,
                      x[1] + 2*x[2] <= 3*bool_var,
                      x[1] >= 0,
                      x[2] >= 0,
                      int_var == 3*bool_var,
                      int_var == 3)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GLPK_MI", verbose = TRUE)
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(int_var), 3, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 1, tolerance = TOL)
  expect_equal(result$getValue(x), matrix(c(1, 1)), tolerance = TOL)
})

test_that("Test a basic LP with CPLEX", {
  skip_on_cran()
  skip_if_not(CPLEX_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  ## Example from
  ## http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  ## CPLEX's default lower bound for a decision variable is zero
  ## This quick test ensures that the cvxpy interface for CPLEX does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)

  ## Boolean and integer version.
  bool_var <- Variable(boolean = TRUE)
  int_var <- Variable(integer = TRUE)
  prob <- Problem(Minimize(p_norm(x,1)), list(x == bool_var, bool_var == 0))
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  ## Example from
  ## http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= int_var, x[1] + 2*x[2] <= 3*bool_var, x[1] >= 0, x[2] >= 0, int_var == 3*bool_var, int_var == 3)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(int_var), 3, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 1, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1,1)), tolerance = TOL)
})

test_that("Test a basic SOCP with CPLEX", {
  skip_on_cran()
  skip_if_not(CPLEX_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,2) + 1.0), list(x == 0))
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, (x[1] + 2*x[2])^2 <= 9, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  # CPLEX's default lower bound for a decision variable is zero
  # This quick test ensures that the CVXR interface for CPLEX does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)

  # Boolean and integer version.
  bool_var <- Variable(boolean = TRUE)
  int_var <- Variable(integer = TRUE)
  prob <- Problem(Minimize(p_norm(x,2)), list(x == bool_var, bool_var == 0))
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= int_var, (x[1] + 2*x[2])^2 <= 9*bool_var, x[1] >= 0, x[2] >= 0, int_var == 3*bool_var, int_var == 3)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(int_var), 3, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 1, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1,1)), tolerance = TOL)
})

test_that("Make sure CPLEX's dual result matches other solvers", {
  skip_on_cran()
  skip_if_not(CPLEX_INSTALLED)
  constraints <- list(x == 0)
  prob <- Problem(Minimize(p_norm(x,1)))
  result <- solve(prob, solver = "CPLEX")
  duals_gurobi <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_gurobi[[i]], duals_ecos[[i]], tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX")
  duals_gurobi <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
      expect_equal(duals_gurobi[[i]], duals_ecos[[i]], tolerance = TOL)
})

test_that("Test CPLEX warm start", {
  ## Make sure that warm starting CPLEX behaves as expected.
  ## Note: This only checks output, not whether or not CPLEX is warm starting internally.
  skip_on_cran()
  skip_if_not(CPLEX_INSTALLED)
  A <- Parameter(2, 2)
  b <- Parameter(2)
  h <- Parameter(2)
  c <- Parameter(2)

  value(A) <- rbind(c(1,0), c(0,0))
  value(b) <- c(1,0)
  value(h) <- c(2,2)
  value(c) <- c(1,1)

  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX", warm_start = TRUE)
  expect_equal(result$value, 3)
  expect_equal(result$getValue(x), matrix(c(1, 2)), tolerance = TOL)

  # Change A and b from the original values.
  value(A) <- rbind(c(0,0), c(0,1))   # <----- Changed.
  value(b) <- c(0,1)   # <----- Changed.
  value(h) <- c(2,2)
  value(c) <- c(1,1)

  # Without setting update_eq_constrs = FALSE, the results should change to the correct answer.
  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX", warm_start = TRUE)
  expect_equal(result$value, 3)
  expect_equal(result$getValue(x), matrix(c(2, 1)), tolerance = TOL)

  # Change h from the original values.
  value(A) <- rbind(c(1,0), c(0,0))
  value(b) <- c(1,0)
  value(h) <- c(1,1)   # <----- Changed.
  value(c) <- c(1,1)

  # Without setting update_eq_constrs = FALSE, the results should change to the correct answer.
  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX", warm_start = TRUE)
  expect_equal(result$value, 2)
  expect_equal(result$getValue(x), matrix(c(1, 1)), tolerance = TOL)

  # Change c from the original values.
  value(A) <- rbind(c(1,0), c(0,0))
  value(b) <- c(1,0)
  value(h) <- c(2,2)
  value(c) <- c(2,1)   # <----- Changed.

  # Without setting update_eq_constrs = FALSE, the results should change to the correct answer.
  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CPLEX", warm_start = TRUE)
  expect_equal(result$value, 4)
  expect_equal(result$getValue(x), matrix(c(1, 2)), tolerance = TOL)
})

## We need a unified interface for solver parameters before doing these checks
## So commenting them out for now

## test_that("Test CPLEX parameters", {
## skip_if_not(CPLEX_INSTALLED)
##   n <- 10
##   m <- 4
##   A <- matrix(rnorm(m*n), nrow = m, ncol = n)
##   x <- matrix(rnorm(n), nrow = n, ncol = 1)
##   y <- A %*% x

##   # Solve a simple basis pursuit problem for testing purposes.
##   z <- Variable(n)
##   objective <- Minimize(norm1(z))
##   constraints <- list(A %*% z == y)
##   problem <- Problem(objective, constraints)
##   ## Until we do a careful check of solver arguments, this check should be commented out
##   ##expect_error(result <- solve(problem, solver = "CPLEX", bogus = "foo"))
##   ##expect_error(result <- solve(problem, solver = "CPLEX", invalid_kwarg = NA))
##   # solve(problem, solver = "CPLEX", advance = 0, simplex.limits.iterations = 1000, timelimit = 1000.0, workdir = "mydir")
## })

test_that("Make sure CVXOPT's dual result matches other solvers", {
  skip_on_cran()
  skip_if_not(CVXOPT_INSTALLED)
  constraints <- list(x == 0)
  prob <- Problem(Minimize(p_norm(x,1)))
  result <- solve(prob, solver = "CVXOPT")
  duals_gurobi <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_gurobi[[i]], duals_ecos[[i]], tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "CVXOPT")
  duals_gurobi <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_gurobi[[i]], duals_ecos[[i]], tolerance = TOL)
})

test_that("Test a basic LP with GUROBI", {
  skip_on_cran()
  skip_if_not(GUROBI_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  # GUROBI's default lower bound for a decision variable is zero
  # This quick test ensures that the cvxpy interface for GUROBI does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)

  # Boolean and integer version.
  bool_var <- Variable(boolean = TRUE)
  int_var <- Variable(integer = TRUE)
  prob <- Problem(Minimize(p_norm(x,1)), list(x == bool_var, bool_var == 0))
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= int_var, x[1] + 2*x[2] <= 3*bool_var, x[1] >= 0, x[2] >= 0, int_var == 3*bool_var, int_var == 3)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(int_var), 3, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 1, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1,1)), tolerance = TOL)
})

test_that("Test a basic SOCP with GUROBI", {
  skip_on_cran()
  skip_if_not(GUROBI_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,2) + 1.0), list(x == 0))
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, (x[1] + 2*x[2])^2 <= 9, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  # GUROBI's default lower bound for a decision variable is zero
  # This quick test ensures that the CVXR interface for GUROBI does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)

  # Boolean and integer version.
  bool_var <- Variable(boolean = TRUE)
  int_var <- Variable(integer = TRUE)
  prob <- Problem(Minimize(p_norm(x,2)), list(x == bool_var, bool_var == 0))
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= int_var, (x[1] + 2*x[2])^2 <= 9*bool_var, x[1] >= 0, x[2] >= 0, int_var == 3*bool_var, int_var == 3)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(int_var), 3, tolerance = TOL)
  expect_equal(result$getValue(bool_var), 1, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1,1)), tolerance = TOL)
})

test_that("Make sure GUROBI's dual result matches other solvers", {
  skip_on_cran()
  skip_if_not(GUROBI_INSTALLED)
  constraints <- list(x == 0)
  prob <- Problem(Minimize(p_norm(x,1)))
  result <- solve(prob, solver = "GUROBI")
  duals_gurobi <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_gurobi[[i]], duals_ecos[[i]], tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI")
  duals_gurobi <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_gurobi[[i]], duals_ecos[[i]], tolerance = TOL)
})

test_that("Test a basic LP with MOSEK", {
  skip_on_cran()
  skip_if_not(MOSEK_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  # MOSEK's default lower bound for a decision variable is zero
  # This quick test ensures that the cvxpy interface for MOSEK does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)
})

test_that("Test a basic SOCP with MOSEK", {
  skip_on_cran()
  skip_if_not(MOSEK_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,2) + 1.0), list(x == 0))
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, (x[1] + 2*x[2])^2 <= 9, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)
})

test_that("Make sure MOSEK's dual result matches other solvers", {
  skip_on_cran()
  skip_if_not(MOSEK_INSTALLED)
  constraints <- list(x == 0)
  prob <- Problem(Minimize(p_norm(x,1)))
  result <- solve(prob, solver = "MOSEK")
  duals_mosek <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "MOSEK")
  duals_mosek <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = TOL)
})

test_that("Test a basic SDP with MOSEK", {
  skip_on_cran()
  # TODO: Should work with PSD (>>, <<).
  skip_if_not(MOSEK_INSTALLED)
  # Test optimality gap for equilibration.
  n <- 3
  Art <- matrix(rnorm(n*n), nrow = n, ncol = n)

  t <- Variable()
  d <- Variable(n)
  D <- diag(d)
  constr <- list(Art %*% D %*% t(Art) - diag(n) == Variable(n, n, PSD = TRUE),
                 Variable(n, n, PSD = TRUE) == t*diag(n) - Art %*% D %*% t(Art), d >= 0)
  prob <- Problem(Minimize(t), constr)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$status, "optimal")
})

## We ignore these test of Mosek parameters since the R mosek interface does not check them.

## test_that("Test MOSEK parameters", {
##   skip_if_not(MOSEK_INSTALLED)
##   n <- 1000
##   m <- 400
##   A <- matrix(rnorm(m*n), nrow = m, ncol = n)
##   x <- matrix(rnorm(n), nrow = n, ncol = 1)
##   y <- A %*% x

##   # Solve a simple basis pursuit problem for testing purposes.
##   z <- Variable(n)
##   objective <- Minimize(norm1(z))
##   constraints <- list(A %*% z == y)
##   problem <- Problem(objective, constraints)
##   ## These tests are currently not useful because the Rmosek interface doesn't check them.
##   ## We have to manually check later
##   ##expect_error(result <- solve(problem, solver = "MOSEK", list(dparam = list(BASIS_TOL_X = "1e-8")))
##   ## expect_error(result <- solve(problem, solver = "MOSEK", list(dparam = list(invalid_kwarg = NA))))
##   solve(problem, solver = "MOSEK",
##         list(dparam = list(BASIS_TOL_X = 1e-1), iparam = list(INTPNT_MAX_ITERATIONS = 20)))
## })

test_that("Test GUROBI warm start", {
  skip_on_cran()
  # Make sure that warm starting GUROBI behaves as expected.
  # Note: This only checks output, not whether or not GUROBI is warm starting internally.
  skip_if_not(GUROBI_INSTALLED)
  A <- Parameter(2, 2)
  b <- Parameter(2)
  h <- Parameter(2)
  c <- Parameter(2)

  value(A) <- rbind(c(1,0), c(0,0))
  value(b) <- c(1,0)
  value(h) <- c(2,2)
  value(c) <- c(1,1)

  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI", warm_start = TRUE)
  expect_equal(result$value, 3)
  expect_equal(result$getValue(x), matrix(c(1, 2)), tolerance = TOL)

  # Change A and b from the original values.
  value(A) <- rbind(c(0,0), c(0,1))   # <----- Changed.
  value(b) <- c(0,1)   # <----- Changed.
  value(h) <- c(2,2)
  value(c) <- c(1,1)

  # Without setting update_eq_constrs = FALSE, the results should change to the correct answer.
  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI", warm_start = TRUE)
  expect_equal(result$value, 3)
  expect_equal(result$getValue(x), matrix(c(2, 1)), tolerance = TOL)

  # Change h from the original values.
  value(A) <- rbind(c(1,0), c(0,0))
  value(b) <- c(1,0)
  value(h) <- c(1,1)   # <----- Changed.
  value(c) <- c(1,1)

  # Without setting update_eq_constrs = FALSE, the results should change to the correct answer.
  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI", warm_start = TRUE)
  expect_equal(result$value, 2)
  expect_equal(result$getValue(x), matrix(c(1, 1)), tolerance = TOL)

  # Change c from the original values.
  value(A) <- rbind(c(1,0), c(0,0))
  value(b) <- c(1,0)
  value(h) <- c(2,2)
  value(c) <- c(2,1)   # <----- Changed.

  # Without setting update_eq_constrs = FALSE, the results should change to the correct answer.
  objective <- Maximize(c[1]*x[1] + c[2]*x[2])
  constraints <- list(x[1] <= h[1],
                      x[2] <= h[2],
                      A %*% x == b)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "GUROBI", warm_start = TRUE)
  expect_equal(result$value, 4)
  expect_equal(result$getValue(x), matrix(c(1, 2)), tolerance = TOL)
})

test_that("Test a basic LP with XPRESS", {
  skip_on_cran()
  skip_if_not(XPRESS_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  result <- solve(prob, solver = "XPRESS")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "XPRESS")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  # XPRESS's default lower bound for a decision variable is zero
  # This quick test ensures that the cvxpy interface for XPRESS does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "MOSEK")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)
})

test_that("Test a basic SOCP with XPRESS", {
  skip_if_not(XPRESS_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,2) + 1.0), list(x == 0))
  result <- solve(prob, solver = "XPRESS")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, (x[1] + 2*x[2])^2 <= 9, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "XPRESS")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "XPRESS")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)
})

test_that("Make sure XPRESS's dual result matches other solvers", {
  skip_on_cran()
  skip_if_not(XPRESS_INSTALLED)
  constraints <- list(x == 0)
  prob <- Problem(Minimize(p_norm(x,1)))
  result <- solve(prob, solver = "XPRESS")
  duals_mosek <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "XPRESS")
  duals_mosek <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = TOL)
})

test_that("Test a basic LP with NAG", {
  skip_on_cran()
  skip_if_not(NAG_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,1) + 1.0), list(x == 0))
  result <- solve(prob, solver = "NAG")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "NAG")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  # NAG's default lower bound for a decision variable is zero
  # This quick test ensures that the cvxpy interface for NAG does *not* have that bound
  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "NAG")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)
})

test_that("Test a basic SOCP with NAG", {
  skip_on_cran()
  skip_if_not(NAG_INSTALLED)
  prob <- Problem(Minimize(p_norm(x,2) + 1.0), list(x == 0))
  result <- solve(prob, solver = "NAG")
  expect_equal(result$value, 1.0, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(0, 0)), tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, (x[1] + 2*x[2])^2 <= 9, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "NAG")
  expect_equal(result$value, -9, tolerance = TOL)
  expect_equal(result$getValue(x), as.matrix(c(1, 1)), tolerance = TOL)

  objective <- Minimize(x[1])
  constraints <- list(x[1] >= -100, x[1] <= -10, x[2] == 1)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "NAG")
  expect_equal(result$getValue(x), as.matrix(c(-100, 1)), tolerance = TOL)
})

test_that("Make sure NAG's dual result matches other solvers", {
  skip_on_cran()
  skip_if_not(NAG_INSTALLED)
  constraints <- list(x == 0)
  prob <- Problem(Minimize(p_norm(x,1)))
  result <- solve(prob, solver = "NAG")
  duals_mosek <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = TOL)

  # Example from
  # http://cvxopt.org/userguide/coneprog.html?highlight=solvers.lp#cvxopt.solvers.lp
  objective <- Minimize(-4*x[1] - 5*x[2])
  constraints <- list(2*x[1] + x[2] <= 3, x[1] + 2*x[2] <= 3, x[1] >= 0, x[2] >= 0)
  prob <- Problem(objective, constraints)
  result <- solve(prob, solver = "NAG")
  duals_mosek <- lapply(constraints, function(c) { result$getDualValue(c) })
  result <- solve(prob, solver = "ECOS")
  duals_ecos <- lapply(constraints, function(c) { result$getDualValue(c) })
  for(i in seq_along(constraints))
    expect_equal(duals_mosek[[i]], duals_ecos[[i]], tolerance = TOL)
})

test_that("Test the list of installed solvers", {
  skip_on_cran()
  prob <- Problem(Minimize(p_norm(x, 1) + 1.0), list(x == 0))
  for(solver in names(SOLVER_MAP_CONIC)) {
    if(solver %in% INSTALLED_SOLVERS) {
      print(solver);
      result <- solve(prob, solver = solver, abstol = TOL, reltol = TOL, verbose = TRUE)
      expect_equal(result$value, 1.0, tolerance = TOL)
      expect_equal(result$getValue(x), matrix(c(0, 0)), tolerance = TOL)
    } else
      expect_error(result <- solve(prob, solver = solver), paste("The solver", solver, "is not installed"))
  }

  for(solver in names(SOLVER_MAP_QP)) {
    if(solver %in% INSTALLED_SOLVERS) {
      result <- solve(prob, solver = solver)
      expect_equal(result$getValue(x), matrix(c(0, 0)), tolerance = TOL)
    } else
      expect_error(result <- solve(prob, solver = solver), paste("The solver", solver, "is not installed"))
  }
})

context("test-g01-objectives")

x <- Variable(name = "x")
y <- Variable(3, name = "y")
z <- Variable(name = "z")

test_that("test the Minimize class", {
  expr <- x + z
  obj <- Minimize(expr)
  
  canon <- canonicalize(obj)
  new_obj <- canon[[1]]
  constraints <- canon[[2]]
  
  expect_equal(length(constraints), 0)
  expect_error(canonical_form(Minimize(y)))
})

test_that("test the Maximize class", {
  expr <- x + z
  obj <- Maximize(expr)
  
  canon <- canonicalize(obj)
  new_obj <- canon[[1]]
  constraints <- canon[[2]]
  
  expect_equal(length(constraints), 0)
  expect_error(canonical_form(Maximize(y)))
})

test_that("test is_dcp for Minimize and Maximize", {
  expect_true(is_dcp(Minimize(norm_inf(x))))
  expect_false(is_dcp(Minimize(-norm_inf(x))))
  
  expect_false(is_dcp(Maximize(norm_inf(x))))
  expect_true(is_dcp(Maximize(-norm_inf(x))))
})

test_that("test adding objectives", {
  expr1 <- x^2
  expr2 <- x^-1
  alpha <- 2
  
  # Addition
  expect_true(is_dcp(Minimize(expr1) + Minimize(expr2)))
  expect_true(is_dcp(Maximize(-expr1) + Maximize(-expr2)))
  
  # Test Minimize + Maximize
  expect_error(Minimize(expr1) + Maximize(-expr2))
  expect_true(is_dcp(Minimize(expr1) - Maximize(-expr2)))
  
  # Multiplication (alpha is a positive scalar)
  expect_true(is_dcp(alpha*Minimize(expr1)))
  expect_true(is_dcp(alpha*Maximize(-expr1)))
  expect_true(is_dcp(-alpha*Maximize(-expr1)))
  expect_true(is_dcp(-alpha*Maximize(-expr1)))
})

context("test-g01-semidefinite_vars")
TOL <- 1e-6

X <- Variable(2, 2, PSD = TRUE)
Y <- Variable(2, 2)
Fmat <- rbind(c(1,0), c(0,-1))

test_that("test that results are symmetric", {
  skip_on_cran()
  M <- Variable(3, 3, PSD = TRUE)
  C1 <- rbind(c(0, 0, 1/2), c(0, 0, 0), c(1/2, 0, 1))
  C2 <- rbind(c(0, 0, 0), c(0, 0, 1/2), c(0, 1/2, 1))
  x1 <- Variable(3, 3, PSD = TRUE)
  x2 <- Variable(3, 3, PSD = TRUE)
  constraints <- list(M + C1 == x1)
  constraints <- c(constraints, M + C2 == x2)
  objective <- Minimize(matrix_trace(M))
  prob <- Problem(objective, constraints)
  result <- solve(prob, abstol = TOL, reltol = TOL)
  M_val <- result$getValue(M)
  expect_equal(M_val, t(M_val), tolerance = TOL)
})

test_that("SDP in objective and constraint", {
  skip_on_cran()
  # PSD in objective.
  obj <- Minimize(sum((X - Fmat)^2))
  p <- Problem(obj, list())
  result <- solve(p, reltol = TOL, abstol = TOL)
  expect_equal(result$value, 1, tolerance = TOL)

  Xres <- result$getValue(X)
  expect_equal(Xres[1,1], 1, tolerance = TOL)
  expect_equal(Xres[1,2], 0, tolerance = TOL)
  expect_equal(Xres[2,1], 0, tolerance = TOL)
  expect_equal(Xres[2,2], 0, tolerance = TOL)

  # PSD in constraint.
  # ECHU: note to self, apparently this is a source of redundancy.
  obj <- Minimize(sum((Y - Fmat)^2))
  p <- Problem(obj, list(Y == Variable(2, 2, PSD = TRUE)))
  result <- solve(p, reltol = TOL, abstol = TOL)
  expect_equal(result$value, 1, tolerance = TOL)

  Yres <- result$getValue(Y)
  expect_equal(Yres[1,1], 1, tolerance = TOL)
  expect_equal(Yres[1,2], 0, tolerance = TOL)
  expect_equal(Yres[2,1], 0, tolerance = TOL)
  expect_equal(Yres[2,2], 0, tolerance = TOL)

  # Index into semidef
  obj <- Minimize((X[1,1] - 1)^2 + (X[2,1] - 2)^2 + (X[2,2] - 4)^2)
  p <- Problem(obj, list())
  result <- solve(p, reltol = TOL, abstol = TOL)
  ## print(result$getValue(X))
  expect_equal(result$value, 0, tolerance = TOL)

  Xres <- result$getValue(X)
  ## Update with scs3.0 the tolerances here have to be more lenient
  expect_equal(Xres[1,1], 1, tolerance = 10 * TOL)
  expect_equal(Xres[1,2], 2, tolerance = 10 * TOL)
  expect_equal(Xres[2,1], 2, tolerance = 10 * TOL)
  expect_equal(Xres[2,2], 4, tolerance = 10 * TOL)
})

context("test-g05-gurobi")

GUROBI_AVAILABLE <- "GUROBI" %in% installed_solvers()
if (GUROBI_AVAILABLE) {
    library(gurobi)
    library(Matrix)
}

test_that("test a simple mixed integer program for GUROBI", {
  skip_on_cran()
  skip_if_not(GUROBI_AVAILABLE, "Skipping GUROBI test as it is not available.!")
  # Example from
  # https://www.gurobi.com/documentation/9.0/examples/mip_r.html
  model <- list()
  model$A          <- matrix(c(1,2,3,1,1,0), nrow=2, ncol=3, byrow=T)
  model$obj        <- c(1,1,2)
  model$modelsense <- 'max'
  model$rhs        <- c(4,1)
  model$sense      <- c('<', '>')
  model$vtype      <- 'B'

  params <- list(OutputFlag=0)

  gurobiResult <- gurobi(model, params)

  xvar <- Variable(3, boolean=T)
  obj <- Maximize(xvar[1] + xvar[2] + 2 * xvar[3])
  constraint <- list(xvar[1] + 2*xvar[2] + 3*xvar[3] <= 4,
                     xvar[1] + xvar[2] >= 1)
  prob <- Problem(obj, constraint)
  cvxr <- solve(prob, solver="GUROBI")

  expect_true(cvxr$status == "optimal")
  expect_equal(cvxr$value, gurobiResult$objval, tolerance = 1e-4)
  expect_equal(cvxr$getValue(xvar), matrix(gurobiResult$x), tolerance = 1e-4)

})

test_that("test a simple QP for GUROBI",{
  skip_on_cran()
  skip_if_not(GUROBI_AVAILABLE, "Skipping GUROBI test as it is not available.!")
  # Example from
  # https://www.gurobi.com/documentation/9.0/examples/qp_r.html

  model <- list()

  model$A     <- matrix(c(1,2,3,1,1,0), nrow=2, byrow=T)
  model$Q     <- matrix(c(1,0.5,0,0.5,1,0.5,0,0.5,1), nrow=3, byrow=T)
  model$obj   <- c(2,0,0)
  model$rhs   <- c(4,1)
  model$sense <- c('>', '>')

  result <- gurobi(model)
  gurobiResult <- gurobi(model)

  xvar <- Variable(3, nonneg=T)
  Pmat <- matrix(c(1,0.5,0,0.5,1,0.5,0,0.5,1), nrow=3, byrow=T)
  obj <- Minimize(quad_form(xvar, Pmat) + 2 * xvar[1])
  constraint <- list(xvar[1] + 2*xvar[2] + 3*xvar[3] >= 4,
                     xvar[1] + xvar[2] >= 1)
  prob <- Problem(obj, constraint)
  cvxr <- solve(prob, solver="GUROBI")

  expect_true(cvxr$status == "optimal")
  expect_equal(cvxr$value, gurobiResult$objval, tolerance = 1e-4)
  expect_equal(cvxr$getValue(xvar), matrix(gurobiResult$x), tolerance = 1e-4)

})

# SOC/PSD constraints not supported by GUROBI
# test_that("test a simple QCP for GUROBI",{
#   skip_on_cran()
#   skip_if_not(GUROBI_AVAILABLE, "Skipping GUROBI test as it is not available.!")
#   # Example from
#   # https://www.gurobi.com/documentation/9.0/examples/qcp_r.html
#
#   model <- list()
#
#   model$A          <- matrix(c(1,1,1), nrow=1, byrow=T)
#   model$modelsense <- 'max'
#   model$obj        <- c(1,0,0)
#   model$rhs        <- c(1)
#   model$sense      <- c('=')
#
#   # First quadratic constraint: x^2 + y^2 - z^2 <= 0
#   qc1 <- list()
#   qc1$Qc <- spMatrix(3, 3, c(1, 2, 3), c(1, 2, 3), c(1.0, 1.0, -1.0))
#   qc1$rhs <- 0.0
#
#   # Second quadratic constraint: x^2 - yz <= 0
#   qc2 <- list()
#   qc2$Qc <- spMatrix(3, 3, c(1, 2), c(1, 3), c(1.0, -1.0))
#   qc2$rhs <- 0.0
#
#   model$quadcon <- list(qc1, qc2)
#
#   gurobiResult <- gurobi(model)
#
#   xvar <- Variable(3, nonneg=T)
#   obj <- Maximize(xvar[1])
#   constraint <- list( xvar[1] + xvar[2] + xvar[3] == 1,
#                       CVXR:::SOC(xvar[3], xvar[1:2]),
#                       CVXR:::PSDConstraint(rbind(cbind(xvar[2], xvar[1]), cbind(xvar[1], xvar[3])))
#                       )
#   prob <- Problem(obj, constraint)
#   cvxr <- solve(prob, solver="GUROBI")
# })

# SOC/PSD constraints not supported by GUROBI
# test_that("test a piecewise linear problem for GUROBI", {
#   skip_on_cran()
#   skip_if_not(GUROBI_AVAILABLE, "Skipping GUROBI test as it is not available.!")
#   # Example from
#   # https://www.gurobi.com/documentation/9.0/examples/piecewise_r.html#subsubsection:piecewise.R
#   model <- list()
#
#   model$A     <- matrix(c(1,2,3,1,1,0), nrow=2, byrow=T)
#   model$obj   <- c(0,-1,0)
#   model$ub    <- c(1,1,1)
#   model$rhs   <- c(4,1)
#   model$sense <- c('<', '>')
#
#   # Uniformly spaced points in [0.0, 1.0]
#   u <- seq(from=0, to=1, by=0.01)
#
#   # First piecewise-linear function: f(x) = exp(-x)
#   pwl1     <- list()
#   pwl1$var <- 1
#   pwl1$x   <- u
#   pwl1$y   <- sapply(u, function(x) exp(-x))
#
#   # Second piecewise-linear function: g(z) = 2 z^2 - 4 z
#   pwl2     <- list()
#   pwl2$var <- 3
#   pwl2$x   <- u
#   pwl2$y   <- sapply(u, function(z) 2 * z * z - 4 * z)
#
#   model$pwlobj <- list(pwl1, pwl2)
#
#   gurobiResult <- gurobi(model)
#
#   xvar <- Variable(3)
#   obj <- Minimize(CVXR:::Exp(xvar[1]) - xvar[2] + 2 *square(xvar[3]) - 4 * xvar[3])
#   constraint <- list(xvar[1] + 2 * xvar[2] + 3 * xvar[3] <= 4,
#                      xvar[1] + xvar[2] >= 1,
#                      xvar[1] <= 1,
#                      xvar[2] <= 1,
#                      xvar[3] <= 1)
#
#   prob <- Problem(obj, constraint)
#   cvxr <- solve(prob, solver="GUROBI")
#
# })

# TODO_NARAS_11: This test is pretty time consuming. Move to manual group?
context("test-g01-qp")
TOL <- 1e-6

a <- Variable(name = "a")
b <- Variable(name = "b")
c <- Variable(name = "c")

x <- Variable(2, name = "x")
y <- Variable(3, name = "y")
z <- Variable(2, name = "z")
w <- Variable(5, name = "w")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

slope <- Variable(1, name = "slope")
offset <- Variable(1, name = "offset")
quadratic_coeff <- Variable(1, name = "quadratic_coeff")

Tlen <- 100
position <- Variable(2, Tlen, name = "position")
velocity <- Variable(2, Tlen, name = "velocity")
force <- Variable(2, Tlen - 1, name = "force")

xs <- Variable(80, name = "xs")
xsr <- Variable(200, name = "xsr")
xef <- Variable(80, name = "xef")

# Check for all installed QP solvers
solvers <- installed_solvers()
## On CRAN skip CPLEX, since I believe there are some
## false positive failures. So skip CPLEX
solvers  <-  setdiff(solvers, "CPLEX")

solvers <- solvers[solvers %in% CVXR:::QP_SOLVERS]
## if("MOSEK" %in% installed_solvers())
##   solvers <- c(solvers, "MOSEK")

solve_QP <- function(problem, solver_name) {
  solve(problem, solver = solver_name, verbose = TRUE)
}

test_quad_over_lin <- function(solver) {
  skip_on_cran()
  p <- Problem(Minimize(0.5 * quad_over_lin(abs(x-1), 1)), list(x <= -1))
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), matrix(c(-1, -1)), tolerance = 1e-4)

  for(con in constraints(p))
    expect_equal(result$getDualValue(con), matrix(c(2, 2)), tolerance = 1e-4)
}

test_abs <- function(solver) {
  skip_on_cran()
  u <- Variable(2)
  constr <- list()
  constr <- c(constr, abs(u[2] - u[1]) <= 100)
  prob <- Problem(Minimize(sum_squares(u)), constr)
  print(paste("The problem is QP: ", is_qp(prob), sep = ""))
  expect_true(is_qp(prob))
  result <- solve(prob, solver = solver)
  expect_equal(result$value, 0, tolerance = TOL)
}

test_power <- function(solver) {
  skip_on_cran()
  p <- Problem(Minimize(sum(power(x, 2))), list())
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), matrix(c(0, 0)), tolerance = 1e-4)
}

test_power_matrix <- function(solver) {
  skip_on_cran()
  p <- Problem(Minimize(sum(power(A - 3, 2))), list())
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), matrix(3, nrow = 2, ncol = 2), tolerance = 1e-4)
}

test_square_affine <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(10*2), nrow = 10, ncol = 2)
  b <- matrix(rnorm(10), nrow = 10, ncol = 1)
  p <- Problem(Minimize(sum_squares(A %*% x - b)))
  result <- solve_QP(p, solver)

  x_star <- base::solve(qr(A),b)
  for(var in variables(p))
    expect_equal(result$getValue(var), x_star, tolerance = 0.1)
}

test_quad_form <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(5*5), nrow = 5, ncol = 5)
  z <- matrix(rnorm(5), nrow = 5, ncol = 1)
  P <- t(A) %*% A
  q <- -2*P %*% z
  p <- Problem(Minimize(quad_form(w, P) + t(q) %*% w))
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), z, tolerance = 1e-4)
}

test_affine_problem <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(5*2), nrow = 5, ncol = 2)
  A <- pmax(A, 0)
  b <- matrix(rnorm(5), nrow = 5, ncol = 1)
  b <- pmax(b, 0)
  p <- Problem(Minimize(sum_entries(x)), list(x >= 0, A %*% x <= b))
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), matrix(c(0, 0)), tolerance = 1e-3)
}

test_maximize_problem <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(5*2), nrow = 5, ncol = 2)
  A <- pmax(A, 0)
  b <- matrix(rnorm(5), nrow = 5, ncol = 1)
  b <- pmax(b, 0)
  p <- Problem(Maximize(-sum_entries(x)), list(x >= 0, A %*% x <= b))
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), matrix(c(0, 0)), tolerance = 1e-3)
}

test_norm_2 <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(10*5), nrow = 10, ncol = 5)
  b <- matrix(rnorm(10), nrow = 10)
  p <- Problem(Minimize(p_norm(A %*% w - b, 2)))
  result <- solve_QP(p, solver)

  x_star <- base::solve(qr(A),b)
  for(var in variables(p))
    expect_equal(result$getValue(var), x_star, tolerance = 0.1)
}

test_mat_norm_2 <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(5*3), nrow = 5, ncol = 3)
  B <- matrix(rnorm(5*2), nrow = 5, ncol = 2)
  p <- Problem(Minimize(p_norm(A %*% C - B, 2)))
  result <- solve_QP(p, solver)

  C_star <- base::solve(qr(A),B)
  for(var in variables(p))
    expect_equal(result$getValue(var), C_star, tolerance = 0.1)
}

test_quad_form_coeff <- function(solver) {
  skip_on_cran()
  A <- matrix(rnorm(5*5), nrow = 5, ncol = 5)
  z <- matrix(rnorm(5), nrow = 5, ncol = 1)
  P <- t(A) %*% A
  q <- -2*P %*% z
  p <- Problem(Minimize(quad_form(w, P) + t(q) %*% w))
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), z, tolerance = 1e-4)
}

test_quad_form_bound <- function(solver) {
  skip_on_cran()
  P <- rbind(c(13, 12, -2), c(12, 17, 6), c(-2, 6, 12))
  q <- matrix(c(-22, -14.5, 13))
  r <- 1
  y_star <- matrix(c(1, 0.5, -1))
  p <- Problem(Minimize(0.5*quad_form(y, P) + t(q) %*% y + r),
               list(y >= -1, y <= 1))
  result <- solve_QP(p, solver)
  for(var in variables(p))
    expect_equal(result$getValue(var), y_star, tolerance = 1e-4)
}

test_regression_1 <- function(solver) {
  skip_on_cran()
  # Number of examples to use
  n <- 100

  # Specify the true value of the variable
  true_coeffs <- matrix(c(2, -2, 0.5), ncol = 1)

  # Generate data
  x_data <- 5*rnorm(n)
  x_data_expanded <- sapply(1:3, function(i) { x_data^i })
  y_data <- x_data_expanded %*% true_coeffs + 0.5*runif(n)

  line <- offset + slope*x_data
  residuals <- line - y_data
  fit_error <- sum_squares(residuals)
  p <- Problem(Minimize(fit_error), list())
  result <- solve_QP(p, solver)

  model <- lm(y_data ~ x_data)
  expect_equal(sum((model$residuals)^2), result$value, tolerance = 1e-4)
  expect_equal(as.numeric(model$coefficients[1]), result$getValue(offset), tolerance = 1e-4)
  expect_equal(as.numeric(model$coefficients[2]), result$getValue(slope), tolerance = 1e-4)
}

test_regression_2 <- function(solver) {
  skip_on_cran()
  # Number of examples to use
  n <- 100

  # Specify the true value of the variable
  true_coeffs <- matrix(c(2, -2, 0.5), ncol = 1)

  # Generate data
  x_data <- 5*rnorm(n)
  x_data_expanded <- sapply(1:3, function(i) { x_data^i })
  y_data <- x_data_expanded %*% true_coeffs + 0.5*runif(n)

  quadratic <- offset + slope*x_data + quadratic_coeff*x_data^2
  residuals <- quadratic - y_data
  fit_error <- sum_squares(residuals)
  p <- Problem(Minimize(fit_error), list())
  result <- solve_QP(p, solver)

  x_data_sq <- x_data^2
  model <- lm(y_data ~ x_data + x_data_sq)
  expect_equal(sum((model$residuals)^2), result$value, tolerance = 1e-4)
  expect_equal(as.numeric(model$coefficients[1]), result$getValue(offset), tolerance = 1e-4)
  expect_equal(as.numeric(model$coefficients[2]), result$getValue(slope), tolerance = 1e-4)
  expect_equal(as.numeric(model$coefficients[3]), result$getValue(quadratic_coeff), tolerance = 1e-4)
}

test_control <- function(solver) {
  skip_on_cran()
  # Some constraints on our motion
  # The object should start from the origin, and end at rest
  initial_velocity <- c(-20, 100)
  final_position <- c(100, 100)

  Tlen <- 100  # The number of timesteps
  h <- 0.1  # The time between time intervals
  mass <- 1  # Mass of object
  drag <- 0.1  # Drag on object
  g <- c(0, -9.8)  # Gravity on object

  # Create a problem instance
  constraints = list()

  # Add constraints on our variables
  for(i in 1:(Tlen - 1)) {
    constraints <- c(constraints, position[,i+1] == position[,i] + h*velocity[,i])
    acceleration <- force[,i]/mass + g - drag*velocity[,i]
    constraints <- c(constraints, velocity[,i+1] == velocity[,i] + h*acceleration)
  }

  # Add position constraints
  constraints <- c(constraints, position[,1] == 0)
  constraints <- c(constraints, position[,ncol(position)] == final_position)

  # Add velocity constraints
  constraints <- c(constraints, velocity[,1] == initial_velocity)
  constraints <- c(constraints, velocity[,ncol(velocity)] == 0)

  # Solve the problem
  p <- Problem(Minimize(.01*sum_squares(force)), constraints)
  result <- solve_QP(p, solver)
  expect_equal(178.500, result$value, tolerance = 0.1)
}

test_sparse_system <- function(solver) {
  skip_on_cran()
  library(Matrix)
  m <- 100
  n <- 80

  density <- 0.4
  A <- rsparsematrix(m, n, density)
  b <- rnorm(m)

  p <- Problem(Minimize(sum_squares(A %*% xs - b)), list(xs == 0))
  result <- solve_QP(p, solver)
  expect_equal(sum(b^2), result$value, tolerance = 1e-4)
}

test_smooth_ridge <- function(solver) {
  skip_on_cran()
  n <- 200
  k <- 50
  eta <- 1

  A <- matrix(1, nrow = k, ncol = n)
  b <- rep(1, k)
  obj <- sum_squares(A %*% xsr - b) + eta*sum_squares(diff(xsr))
  p <- Problem(Minimize(obj), list())
  result <- solve_QP(p, solver)
  expect_equal(0, result$value, tolerance = 1e-4)
}

test_huber_small <- function(solver) {
  skip_on_cran()
  # Solve the Huber regression problem
    x <- Variable(3)
  objective <- sum(huber(x))

  # Solve problem with QP
  p <- Problem(Minimize(objective), list(x[3] >= 3))
  result <- solve_QP(p, solver)
  expect_equal(3, result$getValue(x[3]), tolerance = 1e-4)
  expect_equal(5, result$getValue(objective), tolerance = 1e-4)
}

test_huber <- function(solver) {
  skip_on_cran()
  library(Matrix)

  # Generate problem data
  n <- 3
  m <- 5

  set.seed(1)
  A <- rsparsematrix(m, n, density=0.8)
  x_true <- matrix(rnorm(n), ncol = 1)/sqrt(n)
  ind95 <- as.numeric(rnorm(m) < 0.95)
  b <- A %*% x_true + 0.5*rnorm(m)*ind95 + 10*runif(m)*(1 - ind95)

  # Solve the Huber regression problem
  x <- Variable(n)
  objective <- sum(CVXR::huber(A %*% x - b))

  # Solve problem with QP
  p <- Problem(Minimize(objective))
  result <- solve_QP(p, solver)
  expect_equal(result$getValue(objective), 0.14427356210544268, tolerance = 1e-3)
  expect_equal(result$getValue(x), matrix(c(0.19534822, 0.56081768, -0.02134507)), tolerance = 1e-3)
}

test_equivalent_forms_1 <- function(solver) {
  skip_on_cran()
  m <- 100
  n <- 80
  r <- 70

  set.seed(1)
  A <- matrix(rnorm(m*n), nrow = m, ncol = n)
  b <- matrix(rnorm(m), ncol = 1)
  G <- matrix(rnorm(r*n), nrow = r, ncol = n)
  h <- matrix(rnorm(r), ncol = 1)

  obj1 <- 0.1*sum((A %*% xef - b)^2)
  cons <- list(G %*% xef == h)

  p1 <- Problem(Minimize(obj1), cons)
  result <- solve_QP(p1, solver)
  expect_equal(result$value, 62.2204590894, tolerance = 1e-4)
}

test_equivalent_forms_2 <- function(solver) {
  skip_on_cran()
  m <- 100
  n <- 80
  r <- 70

  set.seed(1)
  A <- matrix(rnorm(m*n), nrow = m, ncol = n)
  b <- matrix(rnorm(m), ncol = 1)
  G <- matrix(rnorm(r*n), nrow = r, ncol = n)
  h <- matrix(rnorm(r), ncol = 1)

  # ||Ax-b||^2 = x^T (A^T A) x - 2(A^T b)^T x + ||b||^2
  P <- t(A) %*% A
  q <- -2*t(A) %*% b
  r <- t(b) %*% b

  obj2 <- 0.1*(quad_form(xef, P) + t(q) %*% xef + r)
  cons <- list(G %*% xef == h)

  p2 <- Problem(Minimize(obj2), cons)
  result <- solve_QP(p2, solver)
  expect_equal(result$value, 62.2204590894, tolerance = 1e-4)
}

test_equivalent_forms_3 <- function(solver) {
  skip_on_cran()
  m <- 100
  n <- 80
  r <- 70

  set.seed(1)
  A <- matrix(rnorm(m*n), nrow = m, ncol = n)
  b <- matrix(rnorm(m), ncol = 1)
  G <- matrix(rnorm(r*n), nrow = r, ncol = n)
  h <- matrix(rnorm(r), ncol = 1)

  # ||Ax-b||^2 = x^T (A^T A) x - 2(A^T b)^T x + ||b||^2
  P <- t(A) %*% A
  q <- -2*t(A) %*% b
  r <- t(b) %*% b
  Pinv <- base::solve(P)

  obj3 <- 0.1 * (matrix_frac(xef, Pinv) + t(q) %*% xef + r)
  cons <- list(G %*% xef == h)

  p3 <- Problem(Minimize(obj3), cons)
  result <- solve_QP(p3, solver)
  expect_equal(result$value, 62.2204590894, tolerance = 1e-4)
}

test_that("test all solvers", {
  skip_on_cran()
  for(solver in solvers) {
    test_quad_over_lin(solver)
    test_power(solver)
    test_power_matrix(solver)
    test_square_affine(solver)
    test_quad_form(solver)
    test_affine_problem(solver)
    test_maximize_problem(solver)
    test_abs(solver)

    # Do we need the following functionality?
    # test_norm_2(solver)
    # test_mat_norm_2(solver)

    test_quad_form_coeff(solver)
    test_quad_form_bound(solver)
    test_regression_1(solver)
    test_regression_2(solver)

    # Slow tests:
    test_control(solver)
    test_sparse_system(solver)
    test_smooth_ridge(solver)
    test_huber_small(solver)
    #test_huber(solver)
    test_equivalent_forms_1(solver)
    test_equivalent_forms_2(solver)
    test_equivalent_forms_3(solver)
  }
})

test_that("Test warm start", {
  skip_on_cran()
  m <- 200
  n <- 100

  A <- matrix(rnorm(m*n), nrow = m, ncol = n)
  b <- Parameter(m)

  # Construct the problem.
  x <- Variable(n)

  value(b) <- rnorm(m)
  prob <- Problem(Minimize(sum_squares(A %*% x - b)))
  result <- solve(prob, warm_start=FALSE)
  result2 <- solve(prob, warm_start=TRUE)
  expect_equal(result$value, result2$value)

  value(b) <- rnorm(m)
  prob <- Problem(Minimize(sum_squares(A %*% x - b)))
  result <- solve(prob, warm_start=TRUE)
  result2 <- solve(prob, warm_start=FALSE)
  expect_equal(result$value, result2$value)
})

test_that("Test solve parametric vs. full problem", {
  skip_on_cran()
  x <- Variable()
  a <- 10
  # b_vec <- c(-10, -2., 2., 3., 10.)
  b_vec <- c(-10, -2.)

  for(solver in solvers) {
    # Solve from scratch with no parameters
    x_full <- list()
    obj_full <- c()
    for(b in b_vec) {
      obj <- Minimize(a*x^2 + b*x)
      constraints <- list(0 <= x, x <= 1)
      prob <- Problem(obj, constraints)
      result <- solve(prob, solver=solver)
      x_full <- c(x_full, list(result$getValue(x)))
      obj_full <- c(obj_full, result$value)
    }

    # Solve parametric
    x_param <- list()
    obj_param <- c()
    b <- Parameter()
    constraints <- list(0 <= x, x <= 1)
    for(b_value in b_vec) {
      value(b) <- b_value
      prob <- Problem(Minimize(a*x^2 + b*x), constraints)
      result <- solve(prob, solver=solver)
      x_param <- c(x_param, list(result$getValue(x)))
      obj_param <- c(obj_param, result$value)
    }

    print(x_full)
    print(x_param)
    for(i in seq_along(b_vec)) {
      expect_equal(x_full[[i]], x_param[[i]], tolerance = 1e-3)
      expect_equal(obj_full[i], obj_param[i], tolerance = TOL)
    }
  }
})

test_that("Test issue arising with square plus parameter", {
  skip_on_cran()
  a <- Parameter(value=1)
  b <- Variable()

  obj <- Minimize(b^2 + abs(a))
  prob <- Problem(obj)
  result <- solve(prob)
  expect_equal(result$value, 1.0)
})

context("test-g01-mip_vars")
TOL <- 1e-6

x_bool <- Variable(boolean = TRUE)
y_int <- Variable(integer = TRUE)
A_bool <- Variable(3, 2, boolean = TRUE)
B_int <- Variable(2, 3, integer = TRUE)

test_that("Test that MIP problems are deterministic", {
  skip_on_cran()
  data_recs <- list()
  result_recs <- list()
  for(i in 1:5) {
    obj <- Minimize((y_int - 0.2)^2)
    p <- Problem(obj, list(A_bool == 0, x_bool == B_int))
    data_recs <- c(data_recs, list(get_problem_data(p, "ECOS_BB")))
  }

  # Check that problem data and result is always the same
  for(i in 1:5) {
    for(key in c("c", "A", "b", "G", "h", "bool_vars_idx", "int_vars_idx")) {
      lh_item <- data_recs[[1]][[1]][[key]]
      rh_item <- data_recs[[i]][[1]][[key]]
      if(key %in% c("A", "G")) {
        lh_item <- as.matrix(lh_item)
        rh_item <- as.matrix(rh_item)
      }
      expect_equal(lh_item, rh_item, tolerance = TOL)
    }
  }
})

test_that("Test Boolean problems", {
  skip_on_cran()
  # Bool in objective
  obj <- Minimize((x_bool - 0.2)^2)
  p <- Problem(obj, list())
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0.04, tolerance = TOL)
  expect_equal(result$getValue(x_bool), 0, tolerance = TOL)

  # Bool in constraint
  t <- Variable()
  obj <- Minimize(t)
  p <- Problem(obj, list(x_bool^2 <= t))
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(x_bool), 0, tolerance = 1e-4)

  # Matrix Bool in objective
  C <- cbind(c(0,1,0), c(1,1,1))
  obj <- Minimize(sum_squares(A_bool - C))
  p <- Problem(obj, list())
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(A_bool), C, tolerance = 1e-4)

  # Matrix Bool in constraint
  t <- Variable()
  obj <- Minimize(t)
  p <- Problem(obj, list(sum_squares(A_bool - C) <= t))
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0, tolerance = TOL)
  expect_equal(result$getValue(A_bool), C, tolerance = 1e-4)
})

test_that("Test Integer problems", {
  skip_on_cran()
  # Int in objective
  obj <- Minimize((y_int - 0.2)^2)
  p <- Problem(obj, list())
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0.04, tolerance = TOL)
  expect_equal(result$getValue(y_int), 0, tolerance = TOL)

  # Infeasible integer problem
  obj <- Minimize(0)
  p <- Problem(obj, list(y_int == 0.5))
  result <- solve(p, solver = "ECOS_BB")   # TODO_NARAS_10: Returns solver_error (MOSEK) or freezes (ECOS_BB). DONE by Naras
  ##result <- solve(p, solver = "CBC")
  expect_true(grepl("infeasible", result$status))
})

test_that("Test SOCP problems", {
  skip_on_cran()
  # Int in objective
  t <- Variable()
  obj <- Minimize(t)
  p <- Problem(obj, list((y_int - 0.2)^2 <= t))
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0.04, tolerance = TOL)
  expect_equal(result$getValue(y_int), 0, tolerance = 2 * TOL)
})

test_that("Test Boolean SOCP problems", {
  skip_on_cran()
  # Int in objective
  t <- Variable()
  obj <- Minimize(t)
  p <- Problem(obj, list((x_bool - 0.2)^2 <= t))
  result <- solve(p, solver = "ECOS_BB")
  expect_equal(result$value, 0.04, tolerance = TOL)
  expect_equal(result$getValue(x_bool), 0, tolerance = TOL)
})

context("test-g01-dimensions")

sum_dims <- CVXR:::sum_dims
mul_dims <- CVXR:::mul_dims

test_that("test addition of matching dimensions", {
  expect_equal(sum_dims(list(c(3,4), c(3,4))), c(3,4))
  expect_equal(sum_dims(lapply(1:5, function(i) { c(3,4) })), c(3,4))
})

test_that("test broadcasting of dimensions during addition", {
  # Broadcasting with scalars is permitted.
  expect_equal(sum_dims(list(c(3,4), c(1,1))), c(3,4))
  expect_equal(sum_dims(list(c(1,1), c(3,4))), c(3,4))
  
  # All other types of broadcasting is not permitted.
  expect_error(sum_dims(list(c(4,2), c(4,1))))
  expect_error(sum_dims(list(c(4,1), c(4,2))))
})

test_that("test addition of incompatible dimensions raises an error", {
  expect_error(sum_dims(list(c(4,2), c(4,1))))
})

test_that("test multiplication by scalars raises an error", {
  expect_error(mul_dims(c(1,1), c(5,9)))
  expect_error(mul_dims(c(5,9), c(1,1)))
})

test_that("test multiplication of dimensions", {
  # Test multiplication where at least one of the shapes is >= 2D.
  expect_equal(mul_dims(c(5,9), c(9,2)), c(5,2))
  expect_equal(mul_dims(c(3,5,9), c(3,9,2)), c(3,5,2))
  
  expect_error(mul_dims(c(5,3), c(9,2)))
  expect_error(mul_dims(c(3,5,9), c(4,9,2)))
})

## These tests are problematic on CRAN because they
## actually install RMOSEK and Rcplex on debian and
## they never tell us what IBM cplex is being used.
## So there is no real way to troubleshoot, short of
## installing everything ourselves.

TOL <- 1e-4

x_bool <- Variable(boolean=TRUE)
y_int <- Variable(integer=TRUE)
A_bool <- Variable(3, 2, boolean=TRUE)
B_int <- Variable(2, 3, integer=TRUE)
## Check for all installed QP solvers

MIP_SOLVERS <- c("ECOS_BB", "GUROBI", "MOSEK")

solvers <- intersect(MIP_SOLVERS, installed_solvers())

bool_prob  <- function(solver) {
    test_that("Test Boolean problems", {
        #skip_on_cran()
        ## Bool in objective
        obj <- Minimize((x_bool - 0.2)^2)
        p <- Problem(obj, list())
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0.04, tolerance = TOL)
        expect_equal(result$getValue(x_bool), 0, tolerance = TOL)

                                        # Bool in constraint
        t <- Variable()
        obj <- Minimize(t)
        p <- Problem(obj, list(x_bool^2 <= t))
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0, tolerance = TOL)
        expect_equal(result$getValue(x_bool), 0, tolerance = 1e-4)

                                        # Matrix Bool in objective
        C <- cbind(c(0,1,0), c(1,1,1))
        obj <- Minimize(sum_squares(A_bool - C))
        p <- Problem(obj, list())
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0, tolerance = TOL)
        expect_equal(result$getValue(A_bool), C, tolerance = 1e-4)

                                        # Matrix Bool in constraint
        t <- Variable()
        obj <- Minimize(t)
        p <- Problem(obj, list(sum_squares(A_bool - C) <= t))
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0, tolerance = TOL)
        expect_equal(result$getValue(A_bool), C, tolerance = 1e-4)
    })
}

int_prob  <- function(solver) {
    test_that("Test Integer problems", {
        #skip_on_cran()

        ## Int in objective
        obj <- Minimize((y_int - 0.2)^2)
        p <- Problem(obj, list())
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0.04, tolerance = TOL)
        expect_equal(result$getValue(y_int), 0, tolerance = TOL)

        ## Infeasible Int prblem
        obj <- Minimize(0)
        p <- Problem(obj, list(y_int == 0.5))
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_true(result$status %in% CVXR:::INF_OR_UNB)
    })
}

int_socp  <- function(solver) {
    test_that("Test SOCP problems", {
        #skip_on_cran()

        ## Int in objective
        t  <- Variable()
        obj <- Minimize(t)
        p <- Problem(obj, list(square(y_int - 0.2) <= t))
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0.04, tolerance = TOL)
        expect_equal(result$getValue(y_int), 0, tolerance = TOL)
    })
}

bool_socp  <- function(solver) {
    test_that("Test Bool SOCP problems", {
        #skip_on_cran()

        ## Int in objective
        t  <- Variable()
        obj <- Minimize(t)
        p <- Problem(obj, list(square(x_bool - 0.2) <= t))
        result <- solve(p, solver = solver, verbose = TRUE)
        expect_equal(result$value, 0.04, tolerance = TOL)
        expect_equal(result$getValue(x_bool), 0, tolerance = TOL)
    })
}


test_all_solvers <- function() {
    for (solver in solvers) {
        bool_prob(solver)
        int_prob(solver)
        bool_socp(solver)
        int_socp(solver)
    }
}

test_all_solvers()

context("test-g02-examples")
TOL <- 1e-6

ECOS.dims_to_solver_dict <- CVXR:::ECOS.dims_to_solver_dict

test_that("Find the largest Euclidean ball in the polyhedron", {
    skip_on_cran()
    ## Create the input data
    a1 <- matrix(c(2,1), nrow = 2, ncol = 1)
    a2 <- matrix(c(2,-1), nrow = 2, ncol = 1)
    a3 <- matrix(c(-1,2), nrow = 2, ncol = 1)
    a4 <- matrix(c(-1,-2), nrow = 2, ncol = 1)
    b <- rep(1,4)
    
    ## Create and solve the model
    r <- Variable(name = "r")
    x_c <- Variable(2, name = "x_c")
    obj <- Maximize(r)
    constraints <- list(
        t(a1) %*% x_c + norm(a1,"F")*r <= b[1],
        t(a2) %*% x_c + norm(a2,"F")*r <= b[2],
        t(a3) %*% x_c + norm(a3,"F")*r <= b[3],
        t(a4) %*% x_c + norm(a4,"F")*r <= b[4]
    )
    
    p <- Problem(obj, constraints)
    result <- solve(p)
    expect_equal(result$value, 0.447214, tolerance = TOL)
    expect_equal(result$getValue(r), result$value, tolerance = TOL)
    expect_equal(result$getValue(x_c), matrix(c(0,0)), tolerance = TOL)
})

test_that("Test issue with scalars", {
    skip_on_cran()
    n <- 6
    eps <- 1e-6
    set.seed(10)
    P0 <- matrix(rnorm(n*n), nrow = n, ncol = n)
    eye <- diag(n)
    P0 <- t(P0) %*% P0 + eps*eye
    
    print(P0)
    
    P1 <- matrix(rnorm(n*n), nrow = n, ncol = n)
    P1 <- t(P1) %*% P1
    P2 <- matrix(rnorm(n*n), nrow = n, ncol = n)
    P2 <- t(P2) %*% P2
    P3 <- matrix(rnorm(n*n), nrow = n, ncol = n)
    P3 <- t(P3) %*% P3
    
    q0 <- matrix(rnorm(n), nrow = n)
    q1 <- matrix(rnorm(n), nrow = n)
    q2 <- matrix(rnorm(n), nrow = n)
    q3 <- matrix(rnorm(n), nrow = n)
    
    r0 <- matrix(rnorm(1))
    r1 <- matrix(rnorm(1))
    r2 <- matrix(rnorm(1))
    r3 <- matrix(rnorm(1))
    
    slack <- Variable()
    # Form the problem
    x <- Variable(n)
    objective <- Minimize(0.5*quad_form(x, P0) + t(q0) %*% x + r0 + slack)
    constraints <- list(0.5*quad_form(x, P1) + t(q1) %*% x + r1 <= slack,
                        0.5*quad_form(x, P2) + t(q2) %*% x + r2 <= slack,
                        0.5*quad_form(x, P3) + t(q3) %*% x + r3 <= slack)
    
    # We now find the primal result and compare it to the dual result to check if strong duality holds, i.e., the duality gap is effectively zero
    p <- Problem(objective, constraints)
    result <- solve(p)
    
    # Note that since our data is random, we may need to run this program multiple times to get a feasible primal.
    # When feasible, we can print out the following values.
    print(result$getValue(x))   # Solution
    lam1 <- result$getDualValue(constraints[[1]])
    lam2 <- result$getDualValue(constraints[[2]])
    lam3 <- result$getDualValue(constraints[[3]])
    print(class(lam1))
    
    P_lam <- P0 + lam1*P1 + lam2*P2 + lam3*P3
    q_lam <- q0 + lam1*q1 + lam2*q2 + lam3*q3
    r_lam <- r0 + lam1*r1 + lam2*r2 + lam3*r3
    dual_result <- -0.5*t(q_lam) %*% P_lam %*% q_lam + r_lam
    print(dim(dual_result))
    expect_equal(dim(dual_result), c(1,1))
})

test_that("Test advanced tutorial", {
    ## Solving a problem with different solvers
    skip_on_cran()
    x <- Variable(2)
    obj <- Minimize(x[1] + norm1(x))
    constraints <- list(x >= 2)
    prob <- Problem(obj, constraints)

    ## Solve with ECOS
    result <- solve(prob, solver = "ECOS")
    print(paste("optimal value with ECOS:", result$value))
    expect_equal(result$value, 6, tolerance = TOL)

    ## Solve with ECOS_BB
    result <- solve(prob, solver = "ECOS_BB")
    print(paste("optimal value with ECOS_BB:", result$value))
    expect_equal(result$value, 6, tolerance = TOL)

    ## Solve with CVXOPT
    if("CVXOPT" %in% installed_solvers()) {
        result <- solve(prob, solver = "CVXOPT")
        print(paste("optimal value with CVXOPT:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    ## Solve with SCS
    result <- solve(prob, solver = "SCS")
    print(paste("optimal value with SCS:", result$value))
    expect_equal(result$value, 6, tolerance = 1e-2)

    ## Solve with CPLEX
    if("CPLEX" %in% installed_solvers()) {
        result <- solve(prob, solver = "CPLEX")
        print(paste("optimal value with CPLEX:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    ## Solve with GLPK
    if("GLPK" %in% installed_solvers()) {
        result <- solve(prob, solver = "GLPK")
        print(paste("optimal value with GLPK:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)

        result <- solve(prob, solver = "GLPK_MI")
        print(paste("optimal value with GLPK_MI:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    ## Solve with GUROBI
    if("GUROBI" %in% installed_solvers()) {
        result <- solve(prob, solver = "GUROBI")
        print(paste("optimal value with GUROBI:", result$value))
        expect_equal(result$value, 6, tolerance = TOL)
    }

    print(installed_solvers())
})

test_that("Test log determinant", {
    skip_on_cran()
    x <- t(data.frame(c(0.55, 0.25, -0.2, -0.25, -0.0, 0.4),
                      c(0.0, 0.35, 0.2, -0.1, -0.3, -0.2)))
    n <- nrow(x)
    m <- ncol(x)

    ## Create and solve the model
    A <- Variable(n, n)
    b <- Variable(n)
    obj <- Maximize(log_det(A))
    constraints <- lapply(1:m, function(i) { p_norm(A %*% as.matrix(x[,i]) + b) <= 1 })
    p <- Problem(obj, constraints)
    result <- solve(p)
    expect_equal(result$value, 1.9746, tolerance = 1e-2)
})

test_that("Test portfolio problem", {
    skip_on_cran()
    set.seed(5)
    n <- 100
    m <- 10
    pbar <- matrix(1, nrow = n, ncol = 1) * 0.03 +
        c(matrix(stats::rnorm(n-1), nrow = n-1, ncol = 1), 0) * 0.12

    Fmat <- Matrix::rsparsematrix(m, n, density = 0.01)
    Fmat@x <- rep(1, length(Fmat@x))
    D <- Matrix::sparseMatrix(1:n, 1:n, x = rep(1,n))
    D@x <- stats::rnorm(length(D@x))^2
    Z <- matrix(stats::rnorm(m), nrow = m, ncol = 1)
    Z <- Z %*% t(Z)

    x <- Variable(n)
    y <- Fmat %*% x
    mu <- 1
    ret <- t(pbar) %*% x
    ## DCP attr causes error because not all the curvature
    ## matrices are reduced to constants when an atom is scalar.
    risk <- p_norm(D %*% x)^2 + (Z %*% y)^2
})

test_that("Test examples from CVXR introduction", {
    skip_on_cran()
    m <- 30
    n <- 20
    set.seed(1)
    A <- matrix(stats::rnorm(m*n), nrow = m, ncol = n)
    b <- matrix(stats::rnorm(m), nrow = m, ncol = 1)

    ## Construct the problem
    x <- Variable(n)
    objective <- Minimize(sum_squares(A %*% x - b))
    constraints <- list(0 <= x, x <= 1)
    prob <- Problem(objective, constraints)

    ## The optimal objective is returned by solve(prob)
    result <- solve(prob)
    ## The optimal value for x
    print(result$getValue(x))
    ## The optimal Lagrange multiplier for a constraint is stored in result$getDualValue(constraints[[1]])
    print(result$getDualValue(constraints[[1]]))

###########################################
    ## Create two scalar variables
    x <- Variable()
    y <- Variable()

    ## Create two constraints
    constraints <- list(x + y == 1, x - y >= 1)

    ## Form objective
    obj <- Minimize((x - y)^2)

    ## Form and solve problem
    prob <- Problem(obj, constraints)
    result <- solve(prob)
    cat("status:", result$status)
    cat("\noptimal value:", result$value)
    cat("\noptimal var:", result$getValue(x), ", ", result$getValue(y))

    expect_equal(tolower(result$status), "optimal")
    expect_equal(result$value, 1.0, tolerance = TOL)
    expect_equal(result$getValue(x), 1.0, tolerance = TOL)
    expect_equal(result$getValue(y), 0, tolerance = TOL)

###########################################
    ## Replace the objective
    prob@objective <- Maximize(x + y)
    result <- solve(prob)
    cat("optimal value:", result$value)

    expect_equal(result$value, 1.0, tolerance = TOL)

    ## Replace the constraints (x + y == 1)
    prob@constraints[[1]] <- (x + y <= 3)
    result <- solve(prob)
    cat("optimal value:", result$value)

    expect_equal(result$value, 3.0, tolerance = TOL)

###########################################
    x <- Variable()

    ## An infeasible problem
    prob <- Problem(Minimize(x), list(x >= 1, x <= 0))
    # TODO_NARAS_11: result <- solve(prob)
    result <- solve(prob, solver = "ECOS")
    cat("status:", result$status)
    cat("optimal value:", result$value)

    expect_equal(result$status, "infeasible")
    expect_equal(result$value, Inf)

    ## An unbounded problem
    prob <- Problem(Minimize(x))
    result <- solve(prob)
    cat("status:", result$status)
    cat("optimal value:", result$value)

    expect_equal(tolower(result$status), "unbounded")
    expect_equal(result$value, -Inf)

###########################################
    ## A scalar variable
    a <- Variable()

    ## Column vector variable of length 5
    x <- Variable(5)

    ## Matrix variable with 4 rows and 7 columns
    A <- Variable(4, 7)

###########################################
    m <- 10
    n <- 5
    set.seed(1)
    A <- matrix(stats::rnorm(m*n), nrow = m, ncol = n)
    b <- matrix(stats::rnorm(m), nrow = m, ncol = 1)

    ## Construct the problem
    x <- Variable(n)
    objective <- Minimize(sum((A %*% x - b)^2))
    constraints <- list(0 <= x, x <= 1)
    prob <- Problem(objective, constraints)

    result <- solve(prob)
    cat("Optimal value:", result$value)
    cat("Optimal var:", result$getValue(x))

    expect_equal(result$value, 7.244277, tolerance = TOL)

###########################################
    ## Positive scalar parameter
    m <- Parameter(nonneg = TRUE)

    ## Column vector parameter with unknown sign (by default)
    c <- Parameter(5)

    ## Matrix parameter with negative entries
    G <- Parameter(4, 7, nonpos = TRUE)

    ## Assigns a constant value to G
    value(G) <- -matrix(1, nrow = 4, ncol = 7)

###########################################
    ## Create parameter, then assign value
    rho <- Parameter(nonneg = TRUE)
    value(rho) <- 2

    ## Initialize parameter with a value
    rho <- Parameter(nonneg = TRUE, value = 2)

###########################################
    ## Problem data
    n <- 15
    m <- 10
    set.seed(1)
    A <- matrix(stats::rnorm(n*m), nrow = n, ncol = m)
    b <- matrix(stats::rnorm(n), nrow = n, ncol = 1)
    ## gamma must be positive due to DCP rules
    gamma <- Parameter(nonneg = TRUE)

    ## Construct the problem
    x <- Variable(m)
    error <- sum_squares(A %*% x - b)

    ## Construct a trade-off curve of ||Ax-b||^2 vs. ||x||_1
    sq_penalty <- c()
    l1_penalty <- c()
    x_values <- list()
    gammas <- 10^seq(-4, 6, length.out = 50)
    for(gamma in gammas) {
        obj <- Minimize(error + gamma*p_norm(x,1))
        prob <- Problem(obj)

        result <- solve(prob)
        sq_penalty <- c(sq_penalty, result$getValue(error))
        l1_penalty <- c(l1_penalty, result$getValue(norm1(x)))
        x_values <- c(x_values, result$getValue(x))
    }

###########################################
    X <- Variable(5, 4)
    A <- matrix(1, nrow = 3, ncol = 5)

    ## Use size(expr) to get the dimensions
    cat("dimensions of X:", size(X))
    cat("\ndimensions of sum_entries(X):", size(sum_entries(X)))
    cat("\ndimensions of A %*% X:", size(A %*% X))

    ## ValueError raised for invalid dimensions
    expect_error(A + X)
})

test_that("Test advanced tutorial 2", {
    skip_on_cran()
    x <- Variable()
    prob <- Problem(Minimize(x^2), list(x == 2))

    # Get ECOS arguments.
    tmp <- get_problem_data(prob, "ECOS")

    # Get ECOS_BB arguments.
    tmp <- get_problem_data(prob, "ECOS_BB")

    # Get CVXOPT arguments.
    if("CVXOPT" %in% installed_solvers())
        tmp <- get_problem_data(prob, "CVXOPT")

    # Get SCS arguments.
    tmp <- get_problem_data(prob, "SCS")

    # Get ECOS arguments.
    library(ECOSolveR)
    tmp <- get_problem_data(prob, "ECOS")
    data <- tmp[[1]]
    chain <- tmp[[2]]
    inverse <- tmp[[3]]

    # Call ECOS solver.
    solution <- ECOSolveR::ECOS_csolve(c = data$c, G = data$G, h = data$h, dims = ECOS.dims_to_solver_dict(data$dims), A = data$A, b = data$b)

    # Unpack raw solver output.
    unpack_results(prob, solution, chain, inverse)
})

context("test-g01-grad")
a <- Variable(name = "a")

x <- Variable(2, name = "x")
y <- Variable(2, name = "y")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

test_that("Test gradient for affine_prod", {
  skip_on_cran()
  value(C) <- rbind(c(1,-2), c(3,4), c(-1,-3))
  value(A) <- rbind(c(3,2), c(-5,1))
  expect_warning(expr <- C %*% A)

  expect_equivalent(as.matrix(grad(expr)[[as.character(C@id)]]), rbind(c(3,0,0,2,0,0), c(0,3,0,0,2,0), c(0,0,3,0,0,2),
                                                    c(-5,0,0,1,0,0), c(0,-5,0,0,1,0), c(0,0,-5,0,0,1)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), rbind(c(1,3,-1,0,0,0), c(-2,4,-3,0,0,0), c(0,0,0,1,3,-1),
                                                   c(0,0,0,-2,4,-3)))
})

test_that("Test gradient for p_norm", {
  skip_on_cran()
  value(x) <- c(-1,0)
  expr <- p_norm(x, 1)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(-1,0)))

  value(x) <- c(0,10)
  expr <- p_norm(x, 1)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(0,1)))

  value(x) <- c(-3,4)
  expr <- p_norm(x, 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(-3.0/5,4.0/5)))

  value(x) <- c(-1,2)
  expr <- p_norm(x, 0.5)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))

  value(x) <- c(0,0)
  expr <- p_norm(x, 0.5)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))

  value(x) <- c(0,0)
  expr <- p_norm(x, 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(0,0)))

  value(A) <- rbind(c(2,-2), c(2,2))
  expr <- p_norm(A, 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(0.5,0.5,-0.5,0.5)))

  value(A) <- rbind(c(3,-3), c(4,4))
  expr <- p_norm(A, 2, axis = 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), rbind(c(0.6,0), c(0.8,0), c(0,-0.6), c(0,0.8)))

  value(A) <- rbind(c(3,-4), c(4,3))
  expr <- p_norm(A, 2, axis = 1)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), rbind(c(0.6,0), c(0,0.8), c(-0.8,0), c(0,0.6)))

  value(A) <- rbind(c(3,-4), c(4,3))
  expr <- p_norm(A, 0.5)
  expect_true(is.na(grad(expr)[[as.character(A@id)]]))
})

test_that("Test gradient for log_sum_exp", {
  skip_on_cran()
  value(x) <- c(0,1)
  expr <- log_sum_exp(x)
  e <- exp(1)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(1.0/(1+e), e/(1+e))))

  value(A) <- rbind(c(0,1), c(-1,0))
  expr <- log_sum_exp(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(1.0/(2+e+1.0/e), 1.0/e/(2+e+1.0/e), e/(2+e+1.0/e), 1.0/(2+e+1.0/e))))

  value(A) <- rbind(c(0,1), c(-1,0))
  expr <- log_sum_exp(A, axis = 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), cbind(c(1.0/(1+1.0/e), 1.0/e/(1+1.0/e), 0, 0), c(0, 0, e/(1+e), 1.0/(1+e))))
})

test_that("Test gradient for geo_mean", {
  skip_on_cran()
  value(x) <- c(1,2)
  expr <- geo_mean(x)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(sqrt(2)/2, 1.0/2/sqrt(2))))

  value(x) <- c(0,2)
  expr <- geo_mean(x)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))

  value(x) <- c(1,2)
  expr <- geo_mean(x, c(1,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(1,0)))

  # No exception for single weight
  value(x) <- c(-1,2)
  expr <- geo_mean(x, c(1,0))
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))
})

test_that("Test gradient for lambda_max", {
  skip_on_cran()
  value(A) <- cbind(c(2,0), c(0,1))
  expr <- lambda_max(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(1,0,0,0)))

  value(A) <- cbind(c(1,0), c(0,2))
  expr <- lambda_max(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(0,0,0,1)))

  value(A) <- cbind(c(1,0), c(0,1))
  expr <- lambda_max(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(0,0,0,1)))
})

test_that("Test gradient for matrix_frac", {
  skip_on_cran()
  value(A) <- diag(2)
  value(B) <- diag(2)
  expr <- matrix_frac(A, B)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(2,0,0,2)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(B@id)]]), matrix(c(-1,0,0,-1)))

  value(B) <- matrix(0, nrow = 2, ncol = 2)
  expr <- matrix_frac(A, B)
  expect_true(is.na(grad(expr)[[as.character(A@id)]]))
  expect_true(is.na(grad(expr)[[as.character(B@id)]]))

  value(x) <- c(2,3)
  value(A) <- diag(2)
  expr <- matrix_frac(x, A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(4,6)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(-4,-6,-6,-9)))
})

test_that("Test gradient for norm_nuc", {
  skip_on_cran()
  value(A) <- cbind(c(10,4), c(4,30))
  expr <- norm_nuc(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(1,0,0,1)))
})

test_that("Test gradient for log_det", {
  skip_on_cran()
  value(A) <- 2*diag(rep(1,2))
  expr <- log_det(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), 1.0/2*diag(2))

  mat <- rbind(c(1,2), c(3,5))
  value(A) <- t(mat) %*% mat
  expr <- log_det(A)
  val <- t(base::solve(value(A)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)

  value(A) <- matrix(0, nrow = 2, ncol = 2)
  expr <- log_det(A)
  expect_true(is.na(grad(expr)[[as.character(A@id)]]))

  value(A) <- -rbind(c(1,2), c(3,4))
  expr <- log_det(A)
  expect_true(is.na(grad(expr)[[as.character(A@id)]]))
})

test_that("Test gradient for quad_over_lin", {
  skip_on_cran()
  value(x) <- c(1,2)
  value(a) <- 2
  expr <- quad_over_lin(x, a)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(1,2)))
  expect_equal(grad(expr)[[as.character(a@id)]], -1.25)

  value(a) <- 0
  expr <- quad_over_lin(x, a)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))

  value(A) <- diag(rep(1,2))
  value(a) <- 2
  expr <- quad_over_lin(A, a)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(1,0,0,1)))
  expect_equal(grad(expr)[[as.character(a@id)]], -0.5)

  value(x) <- c(1,2)
  value(a) <- 2
  value(y) <- c(1,2)
  value(a) <- 2
  expr <- quad_over_lin(x, a) + quad_over_lin(y, a)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(1,2)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(y@id)]]), matrix(c(1,2)))
  expect_equal(grad(expr)[[as.character(a@id)]], -2.5)
})

test_that("Test gradient for max_entries", {
  skip_on_cran()
  value(x) <- c(2,1)
  expr <- max_entries(x)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(c(1,0)))

  value(A) <- rbind(c(1,2), c(4,3))
  expr <- max_entries(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(0,1,0,0)))

  value(A) <- rbind(c(1,2), c(4,3))
  expr <- max_entries(A, axis = 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), rbind(c(0,0), c(1,0), c(0,0), c(0,1)))

  value(A) <- rbind(c(1,2), c(4,3))
  expr <- max_entries(A, axis = 1)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), rbind(c(0,0), c(0,1), c(1,0), c(0,0)))
})

test_that("Test sigma_max", {
  skip_on_cran()
  value(A) <- cbind(c(1,0), c(0,2))
  expr <- sigma_max(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(0,0,0,1)))

  value(A) <- cbind(c(1,0), c(0,1))
  expr <- sigma_max(A)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(1,0,0,0)))
})

test_that("Test sum_largest", {
  skip_on_cran()
  value(A) <- cbind(c(4,3), c(2,1))
  expr <- sum_largest(A, 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(1,0,1,0)))

  value(A) <- cbind(c(1,2), c(3,0.5))
  expr <- sum_largest(A, 2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), matrix(c(0,1,1,0)))
})

test_that("Test abs", {
  skip_on_cran()
  value(A) <- cbind(c(1,2), c(-1,0))
  expr <- abs(A)
  val <- diag(c(1,1,-1,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test linearize method", {
  skip_on_cran()
  # Affine
  value(x) <- c(1,2)
  expr <- (2*x - 5)[1]
  lin_expr <- linearize(expr)
  value(x) <- c(55,22)
  expr <- (2*x - 5)[1]
  lin_expr <- linearize(expr)
  expect_equal(value(lin_expr), value(expr))
  value(x) <- c(-1,-5)
  expr <- (2*x - 5)[1]
  lin_expr <- linearize(expr)
  expect_equal(value(lin_expr), value(expr))

  # Convex
  expr <- A^2 + 5
  expect_error(linearize(expr))

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- A^2 + 5
  lin_expr <- linearize(expr)
  manual <- value(expr) + 2*reshape_expr(value(diag(vec(A))) %*% vec(A - value(A)), c(2, 2))
  expect_equivalent(as.matrix(value(lin_expr)), value(expr))

  value(A) <- rbind(c(-5,-5), c(8.2,4.4))
  expr <- A^2 + 5
  lin_expr <- linearize(expr)
  manual <- value(expr) + 2*reshape_expr(value(diag(vec(A))) %*% vec(A - value(A)), c(2, 2))
  expect_true(all(value(lin_expr) <= value(expr)))
  expect_equivalent(as.matrix(value(lin_expr)), value(manual))

  # Concave
  value(x) <- c(1,2)
  expr <- log(x)/2
  lin_expr <- linearize(expr)
  manual <- value(expr) + value(diag(0.5*x^-1)) %*% (x - value(x))
  expect_equivalent(as.matrix(value(lin_expr)), value(expr))

  value(x) <- c(3,4.4)
  expr <- log(x)/2
  lin_expr <- linearize(expr)
  manual <- value(expr) + value(diag(0.5*x^-1)) %*% (x - value(x))
  expect_true(all(value(lin_expr) >= value(expr)))
  expect_equivalent(as.matrix(value(lin_expr)), value(manual))
})

test_that("Test gradient for log", {
  skip_on_cran()
  value(a) <- 2
  expr <- log(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 1.0/2)

  value(a) <- 3
  expr <- log(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 1.0/3)

  value(a) <- -1
  expr <- log(a)
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))

  value(x) <- c(3,4)
  expr <- log(x)
  val <- diag(c(1/3,1/4))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(-1e-9,4)
  expr <- log(x)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- log(A)
  val <- diag(c(1, 1/2, 1/3, 1/4))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test domain for log1p", {
  skip_on_cran()
  value(a) <- 2
  expr <- log1p(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 1.0/3)

  value(a) <- 3
  expr <- log1p(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 1.0/4)

  value(a) <- -1
  expr <- log1p(a)
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))

  value(x) <- c(3,4)
  expr <- log1p(x)
  val <- diag(c(1/4,1/5))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(-1e-9-1,4)
  expr <- log1p(x)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- log1p(A)
  val <- diag(c(1/2, 1/3, 1/4, 1/5))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test domain for entr", {
  skip_on_cran()
  value(a) <- 2
  expr <- entr(a)
  expect_equal(grad(expr)[[as.character(a@id)]], -log(2)-1)

  value(a) <- 3
  expr <- entr(a)
  expect_equal(grad(expr)[[as.character(a@id)]], -(log(3)+1))

  value(a) <- -1
  expr <- entr(a)
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))

  value(x) <- c(3,4)
  expr <- entr(x)
  val <- diag(-(log(c(3,4)) + 1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(-1e-9,4)
  expr <- entr(x)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- entr(A)
  val <- diag(-(log(1:4)+1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test domain for exp", {
  skip_on_cran()
  value(a) <- 2
  expr <- exp(a)
  expect_equal(grad(expr)[[as.character(a@id)]], exp(2))

  value(a) <- 3
  expr <- exp(a)
  expect_equal(grad(expr)[[as.character(a@id)]], exp(3))

  value(a) <- -1
  expr <- exp(a)
  expect_equal(grad(expr)[[as.character(a@id)]], exp(-1))

  value(x) <- c(3,4)
  expr <- exp(x)
  val <- diag(exp(c(3,4)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(-1e-9,4)
  expr <- exp(x)
  val <- diag(exp(c(-1e-9,4)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- exp(A)
  val <- diag(exp(1:4))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test domain for logistic", {
  skip_on_cran()
  value(a) <- 2
  expr <- logistic(a)
  expect_equal(grad(expr)[[as.character(a@id)]], exp(2)/(1+exp(2)))

  value(a) <- 3
  expr <- logistic(a)
  expect_equal(grad(expr)[[as.character(a@id)]], exp(3)/(1+exp(3)))

  value(a) <- -1
  expr <- logistic(a)
  expect_equal(grad(expr)[[as.character(a@id)]], exp(-1)/(1+exp(-1)))

  value(x) <- c(3,4)
  expr <- logistic(x)
  val <- diag(exp(c(3,4))/(1+exp(c(3,4))))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(-1e-9,4)
  expr <- logistic(x)
  val <- diag(exp(c(-1e-9,4))/(1+exp(c(-1e-9,4))))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- logistic(A)
  val <- diag(exp(1:4)/(1+exp(1:4)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test domain for huber", {
  skip_on_cran()
  value(a) <- 2
  expr <- CVXR::huber(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 2)

  value(a) <- 3
  expr <- CVXR::huber(a, M = 2)
  expect_equal(grad(expr)[[as.character(a@id)]], 4)

  value(a) <- -1
  expr <- CVXR::huber(a, M = 2)
  expect_equal(grad(expr)[[as.character(a@id)]], -2)

  value(x) <- c(3,4)
  expr <- CVXR::huber(x)
  val <- diag(c(2,2))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(-1e-9,4)
  expr <- CVXR::huber(x)
  val <- diag(c(0,2))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- CVXR::huber(A, M = 3)
  val <- diag(c(2,4,6,6))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
})

test_that("Test domain for kl_div", {
  skip_on_cran()
  b <- Variable()
  value(a) <- 2
  value(b) <- 4
  expr <- kl_div(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], log(2/4))
  expect_equal(grad(expr)[[as.character(b@id)]], 1-(2/4))

  value(a) <- 3
  value(b) <- 0
  expr <- kl_div(a, b)
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))
  expect_true(is.na(grad(expr)[[as.character(b@id)]]))

  value(a) <- -1
  value(b) <- 2
  expr <- kl_div(a, b)
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))
  expect_true(is.na(grad(expr)[[as.character(b@id)]]))

  y <- Variable(2)
  value(x) <- c(3,4)
  value(y) <- c(5,8)
  expr <- kl_div(x, y)
  val <- diag(log(c(3,4)) - log(c(5,8)))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)
  val <- diag(c(1-3/5,1-4/8))
  expect_equivalent(as.matrix(grad(expr)[[as.character(y@id)]]), val)

  value(x) <- c(-1e-9,4)
  value(y) <- c(1,2)
  expr <- kl_div(x, y)
  expect_true(is.na(grad(expr)[[as.character(x@id)]]))
  expect_true(is.na(grad(expr)[[as.character(y@id)]]))

  value(A) <- cbind(c(1,2), c(3,4))
  value(B) <- cbind(c(5,1), c(3.5,2.3))
  expr <- kl_div(A, B)
  div <- as.numeric(value(A) / value(B))
  val <- diag(log(div))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
  val <- diag(1-div)
  expect_equivalent(as.matrix(grad(expr)[[as.character(B@id)]]), val)
})

test_that("Test domain for max_elemwise", {
  skip_on_cran()
  b <- Variable()
  value(a) <- 2
  value(b) <- 4
  expr <- max_elemwise(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], 0)
  expect_equal(grad(expr)[[as.character(b@id)]], 1)

  value(a) <- 3
  value(b) <- 0
  expr <- max_elemwise(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], 1)
  expect_equal(grad(expr)[[as.character(b@id)]], 0)

  value(a) <- -1
  value(b) <- 2
  expr <- max_elemwise(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], 0)
  expect_equal(grad(expr)[[as.character(b@id)]], 1)

  y <- Variable(2)
  value(x) <- c(3,4)
  value(y) <- c(5,-5)
  expr <- max_elemwise(x, y)
  val <- diag(c(0,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)
  val <- diag(c(1,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(y@id)]]), val)

  value(x) <- c(-1e-9,4)
  value(y) <- c(1,4)
  expr <- max_elemwise(x, y)
  val <- diag(c(0,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)
  val <- diag(c(1,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(y@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  value(B) <- cbind(c(5,1), c(3,2.3))
  expr <- max_elemwise(A, B)
  div <- as.numeric(value(A) / value(B))
  val <- diag(c(0,1,1,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
  val <- diag(c(1,0,0,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(B@id)]]), val)
})

test_that("Test domain for min_elemwise", {
  skip_on_cran()
  b <- Variable()
  value(a) <- 2
  value(b) <- 4
  expr <- min_elemwise(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], 1)
  expect_equal(grad(expr)[[as.character(b@id)]], 0)

  value(a) <- 3
  value(b) <- 0
  expr <- min_elemwise(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], 0)
  expect_equal(grad(expr)[[as.character(b@id)]], 1)

  value(a) <- -1
  value(b) <- 2
  expr <- min_elemwise(a, b)
  expect_equal(grad(expr)[[as.character(a@id)]], 1)
  expect_equal(grad(expr)[[as.character(b@id)]], 0)

  y <- Variable(2)
  value(x) <- c(3,4)
  value(y) <- c(5,-5)
  expr <- min_elemwise(x, y)
  val <- diag(c(1,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)
  val <- diag(c(0,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(y@id)]]), val)

  value(x) <- c(-1e-9,4)
  value(y) <- c(1,4)
  expr <- min_elemwise(x, y)
  val <- diag(c(1,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)
  val <- diag(c(0,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(y@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  value(B) <- cbind(c(5,1), c(3,2.3))
  expr <- min_elemwise(A, B)
  div <- as.numeric(value(A) / value(B))
  val <- diag(c(1,0,1,0))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)
  val <- diag(c(0,1,0,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(B@id)]]), val)
})

test_that("Test domain for power", {
  skip_on_cran()
  value(a) <- 2
  expr <- sqrt(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 0.5/sqrt(2))

  value(a) <- 3
  expr <- sqrt(a)
  expect_equal(grad(expr)[[as.character(a@id)]], 0.5/sqrt(3))

  value(a) <- -1
  expr <- sqrt(a)
  expect_true(is.na(grad(expr)[[as.character(a@id)]]))

  value(x) <- c(3,4)
  expr <- x^3
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), rbind(c(27,0), c(0,48)))

  value(x) <- c(-1e-9,4)
  expr <- x^3
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), rbind(c(0,0), c(0,48)))

  value(A) <- cbind(c(1,-2), c(3,4))
  expr <- A^2
  val <- diag(c(2,-4,6,8))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)

  # Constant
  expr <- a^0
  expect_equal(grad(expr)[[as.character(a@id)]], 0)

  expr <- x^0
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), matrix(0, nrow = 2, ncol = 2))
})

# test_that("Test grad for partial minimization/maximization problems", {
  # for(obj in list(Minimize(a^-1), Maximize(Entr(a)))) {
  #   prob <- Problem(obj, list(x + a >= c(5,8)))
  #
  #   # Optimize over nothing
  #   expr <- partial_optimize(prob, dont_opt_vars = list(x, a))
  #   value(a) <- NA
  #   value(x) <- NA
  #   grad <- grad(expr)
  #   expect_true(is.na(grad[[as.character(a@id)]]))
  #   expect_true(is.na(grad[[as.character(x@id)]]))
  #
  #   # Outside domain
  #   value(a) <- 1.0
  #   value(x) <- c(5,5)
  #   grad <- grad(expr)
  #   expect_true(is.na(grad[[as.character(a@id)]]))
  #   expect_true(is.na(grad[[as.character(x@id)]]))
  #
  #   value(a) <- 1
  #   value(x) <- c(10,10)
  #   grad <- grad(expr)
  #   expect_equal(grad[[as.character(a@id)]], grad(obj@.args[[1]])[[as.character(a@id)]])
  #   expect_equal(as.matrix(grad[[as.character(x@id)]]), rep(0,4))
  #
  #   # Optimize over x
  #   expr <- partial_optimize(prob, opt_vars = list(x))
  #   value(a) <- 1
  #   grad <- grad(expr)
  #   expect_equal(grad[[as.character(a@id)]], grad(obj@.args[[1]])[[as.character(a@id)]] + 0)
  #
  #   # Optimize over a
  #   fix_prob <- Problem(obj, list(x + a >= c(5,8), x == 0))
  #   result <- solve(fix_prob)
  #   dual_val <- fix_prob@constraints[1]@dual_variable@value
  #   expr <- partial_optimize(prob, opt_vars = list(a))
  #   value(x) <- c(0,0)
  #   grad <- grad(expr)
  #   expect_equal(as.matrix(grad[[as.character(x@id)]]), dual_val)
  #
  #   # Optimize over x and a
  #   expr <- partial_optimize(prob, opt_vars = list(x, a))
  #   grad <- grad(expr)
  #   expect_equal(grad, list())
  # }
# })

test_that("Test grad for affine atoms", {
  skip_on_cran()
  value(a) <- 2
  expr <- -a
  expect_equal(grad(expr)[[as.character(a@id)]], -1)

  value(a) <- 2
  expr <- 2*a
  expect_equal(grad(expr)[[as.character(a@id)]], 2)

  value(a) <- 2
  expr <- a/2
  expect_equal(grad(expr)[[as.character(a@id)]], 0.5)

  value(x) <- c(3,4)
  expr <- -x
  val <- -diag(c(1,1))
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- -A
  val <- -diag(rep(1,4))
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)

  value(A) <- cbind(c(1,2), c(3,4))
  expr <- A[1,2]
  val <- matrix(0, nrow = 4, ncol = 1)
  val[3] <- 1
  expect_equivalent(as.matrix(grad(expr)[[as.character(A@id)]]), val)

  z <- Variable(3)
  value(x) <- c(1,2)
  value(z) <- c(1,2,3)
  expr <- vstack(x, z)
  val <- matrix(0, nrow = 2, ncol = 5)
  val[,1:2] <- diag(2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  val <- matrix(0, nrow = 3, ncol = 5)
  val[,3:ncol(val)] <- diag(3)
  expect_equivalent(as.matrix(grad(expr)[[as.character(z@id)]]), val)

  # Cumulative sum
  value(x) <- c(1,2)
  expr <- cumsum_axis(x)
  val <- matrix(1, nrow = 2, ncol = 2)
  val[2,1] <- 0
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)

  value(x) <- c(1,2)
  expr <- cumsum_axis(x, axis = 1)
  val <- diag(2)
  expect_equivalent(as.matrix(grad(expr)[[as.character(x@id)]]), val)
})

context("test-g04-scs")
TOL <- 1e-3

x <- Variable(2, name = "x")
y <- Variable(2, name = "y")

A <- Variable(2, 2, name = "A")
B <- Variable(2, 2, name = "B")
C <- Variable(3, 2, name = "C")

test_that("Test log problem", {
    ## Log in objective
    skip_on_cran()
    obj <- Maximize(sum(log(x)))
    constr <- list(x <= matrix(c(1, exp(1))))
    p <- Problem(obj, constr)
    result <- solve(p, solver = "SCS")
    expect_equal(result$value, 1, tolerance = TOL)
    expect_equal(result$getValue(x), matrix(c(1, exp(1))), tolerance = TOL)

    ## Log in constraint
    obj <- Minimize(sum(x))
    constr <- list(log(x) >= 0, x <= matrix(c(1,1)))
    p <- Problem(obj, constr)
    result <- solve(p, solver = "SCS")
    expect_equal(result$value, 2, tolerance = TOL)
    expect_equal(result$getValue(x), matrix(c(1, 1)), tolerance = TOL)

    ## Index into log
    obj <- Maximize(log(x)[2])
    constr <- list(x <= c(1, exp(1)))
    p <- Problem(obj, constr)
    result <- solve(p, solver = "SCS")
    expect_equal(result$value, 1, tolerance = TOL)
})

test_that("Test sigma_max", {
    skip_on_cran()
    const <- Constant(rbind(c(1,2), c(3,4), c(5,6)))
    constr <- list(C == const)
    prob <- Problem(Minimize(norm(C, "F")), constr)
    result <- solve(prob, solver = "SCS")
    expect_equal(result$value, value(sqrt(sum(const^2))), tolerance = TOL)
    expect_equal(result$getValue(C), value(const), tolerance = TOL)
})

test_that("Test sdp variable", {
    skip_on_cran()
    const <- Constant(rbind(c(1,2,3), c(4,5,6), c(7,8,9)))
    X <- Variable(3, 3, PSD = TRUE)
    prob <- Problem(Minimize(0), list(X == const))
    result <- solve(prob, verbose = TRUE, solver = "SCS")
    expect_equal(tolower(result$status), "infeasible")
})

test_that("Test complex matrices", {
    skip_on_cran()
    # Complex-valued matrix.
    K <- matrix(runif(4), nrow = 2, ncol = 2) + 1i*matrix(runif(4), nrow = , ncol = 2)   # Example matrix.
    n1 <- sum(svd(K)$d)   # Trace norm of K.
    
    # Dual problem.
    X <- Variable(2, 2, complex = TRUE)
    Y <- Variable(2, 2, complex = TRUE)
    # X, Y >= 0 so trace is real.
    objective <- Minimize(Re(0.5*matrix_trace(X) + 0.5*matrix_trace(Y)))
    constraints <- list(bmat(list(list(X, -t(Conj(K))), list(-K, Y))) %>>% 0, X %>>% 0, Y %>>% 0)
    problem <- Problem(objective, constraints)
    
    sol_scs <- solve(problem, solver = "SCS")
    expect_equal(dim(sol_scs$getDualValue(constraints[[1]])), c(4, 4))
    expect_equal(dim(sol_scs$getDualValue(constraints[[2]])), c(2, 2))
    expect_equal(dim(sol_scs$getDualValue(constraints[[3]])), c(2, 2))
    expect_equal(sol_scs$value, n1, tolerance = TOL)
})

test_that("Test a problem with kl_div", {
    skip_on_cran()
    kK <- 50
    set.seed(10)
    
    # Generate a random reference distribution.
    npSPriors <- runif(kK, 0, 1)
    npSPriors <- npSPriors/sum(npSPriors)
    
    # Reference distribution.
    p_refProb <- Parameter(kK, 1, nonneg = TRUE)
    value(p_refProb) <- npSPriors
    
    # Distributio nto be estimated.
    v_prob <- Variable(kK, 1)
    objkl <- 0.0
    for(k in seq_len(kK))
        objkl <- objkl + kl_div(v_prob[k, 1], p_refProb[k, 1])
    
    constrs <- list(do.call("sum", lapply(seq_len(kK), function(k) { v_prob[k, 1] })) == 1)
    klprob <- Problem(Minimize(objkl), constrs)
    result <- solve(klprob, solver = "SCS", verbose = TRUE)
    expect_equal(result$getValue(v_prob), matrix(npSPriors), tolerance = TOL)
})

test_that("Test a problem with entr", {
    skip_on_cran()
    for(n in c(5, 10, 25)) {
        print(n)
        x <- Variable(n)
        obj <- Maximize(sum(entr(x)))
        p <- Problem(obj, list(sum(x) == 1))
        result <- solve(p, solver = "SCS", verbose = TRUE)
        expect_equal(result$getValue(x), matrix(rep(1.0/n, times = n)), tolerance = TOL)
    }
})

test_that("Test a problem with exp", {
    skip_on_cran()
    for(n in c(5, 10, 25)) {
        print(n)
        x <- Variable(n)
        obj <- Minimize(sum(exp(x)))
        p <- Problem(obj, list(sum(x) == 1))
        result <- solve(p, solver = "SCS", verbose = TRUE)
        expect_equal(result$getValue(x), matrix(rep(1.0/n, times = n)), tolerance = TOL)
    }
})

test_that("Test a problem with log", {
    skip_on_cran()
    for(n in c(5, 10, 25)) {
        print(n)
        x <- Variable(n)
        obj <- Maximize(sum(log(x)))
        p <- Problem(obj, list(sum(x) == 1))
        result <- solve(p, solver = "SCS", verbose = TRUE)
        expect_equal(result$getValue(x), matrix(rep(1.0/n, times = n)), tolerance = TOL)
    }
})

test_that("Test warm starting", {
    skip_on_cran()
    x <- Variable(10)
    obj <- Minimize(sum(exp(x)))
    prob <- Problem(obj, list(sum(x) == 1))
    result <- solve(prob, solver = "SCS")
    expect_equal(solve(prob, solver = "SCS")$value, result$value)
    ## expect_false(solve(prob, solver = "SCS", warm_start = TRUE, verbose = TRUE) == result)
})

test_that("Test PSD constraint", {
    skip_on_cran()
    s <- Variable(2, 2)
    obj <- Maximize(min_elemwise(s[1,2], 10))
    const <- list(s %>>% 0, diag(s) == c(1,1))
    prob <- Problem(obj, const)
    r <- solve(prob, solver = "SCS")
    s <- r$getValue(s)
    # TODO_NARAS_13: print(residual(const[[1]]))   TODO: Need to implement the residual function.
    cat("value", r$value)
    cat("s", s)
    eigs <- eigen(s + t(s), only.values = TRUE)$values
    cat("eigs", eigs)
    expect_true(all(eigs >= 0))
})

context("test-g01-quad_form")
TOL <- 1e-6

test_that("Test quadratic form with a singular matrix", {
  skip_on_cran()
  ## Solve a quadratic program
  for(n in c(3,4,5)) {
      for(i in 0:4) {
          ## Construct a random 1-d finite distribution
          v <- exp(stats::rnorm(n))
          v <- v / sum(v)

          ## Construct a random positive definite matrix
          A <- matrix(stats::rnorm(n^2), nrow = n, ncol = n)
          Q <- A %*% t(A)

          ## Project onto the orthogonal complement of v
          ## This turns Q into a singular matrix with a known nullspace
          E <- diag(rep(1,n)) - v %*% t(v) / as.numeric(t(v) %*% v)
          Q <- E %*% (Q %*% t(E))
          Q_rank <- Matrix::rankMatrix(Q)
          observed_rank <- Q_rank[1]
          desired_rank <- n-1
          expect_equal(observed_rank, desired_rank)

          for(action in c("minimize", "maximize")) {
              ## Look for the extremum of the quadratic form under the simplex constraint
              x <- Variable(n)
              if(action == "minimize") {
                  q <- quad_form(x, Q)
                  objective <- Minimize(q)
              } else if(action == "maximize") {
                  q <- quad_form(x, -Q)
                  objective <- Maximize(q)
              }
              constraints <- list(x >= 0, sum(x) == 1)
              p <- Problem(objective, constraints)
              result <- solve(p)

              ## Check that CVXR found the right answer
              xopt <- result$getValue(x)
              yopt <- t(xopt) %*% (Q %*% xopt)
              sapply(yopt, function(y) { expect_equal(y, 0, tolerance = 1e-3) })
              mapply(function(x_elem, v_elem) { expect_equal(x_elem, v_elem, tolerance = 1e-3) }, xopt, v)
          }
      }
  }
})

test_that("Test quadratic form with a sparse matrix", {
  skip_on_cran()
  Q <- Matrix::sparseMatrix(i = 1:2, j = 1:2, x = rep(1, 2))
  x <- Variable(2)
  cost <- quad_form(x, Q)
  prob <- Problem(Minimize(cost), list(x == c(1, 2)))
  result <- solve(prob)
  expect_equal(result$value, 5, tolerance = TOL)

  # Here are our QP factors
  A <- Constant(Matrix::sparseMatrix(i = 1:4, j = 1:4, x = rep(1, 4)))
  c <- matrix(1, nrow = 1, ncol = 4)

  # Here is our optimization variable
  x <- Variable(4)

  # And the QP problem setup
  fun <- quad_form(x, A) - c %*% x
  objective <- Minimize(fun)
  problem <- Problem(objective)

  result <- solve(problem)
  expect_equal(length(result$getValue(fun)), 1)
})

# test_that("Test quadratic form with a parameter", {
#   P <- Parameter(2,2,PSD = TRUE)
#   Q <- diag(2)
#   x <- Variable(2)
#   cost <- quad_form(x, P)
#   value(P) <- Q
#   prob <- Problem(Minimize(cost), list(x == c(1,2)))
#   # result <- solve(prob)
#   # expect_equal(result$value, 5, tolerance = TOL)
# })

test_that("Test when P is constant and not symmetric", {
  skip_on_cran()
  P <- rbind(c(2, 2), c(3, 4))
  x <- Variable(2)
  cost <- quad_form(x, P)
  prob <- Problem(Minimize(cost), list(x == c(1, 2)))
  expect_error(solve(prob), "Problem does not follow DCP rules.")
})

test_that("Test error when P is symmetric but not definite", {
  skip_on_cran()
  P <- rbind(c(1, 0), c(0, -1))
  x <- Variable(2)

  # Forming quadratic form is okay
  cost <- quad_form(x, P)
  # expect_warning(cost <- quad_form(x, P))
  prob <- Problem(Minimize(cost), list(x == c(1, 2)))
  expect_error(solve(prob), "Problem does not follow DCP rules.")
})

test_that("Test case where objective evaluation differs from result", {
  skip_on_cran()
  x <- Variable(2,1)
  A <- matrix(1, nrow = 1, ncol = 1)
  B <- matrix(1, nrow = 2, ncol = 1)
  obj0 <- -t(B) %*% x
  obj1 <- quad_form(t(B) %*% x, A)
  prob <- Problem(Minimize(obj0 + obj1))
  result <- solve(prob)
  expect_equal(result$value, result$getValue(prob@objective@expr))
})

test_that("Test a quadratic form multiplied by zero", {
  skip_on_cran()
  data_norm <- runif(5)
  M <- matrix(runif(5*2), nrow = 5, ncol = 2)
  c <- Variable(ncol(M))
  lopt <- 0
  laplacian_matrix <- matrix(1, nrow = 2, ncol = 2)
  design_matrix <- Constant(M)
  objective <- Minimize(sum_squares(design_matrix %*% c - data_norm) + lopt*quad_form(c, laplacian_matrix))
  constraints <- list((M[1,1] * c) == 1)   # (K*c >= -0.1)
  prob <- Problem(objective, constraints)
  result <- solve(prob)
  expect_equal(result$status, "optimal")
})

context("test-constant_atoms")

ROBUST_CVXOPT <- "robust_cvxopt"
SOLVERS_TO_TRY <- c("ECOS", "SCS", "OSQP")
SOLVERS_TO_TOL <- list(ECOS = 5e-7, SCS = 1e-2, OSQP = 1e-1) ## ECOS = 1e-7 fails one or two tests!

# Test CVXOPT if installed.
if("CVXOPT" %in% installed_solvers()) {
    SOLVERS_TO_TRYS <- c(SOLVERS_TO_TRY, "CVXOPT", ROBUST_CVXOPT)
    SOLVERS_TO_TOL$CVXOPT <- 1e-7
    SOLVERS_TO_TOL[[ROBUST_CVXOPT]] <- 1e-7
}

# Test MOSEK if installed.
if("MOSEK" %in% installed_solvers()) {
    SOLVERS_TO_TRY <- c(SOLVERS_TO_TRY, "MOSEK")
    SOLVERS_TO_TOL$MOSEK <- 1e-6
}

v_np <- matrix(c(-1, 2, -2), nrow = 1, ncol = 3)
log_sum_exp_axis_1 <- function(x) { log_sum_exp(x, axis = 1) }
log_sum_exp_axis_2 <- function(x) { log_sum_exp(x, axis = 2, keepdims = TRUE) }

atoms <- list(
    list(
        list(
            list(abs, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(5,2), c(3,1)))),
            list(function(x) { cumsum_axis(x, axis=1) }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(-5,2), c(-8,3)))),
            list(function(x) { cumsum_axis(x, axis=2) }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(-5,-3), c(-3,-2)))),
            list(function(x) { cummax_axis(x, axis=1) }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(-5,2), c(-3,2)))),
            list(function(x) { cummax_axis(x, axis=2) }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(-5,2), c(-3,1)))),
            list(diag, c(2,1), list(cbind(c(-5,2), c(-3,1))), Constant(c(-5,1))),
            list(diag, c(2,2), list(matrix(c(-5,1))), Constant(cbind(c(-5,0), c(0,1)))),
            list(exp, c(2,2), list(cbind(c(1,0), c(2,-1))), Constant(cbind(c(exp(1),1), c(exp(2), exp(-1))))),
            list(huber, c(2,2), list(cbind(c(0.5,-1.5), c(4,0))), Constant(cbind(c(0.25,2), c(7,0)))),
            list(function(x) { huber(x,2.5) }, c(2,2), list(cbind(c(0.5,-1.5), c(4,0))), Constant(cbind(c(0.25,2.25), c(13.75,0)))),
            list(inv_pos, c(2,2), list(cbind(c(1,2), c(3,4))), Constant(cbind(c(1,1.0/2), c(1.0/3,1.0/4)))),
            list(function(x) { (x + Constant(0))^-1 }, c(2,2), list(cbind(c(1,2), c(3,4))), Constant(cbind(c(1,1.0/2), c(1.0/3,1.0/4)))),
            list(kl_div, c(1,1), list(exp(1), 1), Constant(1)),
            list(kl_div, c(1,1), list(exp(1), exp(1)), Constant(0)),
            list(kl_div, c(2,1), list(matrix(c(exp(1), 1)), 1), Constant(c(1,0))),
            list(function(x) { kronecker(cbind(c(1,2), c(3,4)), x) }, c(4,4), list(cbind(c(5,6), c(7,8))),
                 Constant(kronecker(cbind(c(1,2), c(3,4)), cbind(c(5,6), c(7,8))))),
            list(lambda_max, c(1,1), list(cbind(c(2,0), c(0,1))), Constant(2)),
            list(lambda_max, c(1,1), list(cbind(c(2,0,0), c(0,3,0), c(0,0,1))), Constant(3)),
            list(lambda_max, c(1,1), list(cbind(c(5,7), c(7,-3))), Constant(9.06225775)),
            list(function(x) { lambda_sum_largest(x,2) }, c(1,1), list(cbind(c(1,2,3), c(2,4,5), c(3,5,6))), Constant(11.51572947)),
            list(log_sum_exp, c(1,1), list(cbind(c(5,7), c(0,-3))), Constant(7.1277708268)),
            list(log_sum_exp_axis_1, c(3,1), list(cbind(c(5,7,1), c(0,-3,6))), Constant(c(5.00671535, 7.0000454, 6.0067153))),
            list(log_sum_exp_axis_2, c(1,2), list(cbind(c(5,7,1), c(0,-3,6))), t(Constant(c(7.12910890, 6.00259878)))),
            list(logistic, c(2,2), list(cbind(c(log(5), log(7)), c(0, log(0.3)))), Constant(cbind(c(log(6),log(8)), c(log(2),log(1.3))))),
            list(matrix_frac, c(1,1), list(matrix(1:3), diag(3)), Constant(14)),
            list(matrix_frac, c(1,1), list(matrix(1:3), cbind(c(67,78,90), c(78,94,108), c(90,108,127))), Constant(0.46557377049180271)),
            list(matrix_frac, c(1,1), list(cbind(1:3, 4:6), cbind(c(67,78,90), c(78,94,108), c(90,108,127))), Constant(0.768852459016)),
            list(max_elemwise, c(2,1), list(matrix(c(-5,2)), matrix(c(-3,1)), 0, matrix(c(-1,2))), Constant(c(0,2))),
            list(max_elemwise, c(2,2), list(cbind(c(-5,2), c(-3,1)), 0, cbind(c(5,4), c(-1,2))), Constant(cbind(c(5,4), c(0,2)))),
            list(max_entries, c(1,1), list(cbind(c(-5,2), c(-3,1))), Constant(2)),
            list(max_entries, c(1,1), list(matrix(c(-5,-10))), Constant(-5)),
            list(function(x) { max_entries(x, axis=1) }, c(2,1), list(cbind(c(-5,2), c(-3,1))), Constant(c(-3,2))),
            list(function(x) { max_entries(x, axis=2, keepdims=TRUE) }, c(1,2), list(cbind(c(-5,2), c(-3,1))), t(Constant(c(2,1)))),
            list(function(x) { norm(x,"2") }, c(1,1), list(v_np), Constant(3)),
            list(function(x) { norm(x,"F") }, c(1,1), list(cbind(c(-1,2), c(3,-4))), Constant(5.47722557)),
            list(function(x) { norm1(x) }, c(1,1), list(v_np), Constant(5)),
            list(function(x) { norm1(x) }, c(1,1), list(cbind(c(-1,2), c(3,-4))), Constant(10)),
            list(function(x) { norm_inf(x) }, c(1,1), list(v_np), Constant(2)),
            list(function(x) { norm_inf(x) }, c(1,1), list(cbind(c(-1,2), c(3,-4))), Constant(4)),
            list(function(x) { norm_nuc(x) }, c(1,1), list(cbind(c(2,0), c(0,1))), Constant(3)),
            list(function(x) { norm_nuc(x) }, c(1,1), list(cbind(3:5, 6:8, 9:11)), Constant(23.173260452512931)),
            list(function(x) { norm_nuc(x) }, c(1,1), list(cbind(3:5, 6:8)), Constant(14.618376738088918)),
            list(function(x) { sum_largest(abs(x),3) }, c(1,1), list(matrix(c(1,2,3,-4,-5))), Constant(5+4+3)),
            list(function(x) { mixed_norm(x,1,1) }, c(1,1), list(cbind(c(1,2), c(3,4), c(5,6))), Constant(21)),
            list(function(x) { mixed_norm(x,1,1) }, c(1,1), list(cbind(1:3, 4:6)), Constant(21)),
            list(function(x) { mixed_norm(x,2,1) }, c(1,1), list(cbind(c(3,1), c(4,sqrt(3)))), Constant(7)),
            list(function(x) { mixed_norm(x,1,Inf) }, c(1,1), list(cbind(c(1,4), c(5,6))), Constant(10)),

            list(p_norm, c(1,1), list(matrix(1:3)), Constant(3.7416573867739413)),
            list(function(x) { p_norm(x,1) }, c(1,1), list(matrix(c(1.1,2,-3))), Constant(6.1)),
            list(function(x) { p_norm(x,2) }, c(1,1), list(matrix(c(1.1,2,-3))), Constant(3.7696153649941531)),
            list(function(x) { p_norm(x,2,axis=2) }, c(2,1), list(cbind(c(1,2), c(3,4))), Constant(c(sqrt(5), 5))),
            list(function(x) { p_norm(x,2,axis=1) }, c(2,1), list(cbind(c(1,2), c(4,5))), Constant(c(sqrt(17), sqrt(29)))),
            list(function(x) { p_norm(x,Inf) }, c(1,1), list(matrix(c(1.1,2,-3))), Constant(3)),
            list(function(x) { p_norm(x,3) }, c(1,1), list(matrix(c(1.1,2,-3))), Constant(3.3120161866074733)),
            list(function(x) { p_norm(x,5.6) }, c(1,1), list(matrix(c(1.1,2,-3))), Constant(3.0548953718931089)),
            list(function(x) { p_norm(x,1.2) }, c(1,1), list(cbind(1:3, 4:6)), Constant(15.971021676279573)),

            list(pos, c(1,1), list(8), Constant(8)),
            list(pos, c(2,1), list(matrix(c(-3,2))), Constant(c(0,2))),
            list(neg, c(2,1), list(matrix(c(-3,3))), Constant(c(3,0))),

            list(function(x) { power(x,1) }, c(1,1), list(7.45), Constant(7.45)),
            list(function(x) { power(x,2) }, c(1,1), list(7.45), Constant(55.502500000000005)),
            list(function(x) { power(x,-1) }, c(1,1), list(7.45), Constant(0.1342281879194631)),
            list(function(x) { power(x,-0.7) }, c(1,1), list(7.45), Constant(0.24518314363015764)),
            list(function(x) { power(x,-1.34) }, c(1,1), list(7.45), Constant(0.06781263100321579)),
            list(function(x) { power(x,1.34) }, c(1,1), list(7.45), Constant(14.746515290825071)),

            list(quad_over_lin, c(1,1), list(cbind(c(-1,2,-2), c(-1,2,-2)), 2), Constant(2*4.5)),
            list(quad_over_lin, c(1,1), list(v_np,2), Constant(4.5)),
            list(function(x) { norm(x,"2") }, c(1,1), list(cbind(c(2,0), c(0,1))),  Constant(2)),
            list(function(x) { norm(x,"2") }, c(1,1), list(cbind(3:5, 6:8, 9:11)), Constant(22.368559552680377)),
            list(function(x) { scalene(x,2,3) }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(15,4), c(9,2)))),
            list(function(x) { power(x,2) }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(25,4), c(9,1)))),
            list(sum_entries, c(1,1), list(cbind(c(-5,2), c(-3,1))), Constant(-5)),
            list(function(x) { sum_entries(x,axis=1) }, c(2,1), list(cbind(c(-5,2), c(-3,1))), Constant(c(-8,3))),
            list(function(x) { sum_entries(x,axis=2) }, c(2,1), list(cbind(c(-5,2), c(-3,1))), Constant(c(-3,-2))),
            list(function(x) { (x + Constant(0))^2 }, c(2,2), list(cbind(c(-5,2), c(-3,1))), Constant(cbind(c(25,4), c(9,1)))),
            list(function(x) { sum_largest(x,3) }, c(1,1), list(matrix(1:5)), Constant(5+4+3)),
            list(function(x) { sum_largest(x,3) }, c(1,1), list(cbind(3:5, 6:8, 9:11)), Constant(9+10+11)),
            list(sum_squares, c(1,1), list(cbind(c(-1,2), c(3,-4))), Constant(30)),
            list(matrix_trace, c(1,1), list(cbind(3:5, 6:8, 9:11)), Constant(3+7+11)),
            list(matrix_trace, c(1,1), list(cbind(c(-5,2), c(-3,1))), Constant(-5+1)),
            list(tv, c(1,1), list(matrix(c(1,-1,2))), Constant(5)),
            list(tv, c(1,1), list(t(matrix(c(1,-1,2)))), Constant(5)),
            list(tv, c(1,1), list(cbind(c(-5,2), c(-3,1))), Constant(sqrt(53))),
            list(tv, c(1,1), list(cbind(c(-5,2), c(-3,1)), cbind(c(6,5), c(-4,3)), cbind(c(8,0), c(15,9))),
                 Constant(base::norm(c(7,-1,-8,2,-10,7), "2"))),
            list(tv, c(1,1), list(cbind(3:5, 6:8, 9:11)), Constant(4*sqrt(10))),
            list(upper_tri, c(3,1), list(cbind(3:5, 6:8, 9:11)), Constant(c(6,9,10))),

            ## Advanced indexing
            list(function(x) { x[cbind(c(2,3), c(1,3))] }, c(2,1), list(cbind(3:5, 6:8, 9:11)), Constant(c(4,11))),
            list(function(x) { x[c(2,3),] }, c(2,1), list(cbind(3:5, 6:8)), Constant(cbind(c(4,5), c(7,8)))),
            list(function(x) { x[cbind(3:5, 6:8) %% 2 == 0] }, c(3,1), list(cbind(3:5, 6:8)), Constant(c(4,6,8))),
            list(function(x) { x[seq(3,2,-1)] }, c(2,1), list(matrix(3:5)), Constant(c(5,4))),
            list(function(x) { x[seq(3,1,-1)] }, c(3,1), list(matrix(3:5)), Constant(c(5,4,3)))
        ),
        Minimize),
    list(
        list(
            list(entr, c(2,2), list(cbind(c(1,exp(1)), c(exp(2), exp(-1)))), Constant(cbind(c(0,-exp(1)), c(-2*exp(2),exp(-1))))),
            list(log_det, c(1,1), list(cbind(c(20, 8, 5, 2),
                                             c(8, 16, 2, 4),
                                             c(5, 2, 5, 2),
                                             c(2, 4, 2, 4))), Constant(7.7424020218157814)),
            list(geo_mean, c(1,1), list(matrix(c(4,1))), Constant(2)),
            list(geo_mean, c(1,1), list(matrix(c(0.01,7))), Constant(0.2645751311064591)),
            list(geo_mean, c(1,1), list(matrix(c(63,7))), Constant(21)),
            list(geo_mean, c(1,1), list(matrix(c(1,10))), Constant(sqrt(10))),
            list(function(x) { geo_mean(x, c(1,1)) }, c(1,1), list(matrix(c(1,10))), Constant(sqrt(10))),
            list(function(x) { geo_mean(x, c(0.4,0.8,4.9)) }, c(1,1), list(matrix(c(0.5,1.8,17))), Constant(10.04921378316062)),
            list(harmonic_mean, c(1,1), list(matrix(c(1,2,3))), Constant(1.6363636363636365)),
            list(harmonic_mean, c(1,1), list(matrix(c(2.5,2.5,2.5,2.5))), Constant(2.5)),
            list(harmonic_mean, c(1,1), list(matrix(c(0,1,2))), Constant(0)),

            list(function(x) { diff(x, differences = 0) }, c(3,1), list(matrix(c(1,2,3))), Constant(c(1,2,3))),
            list(diff, c(2,1), list(matrix(c(1,2,3))), Constant(c(1,1))),
            list(diff, c(1,1), list(matrix(c(1.1,2.3))), Constant(1.2)),
            list(function(x) { diff(x, differences = 2) }, c(1,1), list(matrix(c(1,2,3))), Constant(0)),
            list(diff, c(3,1), list(matrix(c(2.1,1,4.5,-0.1))), Constant(c(-1.1,3.5,-4.6))),
            list(function(x) { diff(x, differences = 2) }, c(2,1), list(matrix(c(2.1,1,4.5,-0.1))), Constant(c(4.6,-8.1))),
            list(function(x) { diff(x, differences = 1, axis = 1) }, c(2,1), list(cbind(c(-5,-3), c(2,1))), Constant(c(7,4))),
            list(function(x) { diff(x, differences = 1, axis = 2) }, c(1,2), list(cbind(c(-5,-3), c(2,1))), Constant(matrix(c(2,-1), nrow = 1))),

            list(function(x) { p_norm(x,0.5) }, c(1,1), list(matrix(c(1.1,2,0.1))), Constant(7.724231543909264)),
            list(function(x) { p_norm(x,-0.4) }, c(1,1), list(matrix(c(1.1,2,0.1))), Constant(0.02713620334)),
            list(function(x) { p_norm(x,-1) }, c(1,1), list(matrix(c(1.1,2,0.1))),  Constant(0.0876494023904)),
            list(function(x) { p_norm(x,-2.3) }, c(1,1), list(matrix(c(1.1,2,0.1))), Constant(0.099781528576)),

            list(lambda_min, c(1,1), list(cbind(c(2,0), c(0,1))), Constant(1)),
            list(lambda_min, c(1,1), list(cbind(c(5,7), c(7,-3))), Constant(-7.06225775)),
            list(function(x) { lambda_sum_smallest(x,2) }, c(1,1), list(cbind(c(1,2,3), c(2,4,5), c(3,5,6))), Constant(-0.34481428)),
            list(log, c(2,2), list(cbind(c(1,exp(1)), c(exp(2), exp(-1)))), Constant(cbind(c(0,1), c(2,-1)))),
            list(log1p, c(2,2), list(cbind(c(0,exp(1)-1), c(exp(2)-1,exp(-1)-1))), Constant(cbind(c(0,1), c(2,-1)))),
            list(min_elemwise, c(2,1), list(matrix(c(-5,2)), matrix(c(-3,1)), 0, matrix(c(1,2))), Constant(c(-5,0))),
            list(min_elemwise, c(2,2), list(cbind(c(-5,2), c(-3,-1)), 0, cbind(c(5,4), c(-1,2))), Constant(cbind(c(-5,0), c(-3,-1)))),
            list(min_entries, c(1,1), list(cbind(c(-5,2), c(-3,1))), Constant(-5)),
            list(min_entries, c(1,1), list(matrix(c(-5,-10))), Constant(-10)),
            list(function(x) { x^0.25 }, c(1,1), list(7.45), Constant(7.45^0.25)),
            list(function(x) { x^0.32 }, c(2,1), list(matrix(c(7.45,3.9))), Constant(matrix(c(7.45,3.9), nrow = 2, ncol = 1)^0.32)),
            list(function(x) { x^0.9 }, c(2,2), list(cbind(c(7.45,2.2), c(4,7))), Constant(cbind(c(7.45,2.2), c(4,7))^0.9)),
            list(sqrt, c(2,2), list(cbind(c(2,4), c(16,1))), Constant(cbind(c(1.414213562373095,2), c(4,1)))),
            list(function(x) { sum_smallest(x,3) }, c(1,1), list(matrix(c(-1,2,3,4,5))), Constant(-1+2+3)),
            list(function(x) { sum_smallest(x,4) }, c(1,1), list(cbind(c(-3,-4,5), c(6,7,8), c(9,10,11))), Constant(-3-4+5+6)),
            list(function(x) { (x + Constant(0))^0.5 }, c(2,2), list(cbind(c(2,4), c(16,1))), Constant(cbind(c(1.414213562373095,2), c(4,1))))
        ),
        Maximize
    )
)

check_solver <- function(prob, solver_name) {
    tryCatch({
        if(solver_name == ROBUST_CVXOPT)
            solver_name <- "CVXOPT"

        chains <- CVXR:::.construct_chains(prob, solver = solver_name)
        return(TRUE)
    }, error = function(e) {
        return(FALSE)
    })
}

ecnt  <- 0
run_atom <- function(atom, problem, obj_val, solver, verbose = FALSE) {
    expect_true(is_dcp(problem))
    ##print(problem)
    if(verbose) {
        print(problem@objective)
        print(problem@constraints)
        print(paste("solver", solver))
    }

    if(check_solver(problem, solver)) {
        tolerance <- SOLVERS_TO_TOL[[solver]]
        result <- solve(problem, solver = solver, verbose = verbose)

        if(result$status %in% c("optimal", "optimal_inaccurate")) {
            if(verbose) {
                print(result$value)
                print(obj_val)
            }

            obj_diff <- (result$value - obj_val)/(1+abs(obj_val))
            expect_true(abs(obj_diff) <= tolerance)

            if(abs(obj_diff) > tolerance) {
                ecnt  <- ecnt + 1
                sink("test_constant_atoms_out.txt", append = TRUE)
                cat(sprintf("Solver: %s\n", solver))
                print(atom)
                cat(sprintf("Result: %.10f \t Expected: %.10f \t Obj_diff: %.10f\n", result$value, obj_val, obj_diff))
                sink()
                saveRDS(list(problem  = problem, solver = "solver"), file = sprintf("error-%02d.RDS", ecnt))
            }
        } else
            stop("Problem status is sub-optimal: ", result$status)
    }
}

test_that("Test all constant atoms", {
    skip_on_cran()
    ## if(file.exists("test_constant_atoms_out.txt"))
    ##  file.remove("test_constant_atoms_out.txt")
    ## atom_part  <- 0 ## counter for atom part (DEBUG AID)
    for(a in atoms) {
        atom_list <- a[[1]]
        objective_type <- a[[2]]
        ## counter  <- 0 ## list item counter (DEBUG AID)
        for(al in atom_list) {
            ##counter  <- counter + 1 ## list item counter (DEBUG AID)
            atom <- al[[1]]
            dims <- al[[2]]
            args <- al[[3]]
            obj_val <- al[[4]]
            for(row in 1:dims[1]) {
                for(col in 1:dims[2]) {
                    for(solver in SOLVERS_TO_TRY) {
                        ## cat(sprintf("i: %d j: %d solver: %S \n", atom_part, counter, solver)) ## (DEBUG AID)
                        ## Atoms with Constant arguments
                        const_args <- lapply(args, Constant)
                        run_atom(atom, Problem(objective_type(do.call(atom, const_args)[row, col])),
                                 value(obj_val[row, col]), solver)

                        ## Atoms with Variable arguments
                        variables <- list()
                        constraints <- list()
                        for(expr in args) {
                            expr_dim <- CVXR:::intf_dim(expr)
                            variables <- c(variables, Variable(expr_dim[1], expr_dim[2]))
                            constraints <- c(constraints, variables[[length(variables)]] == expr)
                        }
                        objective <- objective_type(do.call(atom, variables)[row, col])
                        ## print(atom)
                        ## print(value(obj_val[row, col]))
                        run_atom(atom, Problem(objective, constraints), value(obj_val[row, col]), solver)

                        ## Atoms with Parameter arguments
                        ## parameters <- list()
                        ## for(expr in args) {
                        ##     expr_dim <- dim(expr)
                        ##     parameters <- c(parameters, Parameter(expr_dim[1], expr_dim[2]))
                        ##     value(parameters[[length(parameters)]]) <- as.matrix(expr)
                        ## }
                        ## objective <- objective_type(do.call(atom, parameters)[row, col])
                        ## run_atom(atom, Problem(objective), value(obj_val[row, col]), solver)
                    }
                }
            }
        }
    }
})

## To isolate a problem with a particular atom, run the test below
## after setting uncommenting lines lablled "DEBUG AID"
## From that you will get atom part i, item number j and solver.
## Run this function with the same atoms and those args to isolate it
## run_brat  <- function(atoms, i, j, solver) {
##   atom_el  <- atoms[[i]]
##   objective_type  <- atom_el[[2]]
##   al  <- atom_el[[1]][[j]]
##   atom <- al[[1]]
##   dims <- al[[2]]
##   args <- al[[3]]
##   obj_val <- al[[4]]
##   row  <- dims[1]
##   col  <- dims[2]
##   const_args <- lapply(args, Constant)
##   problem1  <- Problem(objective_type(do.call(atom, const_args)[row, col]))
##   result <- solve(problem1, solver = solver, verbose = TRUE)
##   ## Atoms with Variable arguments
##   variables <- list()
##   constraints <- list()
##   for(expr in args) {
##     expr_dim <- CVXR:::intf_dim(expr)
##     variables <- c(variables, Variable(expr_dim[1], expr_dim[2]))
##     constraints <- c(constraints, variables[[length(variables)]] == expr)
##   }
##   objective <- objective_type(do.call(atom, variables)[row, col])
##   problem2  <- Problem(objective, constraints)
##   result <- solve(problem2, solver = solver, verbose = TRUE)
##   ## Atoms with Parameter arguments
##   parameters <- list()
##   for(expr in args) {
##     expr_dim <- dim(expr)
##     parameters <- c(parameters, Parameter(expr_dim[1], expr_dim[2]))
##     value(parameters[[length(parameters)]]) <- as.matrix(expr)
##   }
##   objective <- objective_type(do.call(atom, parameters)[row, col])
##   run_atom(atom, Problem(objective), value(obj_val[row, col]), solver)
## }

context("test-g01-curvature")

cvx <- Variable()^2
ccv <- Variable()^0.5
aff <- Variable()
const <- Constant(5)
unknown_curv <- log(Variable()^3)

pos <- Constant(1)
neg <- Constant(-1)
zero <- Constant(0)
unknown_sign <- Parameter()

test_that("test curvature addition", {
  skip_on_cran()
  expect_equal(curvature(const + cvx), curvature(cvx))
  expect_equal(curvature(unknown_curv + ccv), curvature(unknown_curv))
  expect_equal(curvature(cvx + ccv), curvature(unknown_curv))
  expect_equal(curvature(cvx + cvx), curvature(cvx))
  expect_equal(curvature(aff + ccv), curvature(ccv))
})

test_that("test curvature subtraction", {
  skip_on_cran()
  expect_equal(curvature(const - cvx), curvature(ccv))
  expect_equal(curvature(unknown_curv - ccv), curvature(unknown_curv))
  expect_equal(curvature(cvx - ccv), curvature(cvx))
  expect_equal(curvature(cvx - cvx), curvature(unknown_curv))
  expect_equal(curvature(aff - ccv), curvature(cvx))
})

test_that("test multiplication of sign and curvature", {
  skip_on_cran()
  expect_equal(curvature(zero * cvx), curvature(aff))
  expect_equal(curvature(neg * cvx), curvature(ccv))
  expect_equal(curvature(neg * ccv), curvature(cvx))
  expect_equal(curvature(neg * unknown_curv), curvature(unknown_curv))
  expect_equal(curvature(pos * aff), curvature(aff))
  expect_equal(curvature(pos * ccv), curvature(ccv))
  expect_equal(curvature(unknown_sign * const), curvature(const))
  expect_equal(curvature(unknown_sign * ccv), curvature(unknown_curv))
})

test_that("test curvature negation", {
  skip_on_cran()
  expect_equal(curvature(-cvx), curvature(ccv))
  expect_equal(curvature(-aff), curvature(aff))
})

test_that("test if curvature is affine, convex, or concave", {
  skip_on_cran()
  expect_true(is_affine(const))
  expect_true(is_affine(aff))
  expect_false(is_affine(cvx))
  expect_false(is_affine(ccv))
  expect_false(is_affine(unknown_curv))

  expect_true(is_convex(const))
  expect_true(is_convex(aff))
  expect_true(is_convex(cvx))
  expect_false(is_convex(ccv))
  expect_false(is_convex(unknown_curv))

  expect_true(is_concave(const))
  expect_true(is_concave(aff))
  expect_false(is_concave(cvx))
  expect_true(is_concave(ccv))
  expect_false(is_concave(unknown_curv))
})
